var CSL=function(){"use strict";var t,e,i,s,r,n,a,o,l,u,p={PROCESSOR_VERSION:"1.2.27",error:function(t){throw"undefined"==typeof Error?new Error("citeproc-js error: "+t):"citeproc-js error: "+t},debug:function(t){"undefined"==typeof console?dump("CSL: "+t+"\n"):console.log("citeproc-js warning: "+t)},LOCATOR_LABELS_REGEXP:new RegExp("^((art|ch|subch|col|fig|l|n|no|op|p|pp|para|subpara|supp|pt|r|sec|subsec|sv|sch|tit|vrs|vol)\\.)\\s+(.*)"),STATUTE_SUBDIV_PLAIN_REGEX:/(?:(?:^| )(?:art|bk|ch|subch|col|fig|fol|l|n|no|op|p|pp|para|subpara|supp|pt|r|sec|subsec|sv|sch|tit|vrs|vol)\. *)/,STATUTE_SUBDIV_PLAIN_REGEX_FRONT:/(?:^\s*[.,;]*\s*(?:art|bk|ch|subch|col|fig|fol|l|n|no|op|p|pp|para|subpara|supp|pt|r|sec|subsec|sv|sch|tit|vrs|vol)\. *)/,STATUTE_SUBDIV_STRINGS:{"art.":"article","bk.":"book","ch.":"chapter","subch.":"subchapter","p.":"page","pp.":"page","para.":"paragraph","subpara.":"subparagraph","pt.":"part","r.":"rule","sec.":"section","subsec.":"subsection","supp.":"supplement","sch.":"schedule","tit.":"title","col.":"column","fig.":"figure","fol.":"folio","l.":"line","n.":"note","no.":"issue","op.":"opus","sv.":"sub-verbo","vrs.":"verse","vol.":"volume"},STATUTE_SUBDIV_STRINGS_REVERSE:{article:"art.",book:"bk.",chapter:"ch.",subchapter:"subch.",page:"p.",paragraph:"para.",subparagraph:"subpara.",part:"pt.",rule:"r.",section:"sec.",subsection:"subsec.",supplement:"supp.",schedule:"sch.",title:"tit.",column:"col.",figure:"fig.",folio:"fol.",line:"l.",note:"n.",issue:"no.",opus:"op.","sub-verbo":"sv.","sub verbo":"sv.",verse:"vrs.",volume:"vol."},LOCATOR_LABELS_MAP:{art:"article",bk:"book",ch:"chapter",subch:"subchapter",col:"column",fig:"figure",fol:"folio",l:"line",n:"note",no:"issue",op:"opus",p:"page",pp:"page",para:"paragraph",subpara:"subparagraph",pt:"part",r:"rule",sec:"section",subsec:"subsection",supp:"supplement",sv:"sub-verbo",sch:"schedule",tit:"title",vrs:"verse",vol:"volume"},MODULE_MACROS:{"juris-pretitle":!0,"juris-title":!0,"juris-pretitle-short":!0,"juris-title-short":!0,"juris-main":!0,"juris-main-short":!0,"juris-tail":!0,"juris-tail-short":!0,"juris-locator":!0},MODULE_TYPES:{legal_case:!0,legislation:!0,bill:!0,hearing:!0,gazette:!0,report:!0,regulation:!0,standard:!0,patent:!0},checkNestedBrace:function(t){"note"===t.opt.xclass?(this.depth=0,this.update=function(t){for(var e=(t=t||"").split(/([\(\)])/),i=1,s=e.length;i<s;i+=2)"("===e[i]?(1==this.depth%2&&(e[i]="["),this.depth+=1):")"===e[i]&&(0==this.depth%2&&(e[i]="]"),this.depth-=1);return e.join("")}):this.update=function(t){return t}},MULTI_FIELDS:["event","publisher","publisher-place","event-place","title","container-title","collection-title","authority","genre","title-short","medium","country","jurisdiction","archive","archive-place"],LangPrefsMap:{title:"titles","title-short":"titles",event:"titles",genre:"titles",medium:"titles","container-title":"journals","collection-title":"titles",archive:"journals",publisher:"publishers",authority:"publishers","publisher-place":"places","event-place":"places","archive-place":"places",jurisdiction:"places",number:"places",edition:"places",issue:"places",volume:"places"},AbbreviationSegments:function(){this["container-title"]={},this["collection-title"]={},this["institution-entire"]={},this["institution-part"]={},this.nickname={},this.number={},this.title={},this.place={},this.hereinafter={},this.classic={},this["container-phrase"]={},this["title-phrase"]={}},FIELD_CATEGORY_REMAP:{title:"title","container-title":"container-title","collection-title":"collection-title",country:"place",number:"number",place:"place",archive:"collection-title","title-short":"title",genre:"title",event:"title",medium:"title","archive-place":"place","publisher-place":"place","event-place":"place",jurisdiction:"place","language-name":"place","language-name-original":"place","call-number":"number","chapter-number":"number","collection-number":"number",edition:"number",page:"number",issue:"number",locator:"number","locator-extra":"number","number-of-pages":"number","number-of-volumes":"number",volume:"number","citation-number":"number",publisher:"institution-part"},parseLocator:function(t){if(this.opt.development_extensions.locator_date_and_revision&&t.locator){t.locator=""+t.locator;var e=t.locator.indexOf("|");if(e>-1){var i=t.locator;t.locator=i.slice(0,e);var s=(i=i.slice(e+1)).match(/^([0-9]{4}-[0-9]{2}-[0-9]{2}).*/);s&&(t["locator-date"]=this.fun.dateparser.parseDateToObject(s[1]),i=i.slice(s[1].length)),t["locator-extra"]=i.replace(/^\s+/,"").replace(/\s+$/,"")}}return t.locator&&(t.locator=(""+t.locator).replace(/\s+$/,"")),t},normalizeLocaleStr:function(t){if(t){var e=t.split("-");return e[0]=e[0].toLowerCase(),e[1]&&(e[1]=e[1].toUpperCase()),e.join("-")}},parseNoteFieldHacks:function(t,e,i){if("string"==typeof t.note){for(var s=[],r=t.note.split("\n"),n=0,a=r.length;n<a;n++){s=[];var o=(f=r[n]).match(p.NOTE_FIELDS_REGEXP);if(o){for(var l=f.split(p.NOTE_FIELDS_REGEXP),u=0,h=l.length-1;u<h;u++)s.push(l[u]),s.push(o[u]);s.push(l[l.length-1]);for(u=1,h=s.length;u<h&&(!s[u-1].trim()||!(n>0||u>1)||s[u-1].match(p.NOTE_FIELD_REGEXP));u+=2)s[u]="\n"+s[u].slice(2,-1).trim()+"\n";r[n]=s.join("")}}var c=0,m={};for(n=0,a=(r=r.join("\n").split("\n")).length;n<a;n++){var f,d=(f=r[n]).match(p.NOTE_FIELD_REGEXP);if(f.trim()){if(!d){if(0===n)continue;c=n;break}var g=d[1],b=d[2].replace(/^\s+/,"").replace(/\s+$/,"");if("type"===g)t.type=b,r[n]="";else if(p.DATE_VARIABLES.indexOf(g.replace(/^alt-/,""))>-1)t[g]&&!i||(t[g]=p.DateParser.parseDateToArray(b),(!e||e[g]&&this.isDateString(b))&&(r[n]=""));else if(!t[g]){if(p.NAME_VARIABLES.indexOf(g.replace(/^alt-/,""))>-1){m[g]||(m[g]=[]);var _=b.split(/\s*\|\|\s*/);if(1===_.length)m[g].push({literal:_[0]});else if(2===_.length){var v={family:_[0],given:_[1]};p.parseParticles(v),m[g].push(v)}}else t[g]=b;e&&!e[g]||(r[n]="")}}}for(var g in m)t[g]=m[g];if(e){r[c].trim()&&(r[c]="\n"+r[c]);for(n=c-1;n>-1;n--)r[n].trim()||(r=r.slice(0,n).concat(r.slice(n+1)))}t.note=r.join("\n").trim()}},checkPrefixSpaceAppend:function(t,e){e||(e="");var i="",s=e.replace(/<[^>]+>/g,"").replace(/["'\u201d\u2019\u00bb\u202f\u00a0 ]+$/g,""),r=s.slice(-1);return s.match(p.ENDSWITH_ROMANESQUE_REGEXP)?i=" ":p.TERMINAL_PUNCTUATION.slice(0,-1).indexOf(r)>-1?i=" ":r.match(/[\)\],0-9]/)&&(i=" "),e=(e+i).replace(/\s+/g," ")},checkIgnorePredecessor:function(t,e){var i=e.replace(/<[^>]+>/g,"").replace(/["'\u201d\u2019\u00bb\u202f\u00a0 ]+$/g,"").slice(-1);return p.TERMINAL_PUNCTUATION.slice(0,-1).indexOf(i)>-1&&e.trim().indexOf(" ")>-1&&(t.tmp.term_predecessor=!1,!0)},checkSuffixSpacePrepend:function(t,e){return e?((e.match(p.STARTSWITH_ROMANESQUE_REGEXP)||["[","("].indexOf(e.slice(0,1))>-1)&&(e=" "+e),e):""},GENDERS:["masculine","feminine"],ERROR_NO_RENDERED_FORM:1,PREVIEW:"Just for laughs.",ASSUME_ALL_ITEMS_REGISTERED:2,START:0,END:1,SINGLETON:2,SEEN:6,SUCCESSOR:3,SUCCESSOR_OF_SUCCESSOR:4,SUPPRESS:5,SINGULAR:0,PLURAL:1,LITERAL:!0,BEFORE:1,AFTER:2,DESCENDING:1,ASCENDING:2,PRIMARY:1,SECONDARY:2,POSITION_FIRST:0,POSITION_SUBSEQUENT:1,POSITION_IBID:2,POSITION_IBID_WITH_LOCATOR:3,POSITION_TEST_VARS:["position","first-reference-note-number","near-note"],AREAS:["citation","citation_sort","bibliography","bibliography_sort","intext"],CITE_FIELDS:["first-reference-note-number","locator","locator-extra"],SWAPPING_PUNCTUATION:[".","!","?",":",","],TERMINAL_PUNCTUATION:[":",".",";","!","?"," "],NONE:0,NUMERIC:1,POSITION:2,TRIGRAPH:3,DATE_PARTS:["year","month","day"],DATE_PARTS_ALL:["year","month","day","season"],DATE_PARTS_INTERNAL:["year","month","day","year_end","month_end","day_end"],NAME_PARTS:["non-dropping-particle","family","given","dropping-particle","suffix","literal"],DISAMBIGUATE_OPTIONS:["disambiguate-add-names","disambiguate-add-givenname","disambiguate-add-year-suffix"],GIVENNAME_DISAMBIGUATION_RULES:["all-names","all-names-with-initials","primary-name","primary-name-with-initials","by-cite"],NAME_ATTRIBUTES:["and","delimiter-precedes-last","delimiter-precedes-et-al","initialize-with","initialize","name-as-sort-order","sort-separator","et-al-min","et-al-use-first","et-al-subsequent-min","et-al-subsequent-use-first","form","prefix","suffix","delimiter"],PARALLEL_MATCH_VARS:["container-title"],PARALLEL_TYPES:["bill","gazette","regulation","legislation","legal_case","treaty","article-magazine","article-journal"],PARALLEL_COLLAPSING_MID_VARSET:["volume","issue","container-title","section","collection-number"],LOOSE:0,STRICT:1,TOLERANT:2,PREFIX_PUNCTUATION:/[.;:]\s*$/,SUFFIX_PUNCTUATION:/^\s*[.;:,\(\)]/,NUMBER_REGEXP:/(?:^\d+|\d+$)/,NAME_INITIAL_REGEXP:/^([A-Z\u0e01-\u0e5b\u00c0-\u017f\u0400-\u042f\u0590-\u05d4\u05d6-\u05ff\u0600-\u06ff\u0370\u0372\u0376\u0386\u0388-\u03ab\u03e2\u03e4\u03e6\u03e8\u03ea\u03ec\u03ee\u03f4\u03f7\u03fd-\u03ff])([a-zA-Z\u0e01-\u0e5b\u00c0-\u017f\u0400-\u052f\u0600-\u06ff\u0370-\u03ff\u1f00-\u1fff]*|)(\.)*/,ROMANESQUE_REGEXP:/[-0-9a-zA-Z\u0e01-\u0e5b\u00c0-\u017f\u0370-\u03ff\u0400-\u052f\u0590-\u05d4\u05d6-\u05ff\u1f00-\u1fff\u0600-\u06ff\u200c\u200d\u200e\u0218\u0219\u021a\u021b\u202a-\u202e]/,ROMANESQUE_NOT_REGEXP:/[^a-zA-Z\u0e01-\u0e5b\u00c0-\u017f\u0370-\u03ff\u0400-\u052f\u0590-\u05d4\u05d6-\u05ff\u1f00-\u1fff\u0600-\u06ff\u200c\u200d\u200e\u0218\u0219\u021a\u021b\u202a-\u202e]/g,STARTSWITH_ROMANESQUE_REGEXP:/^[&a-zA-Z\u0e01-\u0e5b\u00c0-\u017f\u0370-\u03ff\u0400-\u052f\u0590-\u05d4\u05d6-\u05ff\u1f00-\u1fff\u0600-\u06ff\u200c\u200d\u200e\u0218\u0219\u021a\u021b\u202a-\u202e]/,ENDSWITH_ROMANESQUE_REGEXP:/[.;:&a-zA-Z\u0e01-\u0e5b\u00c0-\u017f\u0370-\u03ff\u0400-\u052f\u0590-\u05d4\u05d6-\u05ff\u1f00-\u1fff\u0600-\u06ff\u200c\u200d\u200e\u0218\u0219\u021a\u021b\u202a-\u202e]$/,ALL_ROMANESQUE_REGEXP:/^[a-zA-Z\u0e01-\u0e5b\u00c0-\u017f\u0370-\u03ff\u0400-\u052f\u0590-\u05d4\u05d6-\u05ff\u1f00-\u1fff\u0600-\u06ff\u200c\u200d\u200e\u0218\u0219\u021a\u021b\u202a-\u202e]+$/,VIETNAMESE_SPECIALS:/[\u00c0-\u00c3\u00c8-\u00ca\u00cc\u00cd\u00d2-\u00d5\u00d9\u00da\u00dd\u00e0-\u00e3\u00e8-\u00ea\u00ec\u00ed\u00f2-\u00f5\u00f9\u00fa\u00fd\u0101\u0103\u0110\u0111\u0128\u0129\u0168\u0169\u01a0\u01a1\u01af\u01b0\u1ea0-\u1ef9]/,VIETNAMESE_NAMES:/^(?:(?:[.AaBbCcDdEeGgHhIiKkLlMmNnOoPpQqRrSsTtUuVvXxYy \u00c0-\u00c3\u00c8-\u00ca\u00cc\u00cd\u00d2-\u00d5\u00d9\u00da\u00dd\u00e0-\u00e3\u00e8-\u00ea\u00ec\u00ed\u00f2-\u00f5\u00f9\u00fa\u00fd\u0101\u0103\u0110\u0111\u0128\u0129\u0168\u0169\u01a0\u01a1\u01af\u01b0\u1ea0-\u1ef9]{2,6})(\s+|$))+$/,NOTE_FIELDS_REGEXP:/\{:(?:[\-_a-z]+|[A-Z]+):[^\}]+\}/g,NOTE_FIELD_REGEXP:/^([\-_a-z]+|[A-Z]+):\s*([^\}]+)$/,PARTICLE_GIVEN_REGEXP:/^([^ ]+(?:\u02bb |\u2019 | |\' ) *)(.+)$/,PARTICLE_FAMILY_REGEXP:/^([^ ]+(?:\-|\u02bb|\u2019| |\') *)(.+)$/,DISPLAY_CLASSES:["block","left-margin","right-inline","indent"],NAME_VARIABLES:["author","collection-editor","composer","container-author","director","editor","editorial-director","illustrator","interviewer","original-author","recipient","reviewed-author","translator","commenter"],CREATORS:["author","collection-editor","composer","container-author","director","editor","editorial-director","illustrator","interviewer","original-author","recipient","reviewed-author","translator","commenter"],NUMERIC_VARIABLES:["call-number","chapter-number","collection-number","division","edition","page","issue","locator","locator-extra","number","number-of-pages","number-of-volumes","volume","supplement","citation-number"],DATE_VARIABLES:["locator-date","issued","event-date","accessed","original-date","publication-date","available-date","submitted","alt-issued","alt-event"],VARIABLES_WITH_SHORT_FORM:["title","container-title"],TITLE_FIELD_SPLITS:function(t){for(var e=["title","short","main","sub","subjoin"],i={},s=0,r=e.length;s<r;s++)i[e[s]]=t+"title"+("title"===e[s]?"":"-"+e[s]);return i},demoteNoiseWords:function(t,e,i){var s=t.locale[t.opt.lang].opts["leading-noise-words"];if(e&&i){(e=e.split(/\s+/)).reverse();for(var r=[],n=e.length-1;n>-1&&s.indexOf(e[n].toLowerCase())>-1;n+=-1)r.push(e.pop());e.reverse();var a=e.join(" "),o=r.join(" ");"drop"!==i&&o?"demote"===i&&(e=[a,o].join(", ")):e=a}return e},extractTitleAndSubtitle:function(t,e){for(var i=e?" ":"",s=["","container-"],r=0,n=s.length;r<n;r++){var a=s[r],o=p.TITLE_FIELD_SPLITS(a),l=[!1];if(t.multi)for(var u in t.multi._keys[o.short])l.push(u);for(var h=0,c=l.length;h<c;h++){var m={};(u=l[h])?(t.multi._keys[o.title]&&(m[o.title]=t.multi._keys[o.title][u]),t.multi._keys[o.short]&&(m[o.short]=t.multi._keys[o.short][u])):(m[o.title]=t[o.title],m[o.short]=t[o.short]),m[o.main]=m[o.title],m[o.sub]=!1;var f=m[o.short];if(m[o.title]){if(f&&f.toLowerCase()===m[o.title].toLowerCase())m[o.main]=m[o.title],m[o.subjoin]="",m[o.sub]="";else if(f){var d=m[o.title].slice(f.replace(/[\?\!]+$/,"").length),g=m[o.title].replace(d.replace(/^[\?\!]+/,""),"").trim();if((v=p.TITLE_SPLIT_REGEXP.matchfirst.exec(d))&&g.toLowerCase()===f.toLowerCase())m[o.main]=g,m[o.subjoin]=v[1].replace(/[\?\!]+(\s*)$/,"$1"),m[o.sub]=d.replace(p.TITLE_SPLIT_REGEXP.matchfirst,""),this.opt.development_extensions.force_short_title_casing_alignment&&(m[o.short]=m[o.main]);else 3==(b=p.TITLE_SPLIT(m[o.title])).length?(m[o.main]=b[0],m[o.subjoin]=b[1],m[o.sub]=b[2]):(m[o.main]=m[o.title],m[o.subjoin]="",m[o.sub]="")}else{var b;if(3==(b=p.TITLE_SPLIT(m[o.title])).length){if(m[o.main]=b[0],m[o.subjoin]=b[1],m[o.sub]=b[2],this.opt.development_extensions.implicit_short_title&&!t[o.short]&&!m[o.main].match(/^[\-\.[0-9]+$/)){var _=m[o.subjoin].trim();-1===["?","!"].indexOf(_)&&(_=""),m[o.short]=m[o.main]+_}}else m[o.main]=m[o.title],m[o.subjoin]="",m[o.sub]=""}if(m[o.subjoin]&&m[o.subjoin].match(/([\?\!])/)){var v=m[o.subjoin].match(/(\s*)$/);m[o.main]=m[o.main]+i+m[o.subjoin].trim(),m[o.subjoin]=v[1]}}if(m[o.subjoin]&&(m[o.subjoin].indexOf(":")>-1&&(m[o.subjoin]=i+": "),(m[o.subjoin].indexOf("-")>-1||m[o.subjoin].indexOf("—")>-1)&&(m[o.subjoin]="—")),u)for(var y in m)t.multi._keys[y]||(t.multi._keys[y]={}),t.multi._keys[y][u]=m[y];else for(var y in m)t[y]=m[y]}}},titlecaseSentenceOrNormal:function(t,e,i,s,r){var n=p.TITLE_FIELD_SPLITS(i),a={};if(s&&e.multi?(e.multi._keys[n.title]&&(a[n.title]=e.multi._keys[n.title][s]),e.multi._keys[n.main]&&(a[n.main]=e.multi._keys[n.main][s]),e.multi._keys[n.sub]&&(a[n.sub]=e.multi._keys[n.sub][s]),e.multi._keys[n.subjoin]&&(a[n.subjoin]=e.multi._keys[n.subjoin][s])):(a[n.title]=e[n.title],a[n.main]=e[n.main],a[n.sub]=e[n.sub],a[n.subjoin]=e[n.subjoin]),a[n.main]&&a[n.sub]){var o=a[n.main],l=a[n.subjoin],u=a[n.sub];return r?(o=p.Output.Formatters.sentence(t,o),u=p.Output.Formatters.sentence(t,u)):t.opt.development_extensions.uppercase_subtitles&&(u=p.Output.Formatters["capitalize-first"](t,u)),[o,l,u].join("")}if(a[n.title]){if(r)return p.Output.Formatters.sentence(t,a[n.title]);if(t.opt.development_extensions.uppercase_subtitles){for(var h=p.TITLE_SPLIT(a[n.title]),c=0,m=h.length;c<m;c+=2)h[c]=p.Output.Formatters["capitalize-first"](t,h[c]);for(c=1,m=h.length-1;c<m;c+=2){var f=h[c].match(/([:\?\!] )/);if(f){var d="fr"===t.opt["default-locale"][0].slice(0,2).toLowerCase()?" ":"";h[c]=d+f[1]}(h[c].indexOf("-")>-1||h[c].indexOf("—")>-1)&&(h[c]="—")}return a[n.title]=h.join(""),a[n.title]}return a[n.title]}return""},getSafeEscape:function(t){if(["bibliography","citation"].indexOf(t.tmp.area)>-1){var e=[];return t.opt.development_extensions.thin_non_breaking_space_html_hack&&"html"===t.opt.mode&&e.push((function(t){return t.replace(/\u202f/g,'<span style="white-space:nowrap">&thinsp;</span>')})),e.length?function(i){for(var s=0,r=e.length;s<r;s+=1)i=e[s](i);return p.Output.Formats[t.opt.mode].text_escape(i)}:p.Output.Formats[t.opt.mode].text_escape}return function(t){return t}},SKIP_WORDS:["about","above","across","afore","after","against","al","along","alongside","amid","amidst","among","amongst","anenst","apropos","apud","around","as","aside","astride","at","athwart","atop","barring","before","behind","below","beneath","beside","besides","between","beyond","but","by","circa","despite","down","during","et","except","for","forenenst","from","given","in","inside","into","lest","like","modulo","near","next","notwithstanding","of","off","on","onto","out","over","per","plus","pro","qua","sans","since","than","through"," thru","throughout","thruout","till","to","toward","towards","under","underneath","until","unto","up","upon","versus","vs.","v.","vs","v","via","vis-à-vis","with","within","without","according to","ahead of","apart from","as for","as of","as per","as regards","aside from","back to","because of","close to","due to","except for","far from","inside of","instead of","near to","next to","on to","out from","out of","outside of","prior to","pursuant to","rather than","regardless of","such as","that of","up to","where as","or","yet","so","for","and","nor","a","an","the","de","d'","von","van","c","ca"],FORMAT_KEY_SEQUENCE:["@strip-periods","@font-style","@font-variant","@font-weight","@text-decoration","@vertical-align","@quotes"],INSTITUTION_KEYS:["font-style","font-variant","font-weight","text-decoration","text-case"],SUFFIX_CHARS:"a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z",ROMAN_NUMERALS:[["","i","ii","iii","iv","v","vi","vii","viii","ix"],["","x","xx","xxx","xl","l","lx","lxx","lxxx","xc"],["","c","cc","ccc","cd","d","dc","dcc","dccc","cm"],["","m","mm","mmm","mmmm","mmmmm"]],LANGS:{"af-ZA":"Afrikaans",ar:"Arabic","bg-BG":"Bulgarian","ca-AD":"Catalan","cs-CZ":"Czech","da-DK":"Danish","de-AT":"Austrian","de-CH":"German (CH)","de-DE":"German (DE)","el-GR":"Greek","en-GB":"English (GB)","en-US":"English (US)","es-ES":"Spanish","et-EE":"Estonian",eu:"European","fa-IR":"Persian","fi-FI":"Finnish","fr-CA":"French (CA)","fr-FR":"French (FR)","he-IL":"Hebrew","hr-HR":"Croatian","hu-HU":"Hungarian","is-IS":"Icelandic","it-IT":"Italian","ja-JP":"Japanese","km-KH":"Khmer","ko-KR":"Korean","lt-LT":"Lithuanian","lv-LV":"Latvian","mn-MN":"Mongolian","nb-NO":"Norwegian (Bokmål)","nl-NL":"Dutch","nn-NO":"Norwegian (Nynorsk)","pl-PL":"Polish","pt-BR":"Portuguese (BR)","pt-PT":"Portuguese (PT)","ro-RO":"Romanian","ru-RU":"Russian","sk-SK":"Slovak","sl-SI":"Slovenian","sr-RS":"Serbian","sv-SE":"Swedish","th-TH":"Thai","tr-TR":"Turkish","uk-UA":"Ukrainian","vi-VN":"Vietnamese","zh-CN":"Chinese (CN)","zh-TW":"Chinese (TW)"},LANG_BASES:{af:"af_ZA",ar:"ar",bg:"bg_BG",ca:"ca_AD",cs:"cs_CZ",da:"da_DK",de:"de_DE",el:"el_GR",en:"en_US",es:"es_ES",et:"et_EE",eu:"eu",fa:"fa_IR",fi:"fi_FI",fr:"fr_FR",he:"he_IL",hr:"hr-HR",hu:"hu_HU",is:"is_IS",it:"it_IT",ja:"ja_JP",km:"km_KH",ko:"ko_KR",lt:"lt_LT",lv:"lv-LV",mn:"mn_MN",nb:"nb_NO",nl:"nl_NL",nn:"nn-NO",pl:"pl_PL",pt:"pt_PT",ro:"ro_RO",ru:"ru_RU",sk:"sk_SK",sl:"sl_SI",sr:"sr_RS",sv:"sv_SE",th:"th_TH",tr:"tr_TR",uk:"uk_UA",vi:"vi_VN",zh:"zh_CN"},SUPERSCRIPTS:{"ª":"a","²":"2","³":"3","¹":"1","º":"o","ʰ":"h","ʱ":"ɦ","ʲ":"j","ʳ":"r","ʴ":"ɹ","ʵ":"ɻ","ʶ":"ʁ","ʷ":"w","ʸ":"y","ˠ":"ɣ","ˡ":"l","ˢ":"s","ˣ":"x","ˤ":"ʕ","ᴬ":"A","ᴭ":"Æ","ᴮ":"B","ᴰ":"D","ᴱ":"E","ᴲ":"Ǝ","ᴳ":"G","ᴴ":"H","ᴵ":"I","ᴶ":"J","ᴷ":"K","ᴸ":"L","ᴹ":"M","ᴺ":"N","ᴼ":"O","ᴽ":"Ȣ","ᴾ":"P","ᴿ":"R","ᵀ":"T","ᵁ":"U","ᵂ":"W","ᵃ":"a","ᵄ":"ɐ","ᵅ":"ɑ","ᵆ":"ᴂ","ᵇ":"b","ᵈ":"d","ᵉ":"e","ᵊ":"ə","ᵋ":"ɛ","ᵌ":"ɜ","ᵍ":"g","ᵏ":"k","ᵐ":"m","ᵑ":"ŋ","ᵒ":"o","ᵓ":"ɔ","ᵔ":"ᴖ","ᵕ":"ᴗ","ᵖ":"p","ᵗ":"t","ᵘ":"u","ᵙ":"ᴝ","ᵚ":"ɯ","ᵛ":"v","ᵜ":"ᴥ","ᵝ":"β","ᵞ":"γ","ᵟ":"δ","ᵠ":"φ","ᵡ":"χ","⁰":"0","ⁱ":"i","⁴":"4","⁵":"5","⁶":"6","⁷":"7","⁸":"8","⁹":"9","⁺":"+","⁻":"−","⁼":"=","⁽":"(","⁾":")","ⁿ":"n","℠":"SM","™":"TM","㆒":"一","㆓":"二","㆔":"三","㆕":"四","㆖":"上","㆗":"中","㆘":"下","㆙":"甲","㆚":"乙","㆛":"丙","㆜":"丁","㆝":"天","㆞":"地","㆟":"人","ˀ":"ʔ","ˁ":"ʕ","ۥ":"و","ۦ":"ي"},SUPERSCRIPTS_REGEXP:new RegExp("[ª²³¹ºʰʱʲʳʴʵʶʷʸˠˡˢˣˤᴬᴭᴮᴰᴱᴲᴳᴴᴵᴶᴷᴸᴹᴺᴼᴽᴾᴿᵀᵁᵂᵃᵄᵅᵆᵇᵈᵉᵊᵋᵌᵍᵏᵐᵑᵒᵓᵔᵕᵖᵗᵘᵙᵚᵛᵜᵝᵞᵟᵠᵡ⁰ⁱ⁴⁵⁶⁷⁸⁹⁺⁻⁼⁽⁾ⁿ℠™㆒㆓㆔㆕㆖㆗㆘㆙㆚㆛㆜㆝㆞㆟ˀˁۥۦ]","g"),UPDATE_GROUP_CONTEXT_CONDITION:function(t,e,i){t.tmp.group_context.tip.condition?t.tmp.group_context.tip.condition.test&&(t.tmp.group_context.tip.condition.termtxt=e,t.tmp.group_context.tip.condition.valueTerm=i):e.slice(-1).match(/[0-9]/)?t.tmp.just_did_number=!0:t.tmp.just_did_number=!1},EVALUATE_GROUP_CONDITION:function(t,e){var i;if("empty-label"===e.condition.test)i=!e.condition.termtxt;else if("empty-label-no-decor"===e.condition.test)i=!e.condition.termtxt||e.condition.termtxt.indexOf("%s")>-1;else if("comma-safe"===e.condition.test){var s=!e.condition.termtxt,r=!1;e.condition.termtxt&&(r=e.condition.termtxt.slice(0,1).match(p.ALL_ROMANESQUE_REGEXP));var n=t.tmp.just_did_number;i=s?!!n:!e.condition.valueTerm&&!!r}if(i)var a=!1;else a=!0;return e.condition.not&&(a=!a),a},SYS_OPTIONS:["prioritize_disambiguate_condition","csl_reverse_lookup_support","main_title_from_short_title","uppercase_subtitles","force_short_title_casing_alignment","implicit_short_title"],TITLE_SPLIT_REGEXP:(t=["\\.\\s+","\\!\\s+","\\?\\s+","\\s*::*\\s+","\\s*—\\s*","\\s+\\-\\s+","\\s*\\-\\-\\-*\\s*"],{match:new RegExp("("+t.join("|")+")","g"),matchfirst:new RegExp("^("+t.join("|")+")"),split:new RegExp("(?:"+t.join("|")+")")}),TITLE_SPLIT:function(t){if(!t)return t;for(var e=t.match(p.TITLE_SPLIT_REGEXP.match),i=t.split(p.TITLE_SPLIT_REGEXP.split),s=i.length-2;s>-1;s--)i[s]=i[s].trim(),i[s]&&i[s].slice(-1).toLowerCase()!==i[s].slice(-1)?(i[s]=i[s]+e[s]+i[s+1],i=i.slice(0,s+1).concat(i.slice(s+2))):i=i.slice(0,s+1).concat([e[s]]).concat(i.slice(s+1));return i},GET_COURT_CLASS:function(t,e,i){var s="",r=null,n=e.jurisdiction?e.jurisdiction.split(":")[0]:null,a="court_condition_classes";return i&&(a="court_key_classes"),n&&e.authority&&("string"==typeof e.authority?r=e.authority:e.authority[0]&&e.authority[0].literal&&(r=e.authority[0].literal)),r&&(this.lang&&t.locale[this.lang].opts[a]&&t.locale[this.lang].opts[a][n]&&t.locale[this.lang].opts[a][n][r]?s=t.locale[this.lang].opts[a][n][r]:t.locale[t.opt["default-locale"][0]].opts[a]&&t.locale[t.opt["default-locale"][0]].opts[a][n]&&t.locale[t.opt["default-locale"][0]].opts[a][n][r]&&(s=t.locale[t.opt["default-locale"][0]].opts[a][n][r])),s},SET_COURT_CLASSES:function(t,e,i,s){for(var r=i.getNodesByName(s,"court-class"),n=0,a=i.numberofnodes(r);n<a;n+=1){var o=r[n],l=i.attributes(o),u=l["@name"],p=l["@country"],h=l["@courts"],c="court_key_classes";if(t.registry&&(c="court_condition_classes"),u&&p&&h){h=h.trim().split(/\s+/),t.locale[e].opts[c]||(t.locale[e].opts[c]={}),t.locale[e].opts[c][p]||(t.locale[e].opts[c][p]={});for(var m=0,f=h.length;m<f;m++)t.locale[e].opts[c][p][h[m]]=u}}},INIT_JURISDICTION_MACROS:function(t,e,i){if(!t.sys.retrieveStyleModule||!p.MODULE_MACROS[i]||!e.jurisdiction)return!1;var s=t.getJurisdictionList(e.jurisdiction);if(!t.opt.jurisdictions_seen[s[0]]){var r=t.retrieveAllStyleModules(s);for(var n in r){t.juris[n]={};var a=p.setupXml(r[n]);a.addMissingNameNodes(a.dataObj),a.addInstitutionNodes(a.dataObj),a.insertPublisherAndPlace(a.dataObj),a.flagDateMacros(a.dataObj);for(var o=0,l=(f=a.getNodesByName(a.dataObj,"law-module")).length;o<l;o++){var u=a.getAttributeValue(f[o],"types");if(u){t.juris[n].types={};for(var h=0,c=(u=u.split(/\s+/)).length;h<c;h++)t.juris[n].types[u[h]]=!0}}var m=t.opt.lang?t.opt.lang:t.opt["default-locale"][0];p.SET_COURT_CLASSES(t,m,a,a.dataObj),t.juris[n].types||(t.juris[n].types=p.MODULE_TYPES);var f;for(o=0,l=(f=a.getNodesByName(a.dataObj,"macro")).length;o<l;o++){var d=a.getAttributeValue(f[o],"name");p.MODULE_MACROS[d]?(t.juris[n][d]=[],t.buildTokenLists(f[o],t.juris[n][d]),t.configureTokenList(t.juris[n][d])):p.debug('CSL: skipping non-modular macro name "'+d+'" in module context')}}}t.opt.parallel.enable&&(t.parallel||(t.parallel=new p.Parallel(t)));for(o=0,l=s.length;o<l;o++){n=s[o];if(t.juris[n]&&t.juris[n].types[e.type])return e["best-jurisdiction"]=n,!0}return!1}};return p.XmlJSON=function(t){this.dataObj=t,this.institution={name:"institution",attrs:{"institution-parts":"long",delimiter:", ","substitute-use-first":"1","use-last":"1"},children:[{name:"institution-part",attrs:{name:"long"},children:[]}]}},p.XmlJSON.prototype.clean=function(t){return t},p.XmlJSON.prototype.getStyleId=function(t,e){var i="id";e&&(i="title");for(var s="",r=t.children,n=0,a=r.length;n<a;n++)if("info"===r[n].name)for(var o=r[n].children,l=0,u=o.length;l<u;l++)o[l].name===i&&(s=o[l].children[0]);return s},p.XmlJSON.prototype.children=function(t){return!(!t||!t.children.length)&&t.children.slice()},p.XmlJSON.prototype.nodename=function(t){return t?t.name:null},p.XmlJSON.prototype.attributes=function(t){var e={};for(var i in t.attrs)e["@"+i]=t.attrs[i];return e},p.XmlJSON.prototype.content=function(t){var e="";if(!t||!t.children)return e;for(var i=0,s=t.children.length;i<s;i+=1)"string"==typeof t.children[i]&&(e+=t.children[i]);return e},p.XmlJSON.prototype.namespace={},p.XmlJSON.prototype.numberofnodes=function(t){return t&&"number"==typeof t.length?t.length:0},p.XmlJSON.prototype.getAttributeValue=function(t,e,i){var s="";return i&&(e=i+":"+e),t&&t.attrs&&(s=t.attrs[e]?t.attrs[e]:""),s},p.XmlJSON.prototype.getNodeValue=function(t,e){var i="";if(e)for(var s=0,r=t.children.length;s<r;s+=1)t.children[s].name===e&&(i=t.children[s].children.length?t.children[s]:"");else t&&(i=t);return i&&i.children&&1==i.children.length&&"string"==typeof i.children[0]&&(i=i.children[0]),i},p.XmlJSON.prototype.setAttributeOnNodeIdentifiedByNameAttribute=function(t,e,i,s,r){"@"===s.slice(0,1)&&(s=s.slice(1));for(var n=0,a=t.children.length;n<a;n+=1)t.children[n].name===e&&t.children[n].attrs.name===i&&(t.children[n].attrs[s]=r)},p.XmlJSON.prototype.deleteNodeByNameAttribute=function(t,e){var i,s;for(i=0,s=t.children.length;i<s;i+=1)t.children[i]&&"string"!=typeof t.children[i]&&t.children[i].attrs.name==e&&(t.children=t.children.slice(0,i).concat(t.children.slice(i+1)))},p.XmlJSON.prototype.deleteAttribute=function(t,e){void 0!==t.attrs[e]&&t.attrs.pop(e)},p.XmlJSON.prototype.setAttribute=function(t,e,i){return t.attrs[e]=i,!1},p.XmlJSON.prototype.nodeCopy=function(t,e){if(!e)e={};if("object"==typeof e&&void 0===e.length)for(var i in t)"string"==typeof t[i]?e[i]=t[i]:"object"==typeof t[i]&&(void 0===t[i].length?e[i]=this.nodeCopy(t[i],{}):e[i]=this.nodeCopy(t[i],[]));else for(var s=0,r=t.length;s<r;s+=1)"string"==typeof t[s]?e[s]=t[s]:e[s]=this.nodeCopy(t[s],{});return e},p.XmlJSON.prototype.getNodesByName=function(t,e,i,s){if(!s)s=[];if(!t||!t.children)return s;e===t.name&&(i?i===t.attrs.name&&s.push(t):s.push(t));for(var r=0,n=t.children.length;r<n;r+=1)"object"==typeof t.children[r]&&this.getNodesByName(t.children[r],e,i,s);return s},p.XmlJSON.prototype.nodeNameIs=function(t,e){return void 0!==t&&e==t.name},p.XmlJSON.prototype.makeXml=function(t){return"string"==typeof t&&(t="<"===t.slice(0,1)?this.jsonStringWalker.walkToObject(t):JSON.parse(t)),t},p.XmlJSON.prototype.insertChildNodeAfter=function(t,e,i,s){for(var r=0,n=t.children.length;r<n;r+=1)if(e===t.children[r]){t.children=t.children.slice(0,r).concat([s]).concat(t.children.slice(r+1));break}return t},p.XmlJSON.prototype.insertPublisherAndPlace=function(t){if("group"===t.name){for(var e=!0,i=["publisher","publisher-place"],s=0,r=t.children.length;s<r;s+=1){var n=i.indexOf(t.children[s].attrs.variable);if(!("text"===t.children[s].name&&n>-1)||t.children[s].attrs.prefix||t.children[s].attrs.suffix){e=!1;break}i=i.slice(0,n).concat(i.slice(n+1))}e&&!i.length&&(t.attrs["has-publisher-and-publisher-place"]=!0)}for(s=0,r=t.children.length;s<r;s+=1)"object"==typeof t.children[s]&&this.insertPublisherAndPlace(t.children[s])},p.XmlJSON.prototype.isChildOfSubstitute=function(t){if(t.length>0){var e=t.slice();return"substitute"===e.pop()||this.isChildOfSubstitute(e)}return!1},p.XmlJSON.prototype.addMissingNameNodes=function(t,e){if(e||(e=[]),"names"===t.name&&!this.isChildOfSubstitute(e)){for(var i=!0,s=0,r=t.children.length;s<r;s++)if("name"===t.children[s].name){i=!1;break}i&&(t.children=[{name:"name",attrs:{},children:[]}].concat(t.children))}e.push(t.name);for(s=0,r=t.children.length;s<r;s+=1)"object"==typeof t.children[s]&&this.addMissingNameNodes(t.children[s],e);e.pop()},p.XmlJSON.prototype.addInstitutionNodes=function(t){if("names"===t.name){for(var e={},i=-1,s=0,r=t.children.length;s<r;s+=1){if("name"==t.children[s].name){for(var n in t.children[s].attrs)e[n]=t.children[s].attrs[n];e.delimiter=t.children[s].attrs.delimiter,e.and=t.children[s].attrs.and,i=s;for(var a=0,o=t.children[s].children.length;a<o;a+=1)if("family"===t.children[s].children[a].attrs.name)for(var n in t.children[s].children[a].attrs)e[n]=t.children[s].children[a].attrs[n]}if("institution"==t.children[s].name){i=-1;break}}if(i>-1){var l=this.nodeCopy(this.institution);for(s=0,r=p.INSTITUTION_KEYS.length;s<r;s+=1){var u=p.INSTITUTION_KEYS[s];void 0!==e[u]&&(l.children[0].attrs[u]=e[u]),e.delimiter&&(l.attrs.delimiter=e.delimiter),e.and&&(l.attrs.and="text")}t.children=t.children.slice(0,i+1).concat([l]).concat(t.children.slice(i+1))}}for(s=0,r=t.children.length;s<r;s+=1)"string"!=typeof t.children[s]&&this.addInstitutionNodes(t.children[s])},p.XmlJSON.prototype.flagDateMacros=function(t){for(var e=0,i=t.children.length;e<i;e+=1)"macro"===t.children[e].name&&this.inspectDateMacros(t.children[e])&&(t.children[e].attrs["macro-has-date"]="true")},p.XmlJSON.prototype.inspectDateMacros=function(t){if(!t||!t.children)return!1;if("date"===t.name)return!0;for(var e=0,i=t.children.length;e<i;e+=1)if(this.inspectDateMacros(t.children[e]))return!0;return!1},p.stripXmlProcessingInstruction=function(t){return t?t=(t=(t=(t=t.replace(/^<\?[^?]+\?>/,"")).replace(/<!--[^>]+-->/g,"")).replace(/^\s+/g,"")).replace(/\s+$/g,""):t},p.parseXml=function(t){var e={children:[]},i=[e.children];function s(t){return t.split("&amp;").join("&").split("&quot;").join('"').split("&gt;").join(">").split("&lt;").join("<").replace(/&#([0-9]{1,6});/gi,(function(t,e){var i=parseInt(e,10);return String.fromCharCode(i)})).replace(/&#x([a-f0-9]{1,6});/gi,(function(t,e){var i=parseInt(e,16);return String.fromCharCode(i)}))}function r(t,e){var i=RegExp("^.*[\t ]+"+e+"=(\"(?:[^\"]*)\"|'(?:[^']*)').*$"),s=t.match(i);return s?s[1].slice(1,-1):null}function n(t){var e=RegExp("^<([^\t />]+)"),i=t.match(e);return i?i[1]:null}function a(t){var e={};e.name=n(t),e.attrs={};var i=function(t){var e=t.match(/([^\'\"=	 ]+)=(?:\"[^\"]*\"|\'[^\']*\')/g);if(e)for(var i=0,s=e.length;i<s;i++)e[i]=e[i].replace(/=.*/,"");return e}(t);if(i)for(var a=0,o=i.length;a<o;a++){var l={name:i[a],value:r(t,i[a])};e.attrs[l.name]=s(l.value)}return e.children=[],e}function o(t){return s(t.match(/^.*>([^<]*)<.*$/)[1])}function l(t){i.slice(-1)[0].push(t)}function u(t){var e;t.slice(1).indexOf("<")>-1?((e=a(t.slice(0,t.indexOf(">")+1))).children=[o(t)],l(e)):"/>"===t.slice(-2)?(e=a(t),"term"===n(t)&&e.children.push(""),l(e)):"</"===t.slice(0,2)?i.pop():(l(e=a(t)),function(t){i.push(t.children)}(e))}for(var p=function(t){for(var e=(t=t.split(/(?:\r\n|\n|\r)/).join(" ").replace(/>[	 ]+</g,"><").replace(/<\!--.*?-->/g,"")).split("><"),i=null,s=0,r=e.length;s<r;s++)s>0&&(e[s]="<"+e[s]),s<e.length-1&&(e[s]=e[s]+">"),"number"!=typeof i&&("<style "!==e[s].slice(0,7)&&"<locale "!=e[s].slice(0,8)||(i=s));for(s=(e=e.slice(i)).length-2;s>-1;s--)if(-1===e[s].slice(1).indexOf("<")){var n=e[s].slice(0,5);"/>"!==e[s].slice(-2)&&("<term"===n?"</term"===e[s+1].slice(0,6)&&(e[s]=e[s]+e[s+1],e=e.slice(0,s+1).concat(e.slice(s+2))):["<sing","<mult"].indexOf(n)>-1&&"/>"!==e[s].slice(-2)&&"<"===e[s+1].slice(0,1)&&(e[s]=e[s]+e[s+1],e=e.slice(0,s+1).concat(e.slice(s+2))))}return e}(t),h=0,c=p.length;h<c;h++){u(p[h])}return e.children[0]},p.XmlDOM=function(t){this.dataObj=t,"undefined"==typeof DOMParser?(DOMParser=function(){},DOMParser.prototype.parseFromString=function(t,e){var i;return"undefined"!=typeof ActiveXObject?((i=new ActiveXObject("MSXML.DomDocument")).async=!1,i.loadXML(t),i):"undefined"!=typeof XMLHttpRequest?(e||(e="text/xml"),(i=new XMLHttpRequest).open("GET","data:"+e+";charset=utf-8,"+encodeURIComponent(t),!1),i.overrideMimeType&&i.overrideMimeType(e),i.send(null),i.responseXML):"undefined"!=typeof marknote?(new marknote.Parser).parse(t):void 0},this.hasAttributes=function(t){return!(!t.attributes||!t.attributes.length)}):this.hasAttributes=function(t){return!(!t.attributes||!t.attributes.length)},this.importNode=function(t,e){return void 0===t.importNode?this._importNode(t,e,!0):t.importNode(e,!0)},this._importNode=function(t,e,i){switch(e.nodeType){case 1:var s=t.createElement(e.nodeName);if(e.attributes&&e.attributes.length>0)for(var r=0,n=e.attributes.length;r<n;)s.setAttribute(e.attributes[r].nodeName,e.getAttribute(e.attributes[r++].nodeName));if(i&&e.childNodes&&e.childNodes.length>0)for(r=0,n=e.childNodes.length;r<n;)s.appendChild(this._importNode(t,e.childNodes[r++],i));return s}},this.parser=new DOMParser;var e=this.parser.parseFromString('<docco><institution institution-parts="long" delimiter=", " substitute-use-first="1" use-last="1"><institution-part name="long"/></institution></docco>',"text/xml"),i=e.getElementsByTagName("institution");this.institution=i.item(0);var s=e.getElementsByTagName("institution-part");this.institutionpart=s.item(0),this.ns="http://purl.org/net/xbiblio/csl"},p.XmlDOM.prototype.clean=function(t){return t=(t=(t=(t=(t=t.replace(/<\?[^?]+\?>/g,"")).replace(/<![^>]+>/g,"")).replace(/^\s+/,"")).replace(/\s+$/,"")).replace(/^\n*/,"")},p.XmlDOM.prototype.getStyleId=function(t,e){var i="",s="id";e&&(s="title");var r=t.getElementsByTagName(s);return r&&r.length&&(r=r.item(0)),r&&(i=r.textContent),i||(i=r.innerText),i||(i=r.innerHTML),i},p.XmlDOM.prototype.children=function(t){var e,i,s,r;if(t){for(r=[],i=0,s=(e=t.childNodes).length;i<s;i+=1)"#text"!=e[i].nodeName&&r.push(e[i]);return r}return[]},p.XmlDOM.prototype.nodename=function(t){return t.nodeName},p.XmlDOM.prototype.attributes=function(t){var e,i,s,r,n;if(e=new Object,t&&this.hasAttributes(t))for(r=0,n=(i=t.attributes).length;r<n;r+=1)e["@"+(s=i[r]).name]=s.value;return e},p.XmlDOM.prototype.content=function(t){return void 0!==t.textContent?t.textContent:void 0!==t.innerText?t.innerText:t.txt},p.XmlDOM.prototype.namespace={xml:"http://www.w3.org/XML/1998/namespace"},p.XmlDOM.prototype.numberofnodes=function(t){return t?t.length:0},p.XmlDOM.prototype.getAttributeName=function(t){return t.name},p.XmlDOM.prototype.getAttributeValue=function(t,e,i){var s="";return i&&(e=i+":"+e),t&&this.hasAttributes(t)&&t.getAttribute(e)&&(s=t.getAttribute(e)),s},p.XmlDOM.prototype.getNodeValue=function(t,e){var i=null;if(e){var s=t.getElementsByTagName(e);s.length>0&&(i=void 0!==s[0].textContent?s[0].textContent:void 0!==s[0].innerText?s[0].innerText:s[0].text)}return null===i&&t&&t.childNodes&&(0==t.childNodes.length||1==t.childNodes.length&&"#text"==t.firstChild.nodeName)&&(i=void 0!==t.textContent?t.textContent:void 0!==t.innerText?t.innerText:t.text),null===i&&(i=t),i},p.XmlDOM.prototype.setAttributeOnNodeIdentifiedByNameAttribute=function(t,e,i,s,r){var n,a,o,l;for("@"===s.slice(0,1)&&(s=s.slice(1)),n=0,a=(o=t.getElementsByTagName(e)).length;n<a;n+=1)(l=o[n]).getAttribute("name")==i&&l.setAttribute(s,r)},p.XmlDOM.prototype.deleteNodeByNameAttribute=function(t,e){var i,s,r,n;for(i=0,s=(n=t.childNodes).length;i<s;i+=1)(r=n[i])&&r.nodeType!=r.TEXT_NODE&&this.hasAttributes(r)&&r.getAttribute("name")==e&&t.removeChild(n[i])},p.XmlDOM.prototype.deleteAttribute=function(t,e){t.removeAttribute(e)},p.XmlDOM.prototype.setAttribute=function(t,e,i){return t.ownerDocument||(t=t.firstChild),["function","unknown"].indexOf(typeof t.setAttribute)>-1&&t.setAttribute(e,i),!1},p.XmlDOM.prototype.nodeCopy=function(t){return t.cloneNode(!0)},p.XmlDOM.prototype.getNodesByName=function(t,e,i){var s,r,n,a,o;for(s=[],a=0,o=(r=t.getElementsByTagName(e)).length;a<o;a+=1)n=r.item(a),(!i||this.hasAttributes(n)&&n.getAttribute("name")==i)&&s.push(n);return s},p.XmlDOM.prototype.nodeNameIs=function(t,e){return e==t.nodeName},p.XmlDOM.prototype.makeXml=function(t){return t||(t="<docco><bogus/></docco>"),t=t.replace(/\s*<\?[^>]*\?>\s*\n*/g,""),this.parser.parseFromString(t,"application/xml").firstChild},p.XmlDOM.prototype.insertChildNodeAfter=function(t,e,i,s){var r;return r=this.importNode(e.ownerDocument,s),t.replaceChild(r,e),t},p.XmlDOM.prototype.insertPublisherAndPlace=function(t){for(var e=t.getElementsByTagName("group"),i=0,s=e.length;i<s;i+=1){for(var r=e.item(i),n=[],a=0,o=r.childNodes.length;a<o;a+=1)1!==r.childNodes.item(a).nodeType&&n.push(a);if(r.childNodes.length-n.length==2){var l=[];for(a=0,o=2;a<o;a+=1)if(!(n.indexOf(a)>-1)){for(var u=r.childNodes.item(a),p=[],h=0,c=u.childNodes.length;h<c;h+=1)1!==u.childNodes.item(h).nodeType&&p.push(h);if(u.childNodes.length-p.length==0&&(l.push(u.getAttribute("variable")),u.getAttribute("suffix")||u.getAttribute("prefix"))){l=[];break}}l.indexOf("publisher")>-1&&l.indexOf("publisher-place")>-1&&r.setAttribute("has-publisher-and-publisher-place",!0)}}},p.XmlDOM.prototype.isChildOfSubstitute=function(t){return!!t.parentNode&&("substitute"===t.parentNode.tagName.toLowerCase()||this.isChildOfSubstitute(t.parentNode))},p.XmlDOM.prototype.addMissingNameNodes=function(t){for(var e=t.getElementsByTagName("names"),i=0,s=e.length;i<s;i+=1){var r=e.item(i),n=r.getElementsByTagName("name");if(!(n&&0!==n.length||this.isChildOfSubstitute(r))){var a=r.ownerDocument.createElement("name");r.appendChild(a)}}},p.XmlDOM.prototype.addInstitutionNodes=function(t){var e,i,s,r,n,a,o,l;for(o=0,l=(e=t.getElementsByTagName("names")).length;o<l;o+=1)if(0!=(n=(i=e.item(o)).getElementsByTagName("name")).length&&0==i.getElementsByTagName("institution").length){r=(s=this.importNode(t.ownerDocument,this.institution)).getElementsByTagName("institution-part").item(0),a=n.item(0),i.insertBefore(s,a.nextSibling);for(var u=0,h=p.INSTITUTION_KEYS.length;u<h;u+=1){var c=p.INSTITUTION_KEYS[u];(g=a.getAttribute(c))&&r.setAttribute(c,g)}var m=a.getElementsByTagName("name-part");for(u=0,h=m.length;u<h;u+=1)if("family"===m[u].getAttribute("name"))for(var f=0,d=p.INSTITUTION_KEYS.length;f<d;f+=1){var g;c=p.INSTITUTION_KEYS[f];(g=m[u].getAttribute(c))&&r.setAttribute(c,g)}}},p.XmlDOM.prototype.flagDateMacros=function(t){var e,i,s,r=t.getElementsByTagName("macro");for(e=0,i=r.length;e<i;e+=1)(s=r.item(e)).getElementsByTagName("date").length&&s.setAttribute("macro-has-date","true")},p.setupXml=function(t){var e={},i=null;return void 0!==t?"string"==typeof t?(e="<"===(t=t.replace("^\ufeff","").replace(/^\s+/,"")).slice(0,1)?p.parseXml(t):JSON.parse(t),i=new p.XmlJSON(e)):i=void 0!==t.getAttribute?new p.XmlDOM(t):void 0!==t.toXMLString?new p.XmlE4X(t):new p.XmlJSON(t):p.error("unable to parse XML input"),i||p.error("citeproc-js error: unable to parse CSL style or locale object"),i},p.getSortCompare=function(t){if(p.stringCompare)return p.stringCompare;var e,i={sensitivity:"base",ignorePunctuation:!0,numeric:!0};t||(t="en-US");var s=function(t){return t.replace(/^[\[\]\'\"]*/g,"")},r=!!(e=function(e,s){return e.toLocaleLowerCase().localeCompare(s.toLocaleLowerCase(),t,i)})("[x","x")&&function(t,i){return e(s(t),s(i))};return function(t,i){return r?r(t,i):e(t,i)}},p.ambigConfigDiff=function(t,e){var i,s,r,n;if(t.names.length!==e.names.length)return 1;for(i=0,s=t.names.length;i<s;i+=1){if(t.names[i]!==e.names[i])return 1;for(r=0,n=t.givens[i];r<n;r+=1)if(t.givens[i][r]!==e.givens[i][r])return 1}return t.disambiguate!=e.disambiguate?1:t.year_suffix!==e.year_suffix?1:0},p.cloneAmbigConfig=function(t,e){var i,s,r,n,a,o={names:[],givens:[],year_suffix:!1,disambiguate:!1};for(i=0,s=t.names.length;i<s;i+=1)a=t.names[i],o.names[i]=a;for(i=0,s=t.givens.length;i<s;i+=1){for(a=[],r=0,n=t.givens[i].length;r<n;r+=1)a.push(t.givens[i][r]);o.givens.push(a)}return e?(o.year_suffix=e.year_suffix,o.disambiguate=e.disambiguate):(o.year_suffix=t.year_suffix,o.disambiguate=t.disambiguate),o},p.getAmbigConfig=function(){var t;return(t=this.tmp.disambig_request)||(t=this.tmp.disambig_settings),p.cloneAmbigConfig(t)},p.getMaxVals=function(){return this.tmp.names_max.mystack.slice()},p.getMinVal=function(){return this.tmp["et-al-min"]},p.tokenExec=function(t,e,i){var s,r;s=t.next,r=!1;t.test&&(s=function(e){return e?(this.tmp.jump.replace("succeed"),t.succeed):(this.tmp.jump.replace("fail"),t.fail)}.call(this,t.test(e,i)));for(var n=0,a=t.execs.length;n<a;n++)(r=t.execs[n].call(t,this,e,i))&&(s=r);return s},p.expandMacro=function(t,e){var i,s,r;i=t.postponed_macro;var n=t.strings.sort_direction;t=new p.Token("group",p.START);var a=!1,o=!1;(s=this.cslXml.getNodesByName(this.cslXml.dataObj,"macro",i)).length&&(o=this.cslXml.getAttributeValue(s[0],"cslid"),a=this.cslXml.getAttributeValue(s[0],"macro-has-date")),a&&(i=i+"@"+this.build.current_default_locale,h=function(t){t.tmp.extension&&(t.tmp["doing-macro-with-date"]=!0)},t.execs.push(h)),this.build.macro_stack.indexOf(i)>-1?p.error('CSL processor error: call to macro "'+i+'" would cause an infinite loop'):this.build.macro_stack.push(i),t.cslid=o,p.MODULE_MACROS[i]&&(t.juris=i,this.opt.update_mode=p.POSITION),p.Node.group.build.call(t,this,e,!0),this.cslXml.getNodeValue(s)||p.error('CSL style error: undefined macro "'+i+'"');var l,u=p.getMacroTarget.call(this,i);if(u&&(p.buildMacro.call(this,u,s),p.configureMacro.call(this,u)),!this.build.extension){var h=(l=i,function(t,e,i){for(var s=0;s<t.macros[l].length;)s=p.tokenExec.call(t,t.macros[l][s],e,i)}),c=new p.Token("text",p.SINGLETON);c.execs.push(h),e.push(c)}(r=new p.Token("group",p.END)).strings.sort_direction=n,a&&(h=function(t){t.tmp.extension&&(t.tmp["doing-macro-with-date"]=!1)},r.execs.push(h)),t.juris&&(r.juris=i),p.Node.group.build.call(r,this,e,!0),this.build.macro_stack.pop()},p.getMacroTarget=function(t){var e=!1;return this.build.extension?e=this[this.build.root+this.build.extension].tokens:this.macros[t]||(e=[],this.macros[t]=e),e},p.buildMacro=function(t,e){p.makeBuilder(this,t)(void 0===e.length?e:e[0])},p.configureMacro=function(t){this.build.extension||this.configureTokenList(t)},p.XmlToToken=function(t,e,i,s){var r,n,a,o,l,u;if(r=t.cslXml.nodename(this),!t.build.skip||t.build.skip===r)if(r){if(p.Node[t.cslXml.nodename(this)]||p.error('Undefined node name "'+r+'".'),a=t.cslXml.attributes(this),o=p.setDecorations.call(this,t,a),l=new p.Token(r,e),e!==p.END||"if"===r||"else-if"===r||"layout"===r){for(var h in a)if(a.hasOwnProperty(h)){if(e===p.END&&"@language"!==h&&"@locale"!==h)continue;if(a.hasOwnProperty(h))if(p.Attributes[h])try{p.Attributes[h].call(l,t,""+a[h])}catch(t){p.error(h+" attribute: "+t)}else p.debug('warning: undefined attribute "'+h+'" in style')}l.decorations=o,p.DATE_VARIABLES.indexOf(a["@variable"])>-1&&s.push(l.variables)}else e===p.END&&a["@variable"]&&(l.hasVariable=!0,p.DATE_VARIABLES.indexOf(a["@variable"])>-1&&(l.variables=s.pop()));u=i||t[t.build.area].tokens,p.Node[r].build.call(l,t,u,!0)}else(n=t.cslXml.content(this))&&(t.build.text=n)},p.DateParser=function(){for(var t=[["明治",1867],["大正",1911],["昭和",1925],["平成",1988]],e=0,i=t.length;e<i;e++){t[e][0];var s=t[e][1]}var r=[],n={};for(e=0,i=t.length;e<i;e++){var a=t[e];s=a[0];r.push(s),n[a[0]]=a[1]}var o=r.join("|"),l=new RegExp("(?:"+o+")(?:[0-9]+)"),u=new RegExp("(?:"+o+")(?:[0-9]+)","g"),h=/(\u6708|\u5E74)/g,c=/\u65E5/g,m=/\u301c/g,f="([?0-9]{4}(?:%%NUMD%%[?0-9]{1,2}){0,2}(?![0-9])|(?:[?0-9]{1,2}%%NUMD%%){0,2}[?0-9]{4}(?![0-9])|[?0-9]{1,3}|[%%DATED%%]|[?~]|[^-/~?0-9]+)",d=new RegExp(f.replace(/%%NUMD%%/g,"-").replace(/%%DATED%%/g,"-")),g=new RegExp(f.replace(/%%NUMD%%/g,"-").replace(/%%DATED%%/g,"/")),b=new RegExp(f.replace(/%%NUMD%%/g,"/").replace(/%%DATED%%/g,"-"));this.monthStrings="january february march april may june july august september october november december spring summer fall winter spring summer".split(" "),this.setOrderDayMonth=function(){this.monthGuess=1,this.dayGuess=0},this.setOrderMonthDay=function(){this.monthGuess=0,this.dayGuess=1},this.resetDateParserMonths=function(){this.monthSets=[];for(var t=0,e=this.monthStrings.length;t<e;t++)this.monthSets.push([this.monthStrings[t]]);this.monthAbbrevs=[];for(t=0,e=this.monthSets.length;t<e;t++){this.monthAbbrevs.push([]);for(var i=0,s=this.monthSets[t].length;i<s;i++)this.monthAbbrevs[t].push(this.monthSets[t][0].slice(0,3))}this.monthRexes=[];for(t=0,e=this.monthAbbrevs.length;t<e;t++)this.monthRexes.push(new RegExp("(?:"+this.monthAbbrevs[t].join("|")+")"))},this.addDateParserMonths=function(t){if("string"==typeof t&&(t=t.split(/\s+/)),12===t.length||16===t.length){for(var e=0,i=t.length;e<i;e++){for(var s=null,r=!1,n=3,a={},o=0,l=this.monthAbbrevs.length;o<l;o++){if(a[o]={},o===e){for(var u=0,h=this.monthAbbrevs[e].length;u<h;u++)if(this.monthAbbrevs[e][u]===t[e].slice(0,this.monthAbbrevs[e][u].length)){r=!0;break}}else for(u=0,h=this.monthAbbrevs[o].length;u<h;u++)if(s=this.monthAbbrevs[o][u].length,this.monthAbbrevs[o][u]===t[e].slice(0,s)){for(;this.monthSets[o][u].slice(0,s)===t[e].slice(0,s);){if(s>t[e].length||s>this.monthSets[o][u].length){p.debug("unable to disambiguate month string in date parser: "+t[e]);break}s+=1}n=s,a[o][u]=s}for(var c in a)for(var m in a[c])s=a[c][m],c=parseInt(c,10),m=parseInt(m,10),this.monthAbbrevs[c][m]=this.monthSets[c][m].slice(0,s)}r||(this.monthSets[e].push(t[e]),this.monthAbbrevs[e].push(t[e].slice(0,n)))}this.monthRexes=[],this.monthRexStrs=[];for(e=0,i=this.monthAbbrevs.length;e<i;e++)this.monthRexes.push(new RegExp("^(?:"+this.monthAbbrevs[e].join("|")+")")),this.monthRexStrs.push("^(?:"+this.monthAbbrevs[e].join("|")+")");if(18===this.monthAbbrevs.length)for(e=12,i=14;e<i;e++)this.monthRexes[e+4]=new RegExp("^(?:"+this.monthAbbrevs[e].join("|")+")"),this.monthRexStrs[e+4]="^(?:"+this.monthAbbrevs[e].join("|")+")"}else p.debug("month [+season] list of "+t.length+", expected 12 or 16. Ignoring.")},this.convertDateObjectToArray=function(t){t["date-parts"]=[],t["date-parts"].push([]);for(var e,i=0,s=0,r=3;s<r&&t[e=["year","month","day"][s]];s++)i+=1,t["date-parts"][0].push(t[e]),delete t[e];t["date-parts"].push([]);for(s=0,r=i;s<r&&t[e=["year_end","month_end","day_end"][s]];s++)t["date-parts"][1].push(t[e]),delete t[e];return t["date-parts"][0].length!==t["date-parts"][1].length&&t["date-parts"].pop(),t},this.convertDateObjectToString=function(t){for(var e=[],i=0;i<3&&t[p.DATE_PARTS_ALL[i]];i+=1)e.push(t[p.DATE_PARTS_ALL[i]]);return e.join("-")},this._parseNumericDate=function(t,e,i,s){i||(i="");for(var r=s.split(e),n=0,a=r.length;n<a;n++)if(4===r[n].length){t["year"+i]=r[n].replace(/^0*/,""),r=n?r.slice(0,n):r.slice(1);break}for(n=0,a=r.length;n<a;n++)r[n]=parseInt(r[n],10);1===r.length||2===r.length&&!r[1]?t["month"+i]=""+r[0]:2===r.length&&(r[this.monthGuess]>12?(t["month"+i]=""+r[this.dayGuess],t["day"+i]=""+r[this.monthGuess]):(t["month"+i]=""+r[this.monthGuess],t["day"+i]=""+r[this.dayGuess]))},this.parseDateToObject=function(t){var e,i=t,s=-1,r=-1,a=!1;if(t){if("-"===t.slice(0,1)&&(a=!0,t=t.slice(1)),t.match(/^[0-9]{1,3}$/))for(;t.length<4;)t="0"+t;if(E=(t=(t=""+t).replace(/\s*[0-9]{2}:[0-9]{2}(?::[0-9]+)/,"")).match(h)){var o=(t=(t=(t=(t=(t=(t=t.replace(/\s+/g,"")).replace(c,"")).replace(h,"-")).replace(m,"/")).replace(/\-\//g,"/")).replace(/-$/g,"")).split(l);e=[];var f=t.match(u);if(f){for(var _=[],v=0,y=f.length;v<y;v++)_=_.concat(f[v].match(/([^0-9]+)([0-9]+)/).slice(1));for(v=0,y=o.length;v<y;v++)if(e.push(o[v]),v!==y-1){var x=2*v;e.push(_[x]),e.push(_[x+1])}}else e=o;for(v=1,y=e.length;v<y;v+=3)e[v+1]=n[e[v]]+parseInt(e[v+1],10),e[v]="";s=(t=(t=(t=(t=e.join("")).replace(/\s*-\s*$/,"").replace(/\s*-\s*\//,"/")).replace(/\.\s*$/,"")).replace(/\.(?! )/,"")).indexOf("/"),r=t.indexOf("-")}}var I,S,O="",T="",N={};if('"'===(t=t.replace(/([A-Za-z])\./g,"$1")).slice(0,1)&&'"'===t.slice(-1))return N.literal=t.slice(1,-1),N;s>-1&&r>-1?t.split("/").length>3?(I="-",S="/",e=(t=t.replace(/\_/g,"-")).split(b)):(I="/",S="-",e=(t=t.replace(/\_/g,"/")).split(g)):(I="-",S="-",e=(t=(t=t.replace(/\//g,"-")).replace(/\_/g,"-")).split(d));var A=[];for(v=0,y=e.length;v<y;v++){var E;(E=e[v].match(/^\s*([\-\/]|[^\-\/\~\?0-9]+|[\-~?0-9]+)\s*$/))&&A.push(E[1])}var k=A.indexOf(I),R=[],w=!1;k>-1?(R.push([0,k]),R.push([k+1,A.length]),w=!0):R.push([0,A.length]);var L="";for(v=0,y=R.length;v<y;v++){var C=R[v],j=A.slice(C[0],C[1]);t:for(var P=0,D=j.length;P<D;P++){var U=j[P];if(U.indexOf(S)>-1)this._parseNumericDate(N,S,L,U);else if(U.match(/[0-9]{4}/))N["year"+L]=U.replace(/^0*/,"");else{("~"===U||"?"===U||"c"===U||U.match(/^cir/))&&(N.circa=!0);for(var M=0,B=this.monthRexes.length;M<B;M++)if(U.toLocaleLowerCase().match(this.monthRexes[M])){N["month"+L]=""+(parseInt(M,10)+1);continue t}U.match(/^[0-9]+$/)&&(O=U),U.toLocaleLowerCase().match(/^bc/)&&O?(N["year"+L]=""+-1*O,O=""):U.toLocaleLowerCase().match(/^ad/)&&O?(N["year"+L]=""+O,O=""):!U.toLocaleLowerCase().match(/(?:mic|tri|hil|eas)/)||N["season"+L]||(T=U)}}O&&(N["day"+L]=O,O=""),T&&!N["season"+L]&&(N["season"+L]=T.trim(),T=""),L="_end"}if(w)for(P=0,D=p.DATE_PARTS_ALL.length;P<D;P++){var q=p.DATE_PARTS_ALL[P];N[q]&&!N[q+"_end"]?N[q+"_end"]=N[q]:!N[q]&&N[q+"_end"]&&(N[q]=N[q+"_end"])}(!N.year||N.year&&N.day&&!N.month)&&(N={literal:i});var X=["year","month","day","year_end","month_end","day_end"];for(v=0,y=X.length;v<y;v++){var G=X[v];"string"==typeof N[G]&&N[G].match(/^[0-9]+$/)&&(N[G]=parseInt(N[G],10))}return a&&Object.keys(N).indexOf("year")>-1&&(N.year=-1*N.year),N},this.parseDateToArray=function(t){return this.convertDateObjectToArray(this.parseDateToObject(t))},this.parseDateToString=function(t){return this.convertDateObjectToString(this.parseDateToObject(t))},this.parse=function(t){return this.parseDateToObject(t)},this.setOrderMonthDay(),this.resetDateParserMonths()},p.DateParser=new p.DateParser,p.Engine=function(t,e,i,s){var r,n;for(var a in this.processor_version=p.PROCESSOR_VERSION,this.csl_version="1.0",this.sys=t,"function"!=typeof Object.assign&&Object.defineProperty(Object,"assign",{value:function(t){if(null==t)throw new TypeError("Cannot convert undefined or null to object");for(var e=Object(t),i=1;i<arguments.length;i++){var s=arguments[i];if(null!=s)for(var r in s)Object.prototype.hasOwnProperty.call(s,r)&&(e[r]=s[r])}return e},writable:!0,configurable:!0}),t.variableWrapper&&(p.VARIABLE_WRAPPER_PREPUNCT_REX=new RegExp("^(["+[" "].concat(p.SWAPPING_PUNCTUATION).join("")+"]*)(.*)")),p.retrieveStyleModule&&(this.sys.retrieveStyleModule=p.retrieveStyleModule),p.getAbbreviation&&(this.sys.getAbbreviation=p.getAbbreviation),this.sys.stringCompare&&(p.stringCompare=this.sys.stringCompare),this.sys.AbbreviationSegments=p.AbbreviationSegments,this.transform=new p.Transform(this),this.setParseNames=function(t){this.opt["parse-names"]=t},this.opt=new p.Engine.Opt,this.tmp=new p.Engine.Tmp,this.build=new p.Engine.Build,this.fun=new p.Engine.Fun(this),this.configure=new p.Engine.Configure,this.citation_sort=new p.Engine.CitationSort,this.bibliography_sort=new p.Engine.BibliographySort,this.citation=new p.Engine.Citation(this),this.bibliography=new p.Engine.Bibliography,this.intext=new p.Engine.InText,this.output=new p.Output.Queue(this),this.dateput=new p.Output.Queue(this),this.cslXml=p.setupXml(e),p.SYS_OPTIONS){var o=p.SYS_OPTIONS[a];"boolean"==typeof this.sys[o]&&(this.opt.development_extensions[o]=this.sys[o])}(this.opt.development_extensions.uppercase_subtitles||this.opt.development_extensions.implicit_short_title)&&(this.opt.development_extensions.main_title_from_short_title=!0),this.opt.development_extensions.csl_reverse_lookup_support&&(this.build.cslNodeId=0,this.setCslNodeIds=function(t,e){var i=this.cslXml.children(t);this.cslXml.setAttribute(t,"cslid",this.build.cslNodeId),this.opt.nodenames.push(e),this.build.cslNodeId+=1;for(var s=0,r=this.cslXml.numberofnodes(i);s<r;s+=1)(e=this.cslXml.nodename(i[s]))&&this.setCslNodeIds(i[s],e)},this.setCslNodeIds(this.cslXml.dataObj,"style")),this.cslXml.addMissingNameNodes(this.cslXml.dataObj),this.cslXml.addInstitutionNodes(this.cslXml.dataObj),this.cslXml.insertPublisherAndPlace(this.cslXml.dataObj),this.cslXml.flagDateMacros(this.cslXml.dataObj),void 0===this.cslXml.attributes(this.cslXml.dataObj)["@sort-separator"]&&this.cslXml.setAttribute(this.cslXml.dataObj,"sort-separator",", "),this.opt["initialize-with-hyphen"]=!0,this.setStyleAttributes(),this.opt.xclass=this.cslXml.getAttributeValue(this.cslXml.dataObj,"class"),this.opt.class=this.opt.xclass,this.opt.styleID=this.cslXml.getStyleId(this.cslXml.dataObj),this.opt.styleName=this.cslXml.getStyleId(this.cslXml.dataObj,!0),"1.1m"===this.opt.version.slice(0,4)&&(this.opt.development_extensions.static_statute_locator=!0,this.opt.development_extensions.handle_parallel_articles=!0,this.opt.development_extensions.main_title_from_short_title=!0,this.opt.development_extensions.expect_and_symbol_form=!0,this.opt.development_extensions.require_explicit_legal_case_title_short=!0,this.opt.development_extensions.force_jurisdiction=!0),i&&(i=i.replace("_","-"),i=p.normalizeLocaleStr(i)),this.opt["default-locale"][0]&&(this.opt["default-locale"][0]=this.opt["default-locale"][0].replace("_","-"),this.opt["default-locale"][0]=p.normalizeLocaleStr(this.opt["default-locale"][0])),i&&s&&(this.opt["default-locale"]=[i]),i&&!s&&this.opt["default-locale"][0]&&(i=this.opt["default-locale"][0]),0===this.opt["default-locale"].length&&(i||(i="en-US"),this.opt["default-locale"].push("en-US")),i||(i=this.opt["default-locale"][0]),r=p.localeResolve(i),this.opt.lang=r.best,this.opt["default-locale"][0]=r.best,this.locale={},this.opt["default-locale-sort"]||(this.opt["default-locale-sort"]=this.opt["default-locale"][0]),"dale|".localeCompare("daleb",this.opt["default-locale-sort"])>-1?this.opt.sort_sep="@":this.opt.sort_sep="|",this.localeConfigure(r),this.locale[this.opt.lang].opts["skip-words-regexp"]=(n=(n=this.locale[this.opt.lang].opts["skip-words"]).slice(),new RegExp("(?:(?:[?!:]*\\s+|-|^)(?:"+n.join("|")+")(?=[!?:]*\\s+|-|$))","g")),this.output.adjust=new p.Output.Queue.adjust(this.getOpt("punctuation-in-quote")),this.registry=new p.Registry(this),this.macros={},this.build.area="citation";var l=this.cslXml.getNodesByName(this.cslXml.dataObj,this.build.area);this.buildTokenLists(l,this[this.build.area].tokens),this.build.area="bibliography";l=this.cslXml.getNodesByName(this.cslXml.dataObj,this.build.area);this.buildTokenLists(l,this[this.build.area].tokens),this.build.area="intext";l=this.cslXml.getNodesByName(this.cslXml.dataObj,this.build.area);this.buildTokenLists(l,this[this.build.area].tokens),this.opt.parallel.enable&&(this.parallel=new p.Parallel(this)),this.juris={},this.configureTokenLists(),this.disambiguate=new p.Disambiguation(this),this.splice_delimiter=!1,this.fun.dateparser=p.DateParser,this.fun.flipflopper=new p.Util.FlipFlopper(this),this.setCloseQuotesArray(),this.fun.ordinalizer.init(this),this.fun.long_ordinalizer.init(this),this.fun.page_mangler=p.Util.PageRangeMangler.getFunction(this,"page"),this.fun.year_mangler=p.Util.PageRangeMangler.getFunction(this,"year"),this.setOutputFormat("html")},p.Engine.prototype.setCloseQuotesArray=function(){var t;(t=[]).push(this.getTerm("close-quote")),t.push(this.getTerm("close-inner-quote")),t.push('"'),t.push("'"),this.opt.close_quotes_array=t},p.makeBuilder=function(t,e){var i=[],s=[];function r(r){s.push(r),p.XmlToToken.call(r,t,p.START,e,i)}function n(){var r=s.pop();p.XmlToToken.call(r,t,p.END,e,i)}function a(s){p.XmlToToken.call(s,t,p.SINGLETON,e,i)}return function e(i,s,o){i||(i=[]),void 0===i.length&&(i=[i]);for(var l=0;l<i.length;l++){var u=i[l];null!==t.cslXml.nodename(u)&&(s&&"date"===t.cslXml.nodename(u)&&(p.Util.fixDateNode.call(t,s,l,u),u=t.cslXml.children(s)[l]),t.cslXml.numberofnodes(t.cslXml.children(u))?(r(u),e(t.cslXml.children(u),u),n()):a(u))}}},p.Engine.prototype.buildTokenLists=function(t,e){this.cslXml.getNodeValue(t)&&p.makeBuilder(this,e)(void 0===t.length?t:t[0])},p.Engine.prototype.setStyleAttributes=function(){var t,e,i={};for(e in i.name=this.cslXml.nodename(this.cslXml.dataObj),t=this.cslXml.attributes(this.cslXml.dataObj))t.hasOwnProperty(e)&&p.Attributes[e].call(i,this,t[e])},p.Engine.prototype.getTerm=function(t,e,i,s,r,n){var a;t&&t.match(/[A-Z]/)&&t===t.toUpperCase()&&(p.debug("Warning: term key is in uppercase form: "+t),t=t.toLowerCase()),a=n?this.opt["default-locale"][0]:this.opt.lang;var o=p.Engine.getField(p.LOOSE,this.locale[a].terms,t,e,i,s);return o||"range-delimiter"!==t||(o="–"),void 0===o&&(r===p.STRICT?p.error('Error in getTerm: term "'+t+'" does not exist.'):r===p.TOLERANT&&(o="")),o&&(this.tmp.cite_renders_content=!0),o},p.Engine.prototype.getDate=function(t,e){var i;return i=e?this.opt["default-locale"]:this.opt.lang,!!this.locale[i].dates[t]&&this.locale[i].dates[t]},p.Engine.prototype.getOpt=function(t){return void 0!==this.locale[this.opt.lang].opts[t]&&this.locale[this.opt.lang].opts[t]},p.Engine.prototype.getVariable=function(t,e,i,s){return p.Engine.getField(p.LOOSE,t,e,i,s)},p.Engine.prototype.getDateNum=function(t,e){return void 0===t?0:t[e]},p.Engine.getField=function(t,e,i,s,r,n){var a,o,l,u,h,c;if(a="",void 0===e[i]){if(t!==p.STRICT)return;p.error('Error in getField: term "'+i+'" does not exist.')}for(c=n&&e[i][n]?e[i][n]:e[i],o=[],"symbol"===s?o=["symbol","short"]:"verb-short"===s?o=["verb-short","verb"]:"long"!==s&&(o=[s]),h=(o=o.concat(["long"])).length,u=0;u<h;u+=1)if(l=o[u],"string"==typeof c||"number"==typeof c)a=c;else if(void 0!==c[l]){a="string"==typeof c[l]||"number"==typeof c[l]?c[l]:"number"==typeof r?c[l][r]:c[l][0];break}return a},p.Engine.prototype.configureTokenLists=function(){var t,e;for(e=p.AREAS.length,t=0;t<e;t+=1){var i=this[p.AREAS[t]].tokens;this.configureTokenList(i)}return this.version=p.version,this.state},p.Engine.prototype.configureTokenList=function(t){var e,i,s,r,n,a;for(e=["year","month","day"],r=t.length-1;r>-1;r+=-1){if("date"===(i=t[r]).name&&p.END===i.tokentype&&(s=[]),"date-part"===i.name&&i.strings.name)for(a=e.length,n=0;n<a;n+=1)e[n]===i.strings.name&&s.push(i.strings.name);"date"===i.name&&p.START===i.tokentype&&(s.reverse(),i.dateparts=s),i.next=r+1,i.name&&p.Node[i.name].configure&&p.Node[i.name].configure.call(i,this,r)}},p.Engine.prototype.refetchItems=function(t){for(var e=[],i=0,s=t.length;i<s;i+=1)e.push(this.refetchItem(""+t[i]));return e},p.ITERATION=0,p.Engine.prototype.retrieveItem=function(t){var e,i;if(this.tmp.loadedItemIDs[t])return this.registry.refhash[t];if(this.tmp.loadedItemIDs[t]=!0,this.opt.development_extensions.normalize_lang_keys_to_lowercase&&"boolean"==typeof this.opt.development_extensions.normalize_lang_keys_to_lowercase){for(var s=0,r=this.opt["default-locale"].length;s<r;s+=1)this.opt["default-locale"][s]=this.opt["default-locale"][s].toLowerCase();for(s=0,r=this.opt["locale-translit"].length;s<r;s+=1)this.opt["locale-translit"][s]=this.opt["locale-translit"][s].toLowerCase();for(s=0,r=this.opt["locale-translat"].length;s<r;s+=1)this.opt["locale-translat"][s]=this.opt["locale-translat"][s].toLowerCase();this.opt.development_extensions.normalize_lang_keys_to_lowercase=100}if(p.ITERATION+=1,e=JSON.parse(JSON.stringify(this.sys.retrieveItem(""+t))),this.opt.development_extensions.normalize_lang_keys_to_lowercase){if(e.multi){if(e.multi._keys)for(var n in e.multi._keys)for(var a in e.multi._keys[n])a!==a.toLowerCase()&&(e.multi._keys[n][a.toLowerCase()]=e.multi._keys[n][a],delete e.multi._keys[n][a]);if(e.multi.main)for(var n in e.multi.main)e.multi.main[n]=e.multi.main[n].toLowerCase()}for(s=0,r=p.NAME_VARIABLES.length;s>r;s+=1){var o=p.NAME_VARIABLES[s];if(e[o]&&e[o].multi)for(var l=0,u=e[o].length;l<u;l+=1){var h=e[o][l];if(h.multi){if(h.multi._key)for(var a in h.multi._key)a!==a.toLowerCase()&&(h.multi._key[a.toLowerCase()]=h.multi._key[a],delete h.multi._key[a]);h.multi.main&&(h.multi.main=h.multi.main.toLowerCase())}}}}e.language&&e.language.match(/[><]/)&&("<"===(i=e.language.match(/(.*?)([<>])(.*)/))[2]?(e["language-name"]=i[1],e["language-name-original"]=i[3]):(e["language-name"]=i[3],e["language-name-original"]=i[1]),this.opt.multi_layout?e["language-name-original"]&&(e.language=e["language-name-original"]):e["language-name"]&&(e.language=e["language-name"]));e.page&&(e["page-first"]=e.page,"\\"!==(i=(""+e.page).split(/\s*(?:&|, |-|\u2013)\s*/))[0].slice(-1)&&(e["page-first"]=i[0]));for(var a in this.opt.development_extensions.field_hack&&e.note&&p.parseNoteFieldHacks(e,!1,this.opt.development_extensions.allow_field_hack_date_override),e)if(p.DATE_VARIABLES.indexOf(a.replace(/^alt-/,""))>-1){var c=e[a];c&&(this.opt.development_extensions.raw_date_parsing&&(!c.raw||c["date-parts"]&&0!==c["date-parts"].length||(c=this.fun.dateparser.parseDateToObject(c.raw))),e[a]=this.dateParseArray(c))}if(this.opt.development_extensions.static_statute_locator&&e.type&&["bill","gazette","legislation","regulation","treaty"].indexOf(e.type)>-1){var m,f=["type","title","jurisdiction","genre","volume","container-title"],d=[];for(s=0,r=f.length;s<r;s+=1)e[m=f[s]]&&d.push(e[m]);for(s=0,r=(f=["original-date","issued"]).length;s<r;s+=1)if(e[m=f[s]]&&e[m].year){var g=e[m].year;d.push(g);break}e.legislation_id=d.join("::")}if(this.opt.development_extensions.force_jurisdiction&&"string"==typeof e.authority&&(e.authority=[{literal:e.authority,multi:{_key:{}}}],e.multi&&e.multi._keys&&e.multi._keys.authority))for(var a in e.authority[0].multi._key={},e.multi._keys.authority)e.authority[0].multi._key[a]={literal:e.multi._keys.authority[a]};if(e["title-short"]||(e["title-short"]=e.shortTitle),this.opt.development_extensions.main_title_from_short_title){var b="fr"===this.opt["default-locale"][0].slice(0,2).toLowerCase();p.extractTitleAndSubtitle.call(this,e,b)}var _,v=["bill","legal_case","legislation","gazette","regulation"].indexOf(e.type)>-1;if(this.opt.development_extensions.force_jurisdiction&&v&&(e.jurisdiction||(e.jurisdiction="us")),!v&&e.title&&this.sys.getAbbreviation){e.jurisdiction,_=this.sys.normalizeAbbrevsKey?this.sys.normalizeAbbrevsKey(e.title):e.title;var y=this.transform.loadAbbreviation(e.jurisdiction,"title",_,e.type);this.transform.abbrevs[y].title&&this.transform.abbrevs[y].title[_]&&(e["title-short"]=this.transform.abbrevs[y].title[_])}if(e["container-title-short"]||(e["container-title-short"]=e.journalAbbreviation),e["container-title"]&&this.sys.getAbbreviation){_=this.sys.normalizeAbbrevsKey?this.sys.normalizeAbbrevsKey(e["container-title"]):e["container-title"];y=this.transform.loadAbbreviation(e.jurisdiction,"container-title",_);this.transform.abbrevs[y]["container-title"]&&this.transform.abbrevs[y]["container-title"][_]&&(e["container-title-short"]=this.transform.abbrevs[y]["container-title"][_])}if(e.jurisdiction&&(e.country=e.jurisdiction.split(":")[0]),this.registry.refhash[t]){if(JSON.stringify(this.registry.refhash[t])!=JSON.stringify(e)){for(var a in this.registry.refhash[t])delete this.registry.refhash[t][a];this.tmp.taintedItemIDs[e.id]=!0,Object.assign(this.registry.refhash[t],e)}}else this.registry.refhash[t]=e;return this.registry.refhash[t]},p.Engine.prototype.refetchItem=function(t){return this.registry.refhash[t]},p.Engine.prototype.refetchItem=function(t){return this.registry.refhash[t]},p.Engine.prototype.setOpt=function(t,e,i){"style"===t.name||"cslstyle"===t.name?(this.opt.inheritedAttributes[e]=i,this.citation.opt.inheritedAttributes[e]=i,this.bibliography.opt.inheritedAttributes[e]=i):["citation","bibliography"].indexOf(t.name)>-1?this[t.name].opt.inheritedAttributes[e]=i:t.strings[e]=i},p.Engine.prototype.inheritOpt=function(t,e,i,s){if(void 0!==t.strings[e])return t.strings[e];var r=this[this.tmp.root].opt.inheritedAttributes[i||e];return void 0!==r?r:s},p.Engine.prototype.remapSectionVariable=function(t){for(var e=0,i=t.length;e<i;e+=1){var s=t[e][0],r=t[e][1];if(["bill","gazette","legislation","regulation","treaty"].indexOf(s.type)>-1){if(r.locator)r.locator=r.locator.trim(),(a=r.locator.match(p.STATUTE_SUBDIV_PLAIN_REGEX_FRONT))||(r.label?r.locator=p.STATUTE_SUBDIV_STRINGS_REVERSE[r.label]+" "+r.locator:r.locator="p. "+r.locator);var n=null;if(s.section)s.section=s.section.trim(),(a=s.section.match(p.STATUTE_SUBDIV_PLAIN_REGEX_FRONT))?n=a[0].trim():(s.section="sec. "+s.section,n="sec.");if(s.section)if(r.locator){var a,o=" ";(a=r.locator.match(/^([^ ]*)\s*(.*)/))?("p."===a[1]&&"p."!==n&&(r.locator=a[2]),["[","(",".",",",";",":","?"].indexOf(r.locator.slice(0,1))>-1&&(o="")):o="",r.locator=s.section+o+r.locator}else r.locator=s.section;r.label=""}}},p.Engine.prototype.setNumberLabels=function(t){if(t.number&&["bill","gazette","legislation","regulation","treaty"].indexOf(t.type)>-1&&this.opt.development_extensions.static_statute_locator&&!this.tmp.shadow_numbers.number){this.tmp.shadow_numbers.number={},this.tmp.shadow_numbers.number.values=[],this.tmp.shadow_numbers.number.plural=0,this.tmp.shadow_numbers.number.numeric=!1,this.tmp.shadow_numbers.number.label=!1;var e=""+t.number,i=(e=e.split("\\").join("")).split(/\s+/)[0],s=p.STATUTE_SUBDIV_STRINGS[i];if(s){var r=e.split(p.STATUTE_SUBDIV_PLAIN_REGEX);if(r.length>1){for(var n=[],a=1,o=r.length;a<o;a+=1)n.push(r[a].replace(/\s*$/,"").replace(/^\s*/,""));e=n.join(" ")}else e=r[0];this.tmp.shadow_numbers.number.label=s,this.tmp.shadow_numbers.number.values.push(["Blob",e,!1]),this.tmp.shadow_numbers.number.numeric=!1}else this.tmp.shadow_numbers.number.values.push(["Blob",e,!1]),this.tmp.shadow_numbers.number.numeric=!0}},p.substituteOne=function(t){return function(e,i){return i?t.replace("%%STRING%%",i):""}},p.substituteTwo=function(t){return function(e){var i=t.replace("%%PARAM%%",e);return function(t,e){return e?i.replace("%%STRING%%",e):""}}},p.Mode=function(t){var e,i,s,r,n,a;for(s in e={},i=p.Output.Formats[t])"@"===s.slice(0,1)?(r=!1,n=i[s],a=s.split("/"),"string"==typeof n&&n.indexOf("%%STRING%%")>-1?r=n.indexOf("%%PARAM%%")>-1?p.substituteTwo(n):p.substituteOne(n):"boolean"!=typeof n||n?"function"==typeof n?r=n:p.error("Bad "+t+" config entry for "+s+": "+n):r=p.Output.Formatters.passthrough,1===a.length?e[a[0]]=r:2===a.length&&(e[a[0]]||(e[a[0]]={}),e[a[0]][a[1]]=r)):e[s]=i[s];return e},p.setDecorations=function(t,e){var i,s;for(s in i=[],p.FORMAT_KEY_SEQUENCE){var r;e[r=p.FORMAT_KEY_SEQUENCE[s]]&&(i.push([r,e[r]]),delete e[r])}return i},p.Doppeler=function(t,e){var i=new RegExp("("+t+")","g"),s=new RegExp(t,"g");this.split=function(t){e&&(t=e(t));var r=t.match(i);if(!r)return{tags:[],strings:[t]};for(var n=t.split(s),a=r.length-1;a>-1;a--){"number"==typeof r[a]&&(r[a]=""),"'"===r[a]&&n[a+1].length>0&&(n[a+1]=r[a]+n[a+1],r[a]="")}return{tags:r,strings:n,origStrings:n.slice()}},this.join=function(t){for(var e=t.strings.slice(-1),i=t.tags.length-1;i>-1;i--)e.push(t.tags[i]),e.push(t.strings[i]);return e.reverse(),e.join("")}},p.Engine.prototype.normalDecorIsOrphan=function(t,e){if("normal"===e[1]){for(var i,s=!1,r=(i="citation"===this.tmp.area?[this.citation.opt.layout_decorations].concat(t.alldecor):t.alldecor).length-1;r>-1;r+=-1)for(var n=i[r].length-1;n>-1;n+=-1)i[r][n][0]===e[0]&&"normal"!==i[r][n][1]&&(s=!0);if(!s)return!0}return!1},p.Engine.prototype.getCitationLabel=function(t){var e="",i=this.getTrigraphParams(),s=i[0],r=this.getTerm("reference","short",0);void 0===r&&(r="reference"),r=(r=r.replace(".","")).slice(0,1).toUpperCase()+r.slice(1);for(var n=0,a=p.NAME_VARIABLES.length;n<a;n+=1){var o=p.NAME_VARIABLES[n];if(t[o]){var l=t[o];s=l.length>i.length?i[i.length-1]:i[l.length-1];for(var u=0,h=l.length;u<h&&u!==s.authors.length;u+=1){var c=this.nameOutput.getName(l[u],"locale-translit",!0).name;c&&c.family?r=(r=c.family).replace(/^([ \'\u2019a-z]+\s+)/,""):c&&c.literal&&(r=c.literal);var m=r.toLowerCase().match(/^(a\s+|the\s+|an\s+)/);if(m&&(r=r.slice(m[1].length)),!(r=r.replace(p.ROMANESQUE_NOT_REGEXP,"")))break;(r=r.slice(0,s.authors[u])).length>1?r=r.slice(0,1).toUpperCase()+r.slice(1).toLowerCase():1===r.length&&(r=r.toUpperCase()),e+=r}break}}if(!e&&t.title){var f=this.locale[this.opt.lang].opts["skip-words"],d=t.title.split(/\s+/);for(n=d.length-1;n>-1;n--)f.indexOf(d[n])>-1&&(d=d.slice(0,n).concat(d.slice(n+1)));var g=d.join("");(g=g.slice(0,i[0].authors[0])).length>1?g=g.slice(0,1).toUpperCase()+g.slice(1).toLowerCase():1===g.length&&(g=g.toUpperCase()),e=g}var b="0000";return t.issued&&t.issued.year&&(b=""+t.issued.year),e+=b=b.slice(-1*s.year)},p.Engine.prototype.getTrigraphParams=function(){var t=[],e=this.opt.trigraph.split(":");this.opt.trigraph&&"A"===this.opt.trigraph.slice(0,1)||p.error("Bad trigraph definition: "+this.opt.trigraph);for(var i=0,s=e.length;i<s;i+=1){for(var r=e[i],n={authors:[],year:0},a=0,o=r.length;a<o;a+=1)switch(r.slice(a,a+1)){case"A":n.authors.push(1);break;case"a":n.authors[n.authors.length-1]+=1;break;case"0":n.year+=1;break;default:p.error("Invalid character in trigraph definition: "+this.opt.trigraph)}t.push(n)}return t},p.Engine.prototype.setOutputFormat=function(t){this.opt.mode=t,this.fun.decorate=p.Mode(t),this.output[t]||(this.output[t]={},this.output[t].tmp={})},p.Engine.prototype.getSortFunc=function(){return function(t,e){return t=t.split("-"),e=e.split("-"),t.length<e.length?1:t.length>e.length?-1:(t=t.slice(-1)[0],e=e.slice(-1)[0],t.length<e.length?1:t.length>e.length?-1:0)}},p.Engine.prototype.setLangTagsForCslSort=function(t){var e,i;if(t)for(this.opt["locale-sort"]=[],e=0,i=t.length;e<i;e+=1)this.opt["locale-sort"].push(t[e]);this.opt["locale-sort"].sort(this.getSortFunc())},p.Engine.prototype.setLangTagsForCslTransliteration=function(t){var e,i;if(this.opt["locale-translit"]=[],t)for(e=0,i=t.length;e<i;e+=1)this.opt["locale-translit"].push(t[e]);this.opt["locale-translit"].sort(this.getSortFunc())},p.Engine.prototype.setLangTagsForCslTranslation=function(t){var e,i;if(this.opt["locale-translat"]=[],t)for(e=0,i=t.length;e<i;e+=1)this.opt["locale-translat"].push(t[e]);this.opt["locale-translat"].sort(this.getSortFunc())},p.Engine.prototype.setLangPrefsForCites=function(t,e){var i=this.opt["cite-lang-prefs"];e||(e=function(t){return t.toLowerCase()});for(var s=["Persons","Institutions","Titles","Journals","Publishers","Places"],r=0,n=s.length;r<n;r+=1){var a=e(s[r]),o=s[r].toLowerCase();if(t[a]){for(var l=[];t[a].length>1;)l.push(t[a].pop());var u={orig:1,translit:2,translat:3};for(2===l.length&&u[l[0]]<u[l[1]]&&l.reverse();l.length;)t[a].push(l.pop());for(var p=i[o];p.length;)p.pop();for(var h=0,c=t[a].length;h<c;h+=1)p.push(t[a][h])}}},p.Engine.prototype.setLangPrefsForCiteAffixes=function(t){if(t&&48===t.length){for(var e,i=this.opt.citeAffixes,s=0,r=["persons","institutions","titles","journals","publishers","places"],n=["translit","orig","translit","translat"],a=0,o=r.length;a<o;a+=1)for(var l=0,u=n.length;l<u;l+=1)e="",s%8==4&&(i[r[a]]["locale-"+n[l]].prefix||i[r[a]]["locale-"+n[l]].suffix)||(e=t[s]?t[s]:"",i[r[a]]["locale-"+n[l]].prefix=e,e=t[s]?t[s+1]:"",i[r[a]]["locale-"+n[l]].suffix=e),s+=2;this.opt.citeAffixes=i}},p.Engine.prototype.setAutoVietnameseNamesOption=function(t){this.opt["auto-vietnamese-names"]=!!t},p.Engine.prototype.setAbbreviations=function(t){this.sys.setAbbreviations&&this.sys.setAbbreviations(t)},p.Engine.prototype.setSuppressTrailingPunctuation=function(t){this.citation.opt.suppressTrailingPunctuation=!!t},p.Output={},p.Output.Queue=function(t){this.levelname=["top"],this.state=t,this.queue=[],this.empty=new p.Token("empty");var e={};e.empty=this.empty,this.formats=new p.Stack(e),this.current=new p.Stack(this.queue)},p.Output.Queue.prototype.pop=function(){var t=this.current.value();return t.length?t.pop():t.blobs.pop()},p.Output.Queue.prototype.getToken=function(t){return this.formats.value()[t]},p.Output.Queue.prototype.mergeTokenStrings=function(t,e){var i,s,r;if(r=i=this.formats.value()[t],s=this.formats.value()[e]){i||((i=new p.Token(t,p.SINGLETON)).decorations=[]),r=new p.Token(t,p.SINGLETON);var n="";for(var n in i.strings)i.strings.hasOwnProperty(n)&&(r.strings[n]=i.strings[n]);for(var n in s.strings)s.strings.hasOwnProperty(n)&&(r.strings[n]=s.strings[n]);r.decorations=i.decorations.concat(s.decorations)}return r},p.Output.Queue.prototype.addToken=function(t,e,i){var s,r;if(s=new p.Token("output"),"string"==typeof i&&(i=this.formats.value()[i]),i&&i.strings){for(r in i.strings)i.strings.hasOwnProperty(r)&&(s.strings[r]=i.strings[r]);s.decorations=i.decorations}"string"==typeof e&&(s.strings.delimiter=e),this.formats.value()[t]=s},p.Output.Queue.prototype.pushFormats=function(t){t||(t={}),t.empty=this.empty,this.formats.push(t)},p.Output.Queue.prototype.popFormats=function(){this.formats.pop()},p.Output.Queue.prototype.startTag=function(t,e){var i={};this.state.tmp["doing-macro-with-date"]&&this.state.tmp.extension&&(e=this.empty,t="empty"),i[t]=e,this.pushFormats(i),this.openLevel(t)},p.Output.Queue.prototype.endTag=function(t){this.closeLevel(t),this.popFormats()},p.Output.Queue.prototype.openLevel=function(t){var e,i;"object"==typeof t?e=new p.Blob(void 0,t):void 0===t?e=new p.Blob(void 0,this.formats.value().empty,"empty"):(this.formats.value()&&this.formats.value()[t]||p.error('CSL processor error: call to nonexistent format token "'+t+'"'),e=new p.Blob(void 0,this.formats.value()[t],t)),i=this.current.value(),!this.state.tmp.just_looking&&this.checkNestedBrace&&(e.strings.prefix=this.checkNestedBrace.update(e.strings.prefix)),i.push(e),this.current.push(e)},p.Output.Queue.prototype.closeLevel=function(t){t&&t!==this.current.value().levelname&&p.error("Level mismatch error:  wanted "+t+" but found "+this.current.value().levelname);var e=this.current.pop();!this.state.tmp.just_looking&&this.checkNestedBrace&&(e.strings.suffix=this.checkNestedBrace.update(e.strings.suffix))},p.Output.Queue.prototype.append=function(t,e,i,s,r){var n,a,o,l=!0;if(i&&(s=!0),this.state.tmp["doing-macro-with-date"]&&!i){if("macro-with-date"!==e)return!1;"macro-with-date"===e&&(e="empty")}if(void 0===t)return!1;if("number"==typeof t&&(t=""+t),!i&&this.state.tmp.element_trace&&"suppress-me"===this.state.tmp.element_trace.value())return!1;if(a=!1,e?"literal"===e?(n=!0,l=!1):n="string"==typeof e?this.formats.value()[e]:e:n=this.formats.value().empty,n||p.error("CSL processor error: unknown format token name: "+e),n.strings&&void 0===n.strings.delimiter&&(n.strings.delimiter=""),"string"==typeof t&&t.length&&(t=t.replace(/ ([:;?!\u00bb])/g," $1").replace(/\u00ab /g,"« "),this.last_char_rendered=t.slice(-1),t=t.replace(/\s+'/g," '"),i||(t=t.replace(/^'/g," '")),s?i&&(this.state.tmp.term_predecessor_name=!0):(this.state.tmp.term_predecessor=!0,this.state.tmp.in_cite_predecessor=!0)),a=new p.Blob(t,n),void 0===(o=this.current.value())&&0===this.current.mystack.length&&(this.current.mystack.push([]),o=this.current.value()),"string"==typeof a.blobs&&(s?i&&(this.state.tmp.term_predecessor_name=!0):(this.state.tmp.term_predecessor=!0,this.state.tmp.in_cite_predecessor=!0)),"string"==typeof t){if("string"==typeof a.blobs&&" "!==a.blobs.slice(0,1)){for(var u="",h=a.blobs;p.TERMINAL_PUNCTUATION.indexOf(h.slice(0,1))>-1;)u+=h.slice(0,1),h=h.slice(1);h&&u&&(a.strings.prefix=a.strings.prefix+u,a.blobs=h)}a.strings["text-case"]&&(a.blobs=p.Output.Formatters[a.strings["text-case"]](this.state,t)),this.state.tmp.strip_periods&&!r&&(a.blobs=a.blobs.replace(/\.([^a-z]|$)/g,"$1"));for(var c=a.decorations.length-1;c>-1;c+=-1)"@quotes"===a.decorations[c][0]&&"false"!==a.decorations[c][1]&&(a.punctuation_in_quote=this.state.getOpt("punctuation-in-quote")),a.blobs.match(p.ROMANESQUE_REGEXP)||"@font-style"===a.decorations[c][0]&&(a.decorations=a.decorations.slice(0,c).concat(a.decorations.slice(c+1)));o.push(a),this.state.fun.flipflopper.processTags(a)}else l?o.push(a):o.push(t);return!0},p.Output.Queue.prototype.string=function(t,e,i){var s,r=p.getSafeEscape(this.state),n=e.slice(),a=[];if(0===n.length)return a;var o,l,u,h,c="";i?c=i.strings.delimiter:(t.tmp.count_offset_characters=!1,t.tmp.offset_characters=0),i&&i.new_locale&&(i.old_locale=t.opt.lang,t.opt.lang=i.new_locale);for(var m=0,f=n.length;m<f;m+=1){if((o=n[m]).strings.first_blob&&(t.tmp.count_offset_characters=o.strings.first_blob),"string"==typeof o.blobs){if("number"==typeof o.num)a.push(o);else if(o.blobs){o.particle&&(o.blobs=o.particle+o.blobs,o.particle="");var d=(s=r(o.blobs)).length;if(!t.tmp.suppress_decorations)for(_=0,v=o.decorations.length;_<v;_+=1)"@showid"!==(h=o.decorations[_])[0]&&(t.normalDecorIsOrphan(o,h)||(s=t.fun.decorate[h[0]][h[1]].call(o,t,s,h[2])));if(s&&s.length){if(s=r(o.strings.prefix)+s+r(o.strings.suffix),t.opt.development_extensions.csl_reverse_lookup_support&&!t.tmp.suppress_decorations)for(_=0,v=o.decorations.length;_<v;_+=1)"@showid"===(h=o.decorations[_])[0]&&(s=t.fun.decorate[h[0]][h[1]].call(o,t,s,h[2]));a.push(s),t.tmp.count_offset_characters&&(t.tmp.offset_characters+=d+o.strings.suffix.length+o.strings.prefix.length)}}}else if(o.blobs.length){var g=t.output.string(t,o.blobs,o);if(i&&"string"!==g&&g.length>1&&o.strings.delimiter)for(var b=!1,_=0,v=g.length;_<v;_++)"string"!=typeof g[_]?b=!0:b&&(g[_]=o.strings.delimiter+g[_]);a=a.concat(g)}o.strings.first_blob&&t.registry.registry[o.strings.first_blob]&&(t.registry.registry[o.strings.first_blob].offset=t.tmp.offset_characters,t.tmp.count_offset_characters=!1)}for(m=0,f=a.length-1;m<f;m+=1)"number"!=typeof a[m].num||"number"!=typeof a[m+1].num||a[m+1].UGLY_DELIMITER_SUPPRESS_HACK||(a[m].strings.suffix=a[m].strings.suffix+(c||""),a[m+1].successor_prefix="",a[m+1].UGLY_DELIMITER_SUPPRESS_HACK=!0);var y=0;for(m=0,f=a.length;m<f;m+=1)"string"==typeof a[m]&&(y=parseInt(m,10)+1,m<a.length-1&&"object"==typeof a[m+1]&&(c&&!a[m+1].UGLY_DELIMITER_SUPPRESS_HACK&&(a[m]+=r(c)),a[m+1].UGLY_DELIMITER_SUPPRESS_HACK=!0));if(i&&(i.decorations.length||i.strings.suffix))y=a.length;else if(i&&i.strings.prefix)for(m=0,f=a.length;m<f;m++)if(void 0!==a[m].num){y=m,0===m&&(a[m].strings.prefix=i.strings.prefix+a[m].strings.prefix);break}var x=t.output.renderBlobs(a.slice(0,y),c,!1,i);if(x&&i&&(i.decorations.length||i.strings.suffix||i.strings.prefix)){if(!t.tmp.suppress_decorations)for(m=0,f=i.decorations.length;m<f;m+=1)h=i.decorations[m],["@cite","@bibliography","@display","@showid"].indexOf(h[0])>-1||t.normalDecorIsOrphan(o,h)||"string"==typeof x&&(x=t.fun.decorate[h[0]][h[1]].call(i,t,x,h[2]));if(s=x,l=i.strings.suffix,s&&s.length&&(s=r(u=i.strings.prefix)+s+r(l),t.tmp.count_offset_characters&&(t.tmp.offset_characters+=u.length+l.length)),x=s,!t.tmp.suppress_decorations)for(m=0,f=i.decorations.length;m<f;m+=1)h=i.decorations[m],-1!==["@cite","@bibliography","@display","@showid"].indexOf(h[0])&&"string"==typeof x&&(x=t.fun.decorate[h[0]][h[1]].call(i,t,x,h[2]))}var I=a.slice(y,a.length);return!I.length&&x?a=[x]:I.length&&!x?a=I:x&&I.length&&(a=[x].concat(I)),void 0===i?(this.queue=[],this.current.mystack=[],this.current.mystack.push(this.queue),t.tmp.suppress_decorations&&(a=t.output.renderBlobs(a,void 0,!1))):"boolean"==typeof i&&(a=t.output.renderBlobs(a,void 0,!0)),i&&i.new_locale&&(t.opt.lang=i.old_locale),a},p.Output.Queue.prototype.clearlevel=function(){var t,e,i;for(i=(t=this.current.value()).blobs.length,e=0;e<i;e+=1)t.blobs.pop()},p.Output.Queue.prototype.renderBlobs=function(t,e,i,s){var r,n,a,o,l,u,h,c,m,f,d;if(d=p.getSafeEscape(this.state),e||(e=""),r=this.state,n="",a="",u=t.length,"citation"===this.state.tmp.area&&!this.state.tmp.just_looking&&1===u&&"object"==typeof t[0]&&s)return t[0].strings.prefix=s.strings.prefix+t[0].strings.prefix,t[0].strings.suffix=t[0].strings.suffix+s.strings.suffix,t[0].decorations=t[0].decorations.concat(s.decorations),t[0].params=s.params,t[0];var g=!0;for(l=0;l<u;l+=1)t[l].checkNext?(t[l].checkNext(t[l+1],g),g=!1):g=!t[l+1]||!t[l+1].splice_prefix;var b=!0;for(l=t.length-1;l>0;l+=-1)t[l].checkLast?b&&t[l].checkLast(t[l-1])&&(b=!1):b=!0;for(u=t.length,l=0;l<u;l+=1)if(n&&(a=e),"string"==typeof(o=t[l]))n+=d(a),n+=o,r.tmp.count_offset_characters&&(r.tmp.offset_characters+=a.length);else if(i)n=n?[n,o]:[o];else if(o.status!==p.SUPPRESS){var _=(m=o.particle?o.particle+o.num:o.formatter.format(o.num,o.gender)).replace(/<[^>]*>/g,"").length;this.append(m,"empty",!0);var v=this.pop(),y=r.tmp.count_offset_characters;if(m=this.string(r,[v],!1),r.tmp.count_offset_characters=y,o.strings["text-case"]&&(m=p.Output.Formatters[o.strings["text-case"]](this.state,m)),m&&this.state.tmp.strip_periods&&(m=m.replace(/\.([^a-z]|$)/g,"$1")),!r.tmp.suppress_decorations)for(c=o.decorations.length,h=0;h<c;h+=1)f=o.decorations[h],r.normalDecorIsOrphan(o,f)||(m=r.fun.decorate[f[0]][f[1]].call(o,r,m,f[2]));m=d(o.strings.prefix)+m+d(o.strings.suffix);var x="";o.status===p.END?x=d(o.range_prefix):o.status===p.SUCCESSOR?x=d(o.successor_prefix):o.status===p.START?x=l>0&&!o.suppress_splice_prefix?d(o.splice_prefix):"":o.status===p.SEEN&&(x=d(o.splice_prefix)),n+=x,n+=m,r.tmp.count_offset_characters&&(r.tmp.offset_characters+=x.length+o.strings.prefix.length+_+o.strings.suffix.length)}return n},p.Output.Queue.purgeEmptyBlobs=function(t){if("object"==typeof t&&"object"==typeof t.blobs&&t.blobs.length)for(var e=t.blobs.length-1;e>-1;e--){p.Output.Queue.purgeEmptyBlobs(t.blobs[e]);var i=t.blobs[e];if(!i||!i.blobs||!i.blobs.length){for(var s=[];t.blobs.length-1>e;)s.push(t.blobs.pop());for(t.blobs.pop();s.length;)t.blobs.push(s.pop())}}},p.Output.Queue.adjust=function(t){var e={";":!0,":":!0},i={".":!0,"!":!0,"?":!0},s={"!":{".":"!","?":"!?",":":"!",",":"!,",";":"!;"},"?":{"!":"?!",".":"?",":":"?",",":"?,",";":"?;"},".":{"!":".!","?":".?",":":".:",",":".,",";":".;"},":":{"!":"!","?":"?",".":":",",":":,",";":":;"},",":{"!":",!","?":",?",":":",:",".":",.",";":",;"},";":{"!":"!","?":"?",":":";",",":";,",".":";"}},r={},n={},a={},o={};for(var l in s)a[l]=!0,o[l]=!0,e[l]||(r[l]=!0),i[l]||(n[l]=!0);o[" "]=!0,o[" "]=!0;var u={};for(var l in s)for(var p in s[l])u[p]||(u[p]={}),u[p][l]=s[l][p];function h(t){return"number"==typeof t.num||t.blobs&&1===t.blobs.length&&"number"==typeof t.blobs[0].num}function c(t){return"number"==typeof t.num||!(!t.blobs||"object"!=typeof t.blobs)&&(!!c(t.blobs[t.blobs.length-1])||void 0)}function m(t,e){var i=!1,s=["@font-style","@font-variant","@font-weight","@text-decoration","@vertical-align"];if(e&&s.push("@quotes"),t.decorations)for(var r=0,n=t.decorations.length;r<n;r++)if(s.indexOf(t.decorations[r][0])>-1){i=!0;break}return i}function f(t){if(t.decorations)for(var e=0,i=t.decorations.length;e<i;e++)if("@quotes"===t.decorations[e][0]&&"false"!==t.decorations[e][1])return!0;return"object"==typeof t.blobs&&f(t.blobs[t.blobs.length-1])}function d(t,e){var i=e.strings.suffix.slice(-1);i||"string"!=typeof e.blobs||(i=e.blobs.slice(-1));var s=u[t][i];return!(!s||1!==s.length)||"object"==typeof e.blobs&&!!d(t,e.blobs[e.blobs.length-1])}function g(t,e){if(!a[e])return!1;if("string"==typeof t.blobs)return t.blobs.slice(-1)===e;var i=t.blobs[t.blobs.length-1];return!!i&&(i.strings.suffix.slice(-1)?i.strings.suffix.slice(-1)==e:g(i,e))}function b(t,e,i,r,n){var a="blobs"===e?t:t.strings,o="blobs"===r?i:i.strings,l=a[e].slice(-1),p=o[r].slice(0,1);function h(){o[r]=o[r].slice(1)}function c(){a[e]=a[e].slice(0,-1)}function m(t){o[r]=t+o[r]}function f(t){a[e]+=t}var d=n?function(){return s[l]}:function(){return u[p]};var g=n?function(){var t=s[l][p];"string"==typeof t?(c(),h(),m(t)):(m(l),c())}:function(){var t=u[p][l];"string"==typeof t?(c(),h(),f(t)):(f(p),h())};l===p?(n?c:h)():d()&&g()}function _(t){var e=t.strings.suffix.slice(0,1);if("string"==typeof t.blobs)for(;r[e];)b(t,"blobs",t,"suffix"),e=t.strings.suffix.slice(0,1);else for(;r[e];)b(t.blobs[t.blobs.length-1],"suffix",t,"suffix"),e=t.strings.suffix.slice(0,1)}function v(t){if("string"==typeof t.blobs)for(var e=t.blobs.slice(-1);n[e];)b(t,"blobs",t,"suffix",!0),e=t.blobs.slice(-1);else for(e=t.blobs[t.blobs.length-1].strings.suffix.slice(-1);n[e];)b(t.blobs[t.blobs.length-1],"suffix",t,"suffix",!0),e=t.blobs[t.blobs.length-1].strings.suffix.slice(-1)}this.upward=function(t){if(t.blobs&&"string"==typeof t.blobs)a[t.strings.suffix.slice(0,1)]&&t.strings.suffix.slice(0,1)===t.blobs.slice(-1)&&(t.strings.suffix=t.strings.suffix.slice(1));else if("object"==typeof t&&"object"==typeof t.blobs&&t.blobs.length)for(var e=m(t,!0),i=t.blobs.length-1;i>-1;i--){this.upward(t.blobs[i]);var s=t.strings,r=t.blobs[i].strings;if(0===i){" "===s.prefix.slice(-1)&&" "===r.prefix.slice(0,1)&&(r.prefix=r.prefix.slice(1));var n=r.prefix.slice(0,1);e||!o[n]||s.prefix||(s.prefix+=n,r.prefix=r.prefix.slice(1))}if(i===t.blobs.length-1){n=r.suffix.slice(-1);!e&&[" "].indexOf(n)>-1&&(s.suffix.slice(0,1)!==n&&(s.suffix=n+s.suffix),r.suffix=r.suffix.slice(0,-1))}s.delimiter&&i>0&&o[s.delimiter.slice(-1)]&&s.delimiter.slice(-1)===r.prefix.slice(0,1)&&(r.prefix=r.prefix.slice(1))}},this.leftward=function(t){if("object"==typeof t&&"object"==typeof t.blobs&&t.blobs.length)for(var e=t.blobs.length-1;e>-1;e--)if(this.leftward(t.blobs[e]),e<t.blobs.length-1&&!t.strings.delimiter){var i=t.blobs[e],s=i.strings.suffix.slice(-1),r=t.blobs[e+1],n=r.strings.prefix.slice(0,1),o="number"==typeof s||"number"==typeof n;if(!(m(i)||m(r))&&!o&&a[n]&&!o){var l=n===i.strings.suffix.slice(-1),u=!i.strings.suffix&&"string"==typeof i.blobs&&i.blobs.slice(-1)===n;l||u?r.strings.prefix=r.strings.prefix.slice(1):b(i,"suffix",r,"prefix")}}},this.downward=function(e){if(e.blobs&&"string"==typeof e.blobs)a[e.strings.suffix.slice(0,1)]&&e.strings.suffix.slice(0,1)===e.blobs.slice(-1)&&(e.strings.suffix=e.strings.suffix.slice(1));else if("object"==typeof e&&"object"==typeof e.blobs&&e.blobs.length){for(var i=e.strings,s=0,r=e.blobs.length;s<r&&!h(e.blobs[s]);s++);if(i.delimiter&&a[i.delimiter.slice(0,1)]){var n=i.delimiter.slice(0,1);for(s=e.blobs.length-2;s>-1;s--){(u=e.blobs[s].strings).suffix.slice(-1)!==n&&(u.suffix+=n)}i.delimiter=i.delimiter.slice(1)}for(s=e.blobs.length-1;s>-1;s--){var l=e.blobs[s],u=e.blobs[s].strings,p=m(l,!0),_=h(l);if(s===e.blobs.length-1){var v=i.suffix.slice(0,1),y=!1;a[v]&&!(y=d(v,l))&&t&&(y=f(l)),y&&a[v]&&(c(l)||("string"==typeof l.blobs?b(l,"blobs",e,"suffix"):b(l,"suffix",e,"suffix"),"."===i.suffix.slice(0,1)&&(u.suffix+=i.suffix.slice(0,1),i.suffix=i.suffix.slice(1))))," "===u.suffix.slice(-1)&&" "===i.suffix.slice(0,1)&&(i.suffix=i.suffix.slice(1)),o[u.suffix.slice(0,1)]&&("string"==typeof l.blobs&&l.blobs.slice(-1)===u.suffix.slice(0,1)&&(u.suffix=u.suffix.slice(1)),u.suffix.slice(-1)===i.suffix.slice(0,1)&&(i.suffix=i.suffix.slice(0,-1))),g(e,e.strings.suffix.slice(0,1))&&(e.strings.suffix=e.strings.suffix.slice(1))}else if(i.delimiter)o[i.delimiter.slice(0,1)]&&i.delimiter.slice(0,1)===u.suffix.slice(-1)&&(e.blobs[s].strings.suffix=e.blobs[s].strings.suffix.slice(0,-1));else{var x=e.blobs[s+1].strings;h(l)||p||!o[u.suffix.slice(-1)]||u.suffix.slice(-1)!==x.prefix.slice(0,1)||(x.prefix=x.prefix.slice(1))}_||p||!a[u.suffix.slice(0,1)]||"string"!=typeof l.blobs||b(l,"blobs",l,"suffix"),this.downward(e.blobs[s])}}},this.fix=function(e){if("object"==typeof e&&"object"==typeof e.blobs&&e.blobs.length){for(var i,s=0,r=e.blobs.length;s<r;s++){for(var n=e.blobs[s],a=!1,o=0,l=n.decorations.length;o<l;o++){var u=n.decorations[o];"@quotes"===u[0]&&"false"!==u[1]&&(a=!0)}a&&(t?_(n):v(n)),i=this.fix(e.blobs[s]),n.blobs&&"string"==typeof n.blobs&&(i=n.blobs.slice(-1))}return i}}},p.Engine.Opt=function(){this.parallel={enable:!1,no_repeat:null,changes_in:{}},this.has_disambiguate=!1,this.mode="html",this.dates={},this.jurisdictions_seen={},this.suppressedJurisdictions={},this.inheritedAttributes={},this["locale-sort"]=[],this["locale-translit"]=[],this["locale-translat"]=[],this.citeAffixes={persons:{"locale-orig":{prefix:"",suffix:""},"locale-translit":{prefix:"",suffix:""},"locale-translat":{prefix:"",suffix:""}},institutions:{"locale-orig":{prefix:"",suffix:""},"locale-translit":{prefix:"",suffix:""},"locale-translat":{prefix:"",suffix:""}},titles:{"locale-orig":{prefix:"",suffix:""},"locale-translit":{prefix:"",suffix:""},"locale-translat":{prefix:"",suffix:""}},journals:{"locale-orig":{prefix:"",suffix:""},"locale-translit":{prefix:"",suffix:""},"locale-translat":{prefix:"",suffix:""}},publishers:{"locale-orig":{prefix:"",suffix:""},"locale-translit":{prefix:"",suffix:""},"locale-translat":{prefix:"",suffix:""}},places:{"locale-orig":{prefix:"",suffix:""},"locale-translit":{prefix:"",suffix:""},"locale-translat":{prefix:"",suffix:""}}},this["default-locale"]=[],this.update_mode=p.NONE,this.bib_mode=p.NONE,this.sort_citations=!1,this["et-al-min"]=0,this["et-al-use-first"]=1,this["et-al-use-last"]=!1,this["et-al-subsequent-min"]=!1,this["et-al-subsequent-use-first"]=!1,this["demote-non-dropping-particle"]="display-and-sort",this["parse-names"]=!0,this.citation_number_slug=!1,this.trigraph="Aaaa00:AaAa00:AaAA00:AAAA00",this.nodenames=[],this.gender={},this["cite-lang-prefs"]={persons:["orig"],institutions:["orig"],titles:["orig"],journals:["orig"],publishers:["orig"],places:["orig"],number:["orig"]},this.has_layout_locale=!1,this.development_extensions={},this.development_extensions.field_hack=!0,this.development_extensions.allow_field_hack_date_override=!0,this.development_extensions.locator_date_and_revision=!0,this.development_extensions.locator_label_parse=!0,this.development_extensions.raw_date_parsing=!0,this.development_extensions.clean_up_csl_flaws=!0,this.development_extensions.static_statute_locator=!1,this.development_extensions.csl_reverse_lookup_support=!1,this.development_extensions.wrap_url_and_doi=!1,this.development_extensions.handle_parallel_articles=!1,this.development_extensions.thin_non_breaking_space_html_hack=!1,this.development_extensions.apply_citation_wrapper=!1,this.development_extensions.main_title_from_short_title=!1,this.development_extensions.uppercase_subtitles=!1,this.development_extensions.normalize_lang_keys_to_lowercase=!1,this.development_extensions.strict_text_case_locales=!1,this.development_extensions.expect_and_symbol_form=!1,this.development_extensions.require_explicit_legal_case_title_short=!1,this.development_extensions.spoof_institutional_affiliations=!1,this.development_extensions.force_jurisdiction=!1,this.development_extensions.parse_names=!0,this.development_extensions.hanging_indent_legacy_number=!1,this.development_extensions.throw_on_empty=!1,this.development_extensions.strict_inputs=!0,this.development_extensions.prioritize_disambiguate_condition=!1,this.development_extensions.force_short_title_casing_alignment=!0,this.development_extensions.implicit_short_title=!1},p.Engine.Tmp=function(){this.names_max=new p.Stack,this.names_base=new p.Stack,this.givens_base=new p.Stack,this.value=[],this.namepart_decorations={},this.namepart_type=!1,this.area="citation",this.root="citation",this.extension="",this.can_substitute=new p.Stack(0,p.LITERAL),this.element_rendered_ok=!1,this.element_trace=new p.Stack("style"),this.nameset_counter=0,this.group_context=new p.Stack({term_intended:!1,variable_attempt:!1,variable_success:!1,output_tip:void 0,label_form:void 0,parallel_condition:void 0,parallel_result:void 0,parallel_repeats:void 0,no_repeat_condition:void 0,no_repeat_repeats:void 0,condition:!1,force_suppress:!1,done_vars:[]}),this.term_predecessor=!1,this.in_cite_predecessor=!1,this.jump=new p.Stack(0,p.LITERAL),this.decorations=new p.Stack,this.tokenstore_stack=new p.Stack,this.last_suffix_used="",this.last_names_used=[],this.last_years_used=[],this.years_used=[],this.names_used=[],this.taintedItemIDs={},this.taintedCitationIDs={},this.initialize_with=new p.Stack,this.disambig_request=!1,this["name-as-sort-order"]=!1,this.suppress_decorations=!1,this.disambig_settings=new p.AmbigConfig,this.bib_sort_keys=[],this.prefix=new p.Stack("",p.LITERAL),this.suffix=new p.Stack("",p.LITERAL),this.delimiter=new p.Stack("",p.LITERAL),this.cite_locales=[],this.cite_affixes={citation:!1,bibliography:!1,citation_sort:!1,bibliography_sort:!1},this.strip_periods=0,this.shadow_numbers={},this.authority_stop_last=0,this.loadedItemIDs={},this.condition_counter=0,this.condition_lang_val_arr=[],this.condition_lang_counter_arr=[]},p.Engine.Fun=function(t){this.match=new p.Util.Match,this.suffixator=new p.Util.Suffixator(p.SUFFIX_CHARS),this.romanizer=new p.Util.Romanizer,this.ordinalizer=new p.Util.Ordinalizer(t),this.long_ordinalizer=new p.Util.LongOrdinalizer},p.Engine.Build=function(){this["alternate-term"]=!1,this.in_bibliography=!1,this.in_style=!1,this.skip=!1,this.postponed_macro=!1,this.layout_flag=!1,this.name=!1,this.names_variables=[[]],this.name_label=[{}],this.form=!1,this.term=!1,this.macro={},this.macro_stack=[],this.text=!1,this.lang=!1,this.area="citation",this.root="citation",this.extension="",this.substitute_level=new p.Stack(0,p.LITERAL),this.names_level=0,this.render_nesting_level=0,this.render_seen=!1,this.bibliography_key_pos=0},p.Engine.Configure=function(){this.tests=[],this.fail=[],this.succeed=[]},p.Engine.Citation=function(t){this.opt={inheritedAttributes:{}},this.tokens=[],this.srt=new p.Registry.Comparifier(t,"citation_sort"),this.opt.collapse=[],this.opt["disambiguate-add-names"]=!1,this.opt["disambiguate-add-givenname"]=!1,this.opt["disambiguate-add-year-suffix"]=!1,this.opt["givenname-disambiguation-rule"]="by-cite",this.opt["near-note-distance"]=5,this.opt.topdecor=[],this.opt.layout_decorations=[],this.opt.layout_prefix="",this.opt.layout_suffix="",this.opt.layout_delimiter="",this.opt.sort_locales=[],this.opt.max_number_of_names=0,this.root="citation"},p.Engine.Bibliography=function(){this.opt={inheritedAttributes:{}},this.tokens=[],this.opt.collapse=[],this.opt.topdecor=[],this.opt.layout_decorations=[],this.opt.layout_prefix="",this.opt.layout_suffix="",this.opt.layout_delimiter="",this.opt["line-spacing"]=1,this.opt["entry-spacing"]=1,this.opt.sort_locales=[],this.opt.max_number_of_names=0,this.root="bibliography"},p.Engine.BibliographySort=function(){this.tokens=[],this.opt={},this.opt.sort_directions=[],this.opt.topdecor=[],this.opt.citation_number_sort_direction=p.ASCENDING,this.opt.citation_number_secondary=!1,this.tmp={},this.keys=[],this.root="bibliography"},p.Engine.CitationSort=function(){this.tokens=[],this.opt={},this.opt.sort_directions=[],this.keys=[],this.opt.topdecor=[],this.root="citation"},p.Engine.InText=function(){this.opt={inheritedAttributes:{}},this.tokens=[],this.opt.collapse=[],this.opt["disambiguate-add-names"]=!1,this.opt["disambiguate-add-givenname"]=!1,this.opt["disambiguate-add-year-suffix"]=!1,this.opt["givenname-disambiguation-rule"]="by-cite",this.opt["near-note-distance"]=5,this.opt.topdecor=[],this.opt.layout_decorations=[],this.opt.layout_prefix="",this.opt.layout_suffix="",this.opt.layout_delimiter="",this.opt.sort_locales=[],this.opt.max_number_of_names=0,this.root="intext"},p.Engine.prototype.previewCitationCluster=function(t,e,i,s){var r=this.opt.mode;this.setOutputFormat(s),t.citationID&&delete t.citationID;var n=this.processCitationCluster(t,e,i,p.PREVIEW);return this.setOutputFormat(r),n[1]},p.Engine.prototype.appendCitationCluster=function(t){for(var e=[],i=this.registry.citationreg.citationByIndex.length,s=0;s<i;s+=1){var r=this.registry.citationreg.citationByIndex[s];e.push([""+r.citationID,r.properties.noteIndex])}return this.processCitationCluster(t,e,[])[1]},p.Engine.prototype.processCitationCluster=function(t,e,i,s){var r,n,a,o,l,u,h,c,m,f,d,g,b,_,v,y,x;if(this.debug=!1,this.tmp.loadedItemIDs={},this.tmp.citation_errors=[],this.registry.return_data={bibchange:!1},this.setCitationId(t),s===p.PREVIEW){this.debug&&p.debug("****** start state save *********"),v=this.registry.citationreg.citationByIndex.slice(),y=this.registry.reflist.slice();for(var I=e.concat(i),S={},O=[],T=0,N=I.length;T<N;T+=1)for(o=0,l=(r=this.registry.citationreg.citationById[I[T][0]]).citationItems.length;o<l;o+=1)S[r.citationItems[o].id]=!0,O.push(""+r.citationItems[o].id);for(o=0,l=t.citationItems.length;o<l;o+=1)S[t.citationItems[o].id]=!0,O.push(""+t.citationItems[o].id);x={};for(T=0,N=y.length;T<N;T+=1)if(!S[y[T].id]){var A=this.registry.registry[y[T].id].ambig,E=this.registry.ambigcites[A];if(E)for(o=0,l=E.length;o<l;o+=1)x[E[o]]=p.cloneAmbigConfig(this.registry.registry[E[o]].disambig)}this.debug&&p.debug("****** end state save *********")}this.tmp.taintedCitationIDs={};var k=[],R={};for(T=0,N=t.citationItems.length;T<N;T+=1){for(var w in d={},t.citationItems[T])d[w]=t.citationItems[T][w];var L;if((f=this.retrieveItem(""+d.id)).id&&this.transform.loadAbbreviation("default","hereinafter",f.id),d=p.parseLocator.call(this,d),this.opt.development_extensions.static_statute_locator&&this.remapSectionVariable([[f,d]]),this.opt.development_extensions.locator_label_parse)if(d.locator&&-1===["bill","gazette","legislation","regulation","treaty"].indexOf(f.type)&&(!d.label||"page"===d.label))if(L=p.LOCATOR_LABELS_REGEXP.exec(d.locator)){var C=p.LOCATOR_LABELS_MAP[L[2]];this.getTerm(C)&&(d.label=C,d.locator=L[3])}var j=[f,d];k.push(j),t.citationItems[T].item=f}t.sortedItems=k;var P,D=[],U={};for(T=0,N=e.length;T<N;T+=1)n=e[T],this.opt.development_extensions.strict_inputs&&(U[n[0]]&&p.error("Previously referenced citationID "+n[0]+" encountered in citationsPre"),n[1]&&(P>n[1]&&p.debug("Note index sequence is not sane at citationsPre["+T+"]"),P=n[1])),this.registry.citationreg.citationById[n[0]].properties.noteIndex=n[1],D.push(this.registry.citationreg.citationById[n[0]]),U[n[0]]=this.registry.citationreg.citationById[n[0]];for(t.properties||(t.properties={noteIndex:0}),this.opt.development_extensions.strict_inputs&&(U[t.citationID]&&p.error("Citation with previously referenced citationID "+t.citationID),t.properties.noteIndex&&(P>t.properties.noteIndex&&p.debug("Note index sequence is not sane for citation "+t.citationID),P=t.properties.noteIndex)),D.push(t),U[t.citationID]=t,T=0,N=i.length;T<N;T+=1)a=i[T],this.opt.development_extensions.strict_inputs&&(U[a[0]]&&p.error("Previously referenced citationID "+a[0]+" encountered in citationsPost"),a[1]&&(P>a[1]&&p.debug("Note index sequence is not sane at postCitation["+T+"]"),P=a[1])),this.registry.citationreg.citationById[a[0]].properties.noteIndex=a[1],D.push(this.registry.citationreg.citationById[a[0]]),U[a[0]]=this.registry.citationreg.citationById[a[0]];this.registry.citationreg.citationByIndex=D,this.registry.citationreg.citationById=U,this.registry.citationreg.citationsByItemId={},this.opt.update_mode===p.POSITION&&(b=[],g=[],_={});var M,B=[];for(T=0,N=D.length;T<N;T+=1){for(D[T].properties.index=T,o=0,l=D[T].sortedItems.length;o<l;o+=1)d=D[T].sortedItems[o],this.registry.citationreg.citationsByItemId[d[1].id]||(this.registry.citationreg.citationsByItemId[d[1].id]=[],B.push(""+d[1].id)),-1===this.registry.citationreg.citationsByItemId[d[1].id].indexOf(D[T])&&this.registry.citationreg.citationsByItemId[d[1].id].push(D[T]);this.opt.update_mode===p.POSITION&&(D[T].properties.noteIndex?g.push(D[T]):(D[T].properties.noteIndex=0,b.push(D[T])))}if(s!==p.ASSUME_ALL_ITEMS_REGISTERED&&(this.debug&&p.debug("****** start update items *********"),this.updateItems(B,null,null,!0),this.debug&&p.debug("****** endo update items *********")),!this.opt.citation_number_sort&&k&&k.length>1&&this.citation_sort.tokens.length>0){for(T=0,N=k.length;T<N;T+=1)k[T][1].sortkeys=p.getSortKeys.call(this,k[T][0],"citation_sort");if(this.opt.grouped_sort&&!t.properties.unsorted){for(T=0,N=k.length;T<N;T+=1){var q=k[T][1].sortkeys;this.tmp.authorstring_request=!0;var X=this.registry.registry[k[T][0].id].disambig;this.tmp.authorstring_request=!0,p.getAmbiguousCite.call(this,k[T][0],X);var G=this.registry.authorstrings[k[T][0].id];this.tmp.authorstring_request=!1,k[T][1].sortkeys=[G].concat(q)}k.sort(this.citation.srt.compareCompositeKeys);var z=!1,F=!1,V=!1;for(T=0,N=k.length;T<N;T+=1)k[T][1].sortkeys[0]!==z&&(V=k[T][1].sortkeys[0],F=k[T][1].sortkeys[1]),k[T][1].sortkeys[0]=""+F+T,z=V}t.properties.unsorted||k.sort(this.citation.srt.compareCompositeKeys)}if(this.opt.parallel.enable&&this.parallel.StartCitation(t.sortedItems),this.opt.update_mode===p.POSITION)for(T=0;T<2;T+=1){var $={},W={};for(o=0,l=(M=[b,g][T]).length;o<l;o+=1){var J=M[o];for(M[o].properties.noteIndex||(M[o].properties.noteIndex=0),M[o].properties.noteIndex=parseInt(M[o].properties.noteIndex,10),o>0&&M[o-1].properties.noteIndex>M[o].properties.noteIndex&&(_={},$={},W={}),u=0,h=J.sortedItems.length;u<h;u+=1)J.sortedItems[u][1].parallel&&"first"!==J.sortedItems[u][1].parallel||(_[J.properties.noteIndex]?_[J.properties.noteIndex]+=1:_[J.properties.noteIndex]=1);for(u=0,h=M[o].sortedItems.length;u<h;u+=1){var K,H,Q=(d=M[o].sortedItems[u])[0].id,Y=d[1]["locator-extra"],Z=d[1].locator,tt=d[1].label;if(d[0].legislation_id&&(Q=d[0].legislation_id),u>0)if(J.sortedItems[u-1][0].legislation_id)K=J.sortedItems[u-1][0].legislation_id;else{K=J.sortedItems[u-1][1].id,H=J.sortedItems[u-1][1]["locator-extra"];for(var et=u-2;et>-1;et--)"first"===J.sortedItems[et][1].parallel&&(K=J.sortedItems[et][1].id,H=J.sortedItems[et][1]["locator-extra"])}if(s!==p.PREVIEW||J.citationID==t.citationID){var it,st,rt={};if(rt.position=d[1].position,rt["first-reference-note-number"]=d[1]["first-reference-note-number"],rt["near-note"]=d[1]["near-note"],d[1]["first-reference-note-number"]=0,d[1]["near-note"]=!1,this.registry.citationreg.citationsByItemId[Q]&&"note"===this.opt.xclass&&this.opt.has_disambiguate){var nt=this.registry.registry[Q]["citation-count"],at=this.registry.citationreg.citationsByItemId[Q].length;if(this.registry.registry[Q]["citation-count"]=this.registry.citationreg.citationsByItemId[Q].length,"number"==typeof nt){if(nt<2!==at<2){et=0;for(var ot=this.registry.citationreg.citationsByItemId[Q].length;et<ot;et++)R[this.registry.registry[Q].ambig]=!0,this.tmp.taintedCitationIDs[this.registry.citationreg.citationsByItemId[Q][et].citationID]=!0}}else for(et=0,ot=this.registry.citationreg.citationsByItemId[Q].length;et<ot;et++)R[this.registry.registry[Q].ambig]=!0,this.tmp.taintedCitationIDs[this.registry.citationreg.citationsByItemId[Q][et].citationID]=!0}if(void 0===$[Q]&&"author-only"!==J.properties.mode)$[Q]=J.properties.noteIndex,this.registry.registry[Q]&&(this.registry.registry[Q]["first-reference-note-number"]=J.properties.noteIndex),W[Q]=J.properties.noteIndex,d[1].position=p.POSITION_FIRST;else{var lt=!1,ut=!1,pt=null;if(o>0)pt=M[o-1];var ht,ct,mt,ft,dt=M[o];if(o>0){var gt=1;"author-only"===pt.properties.mode&&o>1&&(gt=2),it=M[o-gt].sortedItems.slice(-1)[0][1].id,st=M[o-gt].sortedItems.slice(-1)[0][1]["locator-extra"],pt.sortedItems[0].slice(-1)[0].legislation_id&&(it=pt.sortedItems[0].slice(-1)[0].legislation_id)}if(o>0&&0===u&&pt.properties.noteIndex!==dt.properties.noteIndex){var bt=!1,_t=pt.sortedItems[0][0].id;if(pt.sortedItems[0][0].legislation_id&&(_t=pt.sortedItems[0][0].legislation_id),_t==Q&&pt.properties.noteIndex>=dt.properties.noteIndex-1){var vt=pt.sortedItems[0][1]["locator-extra"],yt=dt.sortedItems[0][1]["locator-extra"];1!==_[pt.properties.noteIndex]&&0!==pt.properties.noteIndex||vt!==yt||(bt=!0)}bt?lt=!0:ut=!0}else u>0&&K==Q&&H==Y?lt=!0:0===u&&o>0&&pt.properties.noteIndex==dt.properties.noteIndex&&pt.sortedItems.length&&it==Q&&st==Y?lt=!0:ut=!0;if(lt&&((ht=u>0?J.sortedItems[u-1][1]:M[o-1].sortedItems[0][1]).locator?(mt=ht.label?ht.label:"",ct=""+ht.locator+mt):ct=ht.locator,ft=Z?""+Z+(tt||""):Z),lt&&ct&&!ft&&(lt=!1,ut=!0),lt&&(!ct&&ft?d[1].position=p.POSITION_IBID_WITH_LOCATOR:ct||ft?ct&&ft===ct?d[1].position=p.POSITION_IBID:ct&&ft&&ft!==ct?d[1].position=p.POSITION_IBID_WITH_LOCATOR:(lt=!1,ut=!0):d[1].position=p.POSITION_IBID),ut&&(d[1].position=p.POSITION_SUBSEQUENT),(ut||lt)&&("author-only"===J.properties.mode&&(d[1].position=p.POSITION_FIRST),$[Q]!=J.properties.noteIndex&&(d[1]["first-reference-note-number"]=$[Q],this.registry.registry[Q]))){var xt=this.registry.citationreg.citationsByItemId[Q][0].properties.noteIndex,It=J.properties.noteIndex;this.registry.registry[Q]["first-reference-note-number"]=It<xt?It:xt}}if(J.properties.noteIndex){var St=parseInt(J.properties.noteIndex,10)-parseInt(W[Q],10);d[1].position!==p.POSITION_FIRST&&St<=this.citation.opt["near-note-distance"]&&(d[1]["near-note"]=!0),W[Q]=J.properties.noteIndex}if(J.citationID!=t.citationID)for(c=0,m=p.POSITION_TEST_VARS.length;c<m;c+=1){var Ot=p.POSITION_TEST_VARS[c];d[1][Ot]!==rt[Ot]&&(this.registry.registry[Q]&&"first-reference-note-number"===Ot&&(R[this.registry.registry[Q].ambig]=!0,this.tmp.taintedItemIDs[Q]=!0),this.tmp.taintedCitationIDs[J.citationID]=!0)}this.sys.variableWrapper&&(d[1].index=J.properties.index,d[1].noteIndex=J.properties.noteIndex)}else void 0===$[d[1].id]?($[Q]=J.properties.noteIndex,W[Q]=J.properties.noteIndex):W[Q]=J.properties.noteIndex}}}if(this.opt.citation_number_sort&&k&&k.length>1&&this.citation_sort.tokens.length>0&&!t.properties.unsorted){for(T=0,N=k.length;T<N;T+=1)k[T][1].sortkeys=p.getSortKeys.call(this,k[T][0],"citation_sort");k.sort(this.citation.srt.compareCompositeKeys)}for(var w in this.tmp.taintedItemIDs)if(this.tmp.taintedItemIDs.hasOwnProperty(w)&&(M=this.registry.citationreg.citationsByItemId[w]))for(T=0,N=M.length;T<N;T+=1)this.tmp.taintedCitationIDs[M[T].citationID]=!0;var Tt=[];if(s===p.PREVIEW){this.debug&&p.debug("****** start run processor *********");try{Tt=this.process_CitationCluster.call(this,t.sortedItems,t)}catch(t){p.error("Error running CSL processor for preview: "+t)}this.debug&&(p.debug("****** end run processor *********"),p.debug("****** start state restore *********")),this.registry.citationreg.citationByIndex=v,this.registry.citationreg.citationById={};for(T=0,N=v.length;T<N;T+=1)this.registry.citationreg.citationById[v[T].citationID]=v[T];this.debug&&p.debug("****** start final update *********");var Nt=[];for(T=0,N=y.length;T<N;T+=1)Nt.push(""+y[T].id);for(var w in this.updateItems(Nt,null,null,!0),this.debug&&p.debug("****** end final update *********"),x)x.hasOwnProperty(w)&&(this.registry.registry[w].disambig=x[w]);this.debug&&p.debug("****** end state restore *********")}else{for(var At in R)this.disambiguate.run(At,t);var Et;for(var w in this.tmp.taintedCitationIDs)if(w!=t.citationID){var kt=this.registry.citationreg.citationById[w];if(!kt.properties.unsorted){for(T=0,N=kt.sortedItems.length;T<N;T+=1)kt.sortedItems[T][1].sortkeys=p.getSortKeys.call(this,kt.sortedItems[T][0],"citation_sort");kt.sortedItems.sort(this.citation.srt.compareCompositeKeys)}this.tmp.citation_pos=kt.properties.index,this.tmp.citation_note_index=kt.properties.noteIndex,this.tmp.citation_id=""+kt.citationID,(Et=[]).push(kt.properties.index),Et.push(this.process_CitationCluster.call(this,kt.sortedItems,kt)),Et.push(kt.citationID),Tt.push(Et)}this.tmp.taintedItemIDs={},this.tmp.taintedCitationIDs={},this.tmp.citation_pos=t.properties.index,this.tmp.citation_note_index=t.properties.noteIndex,this.tmp.citation_id=""+t.citationID,(Et=[]).push(e.length),Et.push(this.process_CitationCluster.call(this,k,t)),Et.push(t.citationID),Tt.push(Et),Tt.sort((function(t,e){return t[0]>e[0]?1:t[0]<e[0]?-1:0}))}return this.registry.return_data.citation_errors=this.tmp.citation_errors.slice(),[this.registry.return_data,Tt]},p.Engine.prototype.process_CitationCluster=function(t,e){var i="";if(e&&e.properties&&"composite"===e.properties.mode){e.properties.mode="author-only";var s=p.getCitationCluster.call(this,t,e);e.properties.mode="suppress-author";var r="";e.properties.infix&&(this.output.append(e.properties.infix),"object"==typeof(r=this.output.string(this,this.output.queue))&&(r=r.join("")));var n=p.getCitationCluster.call(this,t,e);e.properties.mode="composite",s&&r&&p.SWAPPING_PUNCTUATION.concat(["’","'"]).indexOf(r[0])>-1&&(s+=r,r=!1),i=[s,r,n].filter((function(t){return t})).join(" ")}else i=p.getCitationCluster.call(this,t,e);return i},p.Engine.prototype.makeCitationCluster=function(t){var e,i,s,r,n,a;for(e=[],r=t.length,s=0;s<r;s+=1){for(var o in n={},t[s])n[o]=t[s][o];if(a=this.retrieveItem(""+n.id),this.opt.development_extensions.locator_label_parse&&n.locator&&-1===["bill","gazette","legislation","regulation","treaty"].indexOf(a.type)&&(!n.label||"page"===n.label)){var l=p.LOCATOR_LABELS_REGEXP.exec(n.locator);if(l){var u=p.LOCATOR_LABELS_MAP[l[2]];this.getTerm(u)&&(n.label=u,n.locator=l[3])}}n.locator&&(n.locator=(""+n.locator).replace(/\s+$/,"")),i=[a,n],e.push(i)}if(this.opt.development_extensions.static_statute_locator&&this.remapSectionVariable(e),e&&e.length>1&&this.citation_sort.tokens.length>0){for(r=e.length,s=0;s<r;s+=1)e[s][1].sortkeys=p.getSortKeys.call(this,e[s][0],"citation_sort");e.sort(this.citation.srt.compareCompositeKeys)}return this.tmp.citation_errors=[],this.opt.parallel.enable&&this.parallel.StartCitation(e),p.getCitationCluster.call(this,e)},p.getAmbiguousCite=function(t,e,i,s){var r=this.tmp.group_context.tip,n={term_intended:r.term_intended,variable_attempt:r.variable_attempt,variable_success:r.variable_success,output_tip:r.output_tip,label_form:r.label_form,parallel_condition:r.parallel_condition,parallel_result:r.parallel_result,changes_in_condition:r.changes_in_condition,no_repeat_condition:r.no_repeat_condition,parallel_delimiter_override:r.parallel_delimiter_override,parallel_repeats:r.parallel_repeats,no_repeat_repeats:r.no_repeat_repeats,condition:r.condition,force_suppress:r.force_suppress,done_vars:r.done_vars.slice()};this.tmp.disambig_request=e||!1;var a={position:1,"near-note":!0};s&&(a.locator=s.locator,a.label=s.label),this.registry.registry[t.id]&&this.registry.citationreg.citationsByItemId&&this.registry.citationreg.citationsByItemId[t.id]&&this.registry.citationreg.citationsByItemId[t.id].length&&i&&"by-cite"===this.citation.opt["givenname-disambiguation-rule"]&&(a["first-reference-note-number"]=this.registry.registry[t.id]["first-reference-note-number"]),this.tmp.area="citation",this.tmp.root="citation";var o=this.tmp.suppress_decorations;this.tmp.suppress_decorations=!0,this.tmp.just_looking=!0,p.getCite.call(this,t,a,null,!1);for(var l=0,u=this.output.queue.length;l<u;l+=1)p.Output.Queue.purgeEmptyBlobs(this.output.queue[l]);if(this.opt.development_extensions.clean_up_csl_flaws)for(var h=0,c=this.output.queue.length;h<c;h+=1)this.output.adjust.upward(this.output.queue[h]),this.output.adjust.leftward(this.output.queue[h]),this.output.adjust.downward(this.output.queue[h]),this.output.adjust.fix(this.output.queue[h]);var m=this.output.string(this,this.output.queue);return this.tmp.just_looking=!1,this.tmp.suppress_decorations=o,this.tmp.group_context.replace(n),m},p.getSpliceDelimiter=function(t,e,i){if(void 0!==this.citation.opt["after-collapse-delimiter"])t?this.tmp.splice_delimiter=this.citation.opt["after-collapse-delimiter"]:e&&!this.tmp.have_collapsed?this.tmp.splice_delimiter=this.citation.opt["after-collapse-delimiter"]:e||this.tmp.have_collapsed||"year-suffix"===this.citation.opt.collapse?this.tmp.splice_delimiter=this.citation.opt.layout_delimiter:this.tmp.splice_delimiter=this.citation.opt["after-collapse-delimiter"];else if(this.tmp.use_cite_group_delimiter)this.tmp.splice_delimiter=this.citation.opt.cite_group_delimiter;else if(this.tmp.have_collapsed&&"in-text"===this.opt.xclass&&this.opt.update_mode!==p.NUMERIC)this.tmp.splice_delimiter=", ";else if(this.tmp.cite_locales[i-1]){var s=this.tmp.cite_affixes[this.tmp.area][this.tmp.cite_locales[i-1]];s&&s.delimiter&&(this.tmp.splice_delimiter=s.delimiter)}else this.tmp.splice_delimiter||(this.tmp.splice_delimiter="");return this.tmp.splice_delimiter},p.getCitationCluster=function(t,e){var i,s,r,n,a,o,l,u,h,c,m,f,d,g,b,_,v,y,x,I,S,O="";this.output.checkNestedBrace=new p.checkNestedBrace(this),e&&(x=e.citationID,I="author-only"===e.properties.mode&&!!e.properties.mode,"note"!==this.opt.xclass&&(S="suppress-author"===e.properties.mode&&!!e.properties.mode),e.properties.prefix&&(O=p.checkPrefixSpaceAppend(this,e.properties.prefix))),t=t||[],this.tmp.last_primary_names_string=!1,v=p.getSafeEscape(this),this.tmp.area="citation",this.tmp.root="citation",i="",s=[],this.tmp.last_suffix_used="",this.tmp.last_names_used=[],this.tmp.last_years_used=[],this.tmp.backref_index=[],this.tmp.cite_locales=[];var T=this.output.checkNestedBrace.update(this.citation.opt.layout_prefix+O),N=!1;if("note"===this.opt.xclass&&this.citation.opt.suppressTrailingPunctuation&&(N=!0),x&&this.registry.citationreg.citationById[x].properties["suppress-trailing-punctuation"]&&(N=!0),"note"===this.opt.xclass){for(var A=[],E=!1,k=!1,R=[],w=0,L=t.length;w<L;w+=1){var C=t[w][0].type,j=t[w][0].title,P=t[w][1].position,D=t[w][0].id;j&&"legal_case"===C&&D!==k&&P&&(j===E&&0!==A.length||(R=[],A.push(R)),R.push(t[w][1])),E=j,k=D}for(w=0,L=A.length;w<L;w+=1)if(!((R=A[w]).length<2)){var U=R.slice(-1)[0].locator;if(U)for(var M=0,B=R.length-1;M<B;M+=1)R[M].locator&&(U=!1);U&&(R[0].locator=U,delete R.slice(-1)[0].locator,R[0].label=R.slice(-1)[0].label,R.slice(-1)[0].label&&delete R.slice(-1)[0].label)}}for(r=[],n=t.length,t[0]&&t[0][1]&&(I?(delete t[0][1]["suppress-author"],t[0][1]["author-only"]=!0):S&&(delete t[0][1]["author-only"],t[0][1]["suppress-author"]=!0)),a=0;a<n;a+=1){f=t[a][0],o=t[a][1],o=p.parseLocator.call(this,o),l=this.tmp.have_collapsed;var q=!1;if(a>0&&t[a-1][1]&&(q=!!t[a-1][1].locator),u={},this.tmp.shadow_numbers={},!this.tmp.just_looking&&this.opt.hasPlaceholderTerm){var X=this.output;this.output=new p.Output.Queue(this),this.output.adjust=new p.Output.Queue.adjust,p.getAmbiguousCite.call(this,f,null,!1,o),this.output=X}if(this.tmp.in_cite_predecessor=!1,a>0?p.getCite.call(this,f,o,""+t[a-1][0].id,!0):(this.tmp.term_predecessor=!1,p.getCite.call(this,f,o,null,!0)),this.tmp.cite_renders_content||(y={citationID:""+this.tmp.citation_id,index:this.tmp.citation_pos,noteIndex:this.tmp.citation_note_index,itemID:""+f.id,citationItems_pos:a,error_code:p.ERROR_NO_RENDERED_FORM},this.tmp.citation_errors.push(y)),u.splice_delimiter=p.getSpliceDelimiter.call(this,q,l,a),o&&o["author-only"]&&(this.tmp.suppress_decorations=!0),a>0){var G=(_=t[a-1][1]).suffix&&[";",".",","].indexOf(_.suffix.slice(-1))>-1,z=!_.suffix&&o.prefix&&[";",".",","].indexOf(o.prefix.slice(0,1))>-1;if(G||z){var F=u.splice_delimiter.indexOf(" ");u.splice_delimiter=F>-1&&!z?u.splice_delimiter.slice(F):""}}if(u.suppress_decorations=this.tmp.suppress_decorations,u.have_collapsed=this.tmp.have_collapsed,r.push(u),o["author-only"])break}this.opt.parallel.enable&&this.parallel.purgeGroupsIfParallel(),m=this.output.queue.slice();var V="";e&&(V=p.checkSuffixSpacePrepend(this,e.properties.suffix));var $=this.citation.opt.layout_suffix,W=this.tmp.cite_locales[this.tmp.cite_locales.length-1];W&&this.tmp.cite_affixes[this.tmp.area][W]&&this.tmp.cite_affixes[this.tmp.area][W].suffix&&($=this.tmp.cite_affixes[this.tmp.area][W].suffix),p.TERMINAL_PUNCTUATION.slice(0,-1).indexOf($.slice(0,1))>-1&&($=$.slice(0,1)),$=this.output.checkNestedBrace.update(V+$);for(w=0,L=this.output.queue.length;w<L;w+=1)p.Output.Queue.purgeEmptyBlobs(this.output.queue[w]);if(!this.tmp.suppress_decorations&&this.output.queue.length&&(this.opt.development_extensions.apply_citation_wrapper&&this.sys.wrapCitationEntry&&!this.tmp.just_looking&&"citation"===this.tmp.area||(N||(this.output.queue[this.output.queue.length-1].strings.suffix=$),this.output.queue[0].strings.prefix=T)),this.opt.development_extensions.clean_up_csl_flaws)for(M=0,B=this.output.queue.length;M<B;M+=1)this.output.adjust.upward(this.output.queue[M]),this.output.adjust.leftward(this.output.queue[M]),this.output.adjust.downward(this.output.queue[M]),this.tmp.last_chr=this.output.adjust.fix(this.output.queue[M]);for(a=0,n=m.length;a<n;a+=1){var J=[];if(this.output.queue=[m[a]],this.tmp.suppress_decorations=r[a].suppress_decorations,this.tmp.splice_delimiter=r[a].splice_delimiter,m[a].parallel_delimiter&&(this.tmp.splice_delimiter=m[a].parallel_delimiter),this.tmp.have_collapsed=r[a].have_collapsed,h=this.output.string(this,this.output.queue),this.tmp.suppress_decorations=!1,"string"==typeof h)return this.tmp.suppress_decorations=!1,h||(this.opt.development_extensions.throw_on_empty?p.error("Citation would render no content"):h="[NO_PRINTED_FORM]"),h;if("object"==typeof h&&0===h.length&&!o["suppress-author"]){var K=0===a?v(this.citation.opt.layout_prefix):"",H=a===m.length-1?v(this.citation.opt.layout_suffix):"";h.push(K+"[CSL STYLE ERROR: reference with no printed form.]"+H)}if(J.length&&"string"==typeof h[0]){h.reverse();var Q=h.pop();Q&&","===Q.slice(0,1)?J.push(Q):"string"==typeof J.slice(-1)[0]&&","===J.slice(-1)[0].slice(-1)?J.push(" "+Q):Q&&J.push(v(this.tmp.splice_delimiter)+Q)}else h.reverse(),void 0!==(c=h.pop())&&(J.length&&"string"==typeof J[J.length-1]&&(J[J.length-1]+=c.successor_prefix),J.push(c));for(d=h.length,g=0;g<d;g+=1)"string"!=typeof(b=h[g])?void 0!==(c=h.pop())&&J.push(c):J.push(v(this.tmp.splice_delimiter)+b);0===J.length&&t[a][1]["suppress-author"],J.length>1&&"string"!=typeof J[0]&&(J=[this.output.renderBlobs(J)]),J.length&&("string"==typeof J[0]?a>0&&(J[0]=v(this.tmp.splice_delimiter)+J[0]):J[0].splice_prefix=a>0?this.tmp.splice_delimiter:""),s=s.concat(J)}if((i+=this.output.renderBlobs(s))&&!this.tmp.suppress_decorations)for(n=this.citation.opt.layout_decorations.length,a=0;a<n;a+=1)"normal"!==(u=this.citation.opt.layout_decorations[a])[1]&&(o&&o["author-only"]||(i=this.fun.decorate[u[0]][u[1]](this,i)));return this.tmp.suppress_decorations=!1,i||(this.opt.development_extensions.throw_on_empty?p.error("Citation would render no content"):i="[NO_PRINTED_FORM]"),i},p.getCite=function(t,e,i,s){var r,n,a=this.tmp.area;for(e&&e["author-only"]&&this.intext&&this.intext.tokens.length>0&&(this.tmp.area="intext"),this.tmp.cite_renders_content=!1,this.tmp.probably_rendered_something=!1,p.citeStart.call(this,t,e,s),r=0,this.tmp.name_node={},this.nameOutput=new p.NameOutput(this,t,e);r<this[this.tmp.area].tokens.length;)r=p.tokenExec.call(this,this[this.tmp.area].tokens[r],t,e);return p.citeEnd.call(this,t,e),this.tmp.cite_renders_content||this.tmp.just_looking||"bibliography"===this.tmp.area&&(n={index:this.tmp.bibliography_pos,itemID:""+t.id,error_code:p.ERROR_NO_RENDERED_FORM},this.tmp.bibliography_errors.push(n)),this.tmp.area=a,""+t.id},p.citeStart=function(t,e,i){if(i||(this.tmp.shadow_numbers={}),this.tmp.disambiguate_count=0,this.tmp.disambiguate_maxMax=0,this.tmp.same_author_as_previous_cite=!1,this.tmp.suppress_decorations?this.tmp.subsequent_author_substitute_ok=!1:this.tmp.subsequent_author_substitute_ok=!0,this.tmp.lastchr="","citation"===this.tmp.area&&this.citation.opt.collapse&&this.citation.opt.collapse.length?this.tmp.have_collapsed=!0:this.tmp.have_collapsed=!1,this.tmp.render_seen=!1,this.tmp.disambig_request&&!this.tmp.disambig_override?this.tmp.disambig_settings=this.tmp.disambig_request:this.registry.registry[t.id]&&!this.tmp.disambig_override?(this.tmp.disambig_request=this.registry.registry[t.id].disambig,this.tmp.disambig_settings=this.registry.registry[t.id].disambig):this.tmp.disambig_settings=new p.AmbigConfig,"citation"!==this.tmp.area)if(this.registry.registry[t.id]){if(this.tmp.disambig_restore=p.cloneAmbigConfig(this.registry.registry[t.id].disambig),"bibliography"===this.tmp.area&&this.tmp.disambig_settings&&this.tmp.disambig_override&&(this.opt["disambiguate-add-names"]&&(this.tmp.disambig_settings.names=this.registry.registry[t.id].disambig.names.slice(),this.tmp.disambig_request&&(this.tmp.disambig_request.names=this.registry.registry[t.id].disambig.names.slice())),this.opt["disambiguate-add-givenname"])){this.tmp.disambig_request=this.tmp.disambig_settings,this.tmp.disambig_settings.givens=this.registry.registry[t.id].disambig.givens.slice(),this.tmp.disambig_request.givens=this.registry.registry[t.id].disambig.givens.slice();for(var s=0,r=this.tmp.disambig_settings.givens.length;s<r;s+=1)this.tmp.disambig_settings.givens[s]=this.registry.registry[t.id].disambig.givens[s].slice();for(s=0,r=this.tmp.disambig_request.givens.length;s<r;s+=1)this.tmp.disambig_request.givens[s]=this.registry.registry[t.id].disambig.givens[s].slice()}}else this.tmp.disambig_restore=new p.AmbigConfig;this.tmp.names_used=[],this.tmp.nameset_counter=0,this.tmp.years_used=[],this.tmp.names_max.clear(),this.tmp.splice_delimiter=this[this.tmp.area].opt.layout_delimiter,this.bibliography_sort.keys=[],this.citation_sort.keys=[],this.tmp.has_done_year_suffix=!1,this.tmp.last_cite_locale=!1,!this.tmp.just_looking&&e&&!e.position&&this.registry.registry[t.id]&&(this.tmp.disambig_restore=p.cloneAmbigConfig(this.registry.registry[t.id].disambig)),this.tmp.first_name_string=!1,this.tmp.authority_stop_last=0},p.citeEnd=function(t,e){if(this.tmp.disambig_restore&&this.registry.registry[t.id]){this.registry.registry[t.id].disambig.names=this.tmp.disambig_restore.names.slice(),this.registry.registry[t.id].disambig.givens=this.tmp.disambig_restore.givens.slice();for(var i=0,s=this.registry.registry[t.id].disambig.givens.length;i<s;i+=1)this.registry.registry[t.id].disambig.givens[i]=this.tmp.disambig_restore.givens[i].slice()}if(this.tmp.disambig_restore=!1,e&&e.suffix?this.tmp.last_suffix_used=e.suffix:this.tmp.last_suffix_used="",this.tmp.last_years_used=this.tmp.years_used.slice(),this.tmp.last_names_used=this.tmp.names_used.slice(),this.tmp.cut_var=!1,this.tmp.disambig_request=!1,this.tmp.cite_locales.push(this.tmp.last_cite_locale),this.tmp.issued_date&&this.tmp.renders_collection_number){var r=[];for(i=this.tmp.issued_date.list.length-1;i>this.tmp.issued_date.pos;i+=-1)r.push(this.tmp.issued_date.list.pop());for(this.tmp.issued_date.list.pop(),i=r.length-1;i>-1;i+=-1)this.tmp.issued_date.list.push(r.pop())}this.tmp.issued_date=!1,this.tmp.renders_collection_number=!1},p.Engine.prototype.makeBibliography=function(t){var e,i,s,r,n,a,o;if(!1,!t&&(this.bibliography.opt.exclude_types||this.bibliography.opt.exclude_with_fields)){if(t={exclude:[]},this.bibliography.opt.exclude_types)for(var l in this.bibliography.opt.exclude_types){var u=this.bibliography.opt.exclude_types[l];t.exclude.push({field:"type",value:u})}if(this.bibliography.opt.exclude_with_fields)for(var l in this.bibliography.opt.exclude_with_fields){var h=this.bibliography.opt.exclude_with_fields[l];t.exclude.push({field:h,value:!0})}}if(!this.bibliography.tokens.length)return!1;"string"==typeof t&&(this.opt.citation_number_slug=t,t=!1),a=(e=p.getBibliographyEntries.call(this,t))[0],o=e[1];var c=e[2];for(i={maxoffset:0,entryspacing:this.bibliography.opt["entry-spacing"],linespacing:this.bibliography.opt["line-spacing"],"second-field-align":!1,entry_ids:a,bibliography_errors:this.tmp.bibliography_errors.slice(),done:c},this.bibliography.opt["second-field-align"]&&(i["second-field-align"]=this.bibliography.opt["second-field-align"]),r=this.registry.reflist.length,n=0;n<r;n+=1)(s=this.registry.reflist[n]).offset>i.maxoffset&&(i.maxoffset=s.offset);return this.bibliography.opt.hangingindent&&(i.hangingindent=this.bibliography.opt.hangingindent),i.bibstart=this.fun.decorate.bibstart,i.bibend=this.fun.decorate.bibend,this.opt.citation_number_slug=!1,[i,o]},p.getBibliographyEntries=function(t){var e,i,s,r,n,a,o,l,u,h,c,m,f,d,g,b,_,v,y,x,I;function S(t,e){return t===e}function O(t,e){return"boolean"!=typeof t&&t?"string"==typeof e?S(t,e):!!e&&function(t,e){for(h=e.length,c=0;c<h;c+=1)if(S(t,e[c]))return!0;return!1}(t,e):t?!!e:!e}if(e=[],x=[],this.tmp.area="bibliography",this.tmp.root="bibliography",this.tmp.last_rendered_name=!1,this.tmp.bibliography_errors=[],this.tmp.bibliography_pos=0,i=t&&t.page_start&&t.page_length?this.registry.getSortedIds():this.refetchItems(this.registry.getSortedIds()),this.tmp.disambig_override=!0,_={},t&&t.page_start&&t.page_length&&(I=0,!0!==t.page_start))for(g=0,b=i.length;g<b&&(_[i[g]]=!0,t.page_start!=i[g]);g+=1);var T=[];for(g=0,b=i.length;g<b;g+=1){if(t&&t.page_start&&t.page_length){if(_[i[g]])continue;if(l=this.refetchItem(i[g]),I===t.page_length)break}else if(_[(l=i[g]).id])continue;if(t){if(s=!0,t.include){for(s=!1,A=0,E=t.include.length;A<E;A+=1)if(O((u=t.include[A]).value,l[u.field])){s=!0;break}}else if(t.exclude){for(r=!1,A=0,E=t.exclude.length;A<E;A+=1)if(O((u=t.exclude[A]).value,l[u.field])){r=!0;break}r&&(s=!1)}else if(t.select){for(s=!1,n=!0,A=0,E=t.select.length;A<E;A+=1)O((u=t.select[A]).value,l[u.field])||(n=!1);n&&(s=!0)}if(t.quash){for(n=!0,A=0,E=t.quash.length;A<E;A+=1)O((u=t.quash[A]).value,l[u.field])||(n=!1);n&&(s=!1)}if(!s)continue}if((a=new p.Token("group",p.START)).decorations=[["@bibliography","entry"]].concat(this.bibliography.opt.layout_decorations),this.output.startTag("bib_entry",a),l.system_id&&this.sys.embedBibliographyEntry?this.output.current.value().item_id=l.system_id:this.output.current.value().system_id=l.id,f=[],!this.registry.registry[l.id].master||t&&t.page_start&&t.page_length)this.registry.registry[l.id].siblings||(this.tmp.term_predecessor=!1,f.push(""+p.getCite.call(this,l)),t&&t.page_start&&t.page_length&&(I+=1));else{v=[[l,{id:l.id}]];for(var N,A=0,E=(N=this.registry.registry[l.id].siblings).length;A<E;A++)v.push([{id:N[A]},{id:N[A]}]);for(d=!0,this.parallel.StartCitation(v),this.output.queue[0].strings.delimiter=", ",this.tmp.term_predecessor=!1,f.push(""+p.getCite.call(this,l,v[0][1])),_[l.id]=!0,A=0,E=(N=this.registry.registry[l.id].siblings).length;A<E;A+=1){var k=this.registry.registry[l.id].siblings[A];y=this.refetchItem(k),f.push(""+p.getCite.call(this,y,v[A+1][1])),_[y.id]=!0}this.parallel.purgeGroupsIfParallel()}for(x.push(""),this.tmp.bibliography_pos+=1,T.push(f),this.output.endTag("bib_entry"),this.output.queue[0].blobs.length&&this.output.queue[0].blobs[0].blobs.length&&(d||!this.output.queue[0].blobs[0].blobs[0].strings?(m=this.output.queue[0].blobs,d=!1):m=this.output.queue[0].blobs[0].blobs,m[0].strings.prefix=this.bibliography.opt.layout_prefix+m[0].strings.prefix),A=0,E=this.output.queue.length;A<E;A+=1)p.Output.Queue.purgeEmptyBlobs(this.output.queue[A]);for(A=0,E=this.output.queue.length;A<E;A+=1)this.output.adjust.upward(this.output.queue[A]),this.output.adjust.leftward(this.output.queue[A]),this.output.adjust.downward(this.output.queue[A],!0),this.output.adjust.fix(this.output.queue[A]);if(!(o=this.output.string(this,this.output.queue)[0])&&this.opt.update_mode===p.NUMERIC){var R=e.length+1+". [CSL STYLE ERROR: reference with no printed form.]";o=p.Output.Formats[this.opt.mode]["@bibliography/entry"](this,R)}o&&e.push(o)}var w=!1;if(t&&t.page_start&&t.page_length){var L=i.slice(-1)[0],C=T.slice(-1)[0];L&&C&&L!=C||(w=!0)}return this.tmp.disambig_override=!1,[T,e,w]},p.Engine.prototype.setCitationId=function(t,e){var i,s,r;if(i=!1,!t.citationID||e){for(s=Math.floor(1e14*Math.random());;){if(r=0,!this.registry.citationreg.citationById[s]){t.citationID="a"+s.toString(32);break}s+=1===(r=!r&&s<5e13?1:-1)?1:-1}i=""+s}return this.registry.citationreg.citationById[t.citationID]=t,i},p.Engine.prototype.rebuildProcessorState=function(t,e,i){t||(t=[]),e||(e="html");for(var s={},r=[],n=0,a=t.length;n<a;n+=1)for(var o=0,l=t[n].citationItems.length;o<l;o+=1){var u=""+t[n].citationItems[o].id;s[u]||r.push(u),s[u]=!0}this.updateItems(r);var h=[],c=[],m=[],f=this.opt.mode;this.setOutputFormat(e);for(n=0,a=t.length;n<a;n+=1){var d=this.processCitationCluster(t[n],h,c,p.ASSUME_ALL_ITEMS_REGISTERED);h.push([t[n].citationID,t[n].properties.noteIndex]);for(o=0,l=d[1].length;o<l;o+=1){var g=d[1][o][0];m[g]=[h[g][0],h[g][1],d[1][o][1]]}}return this.updateUncitedItems(i),this.setOutputFormat(f),m},p.Engine.prototype.restoreProcessorState=function(t){var e,i,s,r,n,a,o,l,u,h;l=[],u=[],t||(t=[]);var c=[],m={};for(e=0,i=t.length;e<i;e+=1)m[t[e].citationID]&&this.setCitationId(t[e],!0),m[t[e].citationID]=!0,c.push(t[e].properties.index);var f=t.slice();for(f.sort((function(t,e){return t.properties.index<e.properties.index?-1:t.properties.index>e.properties.index?1:0})),e=0,i=f.length;e<i;e+=1)f[e].properties.index=e;for(e=0,i=f.length;e<i;e+=1){for(h=[],s=0,r=f[e].citationItems.length;s<r;s+=1)void 0===(n=f[e].citationItems[s]).sortkeys&&(n.sortkeys=[]),o=[a=this.retrieveItem(""+n.id),n],h.push(o),f[e].citationItems[s].item=a,u.push(""+n.id);f[e].properties.unsorted||h.sort(this.citation.srt.compareCompositeKeys),f[e].sortedItems=h,this.registry.citationreg.citationById[f[e].citationID]=f[e]}for(this.updateItems(u),e=0,i=t.length;e<i;e+=1)l.push([""+t[e].citationID,t[e].properties.noteIndex]);var d=[];return t&&t.length?d=this.processCitationCluster(t[0],[],l.slice(1)):(this.registry=new p.Registry(this),this.tmp=new p.Engine.Tmp,this.disambiguate=new p.Disambiguation(this)),d},p.Engine.prototype.updateItems=function(t,e,i,s){var r=this.tmp.area,n=this.tmp.root,a=this.tmp.extension;if(0===this.bibliography_sort.tokens.length&&(e=!0),this.tmp.area="citation",this.tmp.root="citation",this.tmp.extension="",s||(this.tmp.loadedItemIDs={}),this.registry.init(t),i)for(var o in this.registry.ambigcites)this.registry.ambigsTouched[o]=!0;return this.registry.dodeletes(this.registry.myhash),this.registry.doinserts(this.registry.mylist),this.registry.dorefreshes(),this.registry.rebuildlist(e),this.registry.setsortkeys(),this.registry.setdisambigs(),this.registry.sorttokens(e),this.registry.renumber(),this.tmp.extension=a,this.tmp.area=r,this.tmp.root=n,this.registry.getSortedIds()},p.Engine.prototype.updateUncitedItems=function(t,e){var i,s=this.tmp.area,r=this.tmp.root,n=this.tmp.extension;if(0===this.bibliography_sort.tokens.length&&(e=!0),this.tmp.area="citation",this.tmp.root="citation",this.tmp.extension="",this.tmp.loadedItemIDs={},t||(t=[]),"object"==typeof t)if(void 0===t.length)for(var a in i=t,t=[],i)t.push(a);else if("number"==typeof t.length){i={};for(var o=0,l=t.length;o<l;o+=1)i[t[o]]=!0}return this.registry.init(t,!0),this.registry.dopurge(i),this.registry.doinserts(this.registry.mylist),this.registry.dorefreshes(),this.registry.rebuildlist(e),this.registry.setsortkeys(),this.registry.setdisambigs(),this.registry.sorttokens(e),this.registry.renumber(),this.tmp.extension=n,this.tmp.area=s,this.tmp.root=r,this.registry.getSortedIds()},p.localeResolve=function(t,e){var i,s;return e||(e="en-US"),t||(t=e),i={},s=t.split(/[\-_]/),i.base=p.LANG_BASES[s[0]],void 0===i.base?{base:e,best:t,bare:s[0]}:(1===s.length&&(i.generic=!0),1===s.length||"x"===s[1]?i.best=i.base.replace("_","-"):i.best=s.slice(0,2).join("-"),i.base=i.base.replace("_","-"),i.bare=s[0],i)},p.Engine.prototype.localeConfigure=function(t,e){var i;if((!e||!this.locale[t.best])&&("en-US"===t.best?(i=p.setupXml(this.sys.retrieveLocale("en-US")),this.localeSet(i,"en-US",t.best)):"en-US"!==t.best&&(t.base!==t.best&&(i=p.setupXml(this.sys.retrieveLocale(t.base)),this.localeSet(i,t.base,t.best)),i=p.setupXml(this.sys.retrieveLocale(t.best)),this.localeSet(i,t.best,t.best)),this.localeSet(this.cslXml,"",t.best),this.localeSet(this.cslXml,t.bare,t.best),t.base!==t.best&&this.localeSet(this.cslXml,t.base,t.best),this.localeSet(this.cslXml,t.best,t.best),void 0===this.locale[t.best].terms["page-range-delimiter"]&&(["fr","pt"].indexOf(t.best.slice(0,2).toLowerCase())>-1?this.locale[t.best].terms["page-range-delimiter"]="-":this.locale[t.best].terms["page-range-delimiter"]="–"),void 0===this.locale[t.best].terms["year-range-delimiter"]&&(this.locale[t.best].terms["year-range-delimiter"]="–"),void 0===this.locale[t.best].terms["citation-range-delimiter"]&&(this.locale[t.best].terms["citation-range-delimiter"]="–"),this.opt.development_extensions.normalize_lang_keys_to_lowercase)){for(var s=["default-locale","locale-sort","locale-translit","locale-translat"],r=0,n=s.length;r<n;r+=1)for(var a=0,o=this.opt[s[r]].length;a<o;a+=1)this.opt[s[r]][a]=this.opt[s[r]][a].toLowerCase();this.opt.lang=this.opt.lang.toLowerCase()}},p.Engine.prototype.localeSet=function(t,e,i){var s,r,n,a,o,l,u,h,c,m,f,d;if(e=e.replace("_","-"),i=i.replace("_","-"),this.opt.development_extensions.normalize_lang_keys_to_lowercase&&(e=e.toLowerCase(),i=i.toLowerCase()),this.locale[i]||(this.locale[i]={},this.locale[i].terms={},this.locale[i].opts={},this.locale[i].opts["skip-words"]=p.SKIP_WORDS,this.locale[i].opts["leading-noise-words"]||(this.locale[i].opts["leading-noise-words"]=[]),this.locale[i].dates={},this.locale[i].ord={"1.0.1":!1,keys:{}},this.locale[i]["noun-genders"]={}),r=t.makeXml(),t.nodeNameIs(t.dataObj,"locale"))r=t.dataObj;else for(n=t.getNodesByName(t.dataObj,"locale"),o=0,f=t.numberofnodes(n);o<f;o+=1)if(s=n[o],t.getAttributeValue(s,"lang","xml")===e){r=s;break}for(n=t.getNodesByName(r,"type"),C=0,j=t.numberofnodes(n);C<j;C+=1){var g=n[C],b=t.getAttributeValue(g,"name"),_=t.getAttributeValue(g,"gender");this.opt.gender[b]=_}if(t.getNodesByName(r,"term","ordinal").length){for(var v in this.locale[i].ord.keys)delete this.locale[i].terms[v];this.locale[i].ord={"1.0.1":!1,keys:{}}}n=t.getNodesByName(r,"term");var y={"last-digit":{},"last-two-digits":{},"whole-number":{}},x=!1,I={};for(o=0,f=t.numberofnodes(n);o<f;o+=1){if(l=n[o],"sub verbo"===(h=t.getAttributeValue(l,"name"))&&(h="sub-verbo"),"ordinal"===h.slice(0,7)){if("ordinal"===h)x=!0;else{var S,O=t.getAttributeValue(l,"match"),T=h.slice(8);(S=t.getAttributeValue(l,"gender-form"))||(S="neuter"),O||(O="last-two-digits","0"===T.slice(0,1)&&(O="last-digit")),"0"===T.slice(0,1)&&(T=T.slice(1)),y[O][T]||(y[O][T]={}),y[O][T][S]=h}this.locale[i].ord.keys[h]=!0}void 0===this.locale[i].terms[h]&&(this.locale[i].terms[h]={}),u="long",S=!1,t.getAttributeValue(l,"form")&&(u=t.getAttributeValue(l,"form")),t.getAttributeValue(l,"gender-form")&&(S=t.getAttributeValue(l,"gender-form")),t.getAttributeValue(l,"gender")&&(this.locale[i]["noun-genders"][h]=t.getAttributeValue(l,"gender")),S?(this.locale[i].terms[h][S]={},this.locale[i].terms[h][S][u]=[],d=this.locale[i].terms[h][S],I[h]=!0):(this.locale[i].terms[h][u]=[],d=this.locale[i].terms[h]),t.numberofnodes(t.getNodesByName(l,"multiple"))?(d[u][0]=t.getNodeValue(l,"single"),d[u][0].indexOf("%s")>-1&&(this.opt.hasPlaceholderTerm=!0),d[u][1]=t.getNodeValue(l,"multiple"),d[u][1].indexOf("%s")>-1&&(this.opt.hasPlaceholderTerm=!0)):(d[u]=t.getNodeValue(l),d[u].indexOf("%s")>-1&&(this.opt.hasPlaceholderTerm=!0))}if(this.locale[i].terms.supplement||(this.locale[i].terms.supplement={}),this.locale[i].terms.supplement.long||(this.locale[i].terms.supplement.long=["supplement","supplements"]),x){for(var N in I){var A={},E=0;for(var k in this.locale[i].terms[N])["masculine","feminine"].indexOf(k)>-1?A[k]=this.locale[i].terms[N][k]:E+=1;if(!E)if(A.feminine)for(var k in A.feminine)this.locale[i].terms[N][k]=A.feminine[k];else if(A.masculine)for(var k in A.masculine)this.locale[i].terms[N][k]=A.masculine[k]}this.locale[i].ord["1.0.1"]=y}for(h in this.locale[i].terms)for(C=0,j=2;C<j;C+=1)if(S=p.GENDERS[C],this.locale[i].terms[h][S])for(u in this.locale[i].terms[h])this.locale[i].terms[h][S][u]||(this.locale[i].terms[h][S][u]=this.locale[i].terms[h][u]);for(n=t.getNodesByName(r,"style-options"),o=0,f=t.numberofnodes(n);o<f;o+=1)for(m in c=n[o],a=t.attributes(c))if(a.hasOwnProperty(m))if("@punctuation-in-quote"===m||"@limit-day-ordinals-to-day-1"===m)"true"===a[m]?this.locale[i].opts[m.slice(1)]=!0:this.locale[i].opts[m.slice(1)]=!1;else if("@jurisdiction-preference"===m){var R=a[m].split(/\s+/);this.locale[i].opts[m.slice(1)]=R}else if("@skip-words"===m){var w=a[m].split(/\s*,\s*/);this.locale[i].opts[m.slice(1)]=w}else if("@leading-noise-words"===m){var L=a[m].split(/\s*,\s*/);this.locale[i].opts["leading-noise-words"]=L}else if("@name-as-sort-order"===m){this.locale[i].opts["name-as-sort-order"]={};for(var C=0,j=(P=a[m].split(/\s+/)).length;C<j;C+=1)this.locale[i].opts["name-as-sort-order"][P[C]]=!0}else if("@name-as-reverse-order"===m){this.locale[i].opts["name-as-reverse-order"]={};for(C=0,j=(P=a[m].split(/\s+/)).length;C<j;C+=1)this.locale[i].opts["name-as-reverse-order"][P[C]]=!0}else if("@name-never-short"===m){this.locale[i].opts["name-never-short"]={};var P;for(C=0,j=(P=a[m].split(/\s+/)).length;C<j;C+=1)this.locale[i].opts["name-never-short"][P[C]]=!0}for(n=t.getNodesByName(r,"date"),o=0,f=t.numberofnodes(n);o<f;o+=1){var D=n[o];this.locale[i].dates[t.getAttributeValue(D,"form")]=D}p.SET_COURT_CLASSES(this,i,t,r)},p.getLocaleNames=function(t,e){var i=p.setupXml(t);function s(t,e){var i=["base","best"];if(e)for(var s=p.localeResolve(e),r=0,n=i.length;r<n;r++)s[i[r]]&&-1===t.indexOf(s[i[r]])&&t.push(s[i[r]])}var r=["en-US"];function n(t){for(var e=i.getNodesByName(i.dataObj,t),s=0,n=e.length;s<n;s++){var a=i.getAttributeValue(e[s],"locale");if(a)for(var o=0,l=(a=a.split(/ +/)).length;o<l;o++)this.extendLocaleList(r,a[o])}}s(r,e);var a=i.getNodesByName(i.dataObj,"style")[0],o=i.getAttributeValue(a,"default-locale");s(r,o);for(var l=0,u=["layout","if","else-if","condition"].length;l<u;l++)n(i);return r},p.Node={},p.Node.bibliography={build:function(t,e){if(this.tokentype===p.START){t.build.area="bibliography",t.build.root="bibliography",t.build.extension="";this.execs.push((function(t){t.tmp.area="bibliography",t.tmp.root="bibliography",t.tmp.extension=""}))}e.push(this)}},p.Node.choose={build:function(t,e){var i;this.tokentype===p.START&&(i=function(t){t.tmp.jump.push(void 0,p.LITERAL)}),this.tokentype===p.END&&(i=function(t){t.tmp.jump.pop()}),this.execs.push(i),e.push(this)},configure:function(t,e){this.tokentype===p.END?(t.configure.fail.push(e),t.configure.succeed.push(e)):(t.configure.fail.pop(),t.configure.succeed.pop())}},p.Node.citation={build:function(t,e){if(this.tokentype===p.START){t.build.area="citation",t.build.root="citation",t.build.extension="";this.execs.push((function(t){t.tmp.area="citation",t.tmp.root="citation",t.tmp.extension=""}))}if(this.tokentype===p.END){if(t.opt.grouped_sort="in-text"===t.opt.xclass&&t.citation.opt.collapse&&t.citation.opt.collapse.length||t.citation.opt.cite_group_delimiter&&t.citation.opt.cite_group_delimiter.length&&t.opt.update_mode!==p.POSITION&&t.opt.update_mode!==p.NUMERIC,t.opt.grouped_sort&&t.citation_sort.opt.sort_directions.length){var i=t.citation_sort.opt.sort_directions[0].slice();t.citation_sort.opt.sort_directions=[i].concat(t.citation_sort.opt.sort_directions)}t.citation.srt=new p.Registry.Comparifier(t,"citation_sort")}e.push(this)}},p.Node["#comment"]={build:function(){}},p.Node.date={build:function(t,e){var i,s,r,n,a,o,l,u,h,c;this.tokentype!==p.START&&this.tokentype!==p.SINGLETON||(t.dateput.string(t,t.dateput.queue),t.tmp.date_token=p.Util.cloneToken(this),t.tmp.date_token.strings.prefix="",t.tmp.date_token.strings.suffix="",t.dateput.openLevel(this),t.build.date_parts=[],t.build.date_variables=this.variables,t.build.extension||p.Util.substituteStart.call(this,t,e),i=t.build.extension?p.dateMacroAsSortKey:function(t,e,i){var p;if(t.tmp.element_rendered_ok=!1,t.tmp.donesies=[],t.tmp.dateparts=[],p=[],!this.variables.length||t.tmp.just_looking&&"accessed"===this.variables[0])t.tmp.date_object=!1;else{for(void 0===(s=e[this.variables[0]])&&(s={"date-parts":[[0]]},t.opt.development_extensions.locator_date_and_revision&&i&&"locator-date"===this.variables[0]&&i["locator-date"]&&(s=i["locator-date"])),t.tmp.date_object=s,r=this.dateparts.length,n=0;n<r;n+=1)a=this.dateparts[n],void 0!==t.tmp.date_object[a+"_end"]?p.push(a):"month"===a&&void 0!==t.tmp.date_object.season_end&&p.push(a);for(o=[],r=(l=["year","month","day"]).length,n=0;n<r;n+=1)p.indexOf(l[n])>-1&&o.push(l[n]);for(p=o.slice(),u=2,r=p.length,n=0;n<r;n+=1)if(a=p[n],h=t.tmp.date_object[a],c=t.tmp.date_object[a+"_end"],h!==c){u=n;break}t.tmp.date_collapse_at=p.slice(u)}},this.execs.push(i),i=function(t,e){if(e[this.variables[0]]&&(t.output.startTag("date",this),"issued"===this.variables[0]&&"legal_case"===e.type&&!t.tmp.extension&&""+e["collection-number"]==""+t.tmp.date_object.year&&1===this.dateparts.length&&"year"===this.dateparts[0]))for(var i in t.tmp.date_object)if(t.tmp.date_object.hasOwnProperty(i)&&"year"===i.slice(0,4)){t.tmp.issued_date={};var s=t.output.current.mystack.slice(-2)[0].blobs;t.tmp.issued_date.list=s,t.tmp.issued_date.pos=s.length-1}},this.execs.push(i)),t.build.extension||this.tokentype!==p.END&&this.tokentype!==p.SINGLETON||(i=function(t,e){e[this.variables[0]]&&t.output.endTag()},this.execs.push(i)),e.push(this),this.tokentype!==p.END&&this.tokentype!==p.SINGLETON||t.build.extension||p.Util.substituteEnd.call(this,t,e)}},p.Node["date-part"]={build:function(t,e){var i,s,r,n,a,o,l,u,h,c,m,f,d,g,b,_,v,y,x;this.strings.form||(this.strings.form="long"),t.build.date_parts.push(this.strings.name);var I=t.build.date_variables[0];function S(e,i,s){if(!s)return s;if(s=""+p.Util.Dates[this.strings.name][e](t,s,i,this.default_locale),"month"===this.strings.name)if(t.tmp.strip_periods)s=s.replace(/\./g,"");else for(var r=0,n=this.decorations.length;r<n;r+=1)if("@strip-periods"===this.decorations[r][0]&&"true"===this.decorations[r][1]){s=s.replace(/\./g,"");break}return s}i=function(t,e){if(t.tmp.date_object){if(t.tmp.probably_rendered_something=!0,n=!0,a="",o="",t.tmp.donesies.push(this.strings.name),t.tmp.date_object.literal&&"year"===this.strings.name&&t.output.append(t.tmp.date_object.literal,this),t.tmp.date_object&&(a=t.tmp.date_object[this.strings.name],o=t.tmp.date_object[this.strings.name+"_end"]),"year"!==this.strings.name||0!==a||t.tmp.suppress_decorations||(a=!1),l=!t.tmp.suppress_decorations,u=t.tmp.have_collapsed,h="year-suffix"===t[t.tmp.area].opt.collapse||"year-suffix-ranged"===t[t.tmp.area].opt.collapse,c=t.opt["disambiguate-add-year-suffix"],l&&c&&h&&(t.tmp.years_used.push(a),t.tmp.last_years_used.length>=t.tmp.years_used.length&&u&&t.tmp.last_years_used[t.tmp.years_used.length-1]===a&&(a=!1)),void 0!==a){m=!1,f=!1,!1,!1,"year"===this.strings.name&&(parseInt(a,10)<500&&parseInt(a,10)>0&&(f=t.getTerm("ad")),parseInt(a,10)<0&&(m=t.getTerm("bc"),a=-1*parseInt(a,10)),o&&(parseInt(o,10)<500&&parseInt(o,10)>0&&t.getTerm("ad"),parseInt(o,10)<0&&(t.getTerm("bc"),o=-1*parseInt(o,10))));for(var i=""+t.tmp.date_object.month;i.length<2;)i="0"+i;i="month-"+i;var O=t.locale[t.opt.lang]["noun-genders"][i];if(this.strings.form){var T=this.strings.form;"day"===this.strings.name&&"ordinal"===T&&t.locale[t.opt.lang].opts["limit-day-ordinals-to-day-1"]&&""+a!="1"&&(T="numeric"),a=S.call(this,T,O,a),o=S.call(this,T,O,o)}if(t.output.openLevel("empty"),t.tmp.date_collapse_at.length){for(d=!0,r=t.tmp.date_collapse_at.length,s=0;s<r;s+=1)if(x=t.tmp.date_collapse_at[s],-1===t.tmp.donesies.indexOf(x)){d=!1;break}if(d){if(""+o!="0"){if(0===t.dateput.queue.length&&(n=!0),t.opt["year-range-format"]&&"expanded"!==t.opt["year-range-format"]&&!t.tmp.date_object.day&&!t.tmp.date_object.month&&!t.tmp.date_object.season&&"year"===this.strings.name&&a&&o){o=t.fun.year_mangler(a+"-"+o,!0);var N=t.getTerm("year-range-delimiter");o=o.slice(o.indexOf(N)+1)}t.dateput.append(o,this),n&&(t.dateput.current.value().blobs[0].strings.prefix="")}t.output.append(a,this),(g=t.output.current.value()).blobs[g.blobs.length-1].strings.suffix="",this.strings["range-delimiter"]?t.output.append(this.strings["range-delimiter"]):t.output.append(t.getTerm("year-range-delimiter"),"empty"),t.dateput.closeLevel(),b=t.dateput.current.value(),g.blobs=g.blobs.concat(b),t.dateput.string(t,t.dateput.queue),t.dateput.openLevel(t.tmp.date_token),t.tmp.date_collapse_at=[]}else t.output.append(a,this),t.tmp.date_collapse_at.indexOf(this.strings.name)>-1&&""+o!="0"&&(0===t.dateput.queue.length&&(n=!0),t.dateput.openLevel("empty"),t.dateput.append(o,this),n&&(t.dateput.current.value().blobs[0].strings.prefix=""),m&&t.dateput.append(m),f&&t.dateput.append(f),t.dateput.closeLevel())}else t.output.append(a,this);m&&t.output.append(m),f&&t.output.append(f),t.output.closeLevel()}else"month"===this.strings.name&&t.tmp.date_object.season&&((a=""+t.tmp.date_object.season)&&a.match(/^[1-4]$/)?(t.tmp.group_context.tip.variable_success=!0,t.output.append(t.getTerm("season-0"+a),this)):a&&t.output.append(a,this));t.tmp.value=[],!e[I]||!a&&!t.tmp.have_collapsed||t.opt.has_year_suffix||"year"!==this.strings.name||t.tmp.just_looking||t.registry.registry[e.id]&&!1!==t.registry.registry[e.id].disambig.year_suffix&&!t.tmp.has_done_year_suffix&&(t.tmp.has_done_year_suffix=!0,v=parseInt(t.registry.registry[e.id].disambig.year_suffix,10),_=new p.NumericBlob(!1,v,this,e.id),this.successor_prefix=t[t.build.area].opt.layout_delimiter,this.splice_prefix=t[t.build.area].opt.layout_delimiter,y=new p.Util.Suffixator(p.SUFFIX_CHARS),_.setFormatter(y),"year-suffix-ranged"===t[t.tmp.area].opt.collapse&&(_.range_prefix=t.getTerm("citation-range-delimiter")),t[t.tmp.area].opt.cite_group_delimiter?_.successor_prefix=t[t.tmp.area].opt.cite_group_delimiter:t[t.tmp.area].opt["year-suffix-delimiter"]?_.successor_prefix=t[t.tmp.area].opt["year-suffix-delimiter"]:_.successor_prefix=t[t.tmp.area].opt.layout_delimiter,_.UGLY_DELIMITER_SUPPRESS_HACK=!0,t.output.append(_,"literal"))}},this.execs.push(i),e.push(this)}},p.Node["else-if"]={build:function(t,e){p.Conditions.TopNode.call(this,t,e),e.push(this)},configure:function(t,e){p.Conditions.Configure.call(this,t,e)}},p.Node.else={build:function(t,e){e.push(this)},configure:function(t,e){this.tokentype===p.START&&(t.configure.fail[t.configure.fail.length-1]=e)}},p.Node["et-al"]={build:function(t,e){if("citation"===t.build.area||"bibliography"===t.build.area){this.execs.push((function(t){t.tmp.etal_node=this,"string"==typeof this.strings.term&&(t.tmp.etal_term=this.strings.term)}))}e.push(this)}},p.Node.group={build:function(t,e,i){var s,r,n;if(this.realGroup=i,this.tokentype===p.START&&(p.Util.substituteStart.call(this,t,e),t.build.substitute_level.value()&&t.build.substitute_level.replace(t.build.substitute_level.value()+1),this.juris||e.push(this),(r=[]).push(s=function(t){if(t.output.startTag("group",this),this.strings.label_form_override&&(t.tmp.group_context.tip.label_form||(t.tmp.group_context.tip.label_form=this.strings.label_form_override)),this.strings.label_capitalize_if_first_override&&(t.tmp.group_context.tip.label_capitalize_if_first||(t.tmp.group_context.tip.label_capitalize_if_first=this.strings.label_capitalize_if_first_override)),this.realGroup){var e=!1,i=!1;t.tmp.group_context.mystack.length&&(t.output.current.value().parent=t.tmp.group_context.tip.output_tip);var s=t.tmp.group_context.tip.label_form;s||(s=this.strings.label_form_override);var r=t.tmp.group_context.tip.label_capitalize_if_first;r||(r=this.strings.label_capitalize_if_first),t.tmp.group_context.tip.condition?(e=t.tmp.group_context.tip.condition,i=t.tmp.group_context.tip.force_suppress):this.strings.reject?e={test:this.strings.reject,not:!0}:this.strings.require&&(e={test:this.strings.require,not:!1}),t.tmp.group_context.push({old_term_predecessor:t.tmp.term_predecessor,term_intended:!1,variable_attempt:!1,variable_success:!1,variable_success_parent:t.tmp.group_context.tip.variable_success,output_tip:t.output.current.tip,label_form:s,label_capitalize_if_first:r,parallel_condition:this.strings.set_parallel_condition,changes_in_condition:this.strings.set_changes_in_condition,no_repeat_condition:this.strings.set_no_repeat_condition,parallel_delimiter_override:this.strings.set_parallel_delimiter_override,parallel_result:void 0,parallel_repeats:void 0,condition:e,force_suppress:i,done_vars:t.tmp.group_context.tip.done_vars.slice()})}}),this.execs=r.concat(this.execs),this.strings["has-publisher-and-publisher-place"]&&(t.build["publisher-special"]=!0,this.strings["subgroup-delimiter"]&&(s=function(t,e){if(e.publisher&&e["publisher-place"]){var i=e.publisher.split(/;\s*/),s=e["publisher-place"].split(/;\s*/);i.length>1&&i.length===s.length&&(t.publisherOutput=new p.PublisherOutput(t,this),t.publisherOutput["publisher-list"]=i,t.publisherOutput["publisher-place-list"]=s)}},this.execs.push(s))),this.juris)){var a=new p.Token("choose",p.START);p.Node.choose.build.call(a,t,e);var o=new p.Token("if",p.START);n=this.juris,s=function(e){return p.INIT_JURISDICTION_MACROS(t,e,n)},o.tests||(o.tests=[]),o.tests.push(s),o.test=t.fun.match.any(o,t,o.tests),e.push(o);var l=new p.Token("text",p.SINGLETON);s=function(t,e,i){var s=0;if(t.juris[e["best-jurisdiction"]][this.juris])for(;s<t.juris[e["best-jurisdiction"]][this.juris].length;)s=p.tokenExec.call(t,t.juris[e["best-jurisdiction"]][this.juris][s],e,i)},l.juris=this.juris,l.execs.push(s),e.push(l);var u=new p.Token("if",p.END);p.Node.if.build.call(u,t,e);var h=new p.Token("else",p.START);p.Node.else.build.call(h,t,e)}if(this.tokentype===p.END&&(t.build["publisher-special"]&&(t.build["publisher-special"]=!1,s=function(t){t.publisherOutput&&(t.publisherOutput.render(),t.publisherOutput=!1)},this.execs.push(s)),s=function(t,e,i){if(t.output.endTag(),this.realGroup){var s=t.tmp.group_context.pop();if("bibliography_sort"===t.tmp.area){var r=s.done_vars.indexOf("citation-number");this.strings.sort_direction&&r>-1&&1==t.tmp.group_context.length()&&(this.strings.sort_direction===p.DESCENDING?t.bibliography_sort.opt.citation_number_sort_direction=p.DESCENDING:t.bibliography_sort.opt.citation_number_sort_direction=p.ASCENDING,s.done_vars=s.done_vars.slice(0,r).concat(s.done_vars.slice(r+1)))}if(s.condition&&(s.force_suppress=p.EVALUATE_GROUP_CONDITION(t,s)),t.tmp.group_context.tip.condition&&(t.tmp.group_context.tip.force_suppress=s.force_suppress),!s.force_suppress&&(s.variable_success||s.term_intended&&!s.variable_attempt)){this.isJurisLocatorLabel||(t.tmp.group_context.tip.variable_success=!0);var n=t.output.current.value().blobs,a=t.output.current.value().blobs.length-1;if(!t.tmp.just_looking&&(s.parallel_condition||s.no_repeat_condition||s.parallel_delimiter_override)){var o={blobs:n,condition:s.condition,parallel_condition:s.parallel_condition,parallel_result:s.parallel_result,changes_in_condition:s.changes_in_condition,parallel_repeats:s.parallel_repeats,no_repeat_condition:s.no_repeat_condition,no_repeat_repeats:s.no_repeat_repeats,parallel_delimiter_override:s.parallel_delimiter_override,id:e.id,pos:a};t.parallel.checkRepeats(o)&&(n&&n.pop(),o.parallel_delimiter_override&&(t.output.queue.slice(-1)[0].parallel_delimiter=o.parallel_delimiter_override)),t.parallel.checkParallels(o,e)&&n&&n.pop(),"citation"===t.tmp.area&&!i.prefix&&["mid","last"].indexOf(o.parallel_result)>-1&&o.parallel_delimiter_override&&(t.output.queue.slice(-1)[0].parallel_delimiter=o.parallel_delimiter_override)}}else{if(t.tmp.term_predecessor=s.old_term_predecessor,t.tmp.group_context.tip.variable_attempt=s.variable_attempt,s.force_suppress&&!t.tmp.group_context.tip.condition&&(t.tmp.group_context.tip.variable_attempt=!0,t.tmp.group_context.tip.variable_success=s.variable_success_parent),s.force_suppress)for(var l=0,u=s.done_vars.length;l<u;l++)for(var h=s.done_vars[l],c=0,m=t.tmp.done_vars.length;c<m;c++)t.tmp.done_vars[c]===h&&(t.tmp.done_vars=t.tmp.done_vars.slice(0,c).concat(t.tmp.done_vars.slice(c+1)));t.output.current.value().blobs&&t.output.current.value().blobs.pop()}}},this.execs.push(s),this.juris)){var c=new p.Token("else",p.END);p.Node.else.build.call(c,t,e);var m=new p.Token("choose",p.END);p.Node.choose.build.call(m,t,e)}this.tokentype===p.END&&(this.juris||e.push(this),t.build.substitute_level.value()&&t.build.substitute_level.replace(t.build.substitute_level.value()-1),p.Util.substituteEnd.call(this,t,e))}},p.Node.if={build:function(t,e){p.Conditions.TopNode.call(this,t,e),e.push(this)},configure:function(t,e){p.Conditions.Configure.call(this,t,e)}},p.Node.conditions={build:function(t){this.tokentype===p.START&&t.tmp.conditions.addMatch(this.match),this.tokentype===p.END&&t.tmp.conditions.matchCombine()}},p.Node.condition={build:function(t){if(this.tokentype===p.SINGLETON){var e=t.fun.match[this.match](this,t,this.tests);t.tmp.conditions.addTest(e)}}},p.Conditions={},p.Conditions.TopNode=function(t){var e;this.tokentype!==p.START&&this.tokentype!==p.SINGLETON||(this.locale&&(t.opt.lang=this.locale),this.tests&&this.tests.length?this.test=t.fun.match[this.match](this,t,this.tests):t.tmp.conditions=new p.Conditions.Engine(t,this),0===t.build.substitute_level.value()&&(e=function(t){t.tmp.condition_counter++},this.execs.push(e))),this.tokentype!==p.END&&this.tokentype!==p.SINGLETON||(0===t.build.substitute_level.value()&&(e=function(t){(t.tmp.condition_counter--,t.tmp.condition_lang_counter_arr.length>0)&&(t.tmp.condition_lang_counter_arr.slice(-1)[0]===t.tmp.condition_counter&&(t.opt.lang=t.tmp.condition_lang_val_arr.pop(),t.tmp.condition_lang_counter_arr.pop()));this.locale_default&&(t.output.current.value().old_locale=this.locale_default,t.output.closeLevel("empty"),t.opt.lang=this.locale_default)},this.execs.push(e)),e=function(t){return this[t.tmp.jump.value()]},this.execs.push(e),this.locale_default&&(t.opt.lang=this.locale_default))},p.Conditions.Configure=function(t,e){this.tokentype===p.START?(this.fail=t.configure.fail.slice(-1)[0],this.succeed=this.next,t.configure.fail[t.configure.fail.length-1]=e):this.tokentype===p.SINGLETON?(this.fail=this.next,this.succeed=t.configure.succeed.slice(-1)[0],t.configure.fail[t.configure.fail.length-1]=e):(this.succeed=t.configure.succeed.slice(-1)[0],this.fail=this.next)},p.Conditions.Engine=function(t,e){this.token=e,this.state=t},p.Conditions.Engine.prototype.addTest=function(t){this.token.tests||(this.token.tests=[]),this.token.tests.push(t)},p.Conditions.Engine.prototype.addMatch=function(t){this.token.match=t},p.Conditions.Engine.prototype.matchCombine=function(){this.token.test=this.state.fun.match[this.token.match](this.token,this.state,this.token.tests)},p.Node.info={build:function(t){this.tokentype===p.START?t.build.skip="info":t.build.skip=!1}},p.Node.institution={build:function(t,e){if([p.SINGLETON,p.START].indexOf(this.tokentype)>-1){this.execs.push((function(t){"string"==typeof this.strings.delimiter?t.tmp.institution_delimiter=this.strings.delimiter:t.tmp.institution_delimiter=t.tmp.name_delimiter,"text"===t.inheritOpt(this,"and")?this.and_term=t.getTerm("and","long",0):"symbol"===t.inheritOpt(this,"and")?t.opt.development_extensions.expect_and_symbol_form?this.and_term=t.getTerm("and","symbol",0):this.and_term="&":"none"===t.inheritOpt(this,"and")&&(this.and_term=t.tmp.institution_delimiter),void 0===this.and_term&&t.tmp.and_term&&(this.and_term=t.getTerm("and","long",0)),p.STARTSWITH_ROMANESQUE_REGEXP.test(this.and_term)?(this.and_prefix_single=" ",this.and_prefix_multiple=", ","string"==typeof t.tmp.institution_delimiter&&(this.and_prefix_multiple=t.tmp.institution_delimiter),this.and_suffix=" "):(this.and_prefix_single="",this.and_prefix_multiple="",this.and_suffix=""),"always"===t.inheritOpt(this,"delimiter-precedes-last")?this.and_prefix_single=t.tmp.institution_delimiter:"never"===t.inheritOpt(this,"delimiter-precedes-last")&&this.and_prefix_multiple&&(this.and_prefix_multiple=" "),this.and={},void 0!==this.and_term?(t.output.append(this.and_term,"empty",!0),this.and.single=t.output.pop(),this.and.single.strings.prefix=this.and_prefix_single,this.and.single.strings.suffix=this.and_suffix,t.output.append(this.and_term,"empty",!0),this.and.multiple=t.output.pop(),this.and.multiple.strings.prefix=this.and_prefix_multiple,this.and.multiple.strings.suffix=this.and_suffix):"undefined"!==this.strings.delimiter&&(this.and.single=new p.Blob(t.tmp.institution_delimiter),this.and.single.strings.prefix="",this.and.single.strings.suffix="",this.and.multiple=new p.Blob(t.tmp.institution_delimiter),this.and.multiple.strings.prefix="",this.and.multiple.strings.suffix=""),t.nameOutput.institution=this}))}e.push(this)},configure:function(t){[p.SINGLETON,p.START].indexOf(this.tokentype)>-1&&(t.build.has_institution=!0)}},p.Node["institution-part"]={build:function(t,e){var i;"long"===this.strings.name?i=this.strings["if-short"]?function(t){t.nameOutput.institutionpart["long-with-short"]=this}:function(t){t.nameOutput.institutionpart.long=this}:"short"===this.strings.name&&(i=function(t){t.nameOutput.institutionpart.short=this}),this.execs.push(i),e.push(this)}},p.Node.key={build:function(t,e){var i;e=t[t.build.root+"_sort"].tokens;var s=new p.Token("key",p.START);t.tmp.root=t.build.root,s.strings["et-al-min"]=t.inheritOpt(this,"et-al-min"),s.strings["et-al-use-first"]=t.inheritOpt(this,"et-al-use-first"),s.strings["et-al-use-last"]=t.inheritOpt(this,"et-al-use-last"),i=function(t){t.tmp.done_vars=[]},s.execs.push(i),i=function(t){t.output.openLevel("empty")},s.execs.push(i);var r=[];if(this.strings.sort_direction===p.DESCENDING?(r.push(1),r.push(-1)):(r.push(-1),r.push(1)),t[t.build.area].opt.sort_directions.push(r),p.DATE_VARIABLES.indexOf(this.variables[0])>-1&&(t.build.date_key=!0),i=function(t){t.tmp.sort_key_flag=!0,t.inheritOpt(this,"et-al-min")&&(t.tmp["et-al-min"]=t.inheritOpt(this,"et-al-min")),t.inheritOpt(this,"et-al-use-first")&&(t.tmp["et-al-use-first"]=t.inheritOpt(this,"et-al-use-first")),"boolean"==typeof t.inheritOpt(this,"et-al-use-last")&&(t.tmp["et-al-use-last"]=t.inheritOpt(this,"et-al-use-last"))},s.execs.push(i),e.push(s),this.variables.length){var n=this.variables[0];if(p.NAME_VARIABLES.indexOf(n)>-1){var a=new p.Token("names",p.START);a.tokentype=p.START,a.variables=this.variables,p.Node.names.build.call(a,t,e);var o=new p.Token("name",p.SINGLETON);o.tokentype=p.SINGLETON,o.strings["name-as-sort-order"]="all",o.strings["sort-separator"]=" ",o.strings["et-al-use-last"]=t.inheritOpt(this,"et-al-use-last"),o.strings["et-al-min"]=t.inheritOpt(this,"et-al-min"),o.strings["et-al-use-first"]=t.inheritOpt(this,"et-al-use-first"),p.Node.name.build.call(o,t,e);var l=new p.Token("institution",p.SINGLETON);l.tokentype=p.SINGLETON,p.Node.institution.build.call(l,t,e);var u=new p.Token("names",p.END);u.tokentype=p.END,p.Node.names.build.call(u,t,e)}else{var h=new p.Token("text",p.SINGLETON);if(h.strings.sort_direction=this.strings.sort_direction,h.dateparts=this.dateparts,p.NUMERIC_VARIABLES.indexOf(n)>-1)i="citation-number"===n?function(t,e){if("bibliography_sort"===t.tmp.area&&(this.strings.sort_direction===p.DESCENDING?t.bibliography_sort.opt.citation_number_sort_direction=p.DESCENDING:t.bibliography_sort.opt.citation_number_sort_direction=p.ASCENDING),"citation_sort"===t.tmp.area&&t.bibliography_sort.tmp.citation_number_map)var i=t.bibliography_sort.tmp.citation_number_map[t.registry.registry[e.id].seq];else i=t.registry.registry[e.id].seq;i&&(i=p.Util.padding(""+i)),t.output.append(i,this)}:function(t,e){var i=!1;(i=e[n])&&(i=p.Util.padding(i)),t.output.append(i,this)};else if("citation-label"===n)i=function(t,e){var i=t.getCitationLabel(e);t.output.append(i,this)};else if(p.DATE_VARIABLES.indexOf(n)>-1)i=p.dateAsSortKey,h.variables=this.variables;else if("title"===n){i=t.transform.getOutputFunction(this.variables,"title",!1,!1,!0)}else i="court-class"===n?function(t,e){p.INIT_JURISDICTION_MACROS(t,e,"juris-main");var i=p.GET_COURT_CLASS(t,e,!0);t.output.append(i,"empty")}:function(t,e){var i=e[n];t.output.append(i,"empty")};h.execs.push(i),e.push(h)}}else{var c=new p.Token("text",p.SINGLETON);c.strings.sort_direction=this.strings.sort_direction,c.postponed_macro=this.postponed_macro,p.expandMacro.call(t,c,e)}var m=new p.Token("key",p.END);i=function(t){var e=t.output.string(t,t.output.queue);t.sys.normalizeUnicode&&(e=t.sys.normalizeUnicode(e)),""===(e=e?e.split(" ").join(t.opt.sort_sep)+t.opt.sort_sep:"")&&(e=void 0),("string"!=typeof e||t.tmp.empty_date)&&(e=void 0,t.tmp.empty_date=!1),t[t[t.tmp.area].root+"_sort"].keys.push(e),t.tmp.value=[]},m.execs.push(i),t.build.date_key&&("citation"===t.build.area&&"_sort"===t.build.extension&&(t[t.build.area].opt.sort_directions.push([-1,1]),i=function(t,e){var i=t.registry.registry[e.id].disambig.year_suffix;i||(i=0);var s=p.Util.padding(""+i);t[t.tmp.area].keys.push(s)},m.execs.push(i)),t.build.date_key=!1),i=function(t){t.tmp["et-al-min"]=void 0,t.tmp["et-al-use-first"]=void 0,t.tmp["et-al-use-last"]=void 0,t.tmp.sort_key_flag=!1},m.execs.push(i),e.push(m)}},p.Node.label={build:function(t,e){if(this.strings.term){this.execs.push((function(t,e,i){var s=p.evaluateLabel(this,t,e,i);i&&"locator"===this.strings.term&&(i.section_form_override=this.strings.form),s&&(t.tmp.group_context.tip.term_intended=!0),p.UPDATE_GROUP_CONTEXT_CONDITION(t,s),-1===s.indexOf("%s")&&(this.strings.capitalize_if_first&&(t.tmp.term_predecessor||"in-text"===t.opt.class&&"citation"===t.tmp.area||(s=p.Output.Formatters["capitalize-first"](t,s))),t.output.append(s,this))}))}else{this.strings.form||(this.strings.form="long");for(var i=t.build.names_variables[t.build.names_variables.length-1],s=t.build.name_label[t.build.name_label.length-1],r=0,n=i.length;r<n;r+=1)s[i[r]]||(s[i[r]]={});if(t.build.name_flag)for(r=0,n=i.length;r<n;r+=1)s[i[r]].after=this;else for(var r=0,n=i.length;r<n;r+=1)s[i[r]].before=this}e.push(this)}},p.Node.layout={build:function(t,e){var i,s,r,n,a;function o(){"bibliography"===t.build.area&&(r=new p.Token("text",p.SINGLETON),i=function(t){var e;e=t.tmp.cite_affixes[t.tmp.area][t.tmp.last_cite_locale]?t.tmp.cite_affixes[t.tmp.area][t.tmp.last_cite_locale].suffix:t.bibliography.opt.layout_suffix;var i=t.output.current.value();t.opt.using_display?i.blobs[i.blobs.length-1].strings.suffix=e:i.strings.suffix=e,t.bibliography.opt["second-field-align"]&&t.output.endTag("bib_other")},r.execs.push(i),e.push(r))}if(this.tokentype===p.START&&(this.locale_raw?t.build.current_default_locale=this.locale_raw:t.build.current_default_locale=t.opt["default-locale"],i=function(t,e,i){if(t.opt.development_extensions.apply_citation_wrapper&&t.sys.wrapCitationEntry&&!t.tmp.just_looking&&e.system_id&&"citation"===t.tmp.area){var s=new p.Token("group",p.START);s.decorations=[["@cite","entry"]],t.output.startTag("cite_entry",s),t.output.current.value().item_id=e.system_id,i&&(t.output.current.value().locator_txt=i.locator_txt,t.output.current.value().suffix_txt=i.suffix_txt)}},this.execs.push(i)),this.tokentype!==p.START||t.tmp.cite_affixes[t.build.area]||(i=function(t,e){t.tmp.done_vars=[],t.opt.suppressedJurisdictions[e.country]&&e.country&&-1===["treaty","patent"].indexOf(e.type)&&t.tmp.done_vars.push("country"),!t.tmp.just_looking&&t.registry.registry[e.id]&&t.registry.registry[e.id].parallel&&t.tmp.done_vars.push("first-reference-note-number"),t.tmp.rendered_name=!1},this.execs.push(i),i=function(t){t.tmp.sort_key_flag=!1},this.execs.push(i),i=function(t){t.tmp.nameset_counter=0},this.execs.push(i),i=function(t,e){var i=new p.Token;t.output.openLevel(i)},this.execs.push(i),e.push(this),"citation"===t.build.area&&(s=new p.Token("text",p.SINGLETON),i=function(t,e,i){if(i&&i.prefix){var s=p.checkPrefixSpaceAppend(t,i.prefix);t.tmp.just_looking||(s=t.output.checkNestedBrace.update(s));var r=p.checkIgnorePredecessor(t,s);t.output.append(s,this,!1,r)}},s.execs.push(i),e.push(s))),this.locale_raw&&((a=new p.Token("dummy",p.START)).locale=this.locale_raw,a.strings.delimiter=this.strings.delimiter,a.strings.suffix=this.strings.suffix,t.tmp.cite_affixes[t.build.area]||(t.tmp.cite_affixes[t.build.area]={})),this.tokentype===p.START&&(t.build.layout_flag=!0,this.locale_raw||(t[t.tmp.area].opt.topdecor=[this.decorations],t[t.tmp.area+"_sort"].opt.topdecor=[this.decorations],t[t.build.area].opt.layout_prefix=this.strings.prefix,t[t.build.area].opt.layout_suffix=this.strings.suffix,t[t.build.area].opt.layout_delimiter=this.strings.delimiter,t[t.build.area].opt.layout_decorations=this.decorations,t.tmp.cite_affixes[t.build.area]&&(n=new p.Token("else",p.START),p.Node.else.build.call(n,t,e))),this.locale_raw)){if(t.build.layout_locale_flag)a.name="else-if",p.Attributes["@locale-internal"].call(a,t,this.locale_raw),p.Node["else-if"].build.call(a,t,e);else{var l=new p.Token("choose",p.START);p.Node.choose.build.call(l,t,e),a.name="if",p.Attributes["@locale-internal"].call(a,t,this.locale_raw),p.Node.if.build.call(a,t,e)}t.tmp.cite_affixes[t.build.area][a.locale]={},t.tmp.cite_affixes[t.build.area][a.locale].delimiter=this.strings.delimiter,t.tmp.cite_affixes[t.build.area][a.locale].suffix=this.strings.suffix}this.tokentype===p.END&&(this.locale_raw&&(o(),t.build.layout_locale_flag?(a.name="else-if",a.tokentype=p.END,p.Attributes["@locale-internal"].call(a,t,this.locale_raw),p.Node["else-if"].build.call(a,t,e)):(a.name="if",a.tokentype=p.END,p.Attributes["@locale-internal"].call(a,t,this.locale_raw),p.Node.if.build.call(a,t,e),t.build.layout_locale_flag=!0)),this.locale_raw||(o(),t.tmp.cite_affixes[t.build.area]&&t.build.layout_locale_flag&&(n=new p.Token("else",p.END),p.Node.else.build.call(n,t,e),n=new p.Token("choose",p.END),p.Node.choose.build.call(n,t,e)),t.build_layout_locale_flag=!0,"citation"===t.build.area&&(r=new p.Token("text",p.SINGLETON),i=function(t,e,i){if(i&&i.suffix){var s=p.checkSuffixSpacePrepend(t,i.suffix);t.tmp.just_looking||(s=t.output.checkNestedBrace.update(s)),t.output.append(s,this)}},r.execs.push(i),e.push(r)),i=function(t){t.output.closeLevel()},this.execs.push(i),i=function(t,e){t.opt.development_extensions.apply_citation_wrapper&&t.sys.wrapCitationEntry&&!t.tmp.just_looking&&e.system_id&&"citation"===t.tmp.area&&t.output.endTag()},this.execs.push(i),e.push(this),t.build.layout_flag=!1,t.build.layout_locale_flag=!1))}},p.Node.macro={build:function(){}},p.Node.alternative={build:function(t,e){if(this.tokentype===p.START){var i=new p.Token("choose",p.START);p.Node.choose.build.call(i,t,e);var s=new p.Token("if",p.START);p.Attributes["@alternative-node-internal"].call(s,t),p.Node.if.build.call(s,t,e);var r=function(t,e){if(t.tmp.oldItem=e,t.tmp.oldLang=t.opt.lang,t.tmp.abort_alternative=!0,e["language-name"]&&e["language-name-original"]){var i=JSON.parse(JSON.stringify(e));i.language=i["language-name"];var s=p.localeResolve(i.language,t.opt["default-locale"][0]);if(t.opt.multi_layout)for(var r in t.opt.multi_layout){var n=t.opt.multi_layout[r],a=!1;for(var o in n){var l=n[o];if(s.best===l.best||s.base===l.base||s.bare===l.bare){a=n[0].best;break}}a||(a=t.opt["default-locale"][0]),t.opt.lang=a}for(var u in i)if(-1===["id","type","language","multi"].indexOf(u)&&"alt-"!==u.slice(0,4))if(i.multi&&i.multi._keys[u]){var h=!0;for(var c in i.multi._keys[u])if(s.bare===c.replace(/^([a-zA-Z]+).*/,"$1")){h=!1;break}h&&delete i[u]}else delete i[u];for(var u in i)"alt-"===u.slice(0,4)?(i[u.slice(4)]=i[u],t.tmp.abort_alternative=!1):i.multi&&i.multi._keys&&!i["alt-"+u]&&i.multi._keys[u]&&(i.multi._keys[u][s.best]?(i[u]=i.multi._keys[u][s.best],t.tmp.abort_alternative=!1):i.multi._keys[u][s.base]?(i[u]=i.multi._keys[u][s.base],t.tmp.abort_alternative=!1):i.multi._keys[u][s.bare]&&(i[u]=i.multi._keys[u][s.bare],t.tmp.abort_alternative=!1))}t.output.openLevel(this),t.registry.refhash[e.id]=i,t.nameOutput=new p.NameOutput(t,i)};this.execs.push(r),e.push(this);i=new p.Token("choose",p.START);p.Node.choose.build.call(i,t,e);s=new p.Token("if",p.START);p.Attributes["@alternative-node-internal"].call(s,t);r=function(t){t.tmp.abort_alternative=!0};s.execs.push(r),p.Node.if.build.call(s,t,e)}else if(this.tokentype===p.END){s=new p.Token("if",p.END);p.Node.if.build.call(s,t,e);i=new p.Token("choose",p.END);p.Node.choose.build.call(i,t,e);r=function(t,e){t.output.closeLevel(),t.registry.refhash[e.id]=t.tmp.oldItem,t.opt.lang=t.tmp.oldLang,t.nameOutput=new p.NameOutput(t,t.tmp.oldItem),t.tmp.abort_alternative=!1};this.execs.push(r),e.push(this);s=new p.Token("if",p.END);p.Node.if.build.call(s,t,e);i=new p.Token("choose",p.END);p.Node.choose.build.call(i,t,e)}}},p.Node["alternative-text"]={build:function(t,e){if(this.tokentype===p.SINGLETON){this.execs.push((function(t,e){e=t.refetchItem(e.id);p.getCite.call(t,e)}))}e.push(this)}},p.NameOutput=function(t,e,i){this.debug=!1,this.debug&&print("(1)"),this.state=t,this.Item=e,this.item=i,this.nameset_base=0,this.etal_spec={},this._first_creator_variable=!1,this._please_chop=!1},p.NameOutput.prototype.init=function(t){this.requireMatch=t.requireMatch,this.state.tmp.term_predecessor&&(this.state.tmp.subsequent_author_substitute_ok=!1),this.nameset_offset&&(this.nameset_base=this.nameset_base+this.nameset_offset),this.nameset_offset=0,this.names=t,this.variables=t.variables,this.state.tmp.value=[],this.state.tmp.rendered_name=[],this.state.tmp.label_blob=!1,this.state.tmp.etal_node=!1,this.state.tmp.etal_term=!1;for(var e=0,i=this.variables.length;e<i;e+=1)this.Item[this.variables[e]]&&this.Item[this.variables[e]].length&&(this.state.tmp.value=this.state.tmp.value.concat(this.Item[this.variables[e]]));if((this["et-al"]=void 0,this.with=void 0,this.name=void 0,this.institutionpart={},this.state.tmp.group_context.tip.variable_attempt=!0,this.labelVariable=this.variables[0],this.state.tmp.value.length)&&this.checkCommonAuthor(this.requireMatch)){for(var e in this.state.tmp.can_substitute.pop(),this.state.tmp.can_substitute.push(!0),this.variables){var s=this.state.tmp.done_vars.indexOf(this.variables[e]);s>-1&&(this.state.tmp.done_vars=this.state.tmp.done_vars.slice(0,s).concat(this.state.tmp.done_vars.slice(e+1)))}this.state.tmp.common_term_match_fail=!0,this.variables=[]}},p.NameOutput.prototype.reinit=function(t,e){if(this.requireMatch=t.requireMatch,this.labelVariable=e,this.state.tmp.can_substitute.value()){this.nameset_offset=0,this.variables=t.variables;var i=this.state.tmp.value.slice();this.state.tmp.value=[];for(var s=0,r=this.variables.length;s<r;s+=1)this.Item[this.variables[s]]&&this.Item[this.variables[s]].length&&(this.state.tmp.value=this.state.tmp.value.concat(this.Item[this.variables[s]]));this.state.tmp.value.length&&this.state.tmp.can_substitute.replace(!1,p.LITERAL),this.state.tmp.value=i}if(this.checkCommonAuthor(this.requireMatch)){for(var s in this.state.tmp.can_substitute.pop(),this.state.tmp.can_substitute.push(!0),this.variables){var n=this.state.tmp.done_vars.indexOf(this.variables[s]);n>-1&&(this.state.tmp.done_vars=this.state.tmp.done_vars.slice(0,n).concat(this.state.tmp.done_vars.slice(s+1)))}this.variables=[]}},p.NameOutput.prototype.outputNames=function(){var t=this.variables;if(this.institution.and&&(this.institution.and.single.blobs&&this.institution.and.single.blobs.length||(this.institution.and.single.blobs=this.name.and.single.blobs),this.institution.and.multiple.blobs&&this.institution.and.multiple.blobs.length||(this.institution.and.multiple.blobs=this.name.and.multiple.blobs)),this.variable_offset={},this.family)for(this.family_decor=p.Util.cloneToken(this.family),this.family_decor.strings.prefix="",this.family_decor.strings.suffix="",f=0,d=this.family.execs.length;f<d;f+=1)this.family.execs[f].call(this.family_decor,this.state,this.Item);else this.family_decor=!1;if(this.given)for(this.given_decor=p.Util.cloneToken(this.given),this.given_decor.strings.prefix="",this.given_decor.strings.suffix="",f=0,d=this.given.execs.length;f<d;f+=1)this.given.execs[f].call(this.given_decor,this.state,this.Item);else this.given_decor=!1;if(this.debug&&print("(2)"),this.getEtAlConfig(),this.debug&&print("(3)"),this.divideAndTransliterateNames(),this.debug&&print("(4)"),this.truncatePersonalNameLists(),this.debug&&print("(5)"),this.debug&&print("(6)"),this.disambigNames(),this.constrainNames(),this.debug&&print("(7)"),"count"!==this.name.strings.form){this.debug&&print("(8)"),this.setEtAlParameters(),this.debug&&print("(9)"),this.setCommonTerm(this.requireMatch),this.debug&&print("(10)"),this.state.tmp.name_node={},this.state.tmp.name_node.children=[],this.renderAllNames(),this.debug&&print("(11)");var e=[];for(f=0,d=t.length;f<d;f+=1){var i=t[f],s=[],r=!1,n=null;if(this.state.opt.development_extensions.spoof_institutional_affiliations){this.debug&&print("(11a)");for(var a=0,o=this.institutions[i].length;a<o;a+=1)s.push(this.joinPersonsAndInstitutions([this.persons[i][a],this.institutions[i][a]]));if(this.debug&&print("(11b)"),this.institutions[i].length){var l=this.nameset_base+this.variable_offset[i];this.freeters[i].length&&(l+=1),r=this.joinInstitutionSets(s,l)}this.debug&&print("(11c)");n=this.joinFreetersAndInstitutionSets([this.freeters[i],r]);this.debug&&print("(11d)")}else n=this._join([this.freeters[i]],"");if(n&&(this.state.tmp.extension||(n=this._applyLabels(n,i)),e.push(n)),this.debug&&print("(11e)"),this.common_term)break}for(this.debug&&print("(12)"),this.state.output.openLevel("empty"),this.state.output.current.value().strings.delimiter=this.state.inheritOpt(this.names,"delimiter","names-delimiter"),this.debug&&print("(13)"),f=0,d=e.length;f<d;f+=1)this.state.output.append(e[f],"literal",!0);!this.state.tmp.just_looking&&e.length>0&&(this.state.tmp.probably_rendered_something=!0),this.debug&&print("(14)"),this.state.output.closeLevel("empty"),this.debug&&print("(15)");var u=this.state.output.pop();this.state.tmp.name_node.top=u,this.debug&&print("(16)");var h=p.Util.cloneToken(this.names);if(this.state.output.append(u,h),this.state.tmp.term_predecessor_name&&(this.state.tmp.term_predecessor=!0),this.debug&&print("(17)"),this.debug&&print("(18)"),"authority"!==t[0]){var c=[],m=this.Item[t[0]];if(m)for(var f=0,d=m.length;f<d;f+=1){var g=p.Util.Names.getRawName(m[f]);g&&c.push(g)}(c=c.join(", "))&&(this.state.tmp.name_node.string=c)}if(this.state.tmp.name_node.string&&!this.state.tmp.first_name_string&&(this.state.tmp.first_name_string=this.state.tmp.name_node.string),"classic"===this.Item.type&&this.state.tmp.first_name_string){var b=[];b.push(this.state.tmp.first_name_string),this.Item.title&&b.push(this.Item.title),(b=b.join(", "))&&this.state.sys.getAbbreviation&&(this.state.transform.loadAbbreviation("default","classic",b),this.state.transform.abbrevs.default.classic[b]&&(this.state.tmp.done_vars.push("title"),this.state.output.append(this.state.transform.abbrevs.default.classic[b],"empty",!0),u=this.state.output.pop(),this.state.tmp.name_node.top.blobs.pop(),this.state.tmp.name_node.top.blobs.push(u)))}this._collapseAuthor(),this.variables=[],this.debug&&print("(19)")}else(this.state.tmp.extension||0!=this.names_count)&&(this.state.output.append(this.names_count,"empty"),this.state.tmp.group_context.tip.variable_success=!0)},p.NameOutput.prototype._applyLabels=function(t,e){var i;if(!this.label||!this.label[this.labelVariable])return t;var s=0,r=this.freeters_count[e]+this.institutions_count[e];if(r>1)s=1;else{for(var n=0,a=this.persons[e].length;n<a;n+=1)r+=this.persons_count[e][n];r>1&&(s=1)}return this.label[this.labelVariable].before?("number"==typeof this.label[this.labelVariable].before.strings.plural&&(s=this.label[this.labelVariable].before.strings.plural),i=this._buildLabel(e,s,"before",this.labelVariable),this.state.output.openLevel("empty"),this.state.output.append(i,this.label[this.labelVariable].before,!0),this.state.output.append(t,"literal",!0),this.state.output.closeLevel("empty"),t=this.state.output.pop()):this.label[this.labelVariable].after&&("number"==typeof this.label[this.labelVariable].after.strings.plural&&(s=this.label[this.labelVariable].after.strings.plural),i=this._buildLabel(e,s,"after",this.labelVariable),this.state.output.openLevel("empty"),this.state.output.append(t,"literal",!0),this.state.output.append(i,this.label[this.labelVariable].after,!0),this.state.tmp.label_blob=this.state.output.pop(),this.state.output.append(this.state.tmp.label_blob,"literal",!0),this.state.output.closeLevel("empty"),t=this.state.output.pop()),t},p.NameOutput.prototype._buildLabel=function(t,e,i,s){this.common_term&&(t=this.common_term);var r=!1,n=this.label[s][i];return n&&(r=p.castLabel(this.state,n,t,e,p.TOLERANT)),r},p.NameOutput.prototype._collapseAuthor=function(){var t,e,i;0!==this.state.tmp.name_node.top.blobs.length&&(0===this.nameset_base&&this.Item[this.variables[0]]&&!this._first_creator_variable&&(this._first_creator_variable=this.variables[0]),(this.state[this.state.tmp.area].opt.collapse&&this.state[this.state.tmp.area].opt.collapse.length||this.state[this.state.tmp.area].opt.cite_group_delimiter&&this.state[this.state.tmp.area].opt.cite_group_delimiter.length)&&(this.state.tmp.authorstring_request?(e="",t=this.state.tmp.name_node.top.blobs.slice(-1)[0].blobs,i=this.state.tmp.offset_characters,t&&(e=this.state.output.string(this.state,t,!1)),this.state.tmp.offset_characters=i,this.state.registry.authorstrings[this.Item.id]=e):this.state.tmp.just_looking||this.state.tmp.suppress_decorations||!(this.state[this.state.tmp.area].opt.collapse&&this.state[this.state.tmp.area].opt.collapse.length||this.state[this.state.tmp.area].opt.cite_group_delimiter&&this.state[this.state.tmp.area].opt.cite_group_delimiter)||(e="",t=this.state.tmp.name_node.top.blobs.slice(-1)[0].blobs,i=this.state.tmp.offset_characters,t&&(e=this.state.output.string(this.state,t,!1)),e===this.state.tmp.last_primary_names_string?((this.item["suppress-author"]||this.state[this.state.tmp.area].opt.collapse&&this.state[this.state.tmp.area].opt.collapse.length)&&(this.state.tmp.name_node.top.blobs.pop(),this.state.tmp.name_node.children=[],this.state.tmp.offset_characters=i),this.state[this.state.tmp.area].opt.cite_group_delimiter&&this.state[this.state.tmp.area].opt.cite_group_delimiter&&(this.state.tmp.use_cite_group_delimiter=!0)):(this.state.tmp.last_primary_names_string=e,this.variables.indexOf(this._first_creator_variable)>-1&&this.item&&this.item["suppress-author"]&&"legal_case"!==this.Item.type&&(this.state.tmp.name_node.top.blobs.pop(),this.state.tmp.name_node.children=[],this.state.tmp.offset_characters=i,this.state.tmp.term_predecessor=!1),this.state.tmp.have_collapsed=!1,this.state[this.state.tmp.area].opt.cite_group_delimiter&&this.state[this.state.tmp.area].opt.cite_group_delimiter&&(this.state.tmp.use_cite_group_delimiter=!1)))))},p.NameOutput.prototype.isPerson=function(t){return!(t.literal||!t.given&&t.family&&t.isInstitution)},p.NameOutput.prototype.truncatePersonalNameLists=function(){var t,e,i,s;for(t in this.freeters_count={},this.persons_count={},this.institutions_count={},this.freeters)this.freeters.hasOwnProperty(t)&&(this.freeters_count[t]=this.freeters[t].length,this.freeters[t]=this._truncateNameList(this.freeters,t));for(t in this.persons)if(this.persons.hasOwnProperty(t))for(this.institutions_count[t]=this.institutions[t].length,this._truncateNameList(this.institutions,t),this.persons[t]=this.persons[t].slice(0,this.institutions[t].length),this.persons_count[t]=[],r=0,n=this.persons[t].length;r<n;r+=1)this.persons_count[t][r]=this.persons[t][r].length,this.persons[t][r]=this._truncateNameList(this.persons,t,r);if((s=1===this.etal_min&&1===this.etal_use_first&&!this.state.tmp.extension&&!this.state.tmp.just_looking&&t)||this._please_chop)for(e=0,i=this.variables.length;e<i;e+=1){t=this.variables[e],this.freeters[t].length&&(this._please_chop===t?(this.freeters[t]=this.freeters[t].slice(1),this.freeters_count[t]+=-1,this._please_chop=!1):s&&!this._please_chop&&(this.freeters[t]=this.freeters[t].slice(0,1),this.freeters_count[t]=1,this.institutions[t]=[],this.persons[t]=[],this._please_chop=s));for(var r=0,n=this.persons[t].length;r<n;r++)if(this.persons[t][r].length){if(this._please_chop===t){this.persons[t][r]=this.persons[t][r].slice(1),this.persons_count[t][r]+=-1,this._please_chop=!1;break}if(s&&!this._please_chop){this.freeters[t]=this.persons[t][r].slice(0,1),this.freeters_count[t]=1,this.institutions[t]=[],this.persons[t]=[],this._please_chop=s;break}}this.institutions[t].length&&(this._please_chop===t?(this.institutions[t]=this.institutions[t].slice(1),this.institutions_count[t]+=-1,this._please_chop=!1):s&&!this._please_chop&&(this.institutions[t]=this.institutions[t].slice(0,1),this.institutions_count[t]=1,this._please_chop=s))}for(e=0,i=this.variables.length;e<i;e+=1){this.institutions[t].length&&(this.nameset_offset+=1);for(r=0,n=this.persons[t].length;r<n;r++)this.persons[t][r].length&&(this.nameset_offset+=1)}},p.NameOutput.prototype._truncateNameList=function(t,e,i){var s;if(s=void 0===i?t[e]:t[e][i],this.state[this.state[this.state.tmp.area].root].opt.max_number_of_names&&s.length>50&&s.length>this.state[this.state[this.state.tmp.area].root].opt.max_number_of_names+2){var r=this.state[this.state[this.state.tmp.area].root].opt.max_number_of_names;s=s.slice(0,r+1).concat(s.slice(-1))}return s},p.NameOutput.prototype.divideAndTransliterateNames=function(){var t,e,i,s,r=this.Item,n=this.variables;for(this.varnames=n.slice(),this.freeters={},this.persons={},this.institutions={},t=0,e=n.length;t<e;t+=1){var a=n[t];this.variable_offset[a]=this.nameset_offset;var o=this._normalizeVariableValue(r,a);if(this.name.strings["suppress-min"]&&o.length>=this.name.strings["suppress-min"]&&(o=[]),this.name.strings["suppress-max"]&&o.length<=this.name.strings["suppress-max"]&&(o=[]),this._getFreeters(a,o),this._getPersonsAndInstitutions(a,o),this.state.opt.development_extensions.spoof_institutional_affiliations)if(0===this.name.strings["suppress-min"])for(this.freeters[a]=[],i=0,s=this.persons[a].length;i<s;i+=1)this.persons[a][i]=[];else if(0===this.institution.strings["suppress-min"]){for(this.institutions[a]=[],this.freeters[a]=this.freeters[a].concat(this.persons[a]),i=0,s=this.persons[a].length;i<s;i+=1)for(var l=0,u=this.persons[a][i].length;l<u;l+=1)this.freeters[a].push(this.persons[a][i][l]);this.persons[a]=[]}}},p.NameOutput.prototype._normalizeVariableValue=function(t,e){var i;return"string"==typeof t[e]||"number"==typeof t[e]?(p.debug('name variable "'+e+'" is string or number, not array. Attempting to fix.'),i=[{literal:t[e]+""}]):t[e]?"number"!=typeof t[e].length?(p.debug('name variable "'+e+'" is object, not array. Attempting to fix.'),t[e]=[t[e]],i=t[e].slice()):i=t[e].slice():i=[],i},p.NameOutput.prototype._getFreeters=function(t,e){if(this.freeters[t]=[],this.state.opt.development_extensions.spoof_institutional_affiliations)for(var i=e.length-1;i>-1&&this.isPerson(e[i]);i--){(s=this._checkNickname(e.pop()))&&this.freeters[t].push(s)}else for(i=e.length-1;i>-1;i--){var s=e.pop();if(this.isPerson(s))s=this._checkNickname(s);this.freeters[t].push(s)}this.freeters[t].reverse(),this.freeters[t].length&&(this.nameset_offset+=1)},p.NameOutput.prototype._getPersonsAndInstitutions=function(t,e){if(this.persons[t]=[],this.institutions[t]=[],this.state.opt.development_extensions.spoof_institutional_affiliations){for(var i=[],s=!1,r=!0,n=e.length-1;n>-1;n+=-1)if(this.isPerson(e[n])){var a=this._checkNickname(e[n]);a&&i.push(a)}else s=!0,this.institutions[t].push(e[n]),r||(i.reverse(),this.persons[t].push(i),i=[]),r=!1;s&&(i.reverse(),this.persons[t].push(i),this.persons[t].reverse(),this.institutions[t].reverse())}},p.NameOutput.prototype._clearValues=function(t){for(var e=t.length-1;e>-1;e+=-1)t.pop()},p.NameOutput.prototype._checkNickname=function(t){if(["interview","personal_communication"].indexOf(this.Item.type)>-1){var e;if((e=p.Util.Names.getRawName(t))&&this.state.sys.getAbbreviation&&(!this.item||!this.item["suppress-author"])){var i=e;this.state.sys.normalizeAbbrevsKey&&(i=this.state.sys.normalizeAbbrevsKey("author",e)),this.state.transform.loadAbbreviation("default","nickname",i);var s=this.state.transform.abbrevs.default.nickname[i];s&&(t="!here>>>"!==s&&{family:s,given:""})}}return t},p.NameOutput.prototype.joinPersons=function(t,e,i,s){return s||(s="name"),void 0===i?1===this.etal_spec[e].freeters?this._joinEtAl(t,s):2===this.etal_spec[e].freeters?this._joinEllipsis(t,s):this.state.tmp.sort_key_flag?this._join(t," "):this._joinAnd(t,s):1===this.etal_spec[e].persons[i]?this._joinEtAl(t,s):2===this.etal_spec[e].persons[i]?this._joinEllipsis(t,s):this.state.tmp.sort_key_flag?this._join(t," "):this._joinAnd(t,s)},p.NameOutput.prototype.joinInstitutionSets=function(t,e){return 1===this.etal_spec[e].institutions?this._joinEtAl(t,"institution"):2===this.etal_spec[e].institutions?this._joinEllipsis(t,"institution"):this._joinAnd(t,"institution")},p.NameOutput.prototype.joinPersonsAndInstitutions=function(t){return this._join(t,this.state.tmp.name_delimiter)},p.NameOutput.prototype.joinFreetersAndInstitutionSets=function(t){return this._join(t,"[never here]",this.with.single,this.with.multiple)},p.NameOutput.prototype._joinEtAl=function(t,e){var i=this._join(t,this.state.tmp.name_delimiter);return this.state.output.openLevel(this._getToken(e)),this.state.output.current.value().strings.delimiter="",this.state.output.append(i,"literal",!0),t.length>1?this.state.output.append(this["et-al"].multiple,"literal",!0):1===t.length&&this.state.output.append(this["et-al"].single,"literal",!0),this.state.output.closeLevel(),this.state.output.pop()},p.NameOutput.prototype._joinEllipsis=function(t,e){return this._join(t,this.state.tmp.name_delimiter,this.name.ellipsis.single,this.name.ellipsis.multiple,e)},p.NameOutput.prototype._joinAnd=function(t,e){return this._join(t,this.state.inheritOpt(this[e],"delimiter",e+"-delimiter",", "),this[e].and.single,this[e].and.multiple,e)},p.NameOutput.prototype._join=function(t,e,i,s){var r,n;if(!t)return!1;for(r=t.length-1;r>-1;r+=-1)t[r]&&0!==t[r].length&&t[r].blobs.length||(t=t.slice(0,r).concat(t.slice(r+1)));if(!t.length)return!1;if(i&&2===t.length)i&&(i=new p.Blob(i.blobs,i)),t=[t[0],i,t[1]];else{var a;for(a=s?2:1,r=0,n=t.length-a;r<n;r+=1)t[r].strings.suffix+=e;if(t.length>1){var o=t.pop();s?(s=new p.Blob(s.blobs,s),t.push(s)):(i&&(i=new p.Blob(i.blobs,i)),t.push(i)),t.push(o)}}for(this.state.output.openLevel(),i&&s&&(this.state.output.current.value().strings.delimiter=""),r=0,n=t.length;r<n;r+=1)this.state.output.append(t[r],!1,!0);return this.state.output.closeLevel(),this.state.output.pop()},p.NameOutput.prototype._getToken=function(t){var e=this[t];return"institution"===t?new p.Token:e},p.NameOutput.prototype.checkCommonAuthor=function(t){if(!t)return!1;var e=!1;if(2===this.variables.length){var i=this.variables.slice();i.sort(),e=i.join("")}if(!e)return!1;var s=!1;if(this.state.locale[this.state.opt.lang].terms[e]&&(s=!0),!s)return this.state.tmp.done_vars.push(this.variables[0]),this.state.tmp.done_vars.push(this.variables[1]),!1;var r=this.Item[this.variables[0]],n=this.Item[this.variables[1]],a=this._compareNamesets(r,n);return!0===a&&(this.state.tmp.done_vars.push(this.variables[0]),this.state.tmp.done_vars.push(this.variables[1])),!a},p.NameOutput.prototype.setCommonTerm=function(){var t=this.variables.slice();if(t.sort(),this.common_term=t.join(""),this.common_term){var e=!1;if(this.label&&this.label[this.variables[0]]&&(this.label[this.variables[0]].before?e=this.state.getTerm(this.common_term,this.label[this.variables[0]].before.strings.form,0):this.label[this.variables[0]].after&&(e=this.state.getTerm(this.common_term,this.label[this.variables[0]].after.strings.form,0))),!this.state.locale[this.state.opt.lang].terms[this.common_term]||!e||this.variables.length<2)this.common_term=!1;else for(var i=0,s=this.variables.length-1;i<s;i+=1){var r=this.variables[i],n=this.variables[i+1];if((this.freeters[r].length||this.freeters[n].length)&&(this.etal_spec[r].freeters!==this.etal_spec[n].freeters||!this._compareNamesets(this.freeters[r],this.freeters[n])))return void(this.common_term=!1);if(this.persons[r].length!==this.persons[n].length)return void(this.common_term=!1);for(var a=0,o=this.persons[r].length;a<o;a+=1)if(this.etal_spec[r].persons[a]!==this.etal_spec[n].persons[a]||!this._compareNamesets(this.persons[r][a],this.persons[n][a]))return void(this.common_term=!1)}}},p.NameOutput.prototype._compareNamesets=function(t,e){if(!t||!e||t.length!==e.length)return!1;for(var i=0,s=e.length;i<s;i+=1)for(var r=0,n=p.NAME_PARTS.length;r<n;r+=1){var a=p.NAME_PARTS[r];if(!t[i]||t[i][a]!=e[i][a])return!1}return!0},p.NameOutput.prototype.constrainNames=function(){var t;this.names_count=0;for(var e=0,i=this.variables.length;e<i;e+=1){var s=this.variables[e];t=this.nameset_base+e,this.freeters[s].length&&(this.state.tmp.names_max.push(this.freeters[s].length,"literal"),this._imposeNameConstraints(this.freeters,this.freeters_count,s,t),this.names_count+=this.freeters[s].length),this.institutions[s].length&&(this.state.tmp.names_max.push(this.institutions[s].length,"literal"),this._imposeNameConstraints(this.institutions,this.institutions_count,s,t),this.persons[s]=this.persons[s].slice(0,this.institutions[s].length),this.names_count+=this.institutions[s].length);for(var r=0,n=this.persons[s].length;r<n;r+=1)this.persons[s][r].length&&(this.state.tmp.names_max.push(this.persons[s][r].length,"literal"),this._imposeNameConstraints(this.persons[s],this.persons_count[s],r,t),this.names_count+=this.persons[s][r].length)}},p.NameOutput.prototype._imposeNameConstraints=function(t,e,i,s){var r=t[i],n=this.state.tmp["et-al-min"];this.state.tmp.suppress_decorations?this.state.tmp.disambig_request&&this.state.tmp.disambig_request.names[s]?n=this.state.tmp.disambig_request.names[s]:e[i]>=this.etal_min&&(n=this.etal_use_first):(this.state.tmp.disambig_request&&this.state.tmp.disambig_request.names[s]>this.etal_use_first?n=e[i]<this.etal_min?e[i]:this.state.tmp.disambig_request.names[s]:e[i]>=this.etal_min&&(n=this.etal_use_first),this.etal_use_last&&n>this.etal_min-2&&(n=this.etal_min-2));var a=this.etal_min>=this.etal_use_first,o=e[i]>n;n>e[i]&&(n=r.length),a&&o&&(this.etal_use_last?t[i]=r.slice(0,n).concat(r.slice(-1)):t[i]=r.slice(0,n)),this.state.tmp.disambig_settings.names[s]=t[i].length,this.state.disambiguate.padBase(this.state.tmp.disambig_settings)},p.NameOutput.prototype.disambigNames=function(){for(var t,e=0,i=this.variables.length;e<i;e+=1){var s=this.variables[e];if(t=this.nameset_base+e,this.freeters[s].length&&this._runDisambigNames(this.freeters[s],t),this.institutions[s].length){void 0===this.state.tmp.disambig_settings.givens[t]&&(this.state.tmp.disambig_settings.givens[t]=[]);for(var r=0,n=this.institutions[s].length;r<n;r+=1)void 0===this.state.tmp.disambig_settings.givens[t][r]&&this.state.tmp.disambig_settings.givens[t].push(2)}for(r=0,n=this.persons[s].length;r<n;r+=1)this.persons[s][r].length&&this._runDisambigNames(this.persons[s][r],t)}},p.NameOutput.prototype._runDisambigNames=function(t,e){var i,s,r,n,a,o;for(n=0,a=t.length;n<a;n+=1)if(t[n].given||t[n].family){if(s=this.state.inheritOpt(this.name,"initialize-with"),this.state.registry.namereg.addname(""+this.Item.id,t[n],n),void 0===this.state.tmp.disambig_settings.givens[e])for(var l=0,u=e+1;l<u;l+=1)this.state.tmp.disambig_settings.givens[l]||(this.state.tmp.disambig_settings.givens[l]=[]);if(void 0===this.state.tmp.disambig_settings.givens[e][n]&&(i=this.state.inheritOpt(this.name,"form","name-form","long"),r=this.state.registry.namereg.evalname(""+this.Item.id,t[n],n,0,i,s),this.state.tmp.disambig_settings.givens[e].push(r)),i=this.state.inheritOpt(this.name,"form","name-form","long"),o=this.state.registry.namereg.evalname(""+this.Item.id,t[n],n,0,i,s),this.state.tmp.disambig_request){var h=this.state.tmp.disambig_settings.givens[e][n];1!==h||"by-cite"!==this.state.citation.opt["givenname-disambiguation-rule"]||void 0!==this.state.inheritOpt(this.name,"initialize-with")&&void 0!==t[n].given||(h=2),r=h,this.state.opt["disambiguate-add-givenname"]&&t[n].given&&(r=this.state.registry.namereg.evalname(""+this.Item.id,t[n],n,r,this.state.inheritOpt(this.name,"form","name-form","long"),this.state.inheritOpt(this.name,"initialize-with")))}else r=o;!this.state.tmp.just_looking&&this.item&&this.item.position===p.POSITION_FIRST&&o>r&&(r=o),this.state.tmp.sort_key_flag||(this.state.tmp.disambig_settings.givens[e][n]=r,"string"!=typeof s||void 0!==this.name.strings.initialize&&!0!==this.name.strings.initialize||(this.state.tmp.disambig_settings.use_initials=!0))}},p.NameOutput.prototype.getEtAlConfig=function(){var t=this.item;this["et-al"]={},this.state.output.append(this.etal_term,this.etal_style,!0),this["et-al"].single=this.state.output.pop(),this["et-al"].single.strings.suffix=this.etal_suffix,this["et-al"].single.strings.prefix=this.etal_prefix_single,this.state.output.append(this.etal_term,this.etal_style,!0),this["et-al"].multiple=this.state.output.pop(),this["et-al"].multiple.strings.suffix=this.etal_suffix,this["et-al"].multiple.strings.prefix=this.etal_prefix_multiple,void 0===t&&(t={}),t.position?(this.state.inheritOpt(this.name,"et-al-subsequent-min")?this.etal_min=this.state.inheritOpt(this.name,"et-al-subsequent-min"):this.etal_min=this.state.inheritOpt(this.name,"et-al-min"),this.state.inheritOpt(this.name,"et-al-subsequent-use-first")?this.etal_use_first=this.state.inheritOpt(this.name,"et-al-subsequent-use-first"):this.etal_use_first=this.state.inheritOpt(this.name,"et-al-use-first")):(this.state.tmp["et-al-min"]?this.etal_min=this.state.tmp["et-al-min"]:this.etal_min=this.state.inheritOpt(this.name,"et-al-min"),this.state.tmp["et-al-use-first"]?this.etal_use_first=this.state.tmp["et-al-use-first"]:this.etal_use_first=this.state.inheritOpt(this.name,"et-al-use-first"),"boolean"==typeof this.state.tmp["et-al-use-last"]?this.etal_use_last=this.state.tmp["et-al-use-last"]:this.etal_use_last=this.state.inheritOpt(this.name,"et-al-use-last")),this.state.tmp["et-al-min"]||(this.state.tmp["et-al-min"]=this.etal_min)},p.NameOutput.prototype.setEtAlParameters=function(){var t,e,i,s;for(t=0,e=this.variables.length;t<e;t+=1){var r=this.variables[t];for(void 0===this.etal_spec[r]&&(this.etal_spec[r]={freeters:0,institutions:0,persons:[]}),this.etal_spec[this.nameset_base+t]=this.etal_spec[r],this.freeters[r].length&&this._setEtAlParameter("freeters",r),i=0,s=this.persons[r].length;i<s;i+=1)void 0===this.etal_spec[r][i]&&(this.etal_spec[r].persons[i]=0),this._setEtAlParameter("persons",r,i);this.institutions[r].length&&this._setEtAlParameter("institutions",r)}},p.NameOutput.prototype._setEtAlParameter=function(t,e,i){var s,r;"persons"===t?(s=this.persons[e][i],r=this.persons_count[e][i]):(s=this[t][e],r=this[t+"_count"][e]),s.length<r&&!this.state.tmp.sort_key_flag?this.etal_use_last?"persons"===t?this.etal_spec[e].persons[i]=2:this.etal_spec[e][t]=2:"persons"===t?this.etal_spec[e].persons[i]=1:this.etal_spec[e][t]=1:"persons"===t?this.etal_spec[e].persons[i]=0:this.etal_spec[e][t]=0},p.NameOutput.prototype.renderAllNames=function(){for(var t,e=0,i=this.variables.length;e<i;e+=1){var s=this.variables[e];(this.freeters[s].length||this.institutions[s].length)&&(this.state.tmp.group_context.tip.condition||(this.state.tmp.just_did_number=!1)),t=this.nameset_base+e,this.freeters[s].length&&(this.freeters[s]=this._renderNames(s,this.freeters[s],t));for(var r=0,n=this.institutions[s].length;r<n;r+=1)this.persons[s][r]=this._renderNames(s,this.persons[s][r],t,r)}this.renderInstitutionNames()},p.NameOutput.prototype.renderInstitutionNames=function(){for(var t=0,e=this.variables.length;t<e;t+=1)for(var i=this.variables[t],s=0,r=this.institutions[i].length;s<r;s+=1){var n,a=this.institutions[i][s],o={primary:"locale-orig",secondary:!1,tertiary:!1};if(n=this.state.tmp.extension?["sort"]:a.isInstitution||a.literal?this.state.opt["cite-lang-prefs"].institutions:this.state.opt["cite-lang-prefs"].persons)for(var l=["primary","secondary","tertiary"],u=0,p=l.length;u<p&&!(n.length-1<u);u+=1)n[u]&&(o[l[u]]="locale-"+n[u]);else o.primary="locale-translat";"bibliography"===this.state.tmp.area||"citation"===this.state.tmp.area&&"note"===this.state.opt.xclass&&this.item&&!this.item.position||(o.secondary=!1,o.tertiary=!1),this.setRenderedName(a);var h=this._renderInstitutionName(i,a,o,s);this.institutions[i][s]=h}},p.NameOutput.prototype._renderInstitutionName=function(t,e,i,s){var r,n,a,o,l,u=this.getName(e,i.primary,!0),p=u.name,h=u.usedOrig;if(p&&(p=this.fixupInstitution(p,t,s)),c=!1,i.secondary){var c=(u=this.getName(e,i.secondary,!1,h)).name;h=u.usedOrig,c&&(c=this.fixupInstitution(c,t,s))}r=!1,i.tertiary&&(r=(u=this.getName(e,i.tertiary,!1,h)).name)&&(r=this.fixupInstitution(r,t,s));var m={l:{pri:!1,sec:!1,ter:!1},s:{pri:!1,sec:!1,ter:!1}};switch(p&&(m.l.pri=p.long,m.s.pri=p.short.length?p.short:p.long),c&&(m.l.sec=c.long,m.s.sec=c.short.length?c.short:c.long),r&&(m.l.ter=r.long,m.s.ter=r.short.length?r.short:r.long),this.institution.strings["institution-parts"]){case"short":p.short.length?(a=this._getShortStyle(),o=[this._composeOneInstitutionPart([m.s.pri,m.s.sec,m.s.ter],i,a,t)]):(n=this._getLongStyle(p,t,s),o=[this._composeOneInstitutionPart([m.l.pri,m.l.sec,m.l.ter],i,n,t)]);break;case"short-long":n=this._getLongStyle(p,t,s),a=this._getShortStyle(),o=[l=this._renderOneInstitutionPart(p.short,a),this._composeOneInstitutionPart([m.l.pri,m.l.sec,m.l.ter],i,n,t)];break;case"long-short":n=this._getLongStyle(p,t,s),a=this._getShortStyle(),l=this._renderOneInstitutionPart(p.short,a),o=[this._composeOneInstitutionPart([m.l.pri,m.l.sec,m.l.ter],i,n,t),l];break;default:n=this._getLongStyle(p,t,s),o=[this._composeOneInstitutionPart([m.l.pri,m.l.sec,m.l.ter],i,n,t)]}var f=this._join(o," ");return this.state.tmp.name_node.children.push(f),f},p.NameOutput.prototype._composeOneInstitutionPart=function(t,e,i){var s,r,n,a,o=!1,l=!1,u=!1;if(t[0]){if(s=p.Util.cloneToken(i),this.state.opt.citeAffixes[e.primary]&&"<i>"===this.state.opt.citeAffixes.institutions[e.primary].prefix){for(var h=!1,c=0,m=s.decorations.length;c<m;c+=1)"@font-style"===i.decorations[c][0]&&"italic"===s.decorations[c][1]&&(h=!0);h||s.decorations.push(["@font-style","italic"])}o=this._renderOneInstitutionPart(t[0],s)}if(t[1]&&(l=this._renderOneInstitutionPart(t[1],i)),t[2]&&(u=this._renderOneInstitutionPart(t[2],i)),l||u){this.state.output.openLevel("empty"),this.state.output.append(o),r=p.Util.cloneToken(i),e.secondary&&(r.strings.prefix=this.state.opt.citeAffixes.institutions[e.secondary].prefix,r.strings.suffix=this.state.opt.citeAffixes.institutions[e.secondary].suffix,r.strings.prefix||(r.strings.prefix=" "));var f=new p.Token;f.decorations.push(["@font-style","normal"]),f.decorations.push(["@font-weight","normal"]),this.state.output.openLevel(f),this.state.output.append(l,r),this.state.output.closeLevel(),n=p.Util.cloneToken(i),e.tertiary&&(n.strings.prefix=this.state.opt.citeAffixes.institutions[e.tertiary].prefix,n.strings.suffix=this.state.opt.citeAffixes.institutions[e.tertiary].suffix,n.strings.prefix||(n.strings.prefix=" "));var d=new p.Token;d.decorations.push(["@font-style","normal"]),d.decorations.push(["@font-weight","normal"]),this.state.output.openLevel(d),this.state.output.append(u,n),this.state.output.closeLevel(),this.state.output.closeLevel(),a=this.state.output.pop()}else a=o;return a},p.NameOutput.prototype._renderOneInstitutionPart=function(t,e){for(var i=0,s=t.length;i<s;i+=1)if(t[i]){var r=t[i];if(this.state.tmp.strip_periods)r=r.replace(/\./g,"");else for(var n=0,a=e.decorations.length;n<a;n+=1)if("@strip-periods"===e.decorations[n][0]&&"true"===e.decorations[n][1]){r=r.replace(/\./g,"");break}this.state.tmp.group_context.tip.variable_success=!0,this.state.tmp.can_substitute.replace(!1,p.LITERAL),"!here>>>"===r?t[i]=!1:(this.state.output.append(r,e,!0),t[i]=this.state.output.pop())}return void 0===this.institution.strings["part-separator"]&&(this.institution.strings["part-separator"]=this.state.tmp.name_delimiter),this._join(t,this.institution.strings["part-separator"])},p.NameOutput.prototype._renderNames=function(t,e,i,s){var r=!1;if(e.length){for(var n=[],a=0,o=e.length;a<o;a+=1){var l,u=e[a],h={primary:"locale-orig",secondary:!1,tertiary:!1};if(l=this.state.tmp.extension?["sort"]:u.isInstitution||u.literal?this.state.opt["cite-lang-prefs"].institutions:this.state.opt["cite-lang-prefs"].persons)for(var c=["primary","secondary","tertiary"],m=0,f=c.length;m<f&&!(l.length-1<m);m+=1)h[c[m]]="locale-"+l[m];else h.primary="locale-translat";if((this.state.tmp.sort_key_flag||"bibliography"!==this.state.tmp.area&&("citation"!==this.state.tmp.area||"note"!==this.state.opt.xclass||!this.item||this.item.position))&&(h.secondary=!1,h.tertiary=!1),this.setRenderedName(u),u.literal||u.isInstitution)n.push(this._renderInstitutionName(t,u,h,s));else{var d=this._renderPersonalName(t,u,h,i,a,s),g=p.Util.cloneToken(this.name);this.state.output.append(d,g,!0),n.push(this.state.output.pop())}}r=this.joinPersons(n,i,s)}return r},p.NameOutput.prototype._renderPersonalName=function(t,e,i,s,r,n){var a=this.getName(e,i.primary,!0),o=this._renderOnePersonalName(a.name,s,r,n),l=!1;i.secondary&&(a=this.getName(e,i.secondary,!1,a.usedOrig)).name&&(l=this._renderOnePersonalName(a.name,s,r,n));var u,h=!1;if(i.tertiary&&(a=this.getName(e,i.tertiary,!1,a.usedOrig)).name&&(h=this._renderOnePersonalName(a.name,s,r,n)),l||h){this.state.output.openLevel("empty"),this.state.output.append(o);var c=new p.Token;i.secondary&&(c.strings.prefix=this.state.opt.citeAffixes.persons[i.secondary].prefix,c.strings.suffix=this.state.opt.citeAffixes.persons[i.secondary].suffix,c.strings.prefix||(c.strings.prefix=" ")),this.state.output.append(l,c);var m=new p.Token;i.tertiary&&(m.strings.prefix=this.state.opt.citeAffixes.persons[i.tertiary].prefix,m.strings.suffix=this.state.opt.citeAffixes.persons[i.tertiary].suffix,m.strings.prefix||(m.strings.prefix=" ")),this.state.output.append(h,m),this.state.output.closeLevel(),u=this.state.output.pop()}else u=o;return u},p.NameOutput.prototype._isRomanesque=function(t){var e,i=2;return t.family.replace(/\"/g,"").match(p.ROMANESQUE_REGEXP)||(i=0),!i&&t.given&&t.given.match(p.STARTSWITH_ROMANESQUE_REGEXP)&&(i=1),2==i&&(t.multi&&t.multi.main?e=t.multi.main.slice(0,2):this.Item.language&&(e=this.Item.language.slice(0,2)),["ja","zh"].indexOf(e)>-1&&(i=1)),i},p.NameOutput.prototype._renderOnePersonalName=function(t,e,i,s){var r=t,n=this._droppingParticle(r,e,s),a=this._familyName(r),o=this._nonDroppingParticle(r),l=this._givenName(r,e,i),u=this._nameSuffix(r);!1===l&&(n=!1,u=!1);var h,c=this.state.inheritOpt(this.name,"sort-separator");c||(c=""),h=r["comma-suffix"]?", ":" ";var m=this._isRomanesque(r);var f,d,g,b,_=function t(e){return!!e&&("string"==typeof e.blobs?["’","'","-"," "].indexOf(e.blobs.slice(-1))>-1:t(e.blobs[e.blobs.length-1]))}(o);if(0===m)f=this._join([o,a,l],"");else if(1===m||r["static-ordering"])f=this._join([o,a,l]," ");else if(r["reverse-ordering"])f=this._join([l,o,a]," ");else if(this.state.tmp.sort_key_flag)"never"===this.state.opt["demote-non-dropping-particle"]?(g=this._join([o,a,n]," "),d=this._join([g,l],this.state.opt.sort_sep),f=this._join([d,u]," ")):(b=this._join([l,n,o]," "),d=this._join([a,b],this.state.opt.sort_sep),f=this._join([d,u]," "));else if("all"===this.state.inheritOpt(this.name,"name-as-sort-order")||"first"===this.state.inheritOpt(this.name,"name-as-sort-order")&&0===i&&(0===s||void 0===s))["Lord","Lady"].indexOf(r.given)>-1&&(c=", "),["always","display-and-sort"].indexOf(this.state.opt["demote-non-dropping-particle"])>-1?(b=this._join([l,n],r["comma-dropping-particle"]+" "),(b=this._join([b,o]," "))&&this.given&&(b.strings.prefix=this.given.strings.prefix,b.strings.suffix=this.given.strings.suffix),a&&this.family&&(a.strings.prefix=this.family.strings.prefix,a.strings.suffix=this.family.strings.suffix),d=this._join([a,b],c),f=this._join([d,u],c)):((g=_?this._join([o,a],""):this._join([o,a]," "))&&this.family&&(g.strings.prefix=this.family.strings.prefix,g.strings.suffix=this.family.strings.suffix),(b=this._join([l,n],r["comma-dropping-particle"]+" "))&&this.given&&(b.strings.prefix=this.given.strings.prefix,b.strings.suffix=this.given.strings.suffix),d=this._join([g,b],c),f=this._join([d,u],c));else{if(r["dropping-particle"]&&r.family&&!r["non-dropping-particle"]){var v=r["dropping-particle"];["'","ʼ","’","-"].indexOf(v.slice(-1))>-1&&"de"!==v.slice(0,-1)&&(a=this._join([n,a],""),n=!1)}var y=" ";this.state.inheritOpt(this.name,"initialize-with")&&this.state.inheritOpt(this.name,"initialize-with").match(/[\u00a0\ufeff]/)&&["fr","ru","cs"].indexOf(this.state.opt["default-locale"][0].slice(0,2))>-1&&(y=" "),_?(b=this._join([o,a],""),b=this._join([n,b],y)):b=this._join([n,o,a],y),(b=this._join([b,u],h))&&this.family&&(b.strings.prefix=this.family.strings.prefix,b.strings.suffix=this.family.strings.suffix),l&&this.given&&(l.strings.prefix=this.given.strings.prefix,l.strings.suffix=this.given.strings.suffix),b.strings.prefix&&(r["comma-dropping-particle"]=""),f=this._join([l,b],r["comma-dropping-particle"]+y)}return this.state.tmp.group_context.tip.variable_success=!0,this.state.tmp.can_substitute.replace(!1,p.LITERAL),this.state.tmp.term_predecessor=!0,this.state.tmp.name_node.children.push(f),f},p.NameOutput.prototype._normalizeNameInput=function(t){var e={literal:t.literal,family:t.family,isInstitution:t.isInstitution,given:t.given,suffix:t.suffix,"comma-suffix":t["comma-suffix"],"non-dropping-particle":t["non-dropping-particle"],"dropping-particle":t["dropping-particle"],"static-ordering":t["static-ordering"],"static-particles":t["static-particles"],"reverse-ordering":t["reverse-ordering"],"full-form-always":t["full-form-always"],"parse-names":t["parse-names"],"comma-dropping-particle":"",block_initialize:t.block_initialize,multi:t.multi};return this._parseName(e),e},p.NameOutput.prototype._stripPeriods=function(t,e){var i=this[t+"_decor"];if(e)if(this.state.tmp.strip_periods)e=e.replace(/\./g,"");else if(i)for(var s=0,r=i.decorations.length;s<r;s+=1)if("@strip-periods"===i.decorations[s][0]&&"true"===i.decorations[s][1]){e=e.replace(/\./g,"");break}return e},p.NameOutput.prototype._nonDroppingParticle=function(t){var e=t["non-dropping-particle"];e&&this.state.tmp.sort_key_flag&&(e=e.replace(/[\'\u2019]/,""));var i=this._stripPeriods("family",e);return!!this.state.output.append(i,this.family_decor,!0)&&this.state.output.pop()},p.NameOutput.prototype._droppingParticle=function(t,e,i){var s=t["dropping-particle"];s&&this.state.tmp.sort_key_flag&&(s=s.replace(/[\'\u2019]/,""));var r=this._stripPeriods("given",s);if(t["dropping-particle"]&&t["dropping-particle"].match(/^et.?al[^a-z]$/))this.state.inheritOpt(this.name,"et-al-use-last")?void 0===i?this.etal_spec[e].freeters=2:this.etal_spec[e].persons=2:void 0===i?this.etal_spec[e].freeters=1:this.etal_spec[e].persons=1,t["comma-dropping-particle"]="";else if(this.state.output.append(r,this.given_decor,!0))return this.state.output.pop();return!1},p.NameOutput.prototype._familyName=function(t){var e=this._stripPeriods("family",t.family);return!!this.state.output.append(e,this.family_decor,!0)&&this.state.output.pop()},p.NameOutput.prototype._givenName=function(t,e,i){var s,r,n="long"!==this.state.inheritOpt(this.name,"form","name-form","long"),a=!1!==this.state.inheritOpt(this.name,"initialize"),o="string"==typeof this.state.inheritOpt(this.name,"initialize-with")&&!t.block_initialize;if(t["full-form-always"])r=2;else{s=n?0:o?1:2;var l=this.state.tmp.disambig_settings.givens[e][i];r=l>s?l:s}var u=this.state.citation.opt["givenname-disambiguation-rule"];if(u&&"-with-initials"===u.slice(-14)&&(o=!0),t.family&&1===r)if(o){var h=this.state.inheritOpt(this.name,"initialize-with",!1,"");t.given=p.Util.Names.initializeWith(this.state,t.given,h,!a)}else t.given=p.Util.Names.unInitialize(this.state,t.given);else{if(0===r)return!1;2===r&&(t.given=p.Util.Names.unInitialize(this.state,t.given))}var c=this._stripPeriods("given",t.given);return!!this.state.output.append(c,this.given_decor,!0)&&this.state.output.pop()},p.NameOutput.prototype._nameSuffix=function(t){var e,i=t.suffix;"string"==typeof this.state.inheritOpt(this.name,"initialize-with")&&(i=p.Util.Names.initializeWith(this.state,t.suffix,this.state.inheritOpt(this.name,"initialize-with"),!0));var s="";return(i=this._stripPeriods("family",i))&&"."===i.slice(-1)&&(i=i.slice(0,-1),s="."),!!this.state.output.append(i,"empty",!0)&&((e=this.state.output.pop()).strings.suffix=s+e.strings.suffix,e)},p.NameOutput.prototype._getLongStyle=function(t){var e;return(e=t.short.length&&this.institutionpart["long-with-short"]?this.institutionpart["long-with-short"]:this.institutionpart.long)||(e=new p.Token),e},p.NameOutput.prototype._getShortStyle=function(){return this.institutionpart.short?this.institutionpart.short:new p.Token},p.NameOutput.prototype._parseName=function(t){if(!t["parse-names"]&&void 0!==t["parse-names"])return t;var e;t.family&&!t.given&&t.isInstitution&&(t.literal=t.family,t.family=void 0,t.isInstitution=void 0),t.family&&'"'===t.family.slice(0,1)&&'"'===t.family.slice(-1)||!t["parse-names"]&&void 0!==t["parse-names"]?(t.family=t.family.slice(1,-1),e=!0,t["parse-names"]=0):e=!1,this.state.opt.development_extensions.parse_names&&!t["non-dropping-particle"]&&t.family&&!e&&t.given&&(t["static-particles"]||p.parseParticles(t,!0))},p.NameOutput.prototype.getName=function(t,e,i,s){if(s&&"locale-orig"===e)return{name:!1,usedOrig:s};t.family||(t.family=""),t.given||(t.given="");var r={};r["static-ordering"]=this.getStaticOrder(t);var n,a=!0;if("locale-orig"!==e&&(a=!1,t.multi))for(var o=this.state.opt[e],l=0,u=o.length;l<u;l+=1)if(n=o[l],t.multi._key[n]){a=!0;var p=t.isInstitution;(t=t.multi._key[n]).isInstitution=p,(r=this.getNameParams(n)).transliterated=!0;break}return a||(n=!1,t.multi&&t.multi.main?n=t.multi.main:this.Item.language&&(n=this.Item.language),n&&(r=this.getNameParams(n))),i||a?(t.family||(t.family=""),t.given||(t.given=""),t.literal&&(delete t.family,delete t.given),!(t={family:t.family,given:t.given,"non-dropping-particle":t["non-dropping-particle"],"dropping-particle":t["dropping-particle"],suffix:t.suffix,"static-ordering":r["static-ordering"],"static-particles":t["static-particles"],"reverse-ordering":r["reverse-ordering"],"full-form-always":r["full-form-always"],"parse-names":t["parse-names"],"comma-suffix":t["comma-suffix"],"comma-dropping-particle":t["comma-dropping-particle"],transliterated:r.transliterated,block_initialize:r["block-initialize"],literal:t.literal,isInstitution:t.isInstitution,multi:t.multi}).literal&&!t.given&&t.family&&t.isInstitution&&(t.literal=t.family),t.literal&&(delete t.family,delete t.given),{name:t=this._normalizeNameInput(t),usedOrig:s||!a}):{name:!1,usedOrig:s}},p.NameOutput.prototype.getNameParams=function(t){var e={},i=p.localeResolve(this.Item.language,this.state.opt["default-locale"][0]),s=this.state.locale[i.best]?i.best:this.state.opt["default-locale"][0],r=this.state.locale[s].opts["name-as-sort-order"],n=this.state.locale[s].opts["name-as-reverse-order"],a=this.state.locale[s].opts["name-never-short"],o=t.split("-")[0];return r&&r[o]&&(e["static-ordering"]=!0,e["reverse-ordering"]=!1),n&&n[o]&&(e["reverse-ordering"]=!0,e["static-ordering"]=!1),a&&a[o]&&(e["full-form-always"]=!0),e["static-ordering"]&&(e["block-initialize"]=!0),e},p.NameOutput.prototype.setRenderedName=function(t){if("bibliography"===this.state.tmp.area){for(var e="",i=0,s=p.NAME_PARTS.length;i<s;i+=1)t[p.NAME_PARTS[i]]&&(e+=t[p.NAME_PARTS[i]]);this.state.tmp.rendered_name.push(e)}},p.NameOutput.prototype.fixupInstitution=function(t,e,i){t=this._splitInstitution(t,e,i),this.institution.strings["reverse-order"]&&t.long.reverse();var s=t.long,r=t.long.slice(),n=!1;if(this.state.sys.getAbbreviation)for(var a=this.Item.jurisdiction,o=0,l=s.length;o<l;o+=1){var u=s[o];a=this.state.transform.loadAbbreviation(a,"institution-part",u),this.state.transform.abbrevs[a]["institution-part"][u]&&(r[o]=this.state.transform.abbrevs[a]["institution-part"][u],n=!0)}return t.short=n?r:[],t},p.NameOutput.prototype.getStaticOrder=function(t,e){var i=!1;return!e&&t["static-ordering"]?i=!0:0===this._isRomanesque(t)?i=!0:(!t.multi||!t.multi.main)&&this.Item.language&&["vi","hu"].indexOf(this.Item.language)>-1?i=!0:t.multi&&t.multi.main&&["vi","hu"].indexOf(t.multi.main.slice(0,2))>-1?i=!0:this.state.opt["auto-vietnamese-names"]&&p.VIETNAMESE_NAMES.exec(t.family+" "+t.given)&&p.VIETNAMESE_SPECIALS.exec(t.family+t.given)&&(i=!0),i},p.NameOutput.prototype._splitInstitution=function(t,e,i){var s={};!t.literal&&t.family&&(t.literal=t.family,delete t.family);var r=t.literal.replace(/\s*\|\s*/g,"|");if(r=r.split("|"),"short"===this.institution.strings.form&&this.state.sys.getAbbreviation)for(var n=this.Item.jurisdiction,a=r.length;a>0;a+=-1){var o=r.slice(0,a).join("|");if(n=this.state.transform.loadAbbreviation(n,"institution-entire",o),this.state.transform.abbrevs[n]["institution-entire"][o]){var l=this.state.transform.abbrevs[n]["institution-entire"][o],u=(l=this.state.transform.quashCheck(l)).split(/>>[0-9]{4}>>/),p=l.match(/>>([0-9]{4})>>/);if(l=u.pop(),u.length>0&&this.Item["original-date"]&&this.Item["original-date"].year)for(var h=p.length-1;h>0&&!(parseInt(this.Item["original-date"].year,10)>=parseInt(p[h],10));h+=-1)l=u.pop();r=[l=l.replace(/\s*\|\s*/g,"|")];break}}return r.reverse(),s.long=this._trimInstitution(r,e,i),s},p.NameOutput.prototype._trimInstitution=function(t,e){var i=!1,s=!1,r=t.slice(),n=!1;return this.institution&&(void 0!==this.institution.strings["use-first"]&&(i=this.institution.strings["use-first"]),void 0!==this.institution.strings["stop-last"]?n=this.institution.strings["stop-last"]:"authority"===e&&this.state.tmp.authority_stop_last&&(n=this.state.tmp.authority_stop_last),n&&(r=r.slice(0,n),t=t.slice(0,n)),void 0!==this.institution.strings["use-last"]&&(s=this.institution.strings["use-last"]),"authority"===e&&(n&&(this.state.tmp.authority_stop_last=n),s&&(this.state.tmp.authority_stop_last+=-1*s))),!1===i&&(0===this.persons[e].length&&(i=this.institution.strings["substitute-use-first"]),i||(i=0)),!1===s&&(s=i?0:t.length),i>t.length-s&&(i=t.length-s),t=t.slice(0,i),r=r.slice(i),s&&(s>r.length&&(s=r.length),s&&(t=t.concat(r.slice(r.length-s)))),t},p.PublisherOutput=function(t,e){this.state=t,this.group_tok=e,this.varlist=[]},p.PublisherOutput.prototype.render=function(){this.clearVars(),this.composeAndBlob(),this.composeElements(),this.composePublishers(),this.joinPublishers()},p.PublisherOutput.prototype.composeAndBlob=function(){this.and_blob={};var t=!1;"text"===this.group_tok.strings.and?t=this.state.getTerm("and"):"symbol"===this.group_tok.strings.and&&(t="&");var e=new p.Token;e.strings.suffix=" ",e.strings.prefix=" ",this.state.output.append(t,e,!0);var i=this.state.output.pop();e.strings.prefix=this.group_tok.strings["subgroup-delimiter"],this.state.output.append(t,e,!0);var s=this.state.output.pop();this.and_blob.single=!1,this.and_blob.multiple=!1,t&&("always"===this.group_tok.strings["subgroup-delimiter-precedes-last"]?this.and_blob.single=s:"never"===this.group_tok.strings["subgroup-delimiter-precedes-last"]?(this.and_blob.single=i,this.and_blob.multiple=i):(this.and_blob.single=i,this.and_blob.multiple=s))},p.PublisherOutput.prototype.composeElements=function(){for(var t=0;t<2;t+=1)for(var e=["publisher","publisher-place"][t],i=0,s=this["publisher-list"].length;i<s;i+=1){var r=this[e+"-list"][i],n=this[e+"-token"];this.state.output.append(r,n,!0),this[e+"-list"][i]=this.state.output.pop()}},p.PublisherOutput.prototype.composePublishers=function(){for(var t,e=0,i=this["publisher-list"].length;e<i;e+=1)t=[this[this.varlist[0]+"-list"][e],this[this.varlist[1]+"-list"][e]],this["publisher-list"][e]=this._join(t,this.group_tok.strings.delimiter)},p.PublisherOutput.prototype.joinPublishers=function(){var t=this["publisher-list"],e=this._join(t,this.group_tok.strings["subgroup-delimiter"],this.and_blob.single,this.and_blob.multiple,this.group_tok);this.state.output.append(e,"literal")},p.PublisherOutput.prototype._join=p.NameOutput.prototype._join,p.PublisherOutput.prototype._getToken=p.NameOutput.prototype._getToken,p.PublisherOutput.prototype.clearVars=function(){this.state.tmp["publisher-list"]=!1,this.state.tmp["publisher-place-list"]=!1,this.state.tmp["publisher-group-token"]=!1,this.state.tmp["publisher-token"]=!1,this.state.tmp["publisher-place-token"]=!1},p.evaluateLabel=function(t,e,i,s){var r;"locator"===t.strings.term?(s&&s.label&&(r="sub verbo"===s.label?"sub-verbo":s.label),r||(r="page")):r=t.strings.term;var n=t.strings.plural;if("number"!=typeof n){var a=s&&"locator"===t.strings.term?s:i;a[t.strings.term]&&(e.processNumber(!1,a,t.strings.term,i.type),n=e.tmp.shadow_numbers[t.strings.term].plural,e.tmp.shadow_numbers[t.strings.term].labelForm||e.tmp.shadow_numbers[t.strings.term].labelDecorations||(e.tmp.shadow_numbers[t.strings.term].labelForm=t.strings.form,e.tmp.shadow_numbers[t.strings.term].labelCapitalizeIfFirst=t.strings.capitalize_if_first,e.tmp.shadow_numbers[t.strings.term].labelDecorations=t.decorations.slice()),["locator","number","page"].indexOf(t.strings.term)>-1&&e.tmp.shadow_numbers[t.strings.term].label&&(r=e.tmp.shadow_numbers[t.strings.term].label),t.decorations&&e.opt.development_extensions.csl_reverse_lookup_support&&(t.decorations.reverse(),t.decorations.push(["@showid","true",t.cslid]),t.decorations.reverse()))}return p.castLabel(e,t,r,n,p.TOLERANT)},p.castLabel=function(t,e,i,s,r){var n=e.strings.form,a=e.strings.capitalize_if_first;t.tmp.group_context.tip.label_form&&"static"!==n&&(n=t.tmp.group_context.tip.label_form),t.tmp.group_context.tip.label_capitalize_if_first&&(a=t.tmp.group_context.tip.label_capitalize_if_first);var o=t.getTerm(i,n,s,!1,r,e.default_locale);if(a&&(o=p.Output.Formatters["capitalize-first"](t,o)),t.tmp.strip_periods)o=o.replace(/\./g,"");else for(var l=0,u=e.decorations.length;l<u;l+=1)if("@strip-periods"===e.decorations[l][0]&&"true"===e.decorations[l][1]){o=o.replace(/\./g,"");break}return o},p.Node.name={build:function(t,e){var i,s;[p.SINGLETON,p.START].indexOf(this.tokentype)>-1&&(void 0===t.tmp.root?(s=void 0,t.tmp.root="citation"):s=t.tmp.root,t.inheritOpt(this,"et-al-subsequent-min")&&t.inheritOpt(this,"et-al-subsequent-min")!==t.inheritOpt(this,"et-al-min")&&(t.opt.update_mode=p.POSITION),t.inheritOpt(this,"et-al-subsequent-use-first")&&t.inheritOpt(this,"et-al-subsequent-use-first")!==t.inheritOpt(this,"et-al-use-first")&&(t.opt.update_mode=p.POSITION),t.tmp.root=s,i=function(t){t.tmp.etal_term="et-al",t.tmp.name_delimiter=t.inheritOpt(this,"delimiter","name-delimiter",", "),t.tmp["delimiter-precedes-et-al"]=t.inheritOpt(this,"delimiter-precedes-et-al"),"text"===t.inheritOpt(this,"and")?this.and_term=t.getTerm("and","long",0):"symbol"===t.inheritOpt(this,"and")&&(t.opt.development_extensions.expect_and_symbol_form?this.and_term=t.getTerm("and","symbol",0):this.and_term="&"),t.tmp.and_term=this.and_term,p.STARTSWITH_ROMANESQUE_REGEXP.test(this.and_term)?(this.and_prefix_single=" ",this.and_prefix_multiple=", ","string"==typeof t.tmp.name_delimiter&&(this.and_prefix_multiple=t.tmp.name_delimiter),this.and_suffix=" "):(this.and_prefix_single="",this.and_prefix_multiple="",this.and_suffix=""),"always"===t.inheritOpt(this,"delimiter-precedes-last")?this.and_prefix_single=t.tmp.name_delimiter:"never"===t.inheritOpt(this,"delimiter-precedes-last")?this.and_prefix_multiple&&(this.and_prefix_multiple=" "):"after-inverted-name"===t.inheritOpt(this,"delimiter-precedes-last")&&(this.and_prefix_single&&(this.and_prefix_single=t.tmp.name_delimiter),this.and_prefix_multiple&&(this.and_prefix_multiple=" ")),this.and={},t.inheritOpt(this,"and")?(t.output.append(this.and_term,"empty",!0),this.and.single=t.output.pop(),this.and.single.strings.prefix=this.and_prefix_single,this.and.single.strings.suffix=this.and_suffix,t.output.append(this.and_term,"empty",!0),this.and.multiple=t.output.pop(),this.and.multiple.strings.prefix=this.and_prefix_multiple,this.and.multiple.strings.suffix=this.and_suffix):t.tmp.name_delimiter&&(this.and.single=new p.Blob(t.tmp.name_delimiter),this.and.single.strings.prefix="",this.and.single.strings.suffix="",this.and.multiple=new p.Blob(t.tmp.name_delimiter),this.and.multiple.strings.prefix="",this.and.multiple.strings.suffix=""),this.ellipsis={},t.inheritOpt(this,"et-al-use-last")&&(this.ellipsis_term="…",this.ellipsis_prefix_single=" ",this.ellipsis_prefix_multiple=t.inheritOpt(this,"delimiter","name-delimiter",", "),this.ellipsis_suffix=" ",this.ellipsis.single=new p.Blob(this.ellipsis_term),this.ellipsis.single.strings.prefix=this.ellipsis_prefix_single,this.ellipsis.single.strings.suffix=this.ellipsis_suffix,this.ellipsis.multiple=new p.Blob(this.ellipsis_term),this.ellipsis.multiple.strings.prefix=this.ellipsis_prefix_multiple,this.ellipsis.multiple.strings.suffix=this.ellipsis_suffix),void 0===t.tmp["et-al-min"]&&(t.tmp["et-al-min"]=t.inheritOpt(this,"et-al-min")),void 0===t.tmp["et-al-use-first"]&&(t.tmp["et-al-use-first"]=t.inheritOpt(this,"et-al-use-first")),void 0===t.tmp["et-al-use-last"]&&(t.tmp["et-al-use-last"]=t.inheritOpt(this,"et-al-use-last")),t.nameOutput.name=this},t.build.name_flag=!0,this.execs.push(i));e.push(this)}},p.Node["name-part"]={build:function(t){t.build[this.strings.name]=this}},p.Node.names={build:function(t,e){var i;if(this.tokentype!==p.START&&this.tokentype!==p.SINGLETON||(p.Util.substituteStart.call(this,t,e),t.build.substitute_level.push(1)),this.tokentype===p.SINGLETON){for(var s in t.build.names_variables[t.build.names_variables.length-1].concat(this.variables),this.variables){var r=this.variables[s],n=t.build.name_label[t.build.name_label.length-1];Object.keys(n).length&&(n[r]=n[Object.keys(n)[0]])}i=function(t){t.nameOutput.reinit(this,this.variables_real[0])},this.execs.push(i)}if(this.tokentype===p.START&&(t.build.names_flag=!0,t.build.name_flag=!1,t.build.names_level+=1,t.build.names_variables.push(this.variables),t.build.name_label.push({}),i=function(t){t.tmp.can_substitute.push(!0),t.nameOutput.init(this)},this.execs.push(i)),this.tokentype===p.END){for(s=0;s<3;s+=1){var a=["family","given","et-al"][s];this[a]=t.build[a],1===t.build.names_level&&(t.build[a]=void 0)}this.label=t.build.name_label[t.build.name_label.length-1],t.build.names_level+=-1,t.build.names_variables.pop(),t.build.name_label.pop(),i=function(t){t.tmp.etal_node?this.etal_style=t.tmp.etal_node:this.etal_style="empty",this.etal_term=t.getTerm(t.tmp.etal_term,"long",0),this.etal_prefix_single=" ",this.etal_prefix_multiple=t.tmp.name_delimiter,"always"===t.tmp["delimiter-precedes-et-al"]?this.etal_prefix_single=t.tmp.name_delimiter:"never"===t.tmp["delimiter-precedes-et-al"]?this.etal_prefix_multiple=" ":"after-inverted-name"===t.tmp["delimiter-precedes-et-al"]&&(this.etal_prefix_single=t.tmp.name_delimiter,this.etal_prefix_multiple=" "),this.etal_suffix="",p.STARTSWITH_ROMANESQUE_REGEXP.test(this.etal_term)||(" "===this.etal_prefix_single&&(this.etal_prefix_single="")," "===this.etal_prefix_multiple&&(this.etal_prefix_multiple="")," "===this.etal_suffix&&(this.etal_suffix=""));for(var e=0;e<3;e+=1){var i=["family","given"][e];t.nameOutput[i]=this[i]}t.nameOutput.with=this.with;var s="",r="";p.STARTSWITH_ROMANESQUE_REGEXP.test("with")&&(s=" ",r=" ");var n={};n.single=new p.Blob("with"),n.single.strings.suffix=r,n.multiple=new p.Blob("with"),n.multiple.strings.suffix=r,"always"===t.inheritOpt(t.nameOutput.name,"delimiter-precedes-last")?(n.single.strings.prefix=t.inheritOpt(this,"delimiter","names-delimiter"),n.multiple.strings.prefix=t.inheritOpt(this,"delimiter","names-delimiter")):"contextual"===t.inheritOpt(t.nameOutput.name,"delimiter-precedes-last")?(n.single.strings.prefix=s,n.multiple.strings.prefix=t.inheritOpt(this,"delimiter","names-delimiter")):"after-inverted-name"===t.inheritOpt(t.nameOutput.name,"delimiter-precedes-last")?(n.single.strings.prefix=t.inheritOpt(this,"delimiter","names-delimiter"),n.multiple.strings.prefix=s):(n.single.strings.prefix=s,n.multiple.strings.prefix=s),t.nameOutput.with=n,t.nameOutput.label=this.label,t.nameOutput.etal_style=this.etal_style,t.nameOutput.etal_term=this.etal_term,t.nameOutput.etal_prefix_single=this.etal_prefix_single,t.nameOutput.etal_prefix_multiple=this.etal_prefix_multiple,t.nameOutput.etal_suffix=this.etal_suffix,t.nameOutput.outputNames(),t.tmp["et-al-use-first"]=void 0,t.tmp["et-al-min"]=void 0,t.tmp["et-al-use-last"]=void 0},this.execs.push(i),i=function(t){t.tmp.can_substitute.pop()||t.tmp.can_substitute.replace(!1,p.LITERAL),1===t.tmp.can_substitute.mystack.length&&(t.tmp.can_block_substitute=!1)},this.execs.push(i),t.build.name_flag=!1}e.push(this),this.tokentype!==p.END&&this.tokentype!==p.SINGLETON||(t.build.substitute_level.pop(),p.Util.substituteEnd.call(this,t,e))}},p.Node.number={build:function(t,e){var i;p.Util.substituteStart.call(this,t,e),"roman"===this.strings.form?this.formatter=t.fun.romanizer:"ordinal"===this.strings.form?this.formatter=t.fun.ordinalizer:"long-ordinal"===this.strings.form&&(this.formatter=t.fun.long_ordinalizer),void 0===this.successor_prefix&&(this.successor_prefix=t[t.build.area].opt.layout_delimiter),void 0===this.splice_prefix&&(this.splice_prefix=t[t.build.area].opt.layout_delimiter),i=function(t,e,i){if(0!==this.variables.length){var s;if(s=this.variables[0],void 0===i)i={};if(["locator","locator-extra"].indexOf(s)>-1){if(t.tmp.just_looking)return;if(!i[s])return}else if(!e[s])return;"collection-number"===s&&"legal_case"===e.type&&(t.tmp.renders_collection_number=!0);if(t.tmp.group_context.tip.force_suppress)return!1;["locator","locator-extra"].indexOf(s)>-1?t.processNumber.call(t,this,i,s,e.type):(t.tmp.group_context.tip.condition||(t.tmp.just_did_number=!0),t.processNumber.call(t,this,e,s,e.type)),p.Util.outputNumericField(t,s,e.id),["locator","locator-extra"].indexOf(this.variables_real[0])>-1&&!t.tmp.just_looking&&(t.tmp.done_vars.push(this.variables_real[0]),t.tmp.group_context.tip.done_vars.push(this.variables_real[0]))}},this.execs.push(i),e.push(this),p.Util.substituteEnd.call(this,t,e)}},p.Node.sort={build:function(t,e){if(e=t[t.build.root+"_sort"].tokens,this.tokentype===p.START){"citation"===t.build.area&&(t.opt.sort_citations=!0),t.build.area=t.build.root+"_sort",t.build.extension="_sort";var i=function(t,e){if(t.opt.has_layout_locale){for(var i,s=p.localeResolve(e.language,t.opt["default-locale"][0]),r=t[t.tmp.area.slice(0,-5)].opt.sort_locales,n=0,a=r.length;n<a&&((i=r[n][s.bare])||(i=r[n][s.best]),!i);n+=1);i||(i=t.opt["default-locale"][0]),t.tmp.lang_sort_hold=t.opt.lang,t.opt.lang=i}};this.execs.push(i)}if(this.tokentype===p.END){t.build.area=t.build.root,t.build.extension="";i=function(t){t.opt.has_layout_locale&&(t.opt.lang=t.tmp.lang_sort_hold,delete t.tmp.lang_sort_hold)};this.execs.push(i)}e.push(this)}},p.Node.substitute={build:function(t,e){var i;if(this.tokentype===p.START){var s=new p.Token("choose",p.START);p.Node.choose.build.call(s,t,e);var r=new p.Token("if",p.SINGLETON);i=function(){return!(!t.tmp.value.length||t.tmp.common_term_match_fail)},r.tests=[i],r.test=t.fun.match.any(r,t,r.tests),e.push(r),i=function(t){t.tmp.can_block_substitute=!0,t.tmp.value.length&&!t.tmp.common_term_match_fail&&t.tmp.can_substitute.replace(!1,p.LITERAL),t.tmp.common_term_match_fail=!1},this.execs.push(i),e.push(this)}if(this.tokentype===p.END){e.push(this);var n=new p.Token("choose",p.END);p.Node.choose.build.call(n,t,e)}}},p.Node.text={build:function(t,e){var i,s,r,n,a,o,l,u,h,c,m;if(this.postponed_macro){var f=p.Util.cloneToken(this);f.name="group",f.tokentype=p.START,p.Node.group.build.call(f,t,e),p.expandMacro.call(t,this,e);var d=p.Util.cloneToken(this);d.name="group",d.tokentype=p.END,"juris-locator-label"===this.postponed_macro&&(d.isJurisLocatorLabel=!0),p.Node.group.build.call(d,t,e)}else{if(p.Util.substituteStart.call(this,t,e),this.variables_real||(this.variables_real=[]),this.variables||(this.variables=[]),s="long",r=0,this.strings.form&&(s=this.strings.form),this.strings.plural&&(r=this.strings.plural),"citation-number"===this.variables_real[0]||"year-suffix"===this.variables_real[0]||"citation-label"===this.variables_real[0])"citation-number"===this.variables_real[0]?("citation"===t.build.root&&(t.opt.update_mode=p.NUMERIC),"bibliography"===t.build.root&&(t.opt.bib_mode=p.NUMERIC),"citation-number"===t[t.tmp.area].opt.collapse&&(this.range_prefix=t.getTerm("citation-range-delimiter")),this.successor_prefix=t[t.build.area].opt.layout_delimiter,this.splice_prefix=t[t.build.area].opt.layout_delimiter,i=function(t,e,i){if(n=""+e.id,!t.tmp.just_looking){if("_sort"===t.tmp.area.slice(-5)&&"citation-number"===this.variables[0]){if("bibliography_sort"===t.tmp.area&&t.tmp.group_context.tip.done_vars.push("citation-number"),"citation_sort"===t.tmp.area&&t.bibliography_sort.tmp.citation_number_map)var s=t.bibliography_sort.tmp.citation_number_map[t.registry.registry[e.id].seq];else s=t.registry.registry[e.id].seq;return s&&(s=p.Util.padding(""+s)),void t.output.append(s,this)}i&&i["author-only"]&&t.tmp.element_trace.replace("suppress-me"),s="bibliography_sort"!==t.tmp.area&&t.bibliography_sort.tmp.citation_number_map&&t.bibliography_sort.opt.citation_number_sort_direction===p.DESCENDING?t.bibliography_sort.tmp.citation_number_map[t.registry.registry[n].seq]:t.registry.registry[n].seq,t.opt.citation_number_slug?t.output.append(t.opt.citation_number_slug,this):(o=new p.NumericBlob(!1,s,this,e.id),t.tmp.in_cite_predecessor&&(o.suppress_splice_prefix=!0),t.output.append(o,"literal"))}},this.execs.push(i)):"year-suffix"===this.variables_real[0]?(t.opt.has_year_suffix=!0,"year-suffix-ranged"===t[t.tmp.area].opt.collapse&&(this.range_prefix=t.getTerm("citation-range-delimiter")),this.successor_prefix=t[t.build.area].opt.layout_delimiter,t[t.tmp.area].opt["year-suffix-delimiter"]&&(this.successor_prefix=t[t.build.area].opt["year-suffix-delimiter"]),i=function(t,e){if(t.registry.registry[e.id]&&!1!==t.registry.registry[e.id].disambig.year_suffix&&!t.tmp.just_looking){a=parseInt(t.registry.registry[e.id].disambig.year_suffix,10),t[t.tmp.area].opt.cite_group_delimiter&&(this.successor_prefix=t[t.tmp.area].opt.cite_group_delimiter),o=new p.NumericBlob(!1,a,this,e.id),l=new p.Util.Suffixator(p.SUFFIX_CHARS),o.setFormatter(l),t.output.append(o,"literal"),u=!1;for(var i=0,s=t.tmp.group_context.mystack.length;i<s;i++){var r=t.tmp.group_context.mystack[i];if(!r.variable_success&&(r.variable_attempt||!r.variable_attempt&&!r.term_intended)){u=!0;break}}h=t[t.tmp.area].opt["year-suffix-delimiter"],u&&h&&!t.tmp.sort_key_flag&&(t.tmp.splice_delimiter=t[t.tmp.area].opt["year-suffix-delimiter"])}},this.execs.push(i)):"citation-label"===this.variables_real[0]&&("bibliography"===t.build.root&&(t.opt.bib_mode=p.TRIGRAPH),t.opt.has_year_suffix=!0,i=function(t,e){(c=e["citation-label"])||(c=t.getCitationLabel(e)),t.tmp.just_looking||(m="",t.registry.registry[e.id]&&!1!==t.registry.registry[e.id].disambig.year_suffix&&(a=parseInt(t.registry.registry[e.id].disambig.year_suffix,10),m=t.fun.suffixator.format(a)),c+=m),t.output.append(c,this)},this.execs.push(i));else if(this.strings.term)i=function(t,e){var i,n=t.opt.gender[e.type],a=this.strings.term;if(""!==(a=t.getTerm(a,s,r,n,p.TOLERANT,this.default_locale))&&(t.tmp.group_context.tip.term_intended=!0),p.UPDATE_GROUP_CONTEXT_CONDITION(t,a),i=t.tmp.term_predecessor||"in-text"===t.opt.class&&"citation"===t.tmp.area?a:p.Output.Formatters["capitalize-first"](t,a),t.tmp.strip_periods)i=i.replace(/\./g,"");else for(var o=0,l=this.decorations.length;o<l;o+=1)if("@strip-periods"===this.decorations[o][0]&&"true"===this.decorations[o][1]){i=i.replace(/\./g,"");break}t.output.append(i,this)},this.execs.push(i),t.build.term=!1,t.build.form=!1,t.build.plural=!1;else if(this.variables_real.length){if(i=function(t,e){"locator"!==this.variables_real[0]&&(t.tmp.have_collapsed=!1),!t.tmp.group_context.tip.condition&&e[this.variables[0]]&&(t.tmp.just_did_number=!1);var i=e[this.variables[0]];i&&!t.tmp.group_context.tip.condition&&((""+i).slice(-1).match(/[0-9]/)?t.tmp.just_did_number=!0:t.tmp.just_did_number=!1)},this.execs.push(i),p.MULTI_FIELDS.indexOf(this.variables_real[0])>-1||["language-name","language-name-original"].indexOf(this.variables_real[0])>-1){var g=this.variables[0],b=!1,_=!1,v=!1;"short"===s?"-short"!==this.variables_real[0].slice(-6)&&(_=this.variables_real[0]+"-short"):g=!1,t.build.extension?v=!0:(v=!0,b=!0),i=t.transform.getOutputFunction(this.variables,g,b,_,v)}else i=p.CITE_FIELDS.indexOf(this.variables_real[0])>-1?function(t,e,i){i&&i[this.variables[0]]&&(t.processNumber(this,i,this.variables[0],e.type),p.Util.outputNumericField(t,this.variables[0],e.id),["locator","locator-extra"].indexOf(this.variables_real[0])>-1&&!t.tmp.just_looking&&t.tmp.done_vars.push(this.variables_real[0]))}:["page","page-first","chapter-number","collection-number","edition","issue","number","number-of-pages","number-of-volumes","volume"].indexOf(this.variables_real[0])>-1?function(t,e){t.processNumber(this,e,this.variables[0],e.type),p.Util.outputNumericField(t,this.variables[0],e.id)}:["URL","DOI"].indexOf(this.variables_real[0])>-1?function(t,e){var i;if(this.variables[0]&&(i=t.getVariable(e,this.variables[0],s)))if("URL"===this.variables[0]&&"short"===s&&(i=i.replace(/(.*\.[^\/]+)\/.*/,"$1")).match(/\/\/www\./)&&(i=i.replace(/https?:\/\//,"")),t.opt.development_extensions.wrap_url_and_doi)if(this.decorations.length&&this.decorations[0][0]==="@"+this.variables[0])t.output.append(i,this,!1,!1,!0);else{var r=p.Util.cloneToken(this),n=new p.Blob(null,null,"url-wrapper");if(n.decorations.push(["@DOI","true"]),"DOI"===this.variables_real[0]){var a;this.strings.prefix&&this.strings.prefix.match(/^.*https:\/\/doi\.org\/$/)&&(a=(i=i.replace(/^https?:\/\/doi\.org\//,"")).match(/^https?:\/\//)?"":"https://doi.org/",r.strings.prefix=this.strings.prefix.slice(0,r.strings.prefix.length-16));var o=new p.Blob(a),l=new p.Blob(i);n.push(o),n.push(l),t.output.append(n,r,!1,!1,!0)}else{l=new p.Blob(i);n.push(l),t.output.append(n,r,!1,!1,!0)}}else{if(this.decorations.length)for(var u=this.decorations.length-1;u>-1;u--)this.decorations[u][0]==="@"+this.variables[0]&&(this.decorations=this.decorations.slice(0,u).concat(this.decorations.slice(u+1)));t.output.append(i,this,!1,!1,!0)}}:"section"===this.variables_real[0]?function(t,e){var i;(i=t.getVariable(e,this.variables[0],s))&&t.output.append(i,this)}:"hereinafter"===this.variables_real[0]?function(t,e){var i=t.transform.abbrevs.default.hereinafter[e.id];i&&(t.output.append(i,this),t.tmp.group_context.tip.variable_success=!0)}:function(t,e){var i;this.variables[0]&&(i=t.getVariable(e,this.variables[0],s))&&(i=(i=""+i).split("\\").join(""),t.output.append(i,this))};this.execs.push(i)}else this.strings.value&&(i=function(t){t.tmp.group_context.tip.term_intended=!0,p.UPDATE_GROUP_CONTEXT_CONDITION(t,this.strings.value,!0),t.output.append(this.strings.value,this)},this.execs.push(i));e.push(this),p.Util.substituteEnd.call(this,t,e)}}},p.Node.intext={build:function(t,e){if(this.tokentype===p.START){t.build.area="intext",t.build.root="intext",t.build.extension="";this.execs.push((function(t,e){t.tmp.area="intext",t.tmp.root="intext",t.tmp.extension=""}))}this.tokentype===p.END&&(t.intext_sort={opt:{sort_directions:t.citation_sort.opt.sort_directions}},t.intext.srt=t.citation.srt),e.push(this)}},p.Attributes={},p.Attributes["@disambiguate"]=function(t,e){if(this.tests||(this.tests=[]),"true"===e){t.opt.has_disambiguate=!0;var i=function(e){if("bibliography"===t.tmp.area){if(t.tmp.disambiguate_count<t.registry.registry[e.id].disambig.disambiguate)return t.tmp.disambiguate_count+=1,!0}else if(t.tmp.disambiguate_maxMax+=1,t.tmp.disambig_settings.disambiguate&&t.tmp.disambiguate_count<t.tmp.disambig_settings.disambiguate)return t.tmp.disambiguate_count+=1,!0;return!1};this.tests.push(i)}else if("check-ambiguity-and-backreference"===e){i=function(e){return!!(t.registry.registry[e.id].disambig.disambiguate&&t.registry.registry[e.id]["citation-count"]>1)};this.tests.push(i)}},p.Attributes["@is-numeric"]=function(t,e){this.tests||(this.tests=[]);for(var i=e.split(/\s+/),s=function(e){return function(i,s){var r=i;if(s&&["locator","locator-extra"].indexOf(e)>-1&&(r=s),!r[e])return!1;if(p.NUMERIC_VARIABLES.indexOf(e)>-1){if(t.tmp.shadow_numbers[e]||t.processNumber(!1,r,e,i.type),t.tmp.shadow_numbers[e].numeric)return!0}else if(["title","locator-extra","version"].indexOf(e)>-1&&r[e].slice(-1)===""+parseInt(r[e].slice(-1),10))return!0;return!1}},r=0;r<i.length;r+=1)this.tests.push(s(i[r]))},p.Attributes["@is-uncertain-date"]=function(t,e){this.tests||(this.tests=[]);for(var i=e.split(/\s+/),s=function(t){return function(e){return!(!e[t]||!e[t].circa)}},r=0,n=i.length;r<n;r+=1)this.tests.push(s(i[r]))},p.Attributes["@locator"]=function(t,e){this.tests||(this.tests=[]);for(var i=e.replace("sub verbo","sub-verbo"),s=function(e){return function(i,s){var r;return t.processNumber(!1,s,"locator"),r=t.tmp.shadow_numbers.locator.label,e===r}},r=0,n=(i=i.split(/\s+/)).length;r<n;r+=1)this.tests.push(s(i[r]))},p.Attributes["@position"]=function(t,e){this.tests||(this.tests=[]),t.opt.update_mode=p.POSITION;for(var i=e.split(/\s+/),s=function(t,e){return!!(e&&e.position>=p.POSITION_SUBSEQUENT&&e["near-note"])},r=function(t,e){return!(!e||e.position!=p.POSITION_SUBSEQUENT||e["near-note"])},n=function(e){return function(i,s){if("bibliography"===t.tmp.area)return!1;if(s&&void 0===s.position&&(s.position=0),s&&"number"==typeof s.position){if(0===s.position&&0===e)return!0;if(e>0&&s.position>=e)return!0}else if(0===e)return!0;return!1}},a=0,o=i.length;a<o;a+=1){var l;"first"===(l=i[a])?l=p.POSITION_FIRST:"subsequent"===l?l=p.POSITION_SUBSEQUENT:"ibid"===l?l=p.POSITION_IBID:"ibid-with-locator"===l&&(l=p.POSITION_IBID_WITH_LOCATOR),"near-note"===l?this.tests.push(s):"far-note"===l?this.tests.push(r):this.tests.push(n(l))}},p.Attributes["@type"]=function(t,e){this.tests||(this.tests=[]);for(var i=e.split(/\s+/),s=function(t){return function(e){return!!(e.type===t)}},r=[],n=0,a=i.length;n<a;n+=1)r.push(s(i[n]));this.tests.push(t.fun.match.any(this,t,r))},p.Attributes["@variable"]=function(t,e){var i;if(this.tests||(this.tests=[]),this.variables=e.split(/\s+/),this.variables_real=this.variables.slice(),"label"===this.name&&this.variables[0])this.strings.term=this.variables[0];else if(["names","date","text","number"].indexOf(this.name)>-1)i=function(t,e,i){for(var s=this.variables.length-1;s>-1;s+=-1)this.variables.pop();s=0;for(var r=this.variables_real.length;s<r;s++)-1===t.tmp.done_vars.indexOf(this.variables_real[s])&&this.variables.push(this.variables_real[s]),t.tmp.can_block_substitute&&t.tmp.done_vars.push(this.variables_real[s])},this.execs.push(i),i=function(t,e,i){for(var s=!1,r=0,n=this.variables.length;r<n;r++){var a=this.variables[r];if(["authority","committee"].indexOf(a)>-1&&"string"==typeof e[a]&&"names"===this.name){var o=!0,l=e[a].split(/\s*;\s*/),u={};if(e.multi&&e.multi._keys[a])for(var h in e.multi._keys[a])if(u[h]=e.multi._keys[a][h].split(/\s*;\s*/),u[h].length!==l.length){o=!1;break}o||(l=[e[a]],u=e.multi._keys[a]);for(var c=0,m=l.length;c<m;c++){var f={literal:l[c],multi:{_key:{}}};for(var h in u){var d={literal:u[h][c]};f.multi._key[h]=d}l[c]=f}e[a]=l}if("short"!==this.strings.form||e[a]||("title"===a?a="title-short":"container-title"===a&&(a="container-title-short")),"year-suffix"===a){s=!0;break}if(p.DATE_VARIABLES.indexOf(a)>-1){if(t.opt.development_extensions.locator_date_and_revision&&"locator-date"===a){s=!0;break}if(e[a]){for(var g in e[a])if((-1!==this.dateparts.indexOf(g)||"literal"===g)&&e[a][g]){s=!0;break}if(s)break}}else{if("locator"===a){i&&i.locator&&(s=!0);break}if("locator-extra"===a){i&&i["locator-extra"]&&(s=!0);break}if(["citation-number","citation-label"].indexOf(a)>-1){s=!0;break}if("first-reference-note-number"===a){i&&i["first-reference-note-number"]&&(s=!0);break}if("hereinafter"===a){t.transform.abbrevs.default.hereinafter[e.id]&&t.sys.getAbbreviation&&e.id&&(s=!0);break}if("object"==typeof e[a])break;if("string"==typeof e[a]&&e[a]){s=!0;break}if("number"==typeof e[a]){s=!0;break}}if(s)break}if(s){for(r=0,n=this.variables_real.length;r<n;r++){"citation-number"===(a=this.variables_real[r])&&"bibliography"===t.tmp.area||(t.tmp.cite_renders_content=!0),t.tmp.group_context.tip.variable_success=!0,t.tmp.can_substitute.value()&&"bibliography"===t.tmp.area&&"string"==typeof e[a]&&(t.tmp.name_node.top=t.output.current.value(),t.tmp.rendered_name.push(e[a]))}t.tmp.can_substitute.replace(!1,p.LITERAL)}else t.tmp.group_context.tip.variable_attempt=!0},this.execs.push(i);else if(["if","else-if","condition"].indexOf(this.name)>-1)for(var s=function(e){return function(i,s){var r=i;if(s&&["locator","locator-extra","first-reference-note-number","locator-date"].indexOf(e)>-1&&(r=s),"hereinafter"===e&&t.sys.getAbbreviation&&r.id){if(t.transform.abbrevs.default.hereinafter[r.id])return!0}else if(r[e]){if("number"==typeof r[e]||"string"==typeof r[e])return!0;if("object"==typeof r[e])for(var n in r[e])if(r[e][n])return!0}return!1}},r=0,n=this.variables.length;r<n;r+=1)this.tests.push(s(this.variables[r]))},p.Attributes["@page"]=function(t,e){this.tests||(this.tests=[]);for(var i=e.replace("sub verbo","sub-verbo"),s=function(e){return function(i){var s;return t.processNumber(!1,i,"page",i.type),s=t.tmp.shadow_numbers.page.label?"sub verbo"===t.tmp.shadow_numbers.page.label?"sub-verbo":t.tmp.shadow_numbers.page.label:"page",e===s}},r=0,n=(i=i.split(/\s+/)).length;r<n;r+=1)this.tests.push(s(i[r]))},p.Attributes["@number"]=function(t,e){this.tests||(this.tests=[]);for(var i=e.split(/\s+/),s=function(e){return function(i){var s;return t.processNumber(!1,i,"number",i.type),s=t.tmp.shadow_numbers.number.label?t.tmp.shadow_numbers.number.label:"number",e===s}},r=0,n=i.length;r<n;r+=1)this.tests.push(s(i[r]))},p.Attributes["@jurisdiction"]=function(t,e){this.tests||(this.tests=[]);for(var i=e.split(/\s+/),s=0,r=i.length;s<r;s+=1)i[s]=i[s].split(":");var n=function(t){return function(e){if(!e.jurisdiction)return!1;for(var i=e.jurisdiction.split(":"),s=0,r=i.length;s<r;s+=1)i[s]=i[s].split(":");for(s=t.length;s>0;s+=-1){if(t.slice(0,s).join(":")!==i.slice(0,s).join(":"))return!1}return!0}};for(s=0,r=i.length;s<r;s+=1){var a=i[s].slice();this.tests.push(n(a))}},p.Attributes["@context"]=function(t,e){this.tests||(this.tests=[]);this.tests.push((function(){return["bibliography","citation"].indexOf(e)>-1?t.tmp.area.slice(0,e.length)===e:"alternative"===e?!!t.tmp.abort_alternative:void 0}))},p.Attributes["@has-year-only"]=function(t,e){this.tests||(this.tests=[]);for(var i=e.split(/\s+/),s=function(t){return function(e){var i=e[t];return!(!i||i.month||i.season)}},r=0,n=i.length;r<n;r+=1)this.tests.push(s(i[r]))},p.Attributes["@has-to-month-or-season"]=function(t,e){this.tests||(this.tests=[]);for(var i=e.split(/\s+/),s=function(t){return function(e){var i=e[t];return!(!i||!i.month&&!i.season||i.day)}},r=0,n=i.length;r<n;r+=1)this.tests.push(s(i[r]))},p.Attributes["@has-day"]=function(t,e){this.tests||(this.tests=[]);for(var i=e.split(/\s+/),s=function(t){return function(e){var i=e[t];return!(!i||!i.day)}},r=0,n=i.length;r<n;r+=1)this.tests.push(s(i[r]))},p.Attributes["@is-plural"]=function(t,e){this.tests||(this.tests=[]);this.tests.push((function(i){var s=i[e];if(s&&s.length){for(var r=0,n=0,a=!1,o=0,l=s.length;o<l;o+=1)t.opt.development_extensions.spoof_institutional_affiliations&&(s[o].literal||s[o].isInstitution&&s[o].family&&!s[o].given)?(n+=1,a=!1):(r+=1,a=!0);if(r>1)return!0;if(n>1)return!0;if(n&&a)return!0}return!1}))},p.Attributes["@locale"]=function(t,e){var i,s,r;this.tests||(this.tests=[]);var n=t.opt["default-locale"][0];if("layout"===this.name){if(this.locale_raw=e,this.tokentype===p.START){t.opt.multi_layout||(t.opt.multi_layout=[]);var a=[],o=e.split(/\s+/),l={},u=p.localeResolve(o[0],n);a.push(u),u.generic?l[u.generic]=u.best:l[u.best]=u.best;for(var h=1,c=o.length;h<c;h+=1){var m=p.localeResolve(o[h],n);a.push(m),m.generic?l[m.generic]=u.best:l[m.best]=u.best}t[t.build.area].opt.sort_locales.push(l),t.opt.multi_layout.push(a)}t.opt.has_layout_locale=!0}else{r=e.split(/\s+/);var f=[];for(h=0,c=r.length;h<c;h+=1)s=r[h],i=p.localeResolve(s,n),2===r[h].length&&f.push(i.bare),t.localeConfigure(i,!0),r[h]=i;var d=r.slice();this.tests.push(function(e,i,s){return function(r){var n;n=!1;var a,o;for(o=r.language?r.language:i,a=p.localeResolve(o,i),h=0,c=e.length;h<c;h+=1)if(a.best===e[h].best){t.tmp.condition_lang_counter_arr.push(t.tmp.condition_counter),t.tmp.condition_lang_val_arr.push(t.opt.lang),t.opt.lang=e[0].best,n=!0;break}return!n&&s.indexOf(a.bare)>-1&&(t.tmp.condition_lang_counter_arr.push(t.tmp.condition_counter),t.tmp.condition_lang_val_arr.push(t.opt.lang),t.opt.lang=e[0].best,n=!0),n}}(d,n,f))}},p.Attributes["@alternative-node-internal"]=function(t){this.tests||(this.tests=[]);this.tests.push((function(){return!t.tmp.abort_alternative}))},p.Attributes["@locale-internal"]=function(t,e){var i,s,r,n,a;for(this.tests||(this.tests=[]),r=e.split(/\s+/),this.locale_bares=[],n=0,a=r.length;n<a;n+=1)s=r[n],i=p.localeResolve(s,t.opt["default-locale"][0]),2===r[n].length&&this.locale_bares.push(i.bare),t.localeConfigure(i),r[n]=i;this.locale_default=t.opt["default-locale"][0],this.locale=r[0].best,this.locale_list=r.slice();this.tests.push(function(e){return function(i){var r;r=!1;var o=!1;if(i.language&&(s=i.language,(o=p.localeResolve(s,t.opt["default-locale"][0])).best===t.opt["default-locale"][0]&&(o=!1)),o){for(n=0,a=e.locale_list.length;n<a;n+=1)if(o.best===e.locale_list[n].best){t.opt.lang=e.locale,t.tmp.last_cite_locale=e.locale,t.output.openLevel("empty"),t.output.current.value().new_locale=e.locale,r=!0;break}!r&&e.locale_bares.indexOf(o.bare)>-1&&(t.opt.lang=e.locale,t.tmp.last_cite_locale=e.locale,t.output.openLevel("empty"),t.output.current.value().new_locale=e.locale,r=!0)}return r}}(this))},p.Attributes["@court-class"]=function(t,e){this.tests||(this.tests=[]);for(var i=e.split(/\s+/),s=function(e){return function(i){return p.GET_COURT_CLASS(t,i)===e}},r=0,n=i.length;r<n;r++)this.tests.push(s(i[r]))},p.Attributes["@is-parallel"]=function(t,e){t.opt.parallel.enable=!0,this.strings.set_parallel_condition=e},p.Attributes["@changes-in"]=function(t,e){for(var i=e.split(/\s+/),s=0,r=i.length;s<r;s++)t.opt.parallel.changes_in[i[s]]=!0;this.strings.set_changes_in_condition=i},p.Attributes["@no-repeat"]=function(t,e){t.opt.parallel.no_repeat||(t.opt.parallel.no_repeat={});var i=e.split(/\s+/);t.opt.parallel.enable=!0;for(var s=0,r=i.length;s<r;s++)t.opt.parallel.no_repeat[i[s]]=!0;this.strings.set_no_repeat_condition=i},p.Attributes["@parallel-delimiter-override"]=function(t,e){this.strings.set_parallel_delimiter_override=e},p.Attributes["@require"]=function(t,e){this.strings.require=e},p.Attributes["@reject"]=function(t,e){this.strings.reject=e},p.Attributes["@gender"]=function(t,e){this.gender=e},p.Attributes["@cslid"]=function(t,e){this.cslid=parseInt(e,10)},p.Attributes["@capitalize-if-first"]=function(t,e){this.strings.capitalize_if_first_override=e},p.Attributes["@label-capitalize-if-first"]=function(t,e){this.strings.label_capitalize_if_first_override=e},p.Attributes["@label-form"]=function(t,e){this.strings.label_form_override=e},p.Attributes["@part-separator"]=function(t,e){this.strings["part-separator"]=e},p.Attributes["@leading-noise-words"]=function(t,e){this["leading-noise-words"]=e},p.Attributes["@name-never-short"]=function(t,e){this["name-never-short"]=e},p.Attributes["@class"]=function(t,e){t.opt.class=e},p.Attributes["@version"]=function(t,e){t.opt.version=e},p.Attributes["@value"]=function(t,e){this.strings.value=e},p.Attributes["@name"]=function(t,e){this.strings.name=e},p.Attributes["@form"]=function(t,e){this.strings.form=e},p.Attributes["@date-parts"]=function(t,e){this.strings["date-parts"]=e},p.Attributes["@range-delimiter"]=function(t,e){this.strings["range-delimiter"]=e},p.Attributes["@macro"]=function(t,e){this.postponed_macro=e},p.Attributes["@term"]=function(t,e){this.strings.term="sub verbo"===e?"sub-verbo":e},p.Attributes["@xmlns"]=function(){},p.Attributes["@lang"]=function(t,e){e&&(t.build.lang=e)},p.Attributes["@lingo"]=function(){},p.Attributes["@macro-has-date"]=function(){this["macro-has-date"]=!0},p.Attributes["@suffix"]=function(t,e){this.strings.suffix=e},p.Attributes["@prefix"]=function(t,e){this.strings.prefix=e},p.Attributes["@delimiter"]=function(t,e){this.strings.delimiter=e},p.Attributes["@match"]=function(t,e){this.match=e},p.Attributes["@names-min"]=function(t,e){var i=parseInt(e,10);t[t.build.area].opt.max_number_of_names<i&&(t[t.build.area].opt.max_number_of_names=i),this.strings["et-al-min"]=i},p.Attributes["@names-use-first"]=function(t,e){this.strings["et-al-use-first"]=parseInt(e,10)},p.Attributes["@names-use-last"]=function(t,e){this.strings["et-al-use-last"]="true"===e},p.Attributes["@sort"]=function(t,e){"descending"===e&&(this.strings.sort_direction=p.DESCENDING)},p.Attributes["@plural"]=function(t,e){"always"===e||"true"===e?this.strings.plural=1:"never"===e||"false"===e?this.strings.plural=0:"contextual"===e&&(this.strings.plural=!1)},p.Attributes["@has-publisher-and-publisher-place"]=function(){this.strings["has-publisher-and-publisher-place"]=!0},p.Attributes["@publisher-delimiter-precedes-last"]=function(t,e){this.strings["publisher-delimiter-precedes-last"]=e},p.Attributes["@publisher-delimiter"]=function(t,e){this.strings["publisher-delimiter"]=e},p.Attributes["@publisher-and"]=function(t,e){this.strings["publisher-and"]=e},p.Attributes["@givenname-disambiguation-rule"]=function(t,e){p.GIVENNAME_DISAMBIGUATION_RULES.indexOf(e)>-1&&(t.citation.opt["givenname-disambiguation-rule"]=e)},p.Attributes["@collapse"]=function(t,e){e&&(t[this.name].opt.collapse=e)},p.Attributes["@cite-group-delimiter"]=function(t,e){e&&(t[t.tmp.area].opt.cite_group_delimiter=e)},p.Attributes["@names-delimiter"]=function(t,e){t.setOpt(this,"names-delimiter",e)},p.Attributes["@name-form"]=function(t,e){t.setOpt(this,"name-form",e)},p.Attributes["@subgroup-delimiter"]=function(t,e){this.strings["subgroup-delimiter"]=e},p.Attributes["@subgroup-delimiter-precedes-last"]=function(t,e){this.strings["subgroup-delimiter-precedes-last"]=e},p.Attributes["@name-delimiter"]=function(t,e){t.setOpt(this,"name-delimiter",e)},p.Attributes["@et-al-min"]=function(t,e){var i=parseInt(e,10);t[t.build.area].opt.max_number_of_names<i&&(t[t.build.area].opt.max_number_of_names=i),t.setOpt(this,"et-al-min",i)},p.Attributes["@et-al-use-first"]=function(t,e){t.setOpt(this,"et-al-use-first",parseInt(e,10))},p.Attributes["@et-al-use-last"]=function(t,e){"true"===e?t.setOpt(this,"et-al-use-last",!0):t.setOpt(this,"et-al-use-last",!1)},p.Attributes["@et-al-subsequent-min"]=function(t,e){var i=parseInt(e,10);t[t.build.area].opt.max_number_of_names<i&&(t[t.build.area].opt.max_number_of_names=i),t.setOpt(this,"et-al-subsequent-min",i)},p.Attributes["@et-al-subsequent-use-first"]=function(t,e){t.setOpt(this,"et-al-subsequent-use-first",parseInt(e,10))},p.Attributes["@suppress-min"]=function(t,e){this.strings["suppress-min"]=parseInt(e,10)},p.Attributes["@suppress-max"]=function(t,e){this.strings["suppress-max"]=parseInt(e,10)},p.Attributes["@and"]=function(t,e){t.setOpt(this,"and",e)},p.Attributes["@delimiter-precedes-last"]=function(t,e){t.setOpt(this,"delimiter-precedes-last",e)},p.Attributes["@delimiter-precedes-et-al"]=function(t,e){t.setOpt(this,"delimiter-precedes-et-al",e)},p.Attributes["@initialize-with"]=function(t,e){t.setOpt(this,"initialize-with",e)},p.Attributes["@initialize"]=function(t,e){"false"===e&&t.setOpt(this,"initialize",!1)},p.Attributes["@name-as-reverse-order"]=function(t,e){this["name-as-reverse-order"]=e},p.Attributes["@name-as-sort-order"]=function(t,e){"style-options"===this.name?this["name-as-sort-order"]=e:t.setOpt(this,"name-as-sort-order",e)},p.Attributes["@sort-separator"]=function(t,e){t.setOpt(this,"sort-separator",e)},p.Attributes["@require-match"]=function(t,e){"true"===e&&(this.requireMatch=!0)},p.Attributes["@exclude-types"]=function(t,e){t.bibliography.opt.exclude_types=e.split(/\s+/)},p.Attributes["@exclude-with-fields"]=function(t,e){t.bibliography.opt.exclude_with_fields=e.split(/\s+/)},p.Attributes["@year-suffix-delimiter"]=function(t,e){t[this.name].opt["year-suffix-delimiter"]=e},p.Attributes["@after-collapse-delimiter"]=function(t,e){t[this.name].opt["after-collapse-delimiter"]=e},p.Attributes["@subsequent-author-substitute"]=function(t,e){t[this.name].opt["subsequent-author-substitute"]=e},p.Attributes["@subsequent-author-substitute-rule"]=function(t,e){t[this.name].opt["subsequent-author-substitute-rule"]=e},p.Attributes["@disambiguate-add-names"]=function(t,e){"true"===e&&(t.opt["disambiguate-add-names"]=!0)},p.Attributes["@disambiguate-add-givenname"]=function(t,e){"true"===e&&(t.opt["disambiguate-add-givenname"]=!0)},p.Attributes["@disambiguate-add-year-suffix"]=function(t,e){"true"===e&&"numeric"!==t.opt.xclass&&(t.opt["disambiguate-add-year-suffix"]=!0)},p.Attributes["@second-field-align"]=function(t,e){"flush"!==e&&"margin"!==e||(t[this.name].opt["second-field-align"]=e)},p.Attributes["@hanging-indent"]=function(t,e){"true"===e&&(t.opt.development_extensions.hanging_indent_legacy_number?t[this.name].opt.hangingindent=2:t[this.name].opt.hangingindent=!0)},p.Attributes["@line-spacing"]=function(t,e){e&&e.match(/^[.0-9]+$/)&&(t[this.name].opt["line-spacing"]=parseFloat(e,10))},p.Attributes["@entry-spacing"]=function(t,e){e&&e.match(/^[.0-9]+$/)&&(t[this.name].opt["entry-spacing"]=parseFloat(e,10))},p.Attributes["@near-note-distance"]=function(t,e){t[this.name].opt["near-note-distance"]=parseInt(e,10)},p.Attributes["@text-case"]=function(t,e){this.execs.push((function(t,i){"normal"===e?this.text_case_normal=!0:(this.strings["text-case"]=e,"title"===e&&i.jurisdiction&&(this.strings["text-case"]="passthrough"))}))},p.Attributes["@page-range-format"]=function(t,e){t.opt["page-range-format"]=e},p.Attributes["@year-range-format"]=function(t,e){t.opt["year-range-format"]=e},p.Attributes["@default-locale"]=function(t,e){if("style"===this.name){var i,s,r,n,a;if(a=e.match(/-x-(sort|translit|translat)-/g))for(r=0,s=a.length;r<s;r+=1)a[r]=a[r].replace(/^-x-/,"").replace(/-$/,"");for(n=[(i=e.split(/-x-(?:sort|translit|translat)-/))[0]],r=1,s=i.length;r<s;r+=1)n.push(a[r-1]),n.push(i[r]);for(s=(i=n.slice()).length,r=1;r<s;r+=2)t.opt["locale-"+i[r]].push(i[r+1].replace(/^\s*/g,"").replace(/\s*$/g,""));i.length?t.opt["default-locale"]=i.slice(0,1):t.opt["default-locale"]=["en"]}else"true"===e&&(this.default_locale=!0)},p.Attributes["@default-locale-sort"]=function(t,e){t.opt["default-locale-sort"]=e},p.Attributes["@demote-non-dropping-particle"]=function(t,e){t.opt["demote-non-dropping-particle"]=e},p.Attributes["@initialize-with-hyphen"]=function(t,e){"false"===e&&(t.opt["initialize-with-hyphen"]=!1)},p.Attributes["@institution-parts"]=function(t,e){this.strings["institution-parts"]=e},p.Attributes["@if-short"]=function(t,e){"true"===e&&(this.strings["if-short"]=!0)},p.Attributes["@substitute-use-first"]=function(t,e){this.strings["substitute-use-first"]=parseInt(e,10)},p.Attributes["@use-first"]=function(t,e){this.strings["use-first"]=parseInt(e,10)},p.Attributes["@stop-last"]=function(t,e){this.strings["stop-last"]=-1*parseInt(e,10)},p.Attributes["@use-last"]=function(t,e){this.strings["use-last"]=parseInt(e,10)},p.Attributes["@reverse-order"]=function(t,e){"true"===e&&(this.strings["reverse-order"]=!0)},p.Attributes["@display"]=function(t,e){2===t.bibliography.tokens.length&&(t.opt.using_display=!0),this.strings.cls=e},p.Stack=function(t,e){this.mystack=[],(e||t)&&this.mystack.push(t),this.tip=this.mystack[0]},p.Stack.prototype.push=function(t,e){e||t?this.mystack.push(t):this.mystack.push(""),this.tip=this.mystack[this.mystack.length-1]},p.Stack.prototype.clear=function(){this.mystack=[],this.tip={}},p.Stack.prototype.replace=function(t,e){0===this.mystack.length&&p.error("Internal CSL processor error: attempt to replace nonexistent stack item with "+t),this.mystack[this.mystack.length-1]=e||t?t:"",this.tip=this.mystack[this.mystack.length-1]},p.Stack.prototype.pop=function(){var t=this.mystack.pop();return this.mystack.length?this.tip=this.mystack[this.mystack.length-1]:this.tip={},t},p.Stack.prototype.value=function(){return this.mystack.slice(-1)[0]},p.Stack.prototype.length=function(){return this.mystack.length},p.Parallel=function(t){this.state=t},p.Parallel.Partnerships=function(t,e){this.state=t,this.items=e.concat([[{},{}]]),this.partnerMap=null,this.partnerStatus=null,this.repeatMap=null},p.Parallel.Partnerships.prototype.update=function(t){this.items[t][0];var e=this.items[t+1][0];this.partnerStatus=null,this.partnerMap?this.partnerMap[e.id]?this.partnerStatus="mid":(this.partnerMap=null,this.partnerStatus="last"):this._setPartnerMap(t)&&(this.partnerStatus="first")},p.Parallel.Partnerships.prototype.getPartnerStatus=function(t){return this.partnerStatus},p.Parallel.Partnerships.prototype.getID=function(t){return this.items[t][0].id},p.Parallel.Partnerships.prototype._setPartnerMap=function(t){var e=this.items[t][0],i=this.items[t+1][0],s=!1;if(e.seeAlso&&e.seeAlso.indexOf(i.id)>-1){this.partnerMap={};for(var r=0,n=e.seeAlso.length;r<n;r++)this.partnerMap[e.seeAlso[r]]=!0;s=!0}return s},p.Parallel.Partnerships.prototype._getPartnerRepeats=function(t,e){var i=this.items[t][0],s=this.items[t+1][0],r=/(?:type|multi|id|seeAlso|.*-sub|.*-subjoin|.*-main)/,n={};for(var a in this.state.opt.parallel[e])if(i[a]){if(a.match(r))continue;if(!i[a])continue;"string"==typeof i[a]?i[a]===s[a]&&(n[a]=!0):"object"==typeof i[a]&&JSON.stringify(i[a])===JSON.stringify(s[a])&&(n[a]=!0)}return n},p.Parallel.prototype.StartCitation=function(t,e){if(this.parallel_conditional_blobs_list=[],t.length>1)for(var i=new p.Parallel.Partnerships(this.state,t),s=!1,r=0,n=t.length;r<n;r++){i.update(r);var a=i.getPartnerStatus(),o=i.getID(r);"first"===a?(t[r][1].parallel="first",r<n-1&&(t[r+1][1].parallel_repeats=i._getPartnerRepeats(r,"changes_in"),t[r][1].parallel_repeats=t[r+1][1].parallel_repeats),s=o,this.state.registry.registry[s].master=!0,this.state.registry.registry[s].siblings=[]):"mid"===a?(t[r][1].parallel="mid",r<n-1&&(t[r+1][1].parallel_repeats=i._getPartnerRepeats(r,"changes_in")),this.state.registry.registry[s].siblings.push(o),this.state.registry.masterMap[o]=s):"last"===a&&(t[r][1].parallel="last",r<n-1&&(t[r+1][1].parallel_repeats=i._getPartnerRepeats(r,"changes_in")),this.state.registry.registry[s].siblings.push(o),this.state.registry.masterMap[o]=s),this.state.opt.parallel.no_repeat&&r<n-1&&(t[r+1][1].no_repeat_repeats=i._getPartnerRepeats(r,"no_repeat"))}},p.Parallel.prototype.checkRepeats=function(t){var e=!1;if(t.no_repeat_repeats&&t.no_repeat_condition){for(var i=0,s=0,r=t.no_repeat_condition.length;s<r;s++)t.no_repeat_repeats[t.no_repeat_condition[s]]&&(i+=1);i===t.no_repeat_condition.length&&(e=!0)}return e},p.Parallel.prototype.checkParallels=function(t,e){var i=!1;if(t.parallel_result&&t.parallel_condition&&(i=!0,t.parallel_result===t.parallel_condition&&(i=!1),i&&t.changes_in_condition&&t.parallel_repeats)){i=!1;for(var s=0,r=0,n=t.changes_in_condition.length;r<n;r++)t.parallel_repeats[t.changes_in_condition[r]]&&(s+=1);s===t.changes_in_condition.length&&(i=!0)}return i},p.Parallel.prototype.purgeGroupsIfParallel=function(){},p.Util={},p.Util.Match=function(){this.any=function(t,e,i){return function(t,e){for(var s=0,r=i.length;s<r;s+=1){if(i[s](t,e))return!0}return!1}},this.none=function(t,e,i){return function(t,e){for(var s=0,r=i.length;s<r;s+=1){if(i[s](t,e))return!1}return!0}},this.all=function(t,e,i){return function(t,e){for(var s=0,r=i.length;s<r;s+=1){if(!i[s](t,e))return!1}return!0}},this[void 0]=this.all,this.nand=function(t,e,i){return function(t,e){for(var s=0,r=i.length;s<r;s+=1){if(!i[s](t,e))return!0}return!1}}},p.Transform=function(t){function e(e,i,s){var r="";return t.sys.getHumanForm&&("country"===e?r=(r=t.sys.getHumanForm(i.toLowerCase(),!1,!0)).split("|")[0]:"jurisdiction"===e&&(r=t.sys.getHumanForm(i.toLowerCase(),!1,!0),r=s?"":r.split("|").slice(1).join(", "))),r}function i(t,i,s,r,n,a,o){var l,u="",h=p.FIELD_CATEGORY_REMAP[a];if(!h)return n;var c=a,m=n;t.sys.normalizeAbbrevsKey&&(m=t.sys.normalizeAbbrevsKey(a,n));var f=!1;if("jurisdiction"===c&&m&&(f=-1===m.indexOf(":")),t.sys.getAbbreviation){l=["jurisdiction","country","language-name","language-name-original"].indexOf(c)>-1?"default":s.jurisdiction?s.jurisdiction:"default";var d=t.transform.loadAbbreviation(l,h,m,s.type);if(t.transform.abbrevs[d][h]&&m){var g=t.transform.abbrevs[d][h][m];u="short"===i.strings.form&&g?f?"":g:e(c,m,f)}}return u||t.opt.development_extensions.require_explicit_legal_case_title_short&&"legal_case"===s.type||!r||!s[r]||!o||(u=s[r]),u||t.sys.getAbbreviation||!t.sys.getHumanForm||(u=e(c,m,f)),u||f||t.sys.getHumanForm&&"jurisdiction"===c||(u=n),u}function s(e,i){var s,r=t.opt["default-locale"][0].slice(0,2);if(s=t.opt.development_extensions.strict_text_case_locales?new RegExp("^([a-zA-Z]{2})(?:$|-.*| .*)"):new RegExp("^([a-zA-Z]{2})(?:$|-.*|.*)"),e.language){var n=(""+e.language).match(s);r=n?n[1]:"tlh"}return e.multi&&e.multi&&e.multi.main&&e.multi.main[i]&&(r=e.multi.main[i]),t.opt.development_extensions.strict_text_case_locales&&!t.opt.development_extensions.normalize_lang_keys_to_lowercase||(r=r.toLowerCase()),r}function r(e,i,r,n,a,o){var l,u,h,c=a,m=!1;if(!e[i])return{name:"",usedOrig:a,token:p.Util.cloneToken(this)};var f=!1;p.VARIABLES_WITH_SHORT_FORM.indexOf(i)>-1&&o&&(i+="-short",f=!0);var d=!1,g=null,b=[];"-short"===i.slice(-6)?(b.push(i),b.push(i.slice(0,-6))):b.push(i);for(var _=0,v=b.length;_<v;_++){var y=!1;I={name:"",usedOrig:a,locale:s(e,i=b[_])},h=t.opt[r];var x=!1;if("locale-orig"===r)I=a?{name:"",usedOrig:a}:{name:e[i],usedOrig:!1,locale:s(e,i)},x=!0,m=!0;else if(n&&(void 0===h||0===h.length)){var I={name:e[i],usedOrig:!0,locale:s(e,i)};x=!0,m=!0}if(!x){for(var S=0,O=h.length;S<O;S+=1){if(u=(l=h[S]).split(/[\-_]/)[0],l&&e.multi&&e.multi._keys[i]&&e.multi._keys[i][l]){I.name=e.multi._keys[i][l],I.locale=l,x=!0,y=!0,m=!1;break}if(u&&e.multi&&e.multi._keys[i]&&e.multi._keys[i][u]){I.name=e.multi._keys[i][u],I.locale=u,x=!0,y=!0,m=!1;break}}!I.name&&n&&(I={name:e[i],usedOrig:!0,locale:s(e,i)},m=!0)}if(I.token=p.Util.cloneToken(this),0===_?(y&&(I.found_variant_ok=!0),g=I,f||void 0!==h&&0!==h.length||(d=!0),y&&(d=!0)):f||y||!g?y&&(I.found_variant_ok=!0):(I=g,i=b[0]),["title","container-title"].indexOf(i)>-1&&!(c||I.token.strings["text-case"]&&"sentence"!==I.token.strings["text-case"]&&"normal"!==I.token.strings["text-case"])){var T;t.opt.lang;T=!m&&I.locale;var N=i.slice(0,-5),A="sentence"===I.token.strings["text-case"];I.name=p.titlecaseSentenceOrNormal(t,e,N,T,A),delete I.token.strings["text-case"]}if(d)break}return I}function n(e,s,r,n){var a=e.variables[0];if(t.publisherOutput&&r){if(-1===["publisher","publisher-place"].indexOf(a))return!1;t.publisherOutput[a+"-token"]=e,t.publisherOutput.varlist.push(a);var o=r.split(/;\s*/);o.length===t.publisherOutput[a+"-list"].length&&(t.publisherOutput[a+"-list"]=o);for(var l=0,u=o.length;l<u;l+=1)o[l]=i(t,e,s,!1,o[l],n,!0);return t.tmp[a+"-token"]=e,!0}return!1}function a(e){var i=e.match(/^!([-,_a-z]+)>>>/);if(i){var s=i[1].split(",");e=e.slice(i[0].length);for(var r=0,n=s.length;r<n;r+=1)-1===t.tmp.done_vars.indexOf(s[r])&&t.tmp.done_vars.push(s[r])}return e}this.abbrevs={},this.abbrevs.default=new t.sys.AbbreviationSegments,this.getTextSubField=r,this.loadAbbreviation=function(e,i,s,r){return e||(e="default"),s?(t.sys.getAbbreviation&&((e=t.sys.getAbbreviation(t.opt.styleID,t.transform.abbrevs,e,i,s,r,!0))||(e="default")),e):(t.transform.abbrevs[e]||(t.transform.abbrevs[e]=new t.sys.AbbreviationSegments),t.transform.abbrevs[e][i]||(t.transform.abbrevs[e][i]={}),e)},this.quashCheck=a,this.getOutputFunction=function(e,s,o,l){var u,h=p.LangPrefsMap[e[0]];return u=!!h&&t.opt["cite-lang-prefs"][h],function(t,o,c){var m,f,d,g,b,_;if(!e[0]||!o[e[0]]&&!o[l])return null;if(!t.tmp.just_looking&&c&&c["suppress-author"]&&!t.tmp.probably_rendered_something&&t.tmp.can_substitute.length()>1)return null;var v={primary:!1,secondary:!1,tertiary:!1};if("_sort"===t.tmp.area.slice(-5))v.primary="locale-sort";else if(u&&1===u.length&&"locale-orig"===u[0])v.primary="locale-orig",u=!1;else if(u&&!t.tmp.multi_layout)for(var y=["primary","secondary","tertiary"],x=0,I=y.length;x<I&&!(u.length-1<x);x+=1)u[x]&&(v[y[x]]="locale-"+u[x]);else v.primary="locale-orig";if("title-short"!==e[0]&&("bibliography"===t.tmp.area||"citation"===t.tmp.area&&"note"===t.opt.xclass&&c&&!c.position)||(v.secondary=!1,v.tertiary=!1),t.tmp.multi_layout&&(v.secondary=!1,v.tertiary=!1),t.tmp["publisher-list"])return"publisher"===e[0]?t.tmp["publisher-token"]=this:"publisher-place"===e[0]&&(t.tmp["publisher-place-token"]=this),null;var S=r.call(this,o,e[0],v.primary,!0,null,s);m=S.name,f=S.locale;var O,T,N,A=S.token,E=S.usedOrig;if(s&&!S.found_variant_ok&&(m=i(t,A,o,l,m,s,!0))&&(m=a(m)),n(this,o,m,s))return null;if(d=!1,b=!1,v.secondary&&(d=(S=r.call(this,o,e[0],v.secondary,!1,S.usedOrig,null,s)).name,g=S.locale,O=S.token,s&&!S.found_variant_ok&&d&&(d=i(t,O,o,!1,d,s,!0))),v.tertiary&&(b=(S=r.call(this,o,e[0],v.tertiary,!1,S.usedOrig,null,s)).name,_=S.locale,T=S.token,s&&!S.found_variant_ok&&b&&(b=i(t,T,o,!1,b,s,!0))),"locale-translit"===v.primary&&(N=t.opt.citeAffixes[h][v.primary].prefix),"<i>"===N&&"title"===e[0]&&!E){var k=!1;for(x=0,I=A.decorations.length;x<I;x+=1)"@font-style"===A.decorations[x][0]&&"italic"===A.decorations[x][1]&&(k=!0);k||A.decorations.push(["@font-style","italic"])}if("en"!==f&&"title"===A.strings["text-case"]&&(A.strings["text-case"]="passthrough"),"title"===e[0]&&(m=p.demoteNoiseWords(t,m,this["leading-noise-words"])),d||b){if(t.output.openLevel("empty"),A.strings.suffix=A.strings.suffix.replace(/[ .,]+$/,""),t.output.append(m,A),t.tmp.probably_rendered_something=!0,m===d&&(d=!1),d){O.strings.prefix=t.opt.citeAffixes[h][v.secondary].prefix,O.strings.suffix=t.opt.citeAffixes[h][v.secondary].suffix,O.strings.prefix||(O.strings.prefix=" ");for(x=O.decorations.length-1;x>-1;x+=-1)["@quotes/true","@font-style/italic","@font-style/oblique","@font-weight/bold"].indexOf(O.decorations[x].join("/"))>-1&&(O.decorations=O.decorations.slice(0,x).concat(O.decorations.slice(x+1)));"en"!==g&&"title"===O.strings["text-case"]&&(O.strings["text-case"]="passthrough");var R=new p.Token;R.decorations.push(["@font-style","normal"]),R.decorations.push(["@font-weight","normal"]),t.output.openLevel(R),t.output.append(d,O),t.output.closeLevel();t.output.current.value(),t.output.current.value().blobs.length}if(m===b&&(b=!1),b){T.strings.prefix=t.opt.citeAffixes[h][v.tertiary].prefix,T.strings.suffix=t.opt.citeAffixes[h][v.tertiary].suffix,T.strings.prefix||(T.strings.prefix=" ");for(x=T.decorations.length-1;x>-1;x+=-1)["@quotes/true","@font-style/italic","@font-style/oblique","@font-weight/bold"].indexOf(T.decorations[x].join("/"))>-1&&(T.decorations=T.decorations.slice(0,x).concat(T.decorations.slice(x+1)));"en"!==_&&"title"===T.strings["text-case"]&&(T.strings["text-case"]="passthrough");var w=new p.Token;w.decorations.push(["@font-style","normal"]),w.decorations.push(["@font-weight","normal"]),t.output.openLevel(w),t.output.append(b,T),t.output.closeLevel();t.output.current.value(),t.output.current.value().blobs.length}t.output.closeLevel()}else t.output.append(m,A),t.tmp.probably_rendered_something=!0;return null}}},p.Token=function(t,e,i){this.name=t,this.strings={},this.strings.delimiter=void 0,this.strings.prefix="",this.strings.suffix="",this.decorations=[],this.variables=[],this.execs=[],this.tokentype=e},p.Util.cloneToken=function(t){var e,i,s;if("string"==typeof t)return t;for(var r in e=new p.Token(t.name,t.tokentype),t.strings)t.strings.hasOwnProperty(r)&&(e.strings[r]=t.strings[r]);if(t.decorations)for(e.decorations=[],i=0,s=t.decorations.length;i<s;i+=1)e.decorations.push(t.decorations[i].slice());return t.variables&&(e.variables=t.variables.slice()),t.execs&&(e.execs=t.execs.slice(),t.tests&&(e.tests=t.tests.slice())),e},p.AmbigConfig=function(){this.maxvals=[],this.minval=1,this.names=[],this.givens=[],this.year_suffix=!1,this.disambiguate=0},p.Blob=function(t,e,i){var s,r;if(this.levelname=i,e){for(var n in this.strings={prefix:"",suffix:""},e.strings)e.strings.hasOwnProperty(n)&&(this.strings[n]=e.strings[n]);for(this.decorations=[],s=void 0===e.decorations?0:e.decorations.length,r=0;r<s;r+=1)this.decorations.push(e.decorations[r].slice())}else this.strings={},this.strings.prefix="",this.strings.suffix="",this.strings.delimiter="",this.decorations=[];this.blobs="string"==typeof t?t:t?[t]:[],this.alldecor=[this.decorations]},p.Blob.prototype.push=function(t){"string"==typeof this.blobs?p.error("Attempt to push blob onto string object"):!1!==t&&(t.alldecor=t.alldecor.concat(this.alldecor),this.blobs.push(t))},p.NumericBlob=function(t,e,i,s){this.id=s,this.alldecor=[],this.num=e,this.particle=t,this.blobs=e.toString(),this.status=p.START,this.strings={},i?(this.gender=i.gender,this.decorations=i.decorations,this.strings.prefix=i.strings.prefix,this.strings.suffix=i.strings.suffix,this.strings["text-case"]=i.strings["text-case"],this.successor_prefix=i.successor_prefix,this.range_prefix=i.range_prefix,this.splice_prefix=i.splice_prefix,this.formatter=i.formatter,this.formatter||(this.formatter=new p.Output.DefaultFormatter),this.formatter&&(this.type=this.formatter.format(1))):(this.decorations=[],this.strings.prefix="",this.strings.suffix="",this.successor_prefix="",this.range_prefix="",this.splice_prefix="",this.formatter=new p.Output.DefaultFormatter)},p.NumericBlob.prototype.setFormatter=function(t){this.formatter=t,this.type=this.formatter.format(1)},p.Output.DefaultFormatter=function(){},p.Output.DefaultFormatter.prototype.format=function(t){return t.toString()},p.NumericBlob.prototype.checkNext=function(t,e){e?(this.status=p.START,"object"==typeof t&&(t.num===this.num+1?t.status=p.SUCCESSOR:t.status=p.SEEN)):t&&t.num&&this.type===t.type&&t.num===this.num+1?this.status===p.START||this.status===p.SEEN?t.status=p.SUCCESSOR:this.status!==p.SUCCESSOR&&this.status!==p.SUCCESSOR_OF_SUCCESSOR||(this.range_prefix?(t.status=p.SUCCESSOR_OF_SUCCESSOR,this.status=p.SUPPRESS):t.status=p.SUCCESSOR):(this.status===p.SUCCESSOR_OF_SUCCESSOR&&(this.status=p.END),"object"==typeof t&&(t.status=p.SEEN))},p.NumericBlob.prototype.checkLast=function(t){return(this.status===p.SEEN||t.num!==this.num-1&&this.status===p.SUCCESSOR)&&(this.status=p.SUCCESSOR,!0)},p.Util.fixDateNode=function(t,e,i){var s,r,n,a,o,l,u,p,h,c,m,f,d,g=this.cslXml.getAttributeValue(i,"lingo"),b=this.cslXml.getAttributeValue(i,"default-locale");if(this.build.date_key=!0,s=this.cslXml.getAttributeValue(i,"form"),g=b?this.opt["default-locale"][0]:this.cslXml.getAttributeValue(i,"lingo"),!this.getDate(s,b))return t;var _=this.cslXml.getAttributeValue(i,"date-parts");for(var v in r=this.cslXml.getAttributeValue(i,"variable"),p=this.cslXml.getAttributeValue(i,"prefix"),h=this.cslXml.getAttributeValue(i,"suffix"),f=this.cslXml.getAttributeValue(i,"display"),d=this.cslXml.getAttributeValue(i,"cslid"),n=this.cslXml.nodeCopy(this.getDate(s,b)),this.cslXml.setAttribute(n,"lingo",this.opt.lang),this.cslXml.setAttribute(n,"form",s),this.cslXml.setAttribute(n,"date-parts",_),this.cslXml.setAttribute(n,"cslid",d),this.cslXml.setAttribute(n,"variable",r),this.cslXml.setAttribute(n,"default-locale",b),p&&this.cslXml.setAttribute(n,"prefix",p),h&&this.cslXml.setAttribute(n,"suffix",h),f&&this.cslXml.setAttribute(n,"display",f),c=this.cslXml.children(n))a=c[v],"date-part"===this.cslXml.nodename(a)&&(o=this.cslXml.getAttributeValue(a,"name"),b&&this.cslXml.setAttributeOnNodeIdentifiedByNameAttribute(n,"date-part",o,"@default-locale","true"));for(var v in c=this.cslXml.children(i))if(a=c[v],"date-part"===this.cslXml.nodename(a))for(l in o=this.cslXml.getAttributeValue(a,"name"),m=this.cslXml.attributes(a))"@name"!==l&&(g&&g!==this.opt.lang&&["@suffix","@prefix","@form"].indexOf(l)>-1||(u=m[l],this.cslXml.setAttributeOnNodeIdentifiedByNameAttribute(n,"date-part",o,l,u)));if("year"===this.cslXml.getAttributeValue(i,"date-parts"))this.cslXml.deleteNodeByNameAttribute(n,"month"),this.cslXml.deleteNodeByNameAttribute(n,"day");else if("year-month"===this.cslXml.getAttributeValue(i,"date-parts"))this.cslXml.deleteNodeByNameAttribute(n,"day");else if("month-day"===this.cslXml.getAttributeValue(i,"date-parts")){for(var y=this.cslXml.children(n),x=1,I=this.cslXml.numberofnodes(y);x<I;x++)if("year"===this.cslXml.getAttributeValue(y[x],"name")){this.cslXml.setAttribute(y[x-1],"suffix","");break}this.cslXml.deleteNodeByNameAttribute(n,"year")}return this.cslXml.insertChildNodeAfter(t,i,e,n)},p.dateMacroAsSortKey=function(t,e){p.dateAsSortKey.call(this,t,e,!0)},p.dateAsSortKey=function(t,e,i){var s,r,n,a,o,l,u,h=this.variables[0],c="empty";for(i&&t.tmp.extension&&(c="macro-with-date"),void 0===(s=e[h])&&((s={"date-parts":[[0]]}).year||(t.tmp.empty_date=!0)),void 0===this.dateparts&&(this.dateparts=["year","month","day"]),s.raw?s=t.fun.dateparser.parseDateToArray(s.raw):s["date-parts"]&&(s=t.dateParseArray(s)),void 0===s&&(s={}),l=0,u=p.DATE_PARTS_INTERNAL.length;l<u;l+=1)if(n=0,"_end"===(a=r=p.DATE_PARTS_INTERNAL[l]).slice(-4)&&(a=a.slice(0,-4)),s[r]&&this.dateparts.indexOf(a)>-1&&(n=s[r]),"year"===r.slice(0,4)){var m="Y";"-"===(o=p.Util.Dates[a].numeric(t,n))[0]&&(m="X",o=o.slice(1),o=9999-parseInt(o,10)),t.output.append(p.Util.Dates[r.slice(0,4)].numeric(t,m+o),c)}else(n=p.Util.Dates[a]["numeric-leading-zeros"](t,n))||(n="00"),t.output.append(n,c)},p.Engine.prototype.dateParseArray=function(t){var e,i,s,r;for(i in e={},t)if("date-parts"===i){(s=t["date-parts"]).length>1&&s[0].length!==s[1].length&&p.error("CSL data error: element mismatch in date range input."),r=["","_end"];for(var n=0,a=s.length;n<a;n+=1)for(var o=0,l=p.DATE_PARTS.length;o<l;o+=1)isNaN(parseInt(s[n][o],10))?e[p.DATE_PARTS[o]+r[n]]=void 0:e[p.DATE_PARTS[o]+r[n]]=parseInt(s[n][o],10)}else t.hasOwnProperty(i)&&("literal"===i&&"object"==typeof t.literal&&"string"==typeof t.literal.part?(p.debug("Warning: fixing up weird literal date value"),e.literal=t.literal.part):e[i]=t[i]);return e},p.Util.Names={},p.Util.Names.compareNamesets=p.NameOutput.prototype._compareNamesets,p.Util.Names.unInitialize=function(t,e){var i,s,r,n,a;if(!e)return"";for(r=e.split(/(?:\-|\s+)/),n=e.match(/(\-|\s+)/g),a="",i=0,s=r.length;i<s;i+=1)a+=r[i],i<s-1&&(a+=n[i]);return a},p.Util.Names.initializeWith=function(t,e,i,s){var r,n,a;if(!e)return"";if(i||(i=""),["Lord","Lady"].indexOf(e)>-1||!e.match(p.STARTSWITH_ROMANESQUE_REGEXP)&&!i.match("%s"))return e;var o=e;!1===t.opt["initialize-with-hyphen"]&&(o=o.replace(/\-/g," "));for(var l=(o=(o=o.replace(/\s*\-\s*/g,"-").replace(/\s+/g," ")).replace(/-([a-z])/g,"–$1")).length-2;l>-1;l+=-1)"."===o.slice(l,l+1)&&" "!==o.slice(l+1,l+2)&&(o=o.slice(0,l)+". "+o.slice(l+1));if(n=o.match(/[\-\s]+/g),a=o.split(/[\-\s]+/),null===n){var u=a[0].match(/[^\.]+$/);u&&1===u[0].length&&u[0]!==u[0].toLowerCase()&&(a[0]+=".")}if(0===a.length)o=n;else for(o=[a[0]],l=1,r=a.length;l<r;l+=1)o.push(n[l-1]),o.push(a[l]);return a=o,(s?p.Util.Names.doNormalize(t,a,i):p.Util.Names.doInitialize(t,a,i)).replace(/\u2013([a-z])/g,"-$1")},p.Util.Names.doNormalize=function(t,e,i){var s,r;i=i||"";var n=[];for(s=0,r=e.length;s<r;s+=1)e[s].length>1&&"."===e[s].slice(-1)?(e[s]=e[s].slice(0,-1),n.push(!0)):1===e[s].length&&e[s].toUpperCase()===e[s]?n.push(!0):n.push(!1);for(s=0,r=e.length;s<r;s+=2)n[s]&&(s<e.length-2&&(e[s+1]="",n[s+2]||(e[s+1]=" "),e[s+2].length>1?e[s]=e[s]+i.replace(/\ufeff$/,""):e[s]=e[s]+i),s===e.length-1&&(e[s]=e[s]+i));return e.join("").replace(/[\u0009\u000a\u000b\u000c\u000d\u0020\ufeff\u00a0]+$/,"").replace(/\s*\-\s*/g,"-").replace(/[\u0009\u000a\u000b\u000c\u000d\u0020]+/g," ")},p.Util.Names.doInitialize=function(t,e,i){var s,r,n,a,o,l,u;for(s=0,r=e.length;s<r;s+=2)if(u=e[s])if(!(n=u.match(p.NAME_INITIAL_REGEXP))&&!u.match(p.STARTSWITH_ROMANESQUE_REGEXP)&&u.length>1&&i.match("%s")&&(n=u.match(/(.)(.*)/)),n&&n[2]&&n[3]&&(n[1]=n[1]+n[2],n[2]=""),n&&n[1].slice(0,1)===n[1].slice(0,1).toUpperCase()){var h="";if(n[2]){var c="";for(a=0,o=(l=n[2].split("")).length;a<o;a+=1){var m=l[a];if(m!==m.toUpperCase())break;c+=m}c.length<n[2].length&&(h=c.toLocaleLowerCase())}e[s]=n[1]+h,s<r-1?i.match("%s")?e[s]=i.replace("%s",e[s]):e[s+1].indexOf("-")>-1?e[s+1]=i+e[s+1]:e[s+1]=i:i.match("%s")?e[s]=i.replace("%s",e[s]):e.push(i)}else!u.match(p.ROMANESQUE_REGEXP)||n&&n[3]||(e[s]=" "+u);var f=e.join("");return f=f.replace(/[\u0009\u000a\u000b\u000c\u000d\u0020\ufeff\u00a0]+$/,"").replace(/\s*\-\s*/g,"-").replace(/[\u0009\u000a\u000b\u000c\u000d\u0020]+/g," ")},p.Util.Names.getRawName=function(t){var e=[];return t.literal?e.push(t.literal):(t.given&&e.push(t.given),t.family&&e.push(t.family)),e.join(" ")},p.Util.Dates={},p.Util.Dates.year={},p.Util.Dates.year.long=function(t,e){return e||(e="boolean"==typeof e?"":0),e.toString()},p.Util.Dates.year.imperial=function(t,e,i){var s="";e||(e="boolean"==typeof e?"":0),i=i?"_end":"";var r=t.tmp.date_object["month"+i];for(r=r?""+r:"1";r.length<2;)r="0"+r;var n=t.tmp.date_object["day"+i];for(n=n?""+n:"1";n.length<2;)n="0"+n;var a,o,l=parseInt(e+r+n,10);if(l>=18680908&&l<19120730?(a="明治",o=1867):l>=19120730&&l<19261225?(a="大正",o=1911):l>=19261225&&l<19890108?(a="昭和",o=1925):l>=19890108&&(a="平成",o=1988),a&&o){var u=a;t.sys.normalizeAbbrevsKey&&(u=t.sys.normalizeAbbrevsKey("number",a)),t.transform.abbrevs.default.number[u]||t.transform.loadAbbreviation("default","number",u),t.transform.abbrevs.default.number[u]&&(a=t.transform.abbrevs.default.number[u]),s=a+(e-o)}return s},p.Util.Dates.year.short=function(t,e){if((e=e.toString())&&4===e.length)return e.substr(2)},p.Util.Dates.year.numeric=function(t,e){var i,s;for((s=(e=""+e).match(/([0-9]*)$/))?(i=e.slice(0,-1*s[1].length),e=s[1]):(i=e,e="");e.length<4;)e="0"+e;return i+e},p.Util.Dates.normalizeMonth=function(t,e){var i;if(t||(t=0),(t=""+t).match(/^[0-9]+$/)||(t=0),t=parseInt(t,10),e){var s={stub:"month-",num:t};if(s.num<1||s.num>24)s.num=0;else{for(;s.num>16;)s.num=s.num-4;s.num>12&&(s.stub="season-",s.num=s.num-12)}i=s}else(t<1||t>12)&&(t=0),i=t;return i},p.Util.Dates.month={},p.Util.Dates.month.numeric=function(t,e){return(e=p.Util.Dates.normalizeMonth(e))||(e=""),e},p.Util.Dates.month["numeric-leading-zeros"]=function(t,e){if(e=p.Util.Dates.normalizeMonth(e))for(e=""+e;e.length<2;)e="0"+e;else e="";return e},p.Util.Dates.month.long=function(t,e,i,s){var r=p.Util.Dates.normalizeMonth(e,!0);if(e=r.num){for(e=""+e;e.length<2;)e="0"+e;e=t.getTerm(r.stub+e,"long",0,0,!1,s)}else e="";return e},p.Util.Dates.month.short=function(t,e,i,s){var r=p.Util.Dates.normalizeMonth(e,!0);if(e=r.num){for(e=""+e;e.length<2;)e="0"+e;e=t.getTerm(r.stub+e,"short",0,0,!1,s)}else e="";return e},p.Util.Dates.day={},p.Util.Dates.day.numeric=function(t,e){return e.toString()},p.Util.Dates.day.long=p.Util.Dates.day.numeric,p.Util.Dates.day["numeric-leading-zeros"]=function(t,e){for(e||(e=0),e=e.toString();e.length<2;)e="0"+e;return e.toString()},p.Util.Dates.day.ordinal=function(t,e,i){return t.fun.ordinalizer.format(e,i)},p.Util.Sort={},p.Util.Sort.strip_prepositions=function(t){var e;return"string"==typeof t&&(e=t.toLocaleLowerCase(),e=t.match(/^((a|an|the)\s+)/)),e&&(t=t.substr(e[1].length)),t},p.Util.substituteStart=function(t,e){var i,s,r,n,a,o,l;n=function(t,e,i){i&&i.parallel&&(t.tmp.group_context.tip.parallel_result=i.parallel),i&&i.parallel_repeats&&(t.tmp.group_context.tip.parallel_repeats=i.parallel_repeats),i&&i.no_repeat_repeats&&(t.tmp.group_context.tip.no_repeat_repeats=i.no_repeat_repeats);for(var s=0,r=this.decorations.length;s<r;s+=1)if("@strip-periods"===this.decorations[s][0]&&"true"===this.decorations[s][1]){t.tmp.strip_periods+=1;break}},this.execs.push(n),this.decorations&&t.opt.development_extensions.csl_reverse_lookup_support&&(this.decorations.reverse(),this.decorations.push(["@showid","true",this.cslid]),this.decorations.reverse()),l=["number","date","names"],("text"===this.name&&!this.postponed_macro||l.indexOf(this.name)>-1)&&(i=function(t,e,i){"author"===t.tmp.element_trace.value()||"names"===this.name?(!t.tmp.just_looking&&i&&i["author-only"]&&"intext"!==t.tmp.area&&t.tmp.probably_rendered_something&&t.tmp.element_trace.push("suppress-me"),!t.tmp.just_looking&&i&&i["suppress-author"]&&(t.tmp.probably_rendered_something||t.tmp.element_trace.push("suppress-me"))):"date"===this.name?!t.tmp.just_looking&&i&&i["author-only"]&&"intext"!==t.tmp.area&&t.tmp.probably_rendered_something&&t.tmp.element_trace.push("suppress-me"):!t.tmp.just_looking&&i&&i["author-only"]&&"intext"!==t.tmp.area?!t.tmp.probably_rendered_something&&t.tmp.can_block_substitute||t.tmp.element_trace.push("suppress-me"):i&&i["suppress-author"]&&t.tmp.element_trace.push("do-not-suppress-me")},this.execs.push(i)),s=this.strings.cls,this.strings.cls=!1,0===t.build.render_nesting_level&&("bibliography"===t.build.area&&t.bibliography.opt["second-field-align"]?((r=new p.Token("group",p.START)).decorations=[["@display","left-margin"]],n=function(t,e){t.tmp.render_seen||(r.strings.first_blob=e.id,t.output.startTag("bib_first",r))},r.execs.push(n),e.push(r)):p.DISPLAY_CLASSES.indexOf(s)>-1&&((r=new p.Token("group",p.START)).decorations=[["@display",s]],n=function(t,e){r.strings.first_blob=e.id,t.output.startTag("bib_first",r)},r.execs.push(n),e.push(r)),t.build.cls=s),t.build.render_nesting_level+=1,1===t.build.substitute_level.value()&&(a=new p.Token("choose",p.START),p.Node.choose.build.call(a,t,e),n=function(){return!!t.tmp.can_substitute.value()},(o=new p.Token("if",p.START)).tests||(o.tests=[]),o.tests.push(n),o.test=t.fun.match.any(this,t,o.tests),e.push(o)),t.sys.variableWrapper&&this.variables_real&&this.variables_real.length&&(n=function(t,e,i){if(!t.tmp.just_looking&&!t.tmp.suppress_decorations){var s=new p.Token("text",p.START);s.decorations=[["@showid","true"]],t.output.startTag("variable_entry",s);var r=null;i&&(r=i.position),r||(r=0);var n=0;i&&i.noteIndex&&(n=i.noteIndex);var a=0;i&&i["first-reference-note-number"]&&(a=i["first-reference-note-number"]);var o=0;i&&i["citation-number"]&&(o=i["citation-number"]);var l=0;i&&i.index&&(l=i.index);var u={itemData:e,variableNames:this.variables,context:t.tmp.area,xclass:t.opt.xclass,position:["first","subsequent","ibid","ibid-with-locator"][r],"note-number":n,"first-reference-note-number":a,"citation-number":o,index:l,mode:t.opt.mode};t.output.current.value().params=u}},this.execs.push(n))},p.Util.substituteEnd=function(t,e){var i,s,r,n,a,o;t.sys.variableWrapper&&(this.hasVariable||this.variables_real&&this.variables_real.length)&&(i=function(t){t.tmp.just_looking||t.tmp.suppress_decorations||t.output.endTag("variable_entry")},this.execs.push(i)),i=function(t){for(var e=0,i=this.decorations.length;e<i;e+=1)if("@strip-periods"===this.decorations[e][0]&&"true"===this.decorations[e][1]){t.tmp.strip_periods+=-1;break}},this.execs.push(i),t.build.render_nesting_level+=-1,0===t.build.render_nesting_level&&(t.build.cls?(i=function(t){t.output.endTag("bib_first")},this.execs.push(i),t.build.cls=!1):"bibliography"===t.build.area&&t.bibliography.opt["second-field-align"]&&(i=function(t){t.tmp.render_seen||t.output.endTag("bib_first")},(s=new p.Token("group",p.END)).execs.push(i),e.push(s),(r=new p.Token("group",p.START)).decorations=[["@display","right-inline"]],i=function(t){t.tmp.render_seen||(t.tmp.render_seen=!0,t.output.startTag("bib_other",r))},r.execs.push(i),e.push(r))),1===t.build.substitute_level.value()&&(n=new p.Token("if",p.END),e.push(n),a=new p.Token("choose",p.END),p.Node.choose.build.call(a,t,e)),("names"===this.name||"text"===this.name&&"title"!==this.variables_real)&&(new p.Token("text",p.SINGLETON),i=function(t,e){if("bibliography"===t.tmp.area&&"string"==typeof t.bibliography.opt["subsequent-author-substitute"]&&(!this.variables_real||e[this.variables_real])&&t.tmp.substituted_variable===this.variables_real){var i,s,r=t.bibliography.opt["subsequent-author-substitute-rule"];if(!t.tmp.suppress_decorations&&t.tmp.subsequent_author_substitute_ok&&t.tmp.rendered_name){if("partial-each"===r||"partial-first"===r){var n=!0,a=[];for(i=0,s=t.tmp.name_node.children.length;i<s;i+=1){var l=t.tmp.rendered_name[i];n&&t.tmp.last_rendered_name&&t.tmp.last_rendered_name.length>i-1&&l&&!l.localeCompare(t.tmp.last_rendered_name[i])?(o=new p.Blob(t[t.tmp.area].opt["subsequent-author-substitute"]),t.tmp.name_node.children[i].blobs=[o],"partial-first"===r&&(n=!1)):n=!1,a.push(l)}t.tmp.last_rendered_name=a}else if("complete-each"===r){if(a=t.tmp.rendered_name.join(",")){if(t.tmp.last_rendered_name&&!a.localeCompare(t.tmp.last_rendered_name))for(i=0,s=t.tmp.name_node.children.length;i<s;i+=1)o=new p.Blob(t[t.tmp.area].opt["subsequent-author-substitute"]),t.tmp.name_node.children[i].blobs=[o];t.tmp.last_rendered_name=a}}else{(a=t.tmp.rendered_name.join(","))&&(t.tmp.last_rendered_name&&!a.localeCompare(t.tmp.last_rendered_name)&&(o=new p.Blob(t[t.tmp.area].opt["subsequent-author-substitute"]),t.tmp.label_blob?t.tmp.name_node.top.blobs=[o,t.tmp.label_blob]:t.tmp.name_node.top.blobs.length?t.tmp.name_node.top.blobs[0].blobs=[o]:t.tmp.name_node.top.blobs=[o],t.tmp.substituted_variable=this.variables_real),t.tmp.last_rendered_name=a)}t.tmp.subsequent_author_substitute_ok=!1}}},this.execs.push(i)),("text"===this.name&&!this.postponed_macro||["number","date","names"].indexOf(this.name)>-1)&&(i=function(t,e){t.tmp.element_trace.mystack.length>1&&t.tmp.element_trace.pop()},this.execs.push(i))},p.Util.padding=function(t){var e=t.match(/\s*(-{0,1}[0-9]+)/);if(e)for((t=parseInt(e[1],10))<0&&(t=1e20+t),t=""+t;t.length<20;)t="0"+t;return t},p.Util.LongOrdinalizer=function(){},p.Util.LongOrdinalizer.prototype.init=function(t){this.state=t},p.Util.LongOrdinalizer.prototype.format=function(t,e){t<10&&(t="0"+t);var i=p.Engine.getField(p.LOOSE,this.state.locale[this.state.opt.lang].terms,"long-ordinal-"+t,"long",0,e);return i||(i=this.state.fun.ordinalizer.format(t,e)),this.state.tmp.cite_renders_content=!0,i},p.Util.Ordinalizer=function(t){this.state=t,this.suffixes={}},p.Util.Ordinalizer.prototype.init=function(){if(!this.suffixes[this.state.opt.lang]){this.suffixes[this.state.opt.lang]={};for(var t=0;t<3;t+=1){var e=[void 0,"masculine","feminine"][t];this.suffixes[this.state.opt.lang][e]=[];for(var i=1;i<5;i+=1){var s=this.state.getTerm("ordinal-0"+i,"long",!1,e);if(void 0===s){delete this.suffixes[this.state.opt.lang][e];break}this.suffixes[this.state.opt.lang][e].push(s)}}}},p.Util.Ordinalizer.prototype.format=function(t,e){var i;i=""+(t=parseInt(t,10));var s="",r=[];if(e&&r.push(e),r.push("neuter"),this.state.locale[this.state.opt.lang].ord["1.0.1"]){var n;s=this.state.getTerm("ordinal",!1,0,e);for(var a=0,o=r.length;a<o;a+=1){n=r[a];var l=this.state.locale[this.state.opt.lang].ord["1.0.1"];if(l["whole-number"][i]&&l["whole-number"][i][n]?s=this.state.getTerm(this.state.locale[this.state.opt.lang].ord["1.0.1"]["whole-number"][i][n],!1,0,e):l["last-two-digits"][i.slice(i.length-2)]&&l["last-two-digits"][i.slice(i.length-2)][n]?s=this.state.getTerm(this.state.locale[this.state.opt.lang].ord["1.0.1"]["last-two-digits"][i.slice(i.length-2)][n],!1,0,e):l["last-digit"][i.slice(i.length-1)]&&l["last-digit"][i.slice(i.length-1)][n]&&(s=this.state.getTerm(this.state.locale[this.state.opt.lang].ord["1.0.1"]["last-digit"][i.slice(i.length-1)][n],!1,0,e)),s)break}}else e||(e=void 0),this.state.fun.ordinalizer.init(),s=t/10%10==1||t>10&&t<20?this.suffixes[this.state.opt.lang][e][3]:t%10==1&&t%100!=11?this.suffixes[this.state.opt.lang][e][0]:t%10==2&&t%100!=12?this.suffixes[this.state.opt.lang][e][1]:t%10==3&&t%100!=13?this.suffixes[this.state.opt.lang][e][2]:this.suffixes[this.state.opt.lang][e][3];return i=i+=s},p.Util.Romanizer=function(){},p.Util.Romanizer.prototype.format=function(t){var e,i,s,r,n;if(e="",t<6e3)for((r=t.toString().split("")).reverse(),i=0,s=0,n=r.length,i=0;i<n;i+=1)s=parseInt(r[i],10),e=p.ROMAN_NUMERALS[i][s]+e;return e},p.Util.Suffixator=function(t){t||(t=p.SUFFIX_CHARS),this.slist=t.split(",")},p.Util.Suffixator.prototype.format=function(t){var e;t+=1;var i="";do{e=t%26==0?26:t%26;i=this.slist[e-1]+i;t=(t-e)/26}while(0!==t);return i},p.Engine.prototype.processNumber=function(t,e,i){var s,r=this,n=",\\s+and\\s+|\\s+and\\s+";"en"!==this.opt.lang.slice(0,2)&&(n+="|,\\s+"+this.getTerm("and")+"\\s+|\\s+"+this.getTerm("and")+"\\s+");var a=new RegExp("^\\s*&\\s*$"),o=new RegExp("(\\s*&\\s*|"+n+"|;\\s+|,\\s+|\\s*\\\\*[\\-\\u2013]+\\s*)","g"),l=new RegExp("(?:\\s*&\\s*|"+n+"|;\\s+|,\\s+|\\s*\\\\*[\\-\\u2013]+\\s*|\\s*&\\s*)"),u=this.getTerm("and"),h=this.getTerm("and","symbol");function c(t,e,s,r){r=r||"";var n={};if(e||p.STATUTE_SUBDIV_STRINGS_REVERSE[i]||(e="var:"+i),e){var a=e.match(/(\s*)([^\s]+)(\s*)/);n.label=a[2],n.origLabel=t,n.labelSuffix=a[3]?a[3]:"",n.plural=0,n.labelVisibility=!1}return(a=s.match(/^([0-9]*[a-zA-Z]+0*)?([0-9]+(?:[a-zA-Z]*|[-,a-zA-Z]+))$/))?(n.particle=a[1]?a[1]:"",n.value=a[2]):(n.particle="",n.value=s),n.joiningSuffix=r.replace(/\s*-\s*/,"-"),n}function m(t,e,i){var s=t[i.pos],r=t[e].value,n="\\-"===s.joiningSuffix;r.particle&&r.particle!==s.particle&&(i.collapsible=!1);var a=r.match(/^[0-9]+([-,:a-zA-Z]*)$/),o=s.value.match(/^[0-9]+([-,:a-zA-Z]*)$/);if(r&&a&&o&&!n||(i.collapsible=!1,r&&o||(i.numeric=!1),n&&i.count--),(a&&a[1]||o&&o[1])&&(i.collapsible=!1),void 0===t[e].collapsible){for(var l=e,u=e+i.count;l<u;l++)isNaN(parseInt(t[l].value))&&!t[l].value.match(/^[ivxlcmIVXLCM]+$/)?t[l].collapsible=!1:t[l].collapsible=!0;i.collapsible=t[e].collapsible}var p=i.collapsible;for(l=i.pos,u=i.pos+i.count;l<u;l++)i.count>1&&p&&(t[l].plural=1),t[l].numeric=i.numeric,t[l].collapsible=i.collapsible}function f(t,e,s){"var:"!==s.label.slice(0,4)&&(0===s.pos?(["locator","number","locator-extra"].indexOf(i)>-1&&(r.getTerm(p.STATUTE_SUBDIV_STRINGS[s.label])||(t[s.pos].labelVisibility=!0)),-1===["locator","number","locator-extra"].indexOf(i)&&p.STATUTE_SUBDIV_STRINGS[s.label]!==i&&(t[0].labelVisibility=!0)):t[s.pos].labelVisibility=!0)}function d(t){return t.replace("\\-","-")}function g(e){var i=p.Util.cloneToken(t),s=new p.Token;r.tmp.just_looking||(s.decorations=i.decorations,i.decorations=[],s.strings.prefix=i.strings.prefix,i.strings.prefix="",s.strings.suffix=i.strings.suffix,i.strings.suffix="");var n=e.length?e[0].label:null;if(e.length){for(var a=0,o=e.length;a<o;a++){var l=e[a],u=p.Util.cloneToken(i);u.gender=t.gender,n===l.label&&(u.formatter=t.formatter),l.numeric&&(u.successor_prefix=l.successor_prefix),u.strings.suffix=u.strings.suffix+d(l.joiningSuffix),l.styling=u}r.tmp.just_looking||'"'===e[0].value.slice(0,1)&&'"'===e[e.length-1].value.slice(-1)&&(e[0].value=e[0].value.slice(1),e[e.length-1].value=e[e.length-1].value.slice(0,-1),s.decorations.push(["@quotes",!0]))}return s}function b(t,e){return"page"===t||["locator","locator-extra"].indexOf(t)>-1&&(["p."].indexOf(e.label)>-1||["p."].indexOf(e.origLabel)>-1)}function _(t,e,i,s){var n=b(t,e);return function(t,e){var i,s=!0;return["locator","locator-extra"].indexOf(t)>-1&&(i=e.origLabel?e.origLabel:e.label,s=!!r.getTerm(p.STATUTE_SUBDIV_STRINGS[i])),s}(t,e)&&"-"===i&&s&&((n||["locator","locator-extra","issue","volume","edition","number"].indexOf(t)>-1)&&((i=r.getTerm("page-range-delimiter"))||(i="–")),"collection-number"===t&&((i=r.getTerm("year-range-delimiter"))||(i="–"))),i}function v(t,e,s){if(!(e<1)&&2===s.count&&t[e-1].particle===t[e].particle)if("-"===t[e-1].joiningSuffix)if(!r.opt["page-range-format"]&&parseInt(t[e-1].value,10)>parseInt(t[e].value,10))t[e-1].joiningSuffix=_(i,t[e],t[e-1].joiningSuffix,!0);else{var n,a=t[e];!b(i,a)||isNaN(parseInt(t[e-1].value))||isNaN(parseInt(t[e].value))?((""+t[e-1].value).match(/^([0-9]+|[ivxlcmIVXLCM]+)$/)&&(""+t[e].value).match(/^([0-9]+|[ivxlcmIVXLCM]+)$/)&&(t[e-1].joiningSuffix=r.getTerm("page-range-delimiter")),n=t[e-1].value+d(t[e-1].joiningSuffix)+t[e].value):(n=t[e-1].particle+t[e-1].value+" - "+t[e].particle+t[e].value,n=r.fun.page_mangler(n));var o=n.match(/^((?:[0-9]*[a-zA-Z]+0*))?([0-9]+[a-z]*)(\s*[^0-9]+\s*)([-,a-zA-Z]?0*)([0-9]+[a-z]*)$/);if(o){var l=o[3];l=_(i,a,l,t[e].numeric),t[e-1].particle=o[1],t[e-1].value=o[2],t[e-1].joiningSuffix=l,t[e].particle=o[4],t[e].value=o[5]}s.count=0}else s.count=1}function y(e){if(t&&-1!==["page","page-first","chapter-number","collection-number","edition","issue","number","number-of-pages","number-of-volumes","volume","locator","locator-extra"].indexOf(i)){for(var s={count:0,label:null,lastHadRangeDelimiter:!1},r=0,n=e.length;r<n;r++){var a=e[r];if(a.collapsible)s.label===a.label&&"-"===a.joiningSuffix?s.count=1:s.label===a.label&&"-"!==a.joiningSuffix?(s.count++,2===s.count&&v(e,r,s)):s.label!==a.label?(s.label=a.label,s.count=1):(s.count=1,s.label=a.label);else{s.count=0,s.label=null;var o=a.numeric;a.joiningSuffix=_(i,a,a.joiningSuffix,o)}}2===s.count&&v(e,e.length-1,s)}}if(u===h&&(h="&"),t&&this.tmp.shadow_numbers[i]&&this.tmp.shadow_numbers[i].values.length)return y(O=this.tmp.shadow_numbers[i].values),void(this.tmp.shadow_numbers[i].masterStyling=g(O));if(this.tmp.shadow_numbers[i]||(this.tmp.shadow_numbers[i]={values:[]}),e){var x=p.LangPrefsMap[i];if(x){var I=this.opt["cite-lang-prefs"][x][0];s=(s=this.transform.getTextSubField(e,i,"locale-"+I,!0)).name}else s=e[i];if(s&&this.sys.getAbbreviation){var S=this.transform.loadAbbreviation(e.jurisdiction,"number",s);this.transform.abbrevs[S].number&&(this.transform.abbrevs[S].number[s]?s=this.transform.abbrevs[S].number[s]:void 0!==this.transform.abbrevs[S].number[s]&&delete this.transform.abbrevs[S].number[s])}if(void 0!==s&&("string"==typeof s||"number"==typeof s)){"number"==typeof s&&(s=""+s);var O,T=p.STATUTE_SUBDIV_STRINGS_REVERSE[i];if(!this.tmp.shadow_numbers.values)!function(t){for(var e=0,i=t.length-1;e<i;e++)!t[e].joiningSuffix&&t[e+1].label&&(t[e].joiningSuffix=" ")}(O=function(t,s){s=s||"";var n=[];if(_=(t=function(t){var s=(t=t.trim()).match(/^([^ ]+)/);if(s&&!p.STATUTE_SUBDIV_STRINGS[s[1]]){var r=null;(r=["locator","locator-extra"].indexOf(i)>-1?e.label?p.STATUTE_SUBDIV_STRINGS_REVERSE[e.label]:"p.":p.STATUTE_SUBDIV_STRINGS_REVERSE[i])&&(t=r+" "+t)}return t}(t)).match(o)){for(var u=0,m=_.length;u<m;u++)_[u].match(a)&&(_[u]=" "+h+" ");var f=t.split(l);for(var u in f)if((""+f[u]).replace(/^[a-z]\.\s+/,"").match(/[^\s0-9ivxlcmIVXLCM]/))break;for(u=0,m=f.length-1;u<m;u++)n.push(f[u]),n.push(_[u]);n.push(f[f.length-1]),n=function(t){for(var e=t.length-2;e>-1;e-=2)"-"===t[e]&&t[e-1].match(/^(?:(?:[a-z]|[a-z][a-z]|[a-z][a-z][a-z]|[a-z][a-z][a-z][a-z])\.  *)*[0-9]+[,a-zA-Z]+$/)&&t[e+1].match(/^[,a-zA-Z]+$/)&&(t[e-1]=t.slice(e-1,e+2).join(""),t=t.slice(0,e).concat(t.slice(e+2)));return t}(n)}else n=[t];var d=[],g=s,b="";for(u=0,m=n.length;u<m;u+=2){var _;if(_=n[u].match(/((?:^| )(?:[a-z]|[a-z][a-z]|[a-z][a-z][a-z]|[a-z][a-z][a-z][a-z])(?:\.| ) *)/g)){for(var v=(f=n[u].split(/(?:(?:^| )(?:[a-z]|[a-z][a-z]|[a-z][a-z][a-z]|[a-z][a-z][a-z][a-z])(?:\.| ) *)/)).length-1;v>0;v--)!f[v-1]||f[v].match(/^[0-9]+([-;,:a-zA-Z]*)$/)&&f[v-1].match(/^[0-9]+([-;,:a-zA-Z]*)$/)||(f[v-1]=f[v-1]+_[v-1]+f[v],f=f.slice(0,v).concat(f.slice(v+1)),_=_.slice(0,v-1).concat(_.slice(v)));if(_.length>0){var y=_[0].trim();!p.STATUTE_SUBDIV_STRINGS[y]||!r.getTerm(p.STATUTE_SUBDIV_STRINGS[y])||-1===["locator","number","locator-extra"].indexOf(i)&&p.STATUTE_SUBDIV_STRINGS[y]!==i?0===u&&(_=_.slice(1),f[0]=f[0]+" "+y+" "+f[1],f=f.slice(0,1).concat(f.slice(2))):b=y}v=0;for(var x=f.length;v<x;v++){if(f[v]||v===f.length-1)I=b===(g=_[v-1]?_[v-1]:g).trim()?"":b,t=f[v]?f[v].trim():"",v===f.length-1?d.push(c(I,g,t,n[u+1])):d.push(c(I,g,t))}}else{var I;I=b===g.trim()?"":b,d.push(c(I,g,n[u],n[u+1]))}}return d}(s,T)),function(t){if(0!==t.length){for(var s=0,r=1,n=1,a=t.length;n<a;n++){var o=t[n-1],l=t[n];if(o.label===l.label&&o.particle==o.particle)r++;else(u=JSON.parse(JSON.stringify(t[s]))).pos=s,u.count=r,u.numeric=!0,m(t,s,u),o.label!==l.label&&f(t,0,u),s=n,r=1}var u;(u=JSON.parse(JSON.stringify(t[s]))).pos=s,u.count=r,u.numeric=!0,m(t,s,u),f(t,0,u),t.length&&t[0].numeric&&"number-of-"===i.slice(0,10)&&parseInt(e[i],10)>1&&(t[0].plural=1)}}(O),this.tmp.shadow_numbers[i].values=O;t&&(y(O),this.tmp.shadow_numbers[i].masterStyling=g(O)),function(t,e,i){var s=t[e];i.length&&(s.numeric=i[0].numeric,s.collapsible=i[0].collapsible,s.plural=i[0].plural,s.label=p.STATUTE_SUBDIV_STRINGS[i[0].label],"number"===e&&"issue"===s.label&&r.getTerm("number")&&(s.label="number"))}(this.tmp.shadow_numbers,i,O)}}},p.Util.outputNumericField=function(t,e,i){t.output.openLevel(t.tmp.shadow_numbers[e].masterStyling);var s,r=t.tmp.shadow_numbers[e].values,n=r.length?r[0].label:null,a=t.tmp.shadow_numbers[e].labelForm;s=a||"short";for(var o=t.tmp.shadow_numbers[e].labelCapitalizeIfFirst,l=t.tmp.shadow_numbers[e].labelDecorations,u=null,h=0,c=r.length;h<c;h++){var m,f=r[h],d="";f.label&&(m="var:"===f.label.slice(0,4)?f.label.slice(4):p.STATUTE_SUBDIV_STRINGS[f.label])&&(d=f.label===n?t.getTerm(m,a,f.plural):t.getTerm(m,s,f.plural),o&&(d=p.Output.Formatters["capitalize-first"](t,d)));var g=-1;d&&(g=d.indexOf("%s"));var b,_=p.Util.cloneToken(f.styling);if(_.formatter=f.styling.formatter,_.type=f.styling.type,_.num=f.styling.num,_.gender=f.styling.gender,g>0&&g<d.length-2)_.strings.prefix+=d.slice(0,g),_.strings.suffix=d.slice(g+2)+_.strings.suffix;else if(f.labelVisibility)if(d||(d=f.label,m=f.label),g>0){var v=new p.Token;v.decorations=l,t.output.append(d.slice(0,g),v)}else g!==d.length-2&&-1!==g||t.output.append(d+f.labelSuffix,"empty");if(f.collapsible)void 0===(b=f.value.match(/^[1-9][0-9]*$/)?new p.NumericBlob(f.particle,parseInt(f.value,10),_,i):new p.NumericBlob(f.particle,f.value,_,i)).gender&&(b.gender=t.locale[t.opt.lang]["noun-genders"][e]),t.output.append(b,"literal");else t.output.append(f.particle+f.value,_);if(0===g&&g<d.length-2&&(null===u&&(u=m),m!==u||h===r.length-1)){var y=new p.Token;y.decorations=l,t.output.append(d.slice(g+2),y)}u=m,t.tmp.term_predecessor=!0}t.output.closeLevel()},p.Util.PageRangeMangler={},p.Util.PageRangeMangler.getFunction=function(t,e){var i,s,r,n,a,o,l,u,p,h,c,m,f,d,g,b,_,v=t.getTerm(e+"-range-delimiter");i=/([0-9]*[a-zA-Z]+0*)?([0-9]+[a-z]*)\s*(?:\u2013|-)\s*([0-9]*[a-zA-Z]+0*)?([0-9]+[a-z]*)/,n=function(i){for(r=i.length,s=1;s<r;s+=2)"object"==typeof i[s]&&(i[s]=i[s].join(""));var n=i.join("");return n=n.replace(/([^\\])\-/g,"$1"+t.getTerm(e+"-range-delimiter"))},a=function(t){var e,i,n,a=new RegExp("([^\\\\])[-"+("-"===v?"":v)+"\\u2013]","g");t=t.replace(a,"$1 - ").replace(/\s+-\s+/g," - ");var o=new RegExp("((?:[0-9]*[a-zA-Z]+0*)?[0-9]+[a-z]*\\s+\\-\\s+(?:[0-9]*[a-zA-Z]+0*)?[0-9]+[a-z]*)","g"),l=new RegExp("(?:[0-9]*[a-zA-Z]+0*)?[0-9]+[a-z]*\\s+\\-\\s+(?:[0-9]*[a-zA-Z]+0*)?[0-9]+[a-z]*");if(e=t.match(o),0===(i=t.split(l)).length)n=e;else for(n=[i[0]],s=1,r=i.length;s<r;s+=1)n.push(e[s-1].replace(/\s*\-\s*/g,"-")),n.push(i[s]);return n},o=function(t){for(h=a(t=""+t),r=h.length,s=1;s<r;s+=2)(c=h[s].match(i))&&(c[3]&&c[1]!==c[3]||(c[4].length<c[2].length&&(c[4]=c[2].slice(0,c[2].length-c[4].length)+c[4]),parseInt(c[2],10)<parseInt(c[4],10)&&(c[3]=v+(c[1]?c[1]:""),h[s]=c.slice(1)))),"string"==typeof h[s]&&(h[s]=h[s].replace(/\-/g,v));return h},l=function(t,e,i){r=t.length;for(var s=1,a=t.length;s<a;s+=2)"object"==typeof t[s]&&(t[s][3]=u(t[s][1],t[s][3],e,i),t[s][2].slice(1)===t[s][0]&&(t[s][2]=v));return n(t)},u=function(t,e,i,s){if(i||(i=0),m=(""+t).split(""),f=(""+e).split(""),(d=f.slice()).reverse(),m.length===f.length)for(var r=0,n=m.length;r<n;r+=1){if(!(m[r]===f[r]&&d.length>i)){if(i&&s&&3===d.length){var a=m.slice(0,r);a.reverse(),d=d.concat(a)}break}d.pop()}return d.reverse(),d.join("")},p=function(t){for(r=t.length,s=1;s<r;s+=2)"object"==typeof t[s]&&(c=t[s],g=parseInt(c[1],10),b=parseInt(c[3],10),g>100&&g%100&&parseInt(g/100,10)===parseInt(b/100,10)?c[3]=""+b%100:g>=1e4&&(c[3]=""+b%1e3)),c[2].slice(1)===c[0]&&(c[2]=v);return n(t)};var y=function(t,e,i,s){return e(o(t=""+t),i,s)};return t.opt[e+"-range-format"]?"expanded"===t.opt[e+"-range-format"]?_=function(t){return y(t,n)}:"minimal"===t.opt[e+"-range-format"]?_=function(t){return y(t,l)}:"minimal-two"===t.opt[e+"-range-format"]?_=function(t,e){return y(t,l,2,e)}:"chicago"===t.opt[e+"-range-format"]&&(_=function(t){return y(t,p)}):_=function(t){return y(t,n)},_},p.Util.FlipFlopper=function(t){var e=[],i={'<span class="nocase">':{type:"nocase",opener:'<span class="nocase">',closer:"</span>",attr:null,outer:null,flipflop:null},'<span class="nodecor">':{type:"nodecor",opener:'<span class="nodecor">',closer:"</span>",attr:"@class",outer:"nodecor",flipflop:{nodecor:"nodecor"}},'<span style="font-variant:small-caps;">':{type:"tag",opener:'<span style="font-variant:small-caps;">',closer:"</span>",attr:"@font-variant",outer:"small-caps",flipflop:{"small-caps":"normal",normal:"small-caps"}},"<sc>":{type:"tag",opener:"<sc>",closer:"</sc>",attr:"@font-variant",outer:"small-caps",flipflop:{"small-caps":"normal",normal:"small-caps"}},"<i>":{type:"tag",opener:"<i>",closer:"</i>",attr:"@font-style",outer:"italic",flipflop:{italic:"normal",normal:"italic"}},"<b>":{type:"tag",opener:"<b>",closer:"</b>",attr:"@font-weight",outer:"bold",flipflop:{bold:"normal",normal:"bold"}},"<sup>":{type:"tag",opener:"<sup>",closer:"</sup>",attr:"@vertical-align",outer:"sup",flipflop:{sub:"sup",sup:"sup"}},"<sub>":{type:"tag",opener:"<sub>",closer:"</sub>",attr:"@vertical-align",outer:"sub",flipflop:{sup:"sub",sub:"sub"}},' "':{type:"quote",opener:' "',closer:'"',attr:"@quotes",outer:"true",flipflop:{true:"inner",inner:"true",false:"true"}}," '":{type:"quote",opener:" '",closer:"'",attr:"@quotes",outer:"inner",flipflop:{true:"inner",inner:"true",false:"true"}}};i['("']=i[' "'],i["('"]=i[" '"];var s=t.getTerm("open-quote"),r=t.getTerm("close-quote"),n=t.getTerm("open-inner-quote"),a=t.getTerm("close-inner-quote");function o(t){for(var e=[],s=Object.keys(i),r=0,n=s.length;r<n;r++){var a=s[r];"quote"===i[t].type&&i[t]||e.push(a)}var o=i[t];return o.opener=new RegExp("^(?:"+e.map((function(t){return t.replace("(","\\(")})).join("|")+")"),o}s&&r&&-1===[' "'," '",'"',"'"].indexOf(s)&&(i[s]=JSON.parse(JSON.stringify(i[' "'])),i[s].opener=s,i[s].closer=r),n&&a&&-1===[' "'," '",'"',"'"].indexOf(n)&&(i[n]=JSON.parse(JSON.stringify(i[" '"])),i[n].opener=n,i[n].closer=a);var l=function(){for(var t={},e=Object.keys(i),s=0,r=e.length;s<r;s++){var n=e[s];t[n]=o(n)}return t}(),u=function(){var t=[],e=[],i={};for(var s in l)t.push(s),i[l[s].closer]=!0;for(var r=Object.keys(i),n=0,a=r.length;n<a;n++){var o=r[n];e.push(o)}var u=t.concat(e).map((function(t){return t.replace("(","\\(")})).join("|");return{matchAll:new RegExp("((?:"+u+"))","g"),splitAll:new RegExp("(?:"+u+")","g"),open:new RegExp("(^(?:"+t.map((function(t){return t.replace("(","\\(")})).join("|")+")$)"),close:new RegExp("(^(?:"+e.join("|")+")$)")}}();function h(t,i){return t.match(u.open)?function(t,i){var s=e[e.length-1];return!s||t.match(s.opener)?(e.push({type:l[t].type,opener:l[t].opener,closer:l[t].closer,pos:i}),!1):(e.pop(),e.push({type:l[t].type,opener:l[t].opener,closer:l[t].closer,pos:i}),{fixtag:s.pos})}(t,i):function(t,i){var s=e[e.length-1];return s&&t===s.closer?(e.pop(),"nocase"===s.type&&{nocase:{open:s.pos,close:i}}):s?{fixtag:s.pos}:{fixtag:i}}(t,i)}function c(t,e){return h(t,e)}var m=function(e){var s=[];this.set=function(r){for(var n=i[r].attr,a=null,o=s.length-1;o>-1;o--){if((h=s[o])[0]===n){a=h;break}}if(!a){var l=[t[t.tmp.area].opt.layout_decorations].concat(e.alldecor);t:for(o=l.length-1;o>-1;o--){var u=l[o];if(u)for(var p=u.length-1;p>-1;p--){var h;if((h=u[p])[0]===n){a=h;break t}}}}a=a?[n,i[r].flipflop[a[1]]]:[n,i[r].outer],s.push(a)},this.pair=function(){return s[s.length-1]},this.pop=function(){s.pop()}};function f(t,e){if("'"===t){if(e&&e.match(/^[^\,\.\?\:\;\ ]/))return!0}else if(" '"===t&&e&&e.match(/^[\ ]/))return!0;return!1}this.processTags=function(s){var r=!1;" "!==(g=s.blobs).slice(0,1)||g.match(/^\s+[\'\"]/)||(r=!0);var n=new RegExp("("+p.ROMANESQUE_REGEXP.source+")’("+p.ROMANESQUE_REGEXP.source+")","g"),a=function(t){var e=[],s=(t=(t=t.replace(/(<span)\s+(style=\"font-variant:)\s*(small-caps);?\"[^>]*(>)/g,'$1 $2$3;"$4')).replace(/(<span)\s+(class=\"no(?:case|decor)\")[^>]*(>)/g,"$1 $2$3")).match(u.matchAll);if(!s)return{tags:[],strings:[t],forcedSpaces:[]};for(var r=t.split(u.splitAll),n=0,a=s.length-1;n<a;n++)i[s[n]]&&(""===r[n+1]&&['"',"'"].indexOf(s[n+1])>-1?(s[n+1]=" "+s[n+1],e.push(!0)):e.push(!1));return{tags:s,strings:r,forcedSpaces:e}}(g=" "+g.replace(n,"$1'$2"));if(0!==a.tags.length){for(var o,l=!1,h=0,d=a.tags.length;h<d;h++){var g;if(f(y=a.tags[h],g=a.strings[h+1]))a.strings[h+1]=" '"===y?" ’"+a.strings[h+1]:"’"+a.strings[h+1],a.tags[h]="";else{for(var b;b=c(y,h);){if(!(Object.keys(b).indexOf("fixtag")>-1)){if(b.nocase){a.tags[b.nocase.open]="",a.tags[b.nocase.close]="";break}break}if(y.match(u.close)&&"'"===y)a.strings[h+1]="’"+a.strings[h+1],a.tags[h]="";else{var _=a.tags[b.fixtag];a.forcedSpaces[b.fixtag-1]&&(_=_.slice(1)),a.strings[b.fixtag+1]=_+a.strings[b.fixtag+1],a.tags[b.fixtag]=""}if(!(e.length>0))break;e.pop()}b&&(b.fixtag||0===b.fixtag)&&(a.strings[h+1]=a.tags[h]+a.strings[h+1],a.tags[h]="")}}for(h=e.length-1;h>-1;h--){var v=e[h].pos,y=a.tags[v];a.strings[v+1]=" '"===y||"'"===y?" ’"+a.strings[v+1]:a.tags[v]+a.strings[v+1],a.tags[v]="",e.pop()}for(h=a.tags.length-1;h>-1;h--)a.tags[h]||(a.tags=a.tags.slice(0,h).concat(a.tags.slice(h+1)),a.strings[h]=a.strings[h]+a.strings[h+1],a.strings=a.strings.slice(0,h+1).concat(a.strings.slice(h+2)));for(h=0,d=a.tags.length;h<d;h++){y=a.tags[h];var x=a.forcedSpaces[h-1];[' "'," '",'("',"('"].indexOf(y)>-1&&(l||(i[o=y].outer="true",i[{" '":' "',' "':" '",'("':"('","('":'("'}[o]].outer="inner",l=!0),x||(a.strings[h]+=y.slice(0,1)))}!function(e,i,s){var r=!0,n=new m(e);e.blobs=[];var a=new function(e){this.stack=[e],this.latest=e,this.addStyling=function(e,i){if(r&&(" "===e.slice(0,1)&&(e=e.slice(1))," "===e.slice(0,1)&&(e=e.slice(1)),r=!1),this.latest=this.stack[this.stack.length-1],i){if("string"==typeof this.latest.blobs)(f=new p.Blob).blobs=this.latest.blobs,f.alldecor=this.latest.alldecor.slice(),this.latest.blobs=[f];var s=new p.Token;if((m=new p.Blob(null,s)).alldecor=this.latest.alldecor.slice(),"@class"===i[0]&&"nodecor"===i[1]){for(var n=[],a={},o=[t[t.tmp.area].opt.layout_decorations].concat(m.alldecor),l=o.length-1;l>-1;l--){var u=o[l];if(u)for(var h=u.length-1;h>-1;h--){var c=u[h];["@font-weight","@font-style","@font-variant"].indexOf(c[0])>-1&&!a[c[0]]&&("normal"!==i[1]&&(m.decorations.push([c[0],"normal"]),n.push([c[0],"normal"])),a[c[0]]=!0)}}m.alldecor.push(n)}else m.decorations.push(i),m.alldecor.push([i]);if(this.latest.blobs.push(m),this.stack.push(m),this.latest=m,e){var m;s=new p.Token;(m=new p.Blob(null,s)).blobs=e,m.alldecor=this.latest.alldecor.slice(),this.latest.blobs.push(m)}}else{var f;if(e)(f=new p.Blob).blobs=e,f.alldecor=this.latest.alldecor.slice(),this.latest.blobs.push(f)}},this.popStyling=function(){this.stack.pop()}}(e);if(i.strings.length){var o=i.strings[0];s&&(o=" "+o),a.addStyling(o)}for(var l=0,h=i.tags.length;l<h;l++){var c=i.tags[l];o=i.strings[l+1];c.match(u.open)?(n.set(c),a.addStyling(o,n.pair())):(n.pop(),a.popStyling(),a.addStyling(o))}}(s,a,r)}}},p.Output.Formatters=function(){var t=new p.Doppeler('(?:‘|’|“|”| "| \'|"|\'|[-–—/.,;?!:]|\\[|\\]|\\(|\\)|<span style="font-variant: small-caps;">|<span class="no(?:case|decor)">|</span>|</?(?:i|sc|b|sub|sup)>)',(function(t){return t.replace(/(<span)\s+(class=\"no(?:case|decor)\")[^>]*(>)/g,"$1 $2$3").replace(/(<span)\s+(style=\"font-variant:)\s*(small-caps);?(\")[^>]*(>)/g,"$1 $2 $3;$4$5")})),e=new p.Doppeler("(?:[   -​ 　]+)"),i={'<span style="font-variant: small-caps;">':"</span>",'<span class="nocase">':"</span>",'<span class="nodecor">':"</span>","<sc>":"</sc>","<sub>":"</sub>","<sup>":"</sup>"};function s(t){var e=t.match(/(^\s*)((?:[\0-\t\x0B\f\x0E-\u2027\u202A-\uD7FF\uE000-\uFFFF]|[\uD800-\uDBFF][\uDC00-\uDFFF]|[\uD800-\uDBFF](?![\uDC00-\uDFFF])|(?:[^\uD800-\uDBFF]|^)[\uDC00-\uDFFF]))(.*)/);return!e||e[2].match(/^[\u0370-\u03FF]$/)&&!e[3]?t:e[1]+e[2].toUpperCase()+e[3]}function r(r,n){if(!n)return"";r.doppel=t.split(n);var a={' "':{opener:" '",closer:'"'}," '":{opener:' "',closer:"'"},"‘":{opener:"‘",closer:"’"},"“":{opener:"“",closer:"”"}};function o(t,e){return["“","‘",' "'," '"].indexOf(t)>-1?function(t,e){if(0===r.quoteState.length||t===r.quoteState[r.quoteState.length-1].opener)return r.quoteState.push({opener:a[t].opener,closer:a[t].closer,pos:e}),!1;var i=r.quoteState[r.quoteState.length-1].pos;return r.quoteState.pop(),r.quoteState.push({opener:a[t].opener,closer:a[t].closer,positions:e}),i}(t,e):function(t,e){if(!(r.quoteState.length>0&&t===r.quoteState[r.quoteState.length-1].closer))return e;r.quoteState.pop()}(t,e)}function l(t,e){var i=t.match(/(^(?:\u2018|\u2019|\u201C|\u201D|\"|\')|(?: \"| \')$)/);if(i)return o(i[1],e)}r.doppel.strings.length&&r.doppel.strings[0].trim()&&(r.doppel.strings[0]=r.capitaliseWords(r.doppel.strings[0],0,r.doppel.tags[0]));for(var u=0,p=r.doppel.tags.length;u<p;u++){var h=r.doppel.tags[u],c=r.doppel.strings[u+1];if(null!==r.tagState&&(i[h]?r.tagState.push(i[h]):r.tagState.length&&h===r.tagState[r.tagState.length-1]&&r.tagState.pop()),null!==r.afterPunct&&h.match(/[\!\?\:]$/)&&(r.afterPunct=!0),0===r.tagState.length?r.doppel.strings[u+1]=r.capitaliseWords(c,u+1,r.doppel,r.doppel.tags[u+1]):r.doppel.strings[u+1].trim()&&(r.lastWordPos=null),null!==r.quoteState)if((f=l(h,u))||0===f){var m=r.doppel.origStrings[f+1].slice(0,1);r.doppel.strings[f+1]=m+r.doppel.strings[f+1].slice(1),r.lastWordPos=null}r.isFirst&&c.trim()&&(r.isFirst=!1),r.afterPunct&&c.trim()&&(r.afterPunct=!1)}if(r.quoteState)for(u=0,p=r.quoteState.length;u<p;u++){var f;if(void 0!==(f=r.quoteState[u].pos)){m=r.doppel.origStrings[f+1].slice(0,1);r.doppel.strings[f+1]=m+r.doppel.strings[f+1].slice(1)}}if(r.lastWordPos){var d=e.split(r.doppel.strings[r.lastWordPos.strings]),g=d.strings[r.lastWordPos.words];g.length>1&&g.toLowerCase().match(r.skipWordsRex)&&(g=s(g),d.strings[r.lastWordPos.words]=g),r.doppel.strings[r.lastWordPos.strings]=e.join(d)}return t.join(r.doppel)}return{passthrough:function(t,e){return e},lowercase:function(t,e){return r({quoteState:null,capitaliseWords:function(t){for(var e=t.split(" "),i=0,s=e.length;i<s;i++){var r=e[i];r&&(e[i]=r.toLowerCase())}return e.join(" ")},skipWordsRex:null,tagState:[],afterPunct:null,isFirst:null},e)},uppercase:function(t,e){return r({quoteState:null,capitaliseWords:function(t){for(var e=t.split(" "),i=0,s=e.length;i<s;i++){var r=e[i];r&&(e[i]=r.toUpperCase())}return e.join(" ")},skipWordsRex:null,tagState:[],afterPunct:null,isFirst:null},e)},sentence:function(t,e){var i={quoteState:[],capitaliseWords:function(t){for(var e=t.split(" "),r=0,n=e.length;r<n;r++){var a=e[r];a&&(i.isFirst?(e[r]=s(a),i.isFirst=!1):e[r]=a.toLowerCase())}return e.join(" ")},skipWordsRex:null,tagState:[],afterPunct:null,isFirst:!0};return r(i,e)},title:function(t,i){var n={quoteState:[],capitaliseWords:function(t,i,r){if(t.trim()){for(var a=t.split(/[ \u00A0]+/),o=e.split(t),l=0,u=(a=o.strings).length;l<u;l++){var p=a[l];p&&(p.length>1&&!p.toLowerCase().match(n.skipWordsRex)?a[l]=s(a[l]):l===a.length-1&&"-"===r?a[l]=s(a[l]):n.isFirst?a[l]=s(a[l]):n.afterPunct&&(a[l]=s(a[l])),n.afterPunct=!1,n.isFirst=!1,n.lastWordPos={strings:i,words:l})}t=e.join(o)}return t},skipWordsRex:t.locale[t.opt.lang].opts["skip-words-regexp"],tagState:[],afterPunct:!1,isFirst:!0};return r(n,i)},"capitalize-first":function(t,e){var i={quoteState:[],capitaliseWords:function(t){for(var e=t.split(" "),r=0,n=e.length;r<n;r++){var a=e[r];if(a&&i.isFirst){e[r]=s(a),i.isFirst=!1;break}}return e.join(" ")},skipWordsRex:null,tagState:[],afterPunct:null,isFirst:!0};return r(i,e)},"capitalize-all":function(t,e){return r({quoteState:[],capitaliseWords:function(t){for(var e=t.split(" "),i=0,r=e.length;i<r;i++){var n=e[i];n&&(e[i]=s(n))}return e.join(" ")},skipWordsRex:null,tagState:[],afterPunct:null,isFirst:null},e)}}}(),p.Output.Formats=function(){},p.Output.Formats.prototype.html={text_escape:function(t){return t||(t=""),t.replace(/&/g,"&#38;").replace(/</g,"&#60;").replace(/>/g,"&#62;").replace(/\s\s/g,"  ").replace(p.SUPERSCRIPTS_REGEXP,(function(t){return"<sup>"+p.SUPERSCRIPTS[t]+"</sup>"}))},bibstart:'<div class="csl-bib-body">\n',bibend:"</div>","@font-style/italic":"<i>%%STRING%%</i>","@font-style/oblique":"<em>%%STRING%%</em>","@font-style/normal":'<span style="font-style:normal;">%%STRING%%</span>',"@font-variant/small-caps":'<span style="font-variant:small-caps;">%%STRING%%</span>',"@passthrough/true":p.Output.Formatters.passthrough,"@font-variant/normal":'<span style="font-variant:normal;">%%STRING%%</span>',"@font-weight/bold":"<b>%%STRING%%</b>","@font-weight/normal":'<span style="font-weight:normal;">%%STRING%%</span>',"@font-weight/light":!1,"@text-decoration/none":'<span style="text-decoration:none;">%%STRING%%</span>',"@text-decoration/underline":'<span style="text-decoration:underline;">%%STRING%%</span>',"@vertical-align/sup":"<sup>%%STRING%%</sup>","@vertical-align/sub":"<sub>%%STRING%%</sub>","@vertical-align/baseline":'<span style="baseline">%%STRING%%</span>',"@strip-periods/true":p.Output.Formatters.passthrough,"@strip-periods/false":p.Output.Formatters.passthrough,"@quotes/true":function(t,e){return void 0===e?t.getTerm("open-quote"):t.getTerm("open-quote")+e+t.getTerm("close-quote")},"@quotes/inner":function(t,e){return void 0===e?"’":t.getTerm("open-inner-quote")+e+t.getTerm("close-inner-quote")},"@quotes/false":!1,"@cite/entry":function(t,e){return t.sys.wrapCitationEntry(e,this.item_id,this.locator_txt,this.suffix_txt)},"@bibliography/entry":function(t,e){var i="";return t.sys.embedBibliographyEntry&&(i=t.sys.embedBibliographyEntry(this.item_id)+"\n"),'  <div class="csl-entry">'+e+"</div>\n"+i},"@display/block":function(t,e){return'\n\n    <div class="csl-block">'+e+"</div>\n"},"@display/left-margin":function(t,e){return'\n    <div class="csl-left-margin">'+e+"</div>"},"@display/right-inline":function(t,e){return'<div class="csl-right-inline">'+e+"</div>\n  "},"@display/indent":function(t,e){return'<div class="csl-indent">'+e+"</div>\n  "},"@showid/true":function(t,e,i){if(t.tmp.just_looking||t.tmp.suppress_decorations)return e;if(i)return'<span class="'+t.opt.nodenames[i]+'" cslid="'+i+'">'+e+"</span>";if(this.params&&"string"==typeof e){var s="";if(e){var r=e.match(p.VARIABLE_WRAPPER_PREPUNCT_REX);s=r[1],e=r[2]}var n="";return e&&p.SWAPPING_PUNCTUATION.indexOf(e.slice(-1))>-1&&(n=e.slice(-1),e=e.slice(0,-1)),t.sys.variableWrapper(this.params,s,e,n)}return e},"@URL/true":function(t,e){return'<a href="'+e+'">'+e+"</a>"},"@DOI/true":function(t,e){var i=e;return e.match(/^https?:\/\//)||(i="https://doi.org/"+e),'<a href="'+i+'">'+e+"</a>"}},p.Output.Formats.prototype.text={text_escape:function(t){return t||(t=""),t},bibstart:"",bibend:"","@font-style/italic":!1,"@font-style/oblique":!1,"@font-style/normal":!1,"@font-variant/small-caps":!1,"@passthrough/true":p.Output.Formatters.passthrough,"@font-variant/normal":!1,"@font-weight/bold":!1,"@font-weight/normal":!1,"@font-weight/light":!1,"@text-decoration/none":!1,"@text-decoration/underline":!1,"@vertical-align/baseline":!1,"@vertical-align/sup":!1,"@vertical-align/sub":!1,"@strip-periods/true":p.Output.Formatters.passthrough,"@strip-periods/false":p.Output.Formatters.passthrough,"@quotes/true":function(t,e){return void 0===e?t.getTerm("open-quote"):t.getTerm("open-quote")+e+t.getTerm("close-quote")},"@quotes/inner":function(t,e){return void 0===e?"’":t.getTerm("open-inner-quote")+e+t.getTerm("close-inner-quote")},"@quotes/false":!1,"@cite/entry":function(t,e){return t.sys.wrapCitationEntry(e,this.item_id,this.locator_txt,this.suffix_txt)},"@bibliography/entry":function(t,e){return e+"\n"},"@display/block":function(t,e){return"\n"+e},"@display/left-margin":function(t,e){return e},"@display/right-inline":function(t,e){return e},"@display/indent":function(t,e){return"\n    "+e},"@showid/true":function(t,e){return e},"@URL/true":function(t,e){return e},"@DOI/true":function(t,e){return e}},p.Output.Formats.prototype.rtf={text_escape:function(t){return t||(t=""),t.replace(/([\\{}])/g,"\\$1").replace(p.SUPERSCRIPTS_REGEXP,(function(t){return"\\super "+p.SUPERSCRIPTS[t]+"\\nosupersub{}"})).replace(/[\u007F-\uFFFF]/g,(function(t){return"\\uc0\\u"+t.charCodeAt(0).toString()+"{}"})).split("\t").join("\\tab{}")},"@passthrough/true":p.Output.Formatters.passthrough,"@font-style/italic":"{\\i{}%%STRING%%}","@font-style/normal":"{\\i0{}%%STRING%%}","@font-style/oblique":"{\\i{}%%STRING%%}","@font-variant/small-caps":"{\\scaps %%STRING%%}","@font-variant/normal":"{\\scaps0{}%%STRING%%}","@font-weight/bold":"{\\b{}%%STRING%%}","@font-weight/normal":"{\\b0{}%%STRING%%}","@font-weight/light":!1,"@text-decoration/none":!1,"@text-decoration/underline":"{\\ul{}%%STRING%%}","@vertical-align/baseline":!1,"@vertical-align/sup":"\\super %%STRING%%\\nosupersub{}","@vertical-align/sub":"\\sub %%STRING%%\\nosupersub{}","@strip-periods/true":p.Output.Formatters.passthrough,"@strip-periods/false":p.Output.Formatters.passthrough,"@quotes/true":function(t,e){return void 0===e?p.Output.Formats.rtf.text_escape(t.getTerm("open-quote")):p.Output.Formats.rtf.text_escape(t.getTerm("open-quote"))+e+p.Output.Formats.rtf.text_escape(t.getTerm("close-quote"))},"@quotes/inner":function(t,e){return void 0===e?p.Output.Formats.rtf.text_escape("’"):p.Output.Formats.rtf.text_escape(t.getTerm("open-inner-quote"))+e+p.Output.Formats.rtf.text_escape(t.getTerm("close-inner-quote"))},"@quotes/false":!1,bibstart:"{\\rtf ",bibend:"}","@display/block":"\\line{}%%STRING%%\\line\r\n","@cite/entry":function(t,e){return t.sys.wrapCitationEntry(e,this.item_id,this.locator_txt,this.suffix_txt)},"@bibliography/entry":function(t,e){return e},"@display/left-margin":function(t,e){return e+"\\tab "},"@display/right-inline":function(t,e){return e+"\r\n"},"@display/indent":function(t,e){return"\n\\tab "+e+"\\line\r\n"},"@showid/true":function(t,e){if(t.tmp.just_looking||t.tmp.suppress_decorations)return e;var i="";if(e){var s=e.match(p.VARIABLE_WRAPPER_PREPUNCT_REX);i=s[1],e=s[2]}var r="";return e&&p.SWAPPING_PUNCTUATION.indexOf(e.slice(-1))>-1&&(r=e.slice(-1),e=e.slice(0,-1)),t.sys.variableWrapper(this.params,i,e,r)},"@URL/true":function(t,e){return e},"@DOI/true":function(t,e){return e}},p.Output.Formats.prototype.asciidoc={text_escape:function(t){return t||(t=""),t.replace("*","pass:[*]","g").replace("_","pass:[_]","g").replace("#","pass:[#]","g").replace("^","pass:[^]","g").replace("~","pass:[~]","g").replace("[[","pass:[[[]","g").replace("  ","&#160; ","g").replace(p.SUPERSCRIPTS_REGEXP,(function(t){return"^"+p.SUPERSCRIPTS[t]+"^"}))},bibstart:"",bibend:"","@passthrough/true":p.Output.Formatters.passthrough,"@font-style/italic":"__%%STRING%%__","@font-style/oblique":"__%%STRING%%__","@font-style/normal":!1,"@font-variant/small-caps":"[small-caps]#%%STRING%%#","@font-variant/normal":!1,"@font-weight/bold":"**%%STRING%%**","@font-weight/normal":!1,"@font-weight/light":!1,"@text-decoration/none":!1,"@text-decoration/underline":"[underline]##%%STRING%%##","@vertical-align/sup":"^^%%STRING%%^^","@vertical-align/sub":"~~%%STRING%%~~","@vertical-align/baseline":!1,"@strip-periods/true":p.Output.Formatters.passthrough,"@strip-periods/false":p.Output.Formatters.passthrough,"@quotes/true":function(t,e){return void 0===e?"``":"``"+e+"''"},"@quotes/inner":function(t,e){return void 0===e?"`":"`"+e+"'"},"@quotes/false":!1,"@cite/entry":function(t,e){return t.sys.wrapCitationEntry(e,this.item_id,this.locator_txt,this.suffix_txt)},"@bibliography/entry":function(t,e){return e+"\n"},"@display/block":function(t,e){return e},"@display/left-margin":function(t,e){return e},"@display/right-inline":function(t,e){return" "+e},"@display/indent":function(t,e){return" "+e},"@showid/true":function(t,e){if(t.tmp.just_looking||t.tmp.suppress_decorations||!this.params||"string"!=typeof e)return e;var i="";if(e){var s=e.match(p.VARIABLE_WRAPPER_PREPUNCT_REX);i=s[1],e=s[2]}var r="";return e&&p.SWAPPING_PUNCTUATION.indexOf(e.slice(-1))>-1&&(r=e.slice(-1),e=e.slice(0,-1)),t.sys.variableWrapper(this.params,i,e,r)},"@URL/true":function(t,e){return e},"@DOI/true":function(t,e){var i=e;return e.match(/^https?:\/\//)||(i="https://doi.org/"+e),i+"["+e+"]"}},p.Output.Formats.prototype.fo={text_escape:function(t){return t||(t=""),t.replace(/&/g,"&#38;").replace(/</g,"&#60;").replace(/>/g,"&#62;").replace("  ","&#160; ","g").replace(p.SUPERSCRIPTS_REGEXP,(function(t){return'<fo:inline vertical-align="super">'+p.SUPERSCRIPTS[t]+"</fo:inline>"}))},bibstart:"",bibend:"","@passthrough/true":p.Output.Formatters.passthrough,"@font-style/italic":'<fo:inline font-style="italic">%%STRING%%</fo:inline>',"@font-style/oblique":'<fo:inline font-style="oblique">%%STRING%%</fo:inline>',"@font-style/normal":'<fo:inline font-style="normal">%%STRING%%</fo:inline>',"@font-variant/small-caps":'<fo:inline font-variant="small-caps">%%STRING%%</fo:inline>',"@font-variant/normal":'<fo:inline font-variant="normal">%%STRING%%</fo:inline>',"@font-weight/bold":'<fo:inline font-weight="bold">%%STRING%%</fo:inline>',"@font-weight/normal":'<fo:inline font-weight="normal">%%STRING%%</fo:inline>',"@font-weight/light":'<fo:inline font-weight="lighter">%%STRING%%</fo:inline>',"@text-decoration/none":'<fo:inline text-decoration="none">%%STRING%%</fo:inline>',"@text-decoration/underline":'<fo:inline text-decoration="underline">%%STRING%%</fo:inline>',"@vertical-align/sup":'<fo:inline vertical-align="super">%%STRING%%</fo:inline>',"@vertical-align/sub":'<fo:inline vertical-align="sub">%%STRING%%</fo:inline>',"@vertical-align/baseline":'<fo:inline vertical-align="baseline">%%STRING%%</fo:inline>',"@strip-periods/true":p.Output.Formatters.passthrough,"@strip-periods/false":p.Output.Formatters.passthrough,"@quotes/true":function(t,e){return void 0===e?t.getTerm("open-quote"):t.getTerm("open-quote")+e+t.getTerm("close-quote")},"@quotes/inner":function(t,e){return void 0===e?"’":t.getTerm("open-inner-quote")+e+t.getTerm("close-inner-quote")},"@quotes/false":!1,"@cite/entry":function(t,e){return t.sys.wrapCitationEntry(e,this.item_id,this.locator_txt,this.suffix_txt)},"@bibliography/entry":function(t,e){var i="";if(t.bibliography&&t.bibliography.opt&&t.bibliography.opt.hangingindent){var s=t.bibliography.opt.hangingindent;i=' start-indent="'+s+'em" text-indent="-'+s+'em"'}var r="";return t.sys.embedBibliographyEntry&&(r=t.sys.embedBibliographyEntry(this.item_id)+"\n"),'<fo:block id="'+this.system_id+'"'+i+">"+e+"</fo:block>\n"+r},"@display/block":function(t,e){return"\n  <fo:block>"+e+"</fo:block>\n"},"@display/left-margin":function(t,e){return'\n  <fo:table table-layout="fixed" width="100%">\n    <fo:table-column column-number="1" column-width="$$$__COLUMN_WIDTH_1__$$$"/>\n    <fo:table-column column-number="2" column-width="proportional-column-width(1)"/>\n    <fo:table-body>\n      <fo:table-row>\n        <fo:table-cell>\n          <fo:block>'+e+"</fo:block>\n        </fo:table-cell>\n        "},"@display/right-inline":function(t,e){return"<fo:table-cell>\n          <fo:block>"+e+"</fo:block>\n        </fo:table-cell>\n      </fo:table-row>\n    </fo:table-body>\n  </fo:table>\n"},"@display/indent":function(t,e){return'<fo:block margin-left="2em">'+e+"</fo:block>\n"},"@showid/true":function(t,e){if(t.tmp.just_looking||t.tmp.suppress_decorations||!this.params||"string"!=typeof e)return e;var i="";if(e){var s=e.match(p.VARIABLE_WRAPPER_PREPUNCT_REX);i=s[1],e=s[2]}var r="";return e&&p.SWAPPING_PUNCTUATION.indexOf(e.slice(-1))>-1&&(r=e.slice(-1),e=e.slice(0,-1)),t.sys.variableWrapper(this.params,i,e,r)},"@URL/true":function(t,e){return"<fo:basic-link external-destination=\"url('"+e+"')\">"+e+"</fo:basic-link>"},"@DOI/true":function(t,e){var i=e;return e.match(/^https?:\/\//)||(i="https://doi.org/"+e),"<fo:basic-link external-destination=\"url('"+i+"')\">"+e+"</fo:basic-link>"}},p.Output.Formats.prototype.latex={text_escape:function(t){return t||(t=""),t},bibstart:"\\begin{thebibliography}{4}",bibend:"end{thebibliography}","@font-style/italic":"{\\em %%STRING%%}","@font-style/oblique":!1,"@font-style/normal":!1,"@font-variant/small-caps":!1,"@passthrough/true":p.Output.Formatters.passthrough,"@font-variant/normal":!1,"@font-weight/bold":"{\\bf %%STRING%%}","@font-weight/normal":!1,"@font-weight/light":!1,"@text-decoration/none":!1,"@text-decoration/underline":!1,"@vertical-align/baseline":!1,"@vertical-align/sup":!1,"@vertical-align/sub":!1,"@strip-periods/true":p.Output.Formatters.passthrough,"@strip-periods/false":p.Output.Formatters.passthrough,"@quotes/true":function(t,e){return void 0===e?t.getTerm("open-quote"):t.getTerm("open-quote")+e+t.getTerm("close-quote")},"@quotes/inner":function(t,e){return void 0===e?"’":t.getTerm("open-inner-quote")+e+t.getTerm("close-inner-quote")},"@quotes/false":!1,"@cite/entry":function(t,e){return t.sys.wrapCitationEntry(e,this.item_id,this.locator_txt,this.suffix_txt)},"@bibliography/entry":function(t,e){return"\\bibitem{"+t.sys.embedBibliographyEntry(this.item_id)+"}\n"},"@display/block":function(t,e){return"\n"+e},"@display/left-margin":function(t,e){return e},"@display/right-inline":function(t,e){return e},"@display/indent":function(t,e){return"\n    "+e},"@showid/true":function(t,e,i){return e},"@URL/true":function(t,e){return e},"@DOI/true":function(t,e){return e}},p.Output.Formats=new p.Output.Formats,p.Registry=function(t){this.debug=!1,this.state=t,this.registry={},this.reflist=[],this.refhash={},this.namereg=new p.Registry.NameReg(t),this.citationreg=new p.Registry.CitationReg(t),this.authorstrings={},this.masterMap={},this.mylist=[],this.myhash={},this.deletes=[],this.inserts=[],this.uncited={},this.refreshes={},this.akeys={},this.oldseq={},this.return_data={},this.ambigcites={},this.ambigresets={},this.sorter=new p.Registry.Comparifier(t,"bibliography_sort"),this.getSortedIds=function(){for(var t=[],e=0,i=this.reflist.length;e<i;e+=1)t.push(""+this.reflist[e].id);return t},this.getSortedRegistryItems=function(){for(var t=[],e=0,i=this.reflist.length;e<i;e+=1)t.push(this.reflist[e]);return t}},p.Registry.prototype.init=function(t,e){if(this.oldseq={},e){this.uncited={};for(var i=0,s=t.length;i<s;i+=1)this.myhash[t[i]]||this.mylist.push(""+t[i]),this.uncited[t[i]]=!0,this.myhash[t[i]]=!0}else{for(var r in this.uncited)t.push(r);var n={};for(i=t.length-1;i>-1;i+=-1)n[t[i]]?t=t.slice(0,i).concat(t.slice(i+1)):n[t[i]]=!0;this.mylist=t,this.myhash=n}this.refreshes={},this.touched={},this.ambigsTouched={},this.ambigresets={}},p.Registry.prototype.dopurge=function(t){for(var e=this.mylist.length-1;e>-1;e+=-1)this.citationreg.citationsByItemId&&(this.citationreg.citationsByItemId[this.mylist[e]]||t[this.mylist[e]]||(delete this.myhash[this.mylist[e]],this.mylist=this.mylist.slice(0,e).concat(this.mylist.slice(e+1))));this.dodeletes(this.myhash)},p.Registry.prototype.dodeletes=function(t){var e,i,s,r,n,a,o;if("string"==typeof t){var l=t;(t={})[l]=!0}for(var l in this.registry)if(!t[l]){if(this.uncited[l])continue;for(n in this.namereg.delitems(l))this.refreshes[n]=!0;for(e=this.registry[l].ambig,(a=this.ambigcites[e].indexOf(l))>-1&&(r=this.ambigcites[e].slice(),this.ambigcites[e]=r.slice(0,a).concat(r.slice(a+1,r.length)),this.ambigresets[e]=this.ambigcites[e].length),s=this.ambigcites[e].length,i=0;i<s;i+=1)o=""+this.ambigcites[e][i],this.refreshes[o]=!0;if(this.registry[l].siblings)if(1==this.registry[l].siblings.length){var u=this.registry[l].siblings[0];this.registry[u].master=!0,this.registry[u].siblings.pop(),this.registry[u].parallel=!1}else if(this.registry[l].siblings.length>1){var p=[l];if(this.registry[l].master){var h=this.registry[l].siblings[0],c=this.registry[h];c.master=!0,c.parallel=!1,p.push(h);for(var m=0,f=this.registry[l].siblings.length;m<f;m+=1)this.registry[this.registry[l].siblings[m]].parallel=h}var d=[];for(m=this.registry[l].siblings.length-1;m>-1;m+=-1){var g=this.registry[l].siblings.pop();-1===p.indexOf(g)&&d.push(g)}for(m=d.length-1;m>-1;m+=-1)this.registry[l].siblings.push(d[m])}for(var b=this.reflist.length-1;b>-1;b--)this.reflist[b].id===l&&(this.reflist=this.reflist.slice(0,b).concat(this.reflist.slice(b+1)));delete this.registry[l],delete this.refhash[l],this.return_data.bibchange=!0}},p.Registry.prototype.doinserts=function(t){var e,i,s,r,n;"string"==typeof t&&(t=[t]);for(var a=0,o=t.length;a<o;a+=1)e=t[a],this.registry[e]||(i=this.state.retrieveItem(e),s=p.getAmbiguousCite.call(this.state,i),this.ambigsTouched[s]=!0,i.legislation_id||(this.akeys[s]=!0),r={id:""+e,seq:0,offset:0,sortkeys:!1,ambig:!1,rendered:!1,disambig:!1,ref:i,newItem:!0},this.registry[e]=r,this.citationreg.citationsByItemId&&this.citationreg.citationsByItemId[e]&&(this.registry[e]["first-reference-note-number"]=this.citationreg.citationsByItemId[e][0].properties.noteIndex),n=p.getAmbigConfig.call(this.state),this.registerAmbigToken(s,e,n),this.touched[e]=!0,this.return_data.bibchange=!0)},p.Registry.prototype.rebuildlist=function(t){var e,i,s,r;if(t)for(this.reflist=[],e=this.mylist.length,i=0;i<e;i+=1)s=this.mylist[i],r=this.registry[s],this.reflist.push(r),this.oldseq[s]=this.registry[s].seq,this.registry[s].seq=i+1;else for(this.reflist_inserts=[],e=this.mylist.length,i=0;i<e;i+=1)s=this.mylist[i],(r=this.registry[s]).newItem&&this.reflist_inserts.push(r),this.oldseq[s]=this.registry[s].seq,this.registry[s].seq=i+1},p.Registry.prototype.dorefreshes=function(){var t;for(var e in this.refreshes)if(t=this.registry[e]){t.sortkeys=void 0,n=this.state.refetchItem(e);var i=t.ambig;for(var s in void 0===i&&(this.state.tmp.disambig_settings=!1,i=p.getAmbiguousCite.call(this.state,n),a=p.getAmbigConfig.call(this.state),this.registerAmbigToken(i,e,a)),this.ambigresets)if(1===this.ambigresets[s]){var r=this.ambigcites[i][0],n=this.state.refetchItem(r);this.registry[r].disambig=new p.AmbigConfig,this.state.tmp.disambig_settings=!1;i=p.getAmbiguousCite.call(this.state,n);var a=p.getAmbigConfig.call(this.state);this.registerAmbigToken(i,r,a)}this.state.tmp.taintedItemIDs[e]=!0,this.ambigsTouched[i]=!0,n.legislation_id||(this.akeys[i]=!0),this.touched[e]=!0}},p.Registry.prototype.setdisambigs=function(){for(var t in this.ambigsTouched)this.state.disambiguate.run(t);this.ambigsTouched={},this.akeys={}},p.Registry.prototype.renumber=function(){var t,e,i;for(this.state.bibliography_sort.opt.citation_number_sort_direction===p.DESCENDING&&(this.state.bibliography_sort.tmp.citation_number_map={}),t=this.reflist.length,e=0;e<t;e+=1)(i=this.reflist[e]).seq=e+1,this.state.bibliography_sort.opt.citation_number_sort_direction===p.DESCENDING&&(this.state.bibliography_sort.tmp.citation_number_map[i.seq]=this.reflist.length-i.seq+1),this.state.opt.update_mode===p.NUMERIC&&i.seq!=this.oldseq[i.id]&&(this.state.tmp.taintedItemIDs[i.id]=!0),i.seq!=this.oldseq[i.id]&&(this.return_data.bibchange=!0)},p.Registry.prototype.setsortkeys=function(){for(var t=0,e=this.mylist.length;t<e;t+=1){var i=this.mylist[t];(this.touched[i]||this.state.tmp.taintedItemIDs[i]||!this.registry[i].sortkeys)&&(this.registry[i].sortkeys=p.getSortKeys.call(this.state,this.state.retrieveItem(i),"bibliography_sort"))}},p.Registry.prototype._insertItem=function(t,e){return e.splice(this._locationOf(t,e)+1,0,t),e},p.Registry.prototype._locationOf=function(t,e,i,s){if(0===e.length)return-1;var r=(i=i||0)+(s=s||e.length)>>1,n=this.sorter.compareKeys(t,e[r]);if(s-i<=1)return-1==n?r-1:r;switch(n){case-1:return this._locationOf(t,e,i,r);case 0:return r;case 1:return this._locationOf(t,e,r,s)}},p.Registry.prototype.sorttokens=function(t){var e,i,s;if(!t){for(this.reflist_inserts=[],e=this.mylist.length,s=0;s<e;s+=1)i=this.mylist[s],(o=this.registry[i]).newItem&&this.reflist_inserts.push(o);for(var r in this.state.tmp.taintedItemIDs)if(this.registry[r]&&!this.registry[r].newItem)for(var n=this.reflist.length-1;n>-1;n--)this.reflist[n].id===r&&(this.reflist_inserts.push(this.reflist[n]),this.reflist=this.reflist.slice(0,n).concat(this.reflist.slice(n+1)));n=0;for(var a=this.reflist_inserts.length;n<a;n++){var o;delete(o=this.reflist_inserts[n]).newItem,this.reflist=this._insertItem(o,this.reflist)}for(s=0;s<e;s+=1)i=this.mylist[s],o=this.registry[i],this.registry[i].seq=s+1}},p.Registry.Comparifier=function(t,e){var i,s,r,n,a=p.getSortCompare(t.opt["default-locale-sort"]);i=t[e].opt.sort_directions,this.compareKeys=function(t,e){for(s=t.sortkeys?t.sortkeys.length:0,r=0;r<s;r+=1){var n=0;if(0<(n=t.sortkeys[r]===e.sortkeys[r]?0:void 0===t.sortkeys[r]?i[r][1]:void 0===e.sortkeys[r]?i[r][0]:a(t.sortkeys[r],e.sortkeys[r])))return i[r][1];if(0>n)return i[r][0]}return t.seq>e.seq?1:t.seq<e.seq?-1:0},n=this.compareKeys,this.compareCompositeKeys=function(t,e){return n(t[1],e[1])}},p.Registry.prototype.compareRegistryTokens=function(t,e){return t.seq>e.seq?1:t.seq<e.seq?-1:0},p.Registry.prototype.registerAmbigToken=function(t,e,i){if(this.registry[e]||p.debug("Warning: unregistered item: itemID=("+e+"), akey=("+t+")"),this.registry[e]&&this.registry[e].disambig&&this.registry[e].disambig.names)for(var s=0,r=i.names.length;s<r;s+=1){if(i.names[s]!==this.registry[e].disambig.names[s])this.state.tmp.taintedItemIDs[e]=!0;else if(i.givens[s])for(var n=0,a=i.givens[s].length;n<a;n+=1){i.givens[s][n]!==this.registry[e].disambig.givens[s][n]&&(this.state.tmp.taintedItemIDs[e]=!0)}}this.ambigcites[t]||(this.ambigcites[t]=[]),-1===this.ambigcites[t].indexOf(""+e)&&this.ambigcites[t].push(""+e),this.registry[e].ambig=t,this.registry[e].disambig=p.cloneAmbigConfig(i)},p.getSortKeys=function(t,e){var i,s,r,n,a,o;for(i=this.tmp.area,s=this.tmp.root,r=this.tmp.extension,n=p.Util.Sort.strip_prepositions,this.tmp.area=e,this.tmp.root=e.indexOf("_")>-1?e.slice(0,-5):e,this.tmp.extension="_sort",this.tmp.disambig_override=!0,this.tmp.disambig_request=!1,this.tmp.suppress_decorations=!0,p.getCite.call(this,t),this.tmp.suppress_decorations=!1,this.tmp.disambig_override=!1,a=this[e].keys.length,o=0;o<a;o+=1)this[e].keys[o]=n(this[e].keys[o]);return this.tmp.area=i,this.tmp.root=s,this.tmp.extension=r,this[e].keys},p.Registry.NameReg=function(t){var e,i,s,r,n,a,o,l,u,h,c,m;this.state=t,this.namereg={},this.nameind={},this.nameindpkeys={},this.itemkeyreg={},o=function(t){return t||(t=""),t.replace(/\./g," ").replace(/\s+/g," ").replace(/\s+$/,"")},l=function(t,r,n){e=o(n.family);var a=(s=o(n.given)).match(/[,\!]* ([^,]+)$/);a&&a[1]===a[1].toLowerCase()&&(s=s.replace(/[,\!]* [^,]+$/,"")),i=p.Util.Names.initializeWith(t,s,"%s"),"by-cite"===t.citation.opt["givenname-disambiguation-rule"]&&(e=""+r+e)},u=function(s,a,o,u,p,h){var c;if("bibliography"===t.tmp.area.slice(0,12)&&!p)return"string"==typeof h?1:2;a=t.nameOutput.getName(a,"locale-translit",!0).name,l(this.state,""+s,a),c=2,r=t.opt["disambiguate-add-givenname"];var m=n=t.citation.opt["givenname-disambiguation-rule"];return"by-cite"===n&&(n="all-names"),"short"===p?c=0:"string"==typeof h&&(c=1),void 0===this.namereg[e]||void 0===this.namereg[e].ikey[i]?c:"by-cite"===m&&c<=u?u:r?"string"==typeof n&&"primary-name"===n.slice(0,12)&&o>0?c:(n&&"all-names"!==n&&"primary-name"!==n?"all-names-with-initials"!==n&&"primary-name-with-initials"!==n||(c=this.namereg[e].count>1?1:0):(this.namereg[e].count>1&&(c=1),(this.namereg[e].ikey&&this.namereg[e].ikey[i].count>1||this.namereg[e].count>1&&"string"!=typeof h)&&(c=2)),t.registry.registry[s]?c:"short"==p?0:"string"==typeof h?1:void 0):c},h=function(r){var n,o,l,u,p;"string"!=typeof r&&"number"!=typeof r||(r=[""+r]);for(o=r.length,n=0;n<o;n+=1)if(u=""+r[n],this.nameind[u]){for(p in this.nameind[u])if(this.nameind[u].hasOwnProperty(p)){var h=p.split("::");if(e=h[0],i=h[1],s=h[2],void 0===this.namereg[e])continue;if(a=this.namereg[e].items,s&&this.namereg[e].ikey[i]&&this.namereg[e].ikey[i].skey[s]&&((l=(m=this.namereg[e].ikey[i].skey[s].items).indexOf(""+u))>-1&&(this.namereg[e].ikey[i].skey[s].items=m.slice(0,l).concat(m.slice([l+1]))),0===this.namereg[e].ikey[i].skey[s].items.length&&(delete this.namereg[e].ikey[i].skey[s],this.namereg[e].ikey[i].count+=-1,this.namereg[e].ikey[i].count<2)))for(var c=0,f=this.namereg[e].ikey[i].items.length;c<f;c+=1)t.tmp.taintedItemIDs[this.namereg[e].ikey[i].items[c]]=!0;if(i&&this.namereg[e].ikey[i]&&((l=this.namereg[e].ikey[i].items.indexOf(""+u))>-1&&(a=this.namereg[e].ikey[i].items.slice(),this.namereg[e].ikey[i].items=a.slice(0,l).concat(a.slice([l+1]))),0===this.namereg[e].ikey[i].items.length&&(delete this.namereg[e].ikey[i],this.namereg[e].count+=-1,this.namereg[e].count<2)))for(c=0,f=this.namereg[e].items.length;c<f;c+=1)t.tmp.taintedItemIDs[this.namereg[e].items[c]]=!0;e&&((l=this.namereg[e].items.indexOf(""+u))>-1&&(a=this.namereg[e].items.slice(),this.namereg[e].items=a.slice(0,l).concat(a.slice([l+1],a.length))),this.namereg[e].items.length<2&&delete this.namereg[e]),delete this.nameind[u][p]}delete this.nameind[u],delete this.nameindpkeys[u]}return{}},c=function(r,n,a){if(n=t.nameOutput.getName(n,"locale-translit",!0).name,!t.citation.opt["givenname-disambiguation-rule"]||"primary-"!==t.citation.opt["givenname-disambiguation-rule"].slice(0,8)||0===a){if(l(this.state,""+r,n),e&&(void 0===this.namereg[e]?(this.namereg[e]={},this.namereg[e].count=0,this.namereg[e].ikey={},this.namereg[e].items=[r]):-1===this.namereg[e].items.indexOf(r)&&this.namereg[e].items.push(r)),e&&i)if(void 0===this.namereg[e].ikey[i]){if(this.namereg[e].ikey[i]={},this.namereg[e].ikey[i].count=0,this.namereg[e].ikey[i].skey={},this.namereg[e].ikey[i].items=[r],this.namereg[e].count+=1,2===this.namereg[e].count)for(var o=0,u=this.namereg[e].items.length;o<u;o+=1)t.tmp.taintedItemIDs[this.namereg[e].items[o]]=!0}else-1===this.namereg[e].ikey[i].items.indexOf(r)&&this.namereg[e].ikey[i].items.push(r);if(e&&i&&s)if(void 0===this.namereg[e].ikey[i].skey[s]){if(this.namereg[e].ikey[i].skey[s]={},this.namereg[e].ikey[i].skey[s].items=[r],this.namereg[e].ikey[i].count+=1,2===this.namereg[e].ikey[i].count)for(o=0,u=this.namereg[e].ikey[i].items.length;o<u;o+=1)t.tmp.taintedItemIDs[this.namereg[e].ikey[i].items[o]]=!0}else-1===this.namereg[e].ikey[i].skey[s].items.indexOf(r)&&this.namereg[e].ikey[i].skey[s].items.push(r);void 0===this.nameind[r]&&(this.nameind[r]={},this.nameindpkeys[r]={}),e&&(this.nameind[r][e+"::"+i+"::"+s]=!0,this.nameindpkeys[r][e]=this.namereg[e])}},this.addname=c,this.delitems=h,this.evalname=u},p.Registry.CitationReg=function(){this.citationById={},this.citationByIndex=[]},p.Disambiguation=function(t){this.state=t,this.sys=this.state.sys,this.registry=t.registry.registry,this.ambigcites=t.registry.ambigcites,this.configModes(),this.debug=!1},p.Disambiguation.prototype.run=function(t){this.modes.length&&(this.debug&&print("[A] === RUN ==="),this.akey=t,this.initVars(t)&&this.runDisambig())},p.Disambiguation.prototype.runDisambig=function(){var t;for(this.debug&&print("[C] === runDisambig() ==="),this.initGivens=!0;this.lists.length;){for(this.gnameset=0,this.gname=0,this.clashes=[1,0];this.lists[0][1].length;)this.listpos=0,this.base||(this.base=this.lists[0][0]),t=this.incrementDisambig(),this.scanItems(this.lists[0]),this.evalScan(t);this.lists=this.lists.slice(1)}},p.Disambiguation.prototype.scanItems=function(t){var e;this.debug&&print("[2] === scanItems() ==="),this.Item=t[1][0],this.ItemCite=p.getAmbiguousCite.call(this.state,this.Item,this.base,!0),this.scanlist=t[1],this.partners=[],this.partners.push(this.Item),this.nonpartners=[];for(var i=0,s=1,r=t[1].length;s<r;s+=1){e=t[1][s];var n=p.getAmbiguousCite.call(this.state,e,this.base,!0);this.debug&&s>1&&print("  -----------"),this.ItemCite===n?(this.debug&&(print("  [CLASH]--\x3e "+this.Item.id+": "+this.ItemCite),print("             "+e.id+": "+n)),i+=1,this.partners.push(e)):(this.debug&&(print("  [clear]--\x3e "+this.Item.id+": "+this.ItemCite),print("             "+e.id+": "+n)),this.nonpartners.push(e))}this.clashes[0]=this.clashes[1],this.clashes[1]=i},p.Disambiguation.prototype.evalScan=function(t){this[this.modes[this.modeindex]](t),t&&(this.modeindex<this.modes.length-1?this.modeindex+=1:this.lists[this.listpos+1]=[this.base,[]])},p.Disambiguation.prototype.disNames=function(t){if(this.debug&&print("[3] == disNames() =="),0===this.clashes[1]&&1===this.nonpartners.length)this.captureStepToBase(),this.debug&&(print("  ** RESOLUTION [a]: lone partner, one nonpartner"),print("  registering "+this.partners[0].id+" and "+this.nonpartners[0].id)),this.state.registry.registerAmbigToken(this.akey,""+this.nonpartners[0].id,this.betterbase),this.state.registry.registerAmbigToken(this.akey,""+this.partners[0].id,this.betterbase),this.lists[this.listpos]=[this.betterbase,[]];else if(0===this.clashes[1])this.captureStepToBase(),this.debug&&(print("  ** RESOLUTION [b]: lone partner, unknown number of remaining nonpartners"),print("  registering "+this.partners[0].id)),this.state.registry.registerAmbigToken(this.akey,""+this.partners[0].id,this.betterbase),this.lists[this.listpos]=[this.betterbase,this.nonpartners],this.nonpartners.length&&(this.initGivens=!0);else if(1===this.nonpartners.length)this.captureStepToBase(),this.debug&&(print("  ** RESOLUTION [c]: lone nonpartner, unknown number of partners remaining"),print("  registering "+this.nonpartners[0].id)),this.state.registry.registerAmbigToken(this.akey,""+this.nonpartners[0].id,this.betterbase),this.lists[this.listpos]=[this.betterbase,this.partners];else if(this.clashes[1]<this.clashes[0])this.captureStepToBase(),this.debug&&print("  ** RESOLUTION [d]: better result, but no entries safe to register"),this.lists[this.listpos]=[this.betterbase,this.partners],this.lists.push([this.betterbase,this.nonpartners]);else if(this.debug&&print("  ** RESOLUTION [e]: no improvement, and clashes remain"),t&&(this.lists[this.listpos]=[this.betterbase,this.nonpartners],this.lists.push([this.betterbase,this.partners]),this.modeindex===this.modes.length-1)){this.debug&&print("     (registering clashing entries because we've run out of options)");for(var e=0,i=this.partners.length;e<i;e+=1)this.state.registry.registerAmbigToken(this.akey,""+this.partners[e].id,this.betterbase);this.lists[this.listpos]=[this.betterbase,[]]}},p.Disambiguation.prototype.disExtraText=function(){this.debug&&print("[3] === disExtraText ==");var t=!1;if(0===this.clashes[1]&&this.nonpartners.length<2&&(t=!0),t||this.base.disambiguate&&this.state.tmp.disambiguate_count===this.state.tmp.disambiguate_maxMax){if(t||this.state.tmp.disambiguate_count===this.state.tmp.disambiguate_maxMax)if(t||this.modeindex===this.modes.length-1){var e=this.lists[this.listpos][0];for(i=0,s=this.lists[this.listpos][1].length;i<s;i+=1)this.state.tmp.taintedItemIDs[this.lists[this.listpos][1][i].id]=!0,this.state.registry.registerAmbigToken(this.akey,""+this.lists[this.listpos][1][i].id,e);this.lists[this.listpos]=[this.betterbase,[]]}else{this.modeindex=this.modes.length-1,(e=this.lists[this.listpos][0]).disambiguate=!0;for(i=0,s=this.lists[this.listpos][1].length;i<s;i+=1)this.state.tmp.taintedItemIDs[this.lists[this.listpos][1][i].id]=!0,this.state.registry.registerAmbigToken(this.akey,""+this.lists[this.listpos][1][i].id,e)}}else if(this.modeindex=0,this.base.disambiguate=this.state.tmp.disambiguate_count,this.betterbase.disambiguate=this.state.tmp.disambiguate_count,this.base.disambiguate)this.disNames();else{this.initGivens=!0,this.base.disambiguate=1;for(var i=0,s=this.lists[this.listpos][1].length;i<s;i+=1)this.state.tmp.taintedItemIDs[this.lists[this.listpos][1][i].id]=!0}},p.Disambiguation.prototype.disYears=function(){var t;this.debug&&print("[3] === disYears =="),t=[];var e=this.lists[this.listpos][0];if(this.clashes[1])for(var i=0,s=this.state.registry.mylist.length;i<s;i+=1)for(var r=this.state.registry.mylist[i],n=0,a=this.lists[this.listpos][1].length;n<a;n+=1){var o;if((o=this.lists[this.listpos][1][n]).id==r){t.push(this.registry[o.id]);break}}t.sort(this.state.registry.sorter.compareKeys);for(var l=0,u=t.length;l<u;l+=1){e.year_suffix=""+l;var h=this.state.registry.registry[t[l].id].disambig;this.state.registry.registerAmbigToken(this.akey,""+t[l].id,e),p.ambigConfigDiff(h,e)&&(this.state.tmp.taintedItemIDs[t[l].id]=!0)}this.lists[this.listpos]=[this.betterbase,[]]},p.Disambiguation.prototype.incrementDisambig=function(){if(this.debug&&print("\n[1] === incrementDisambig() ==="),this.initGivens)return this.initGivens=!1,!1;var t=!1,e=!0;if("disNames"===this.modes[this.modeindex]){e=!1,"number"!=typeof this.givensMax&&(e=!0);var i=!1;"number"!=typeof this.namesMax&&(i=!0),"number"==typeof this.givensMax&&(this.base.givens.length&&this.base.givens[this.gnameset][this.gname]<this.givensMax?this.base.givens[this.gnameset][this.gname]+=1:e=!0),"number"==typeof this.namesMax&&e&&(this.state.opt["disambiguate-add-names"]?(i=!1,this.gname<this.namesMax?(this.base.names[this.gnameset]+=1,this.gname+=1):i=!0):i=!0),"number"==typeof this.namesetsMax&&i&&this.gnameset<this.namesetsMax&&(this.gnameset+=1,this.base.names[this.gnameset]=1,this.gname=0),this.debug&&(print("    ------------------"),print("    incremented values"),print("    ------------------"),print("    | gnameset: "+this.gnameset),print("    | gname: "+this.gname),print("    | names value: "+this.base.names[this.gnameset]),this.base.givens.length?print("    | givens value: "+this.base.givens[this.gnameset][this.gname]):print("    | givens value: nil"),print("    | namesetsMax: "+this.namesetsMax),print("    | namesMax: "+this.namesMax),print("    | givensMax: "+this.givensMax)),"number"==typeof this.namesetsMax&&-1!==this.namesetsMax&&this.gnameset!==this.namesetsMax||this.state.opt["disambiguate-add-names"]&&"number"==typeof this.namesMax&&this.gname!==this.namesMax||"number"==typeof this.givensMax&&void 0!==this.base.givens[this.gnameset]&&void 0!==this.base.givens[this.gnameset][this.gname]&&this.base.givens[this.gnameset][this.gname]!==this.givensMax||(t=!0,this.debug&&print("    MAXED"))}else"disExtraText"===this.modes[this.modeindex]&&(this.base.disambiguate+=1,this.betterbase.disambiguate+=1);return t},p.Disambiguation.prototype.initVars=function(t){var e,i,s;if(this.debug&&print("[B] === initVars() ==="),this.lists=[],this.base=!1,this.betterbase=!1,this.akey=t,this.maxNamesByItemId={},i=[],!(e=this.ambigcites[t])||!e.length)return!1;var r=this.state.refetchItem(""+e[0]);if(this.getCiteData(r),this.base=p.getAmbigConfig.call(this.state),e&&e.length>1){i.push([this.maxNamesByItemId[r.id],r]);for(var n=1,a=e.length;n<a;n+=1)r=this.state.refetchItem(""+e[n]),this.getCiteData(r,this.base),i.push([this.maxNamesByItemId[r.id],r]);i.sort((function(t,e){return t[0]>e[0]?1:t[0]<e[0]?-1:t[1].id>e[1].id?1:t[1].id<e[1].id?-1:0})),s=[];for(var n=0,a=i.length;n<a;n+=1)s.push(i[n][1]);this.lists.push([this.base,s]),this.Item=this.lists[0][1][0]}else this.Item=this.state.refetchItem(""+e[0]);return this.modeindex=0,this.state.citation.opt["disambiguate-add-names"],this.namesMax=this.maxNamesByItemId[this.Item.id][0],this.padBase(this.base),this.padBase(this.betterbase),this.base.year_suffix=!1,this.base.disambiguate=!1,this.betterbase.year_suffix=!1,this.betterbase.disambiguate=!1,"by-cite"===this.state.citation.opt["givenname-disambiguation-rule"]&&this.state.opt["disambiguate-add-givenname"]&&(this.givensMax=2),!0},p.Disambiguation.prototype.padBase=function(t){for(var e=0,i=t.names.length;e<i;e+=1){t.givens[e]||(t.givens[e]=[]);for(var s=0,r=t.names[e];s<r;s+=1)t.givens[e][s]||(t.givens[e][s]=0)}},p.Disambiguation.prototype.configModes=function(){var t,e;this.modes=[],t=this.state.opt["disambiguate-add-givenname"],e=this.state.citation.opt["givenname-disambiguation-rule"],(this.state.opt["disambiguate-add-names"]||t&&"by-cite"===e)&&this.modes.push("disNames"),this.state.opt.development_extensions.prioritize_disambiguate_condition?(this.state.opt.has_disambiguate&&this.modes.push("disExtraText"),this.state.opt["disambiguate-add-year-suffix"]&&this.modes.push("disYears")):(this.state.opt["disambiguate-add-year-suffix"]&&this.modes.push("disYears"),this.state.opt.has_disambiguate&&this.modes.push("disExtraText"))},p.Disambiguation.prototype.getCiteData=function(t,e){if(!this.maxNamesByItemId[t.id]){p.getAmbiguousCite.call(this.state,t,e),e=p.getAmbigConfig.call(this.state),this.maxNamesByItemId[t.id]=p.getMaxVals.call(this.state),this.state.registry.registry[t.id].disambig.givens=this.state.tmp.disambig_settings.givens.slice();for(var i=0,s=this.state.registry.registry[t.id].disambig.givens.length;i<s;i+=1)this.state.registry.registry[t.id].disambig.givens[i]=this.state.tmp.disambig_settings.givens[i].slice();this.namesetsMax=this.state.registry.registry[t.id].disambig.names.length-1,this.base||(this.base=e,this.betterbase=p.cloneAmbigConfig(e)),e.names.length<this.base.names.length&&(this.base=e);for(i=0,s=e.names.length;i<s;i+=1)e.names[i]>this.base.names[i]&&(this.base.givens[i]=e.givens[i].slice(),this.base.names[i]=e.names[i],this.betterbase.names=this.base.names.slice(),this.betterbase.givens=this.base.givens.slice(),this.padBase(this.base),this.padBase(this.betterbase));this.betterbase.givens=this.base.givens.slice();for(var r=0,n=this.base.givens.length;r<n;r+=1)this.betterbase.givens[r]=this.base.givens[r].slice()}},p.Disambiguation.prototype.captureStepToBase=function(){"by-cite"===this.state.citation.opt["givenname-disambiguation-rule"]&&this.base.givens&&this.base.givens.length&&void 0!==this.base.givens[this.gnameset][this.gname]&&(this.betterbase.givens.length<this.base.givens.length&&(this.betterbase.givens=JSON.parse(JSON.stringify(this.base.givens))),this.betterbase.givens[this.gnameset][this.gname]=this.base.givens[this.gnameset][this.gname]),this.betterbase.names[this.gnameset]=this.base.names[this.gnameset]},p.Engine.prototype.getJurisdictionList=function(t){for(var e=[],i=t.split(":"),s=i.length;s>0;s--)e.push(i.slice(0,s).join(":"));return-1===e.indexOf("us")&&e.push("us"),e},p.Engine.prototype.retrieveAllStyleModules=function(t){for(var e={},i=this.locale[this.opt.lang].opts["jurisdiction-preference"],s=(i=[""].concat(i=i||[])).length-1;s>-1;s--)for(var r=i[s],n=0,a=t.length;n<a;n++){var o=t[n];if(!this.opt.jurisdictions_seen[o]){var l=this.sys.retrieveStyleModule(o,r);(!l&&!r||l)&&(this.opt.jurisdictions_seen[o]=!0),l&&(e[o]=l)}}return e},p.ParticleList=[["'s",i=[[null,[0,1]]]],["'s-",i],["'t",i],["a",i],["aan 't",s=[[null,[0,2]]]],["aan de",s],["aan den",s],["aan der",s],["aan het",s],["aan t",s],["aan",i],["ad-",n=[[null,[0,1]],[[0,1],null]]],["adh-",n],["af",n],["al",n],["al-",n],["am de",s],["am",i],["an-",n],["ar-",n],["as-",n],["ash-",n],["at-",n],["ath-",n],["auf dem",l=[[[0,2],null],[null,[0,2]]]],["auf den",l],["auf der",l],["auf ter",s],["auf",o=[[[0,1],null],[null,[0,1]]]],["aus 'm",l],["aus dem",l],["aus den",l],["aus der",l],["aus m",l],["aus",o],["aus'm",l],["az-",n],["aš-",n],["aḍ-",n],["aḏ-",n],["aṣ-",n],["aṭ-",n],["aṯ-",n],["aẓ-",n],["ben",i],["bij 't",s],["bij de",s],["bij den",s],["bij het",s],["bij t",s],["bij",i],["bin",i],["boven d",s],["boven d'",s],["d",i],["d'",n],["da",n],["dal",i],["dal'",i],["dall'",i],["dalla",i],["das",n],["de die le",r=[[null,[0,3]]]],["de die",s],["de l",s],["de l'",s],["de la",u=[[null,[0,2]],[[0,1],[1,2]]]],["de las",u],["de le",s],["de li",a=[[null,[0,2]],[[0,2],null]]],["de van der",r],["de",n],["de'",n],["deca",i],["degli",n],["dei",n],["del",n],["dela",e=[[[0,1],null]]],["dell'",n],["della",n],["delle",n],["dello",n],["den",n],["der",n],["des",n],["di",n],["die le",s],["do",i],["don",i],["dos",n],["du",n],["ed-",n],["edh-",n],["el",n],["el-",n],["en-",n],["er-",n],["es-",n],["esh-",n],["et-",n],["eth-",n],["ez-",n],["eš-",n],["eḍ-",n],["eḏ-",n],["eṣ-",n],["eṭ-",n],["eṯ-",n],["eẓ-",n],["het",i],["i",i],["il",e],["im",i],["in 't",s],["in de",s],["in den",s],["in der",a],["in het",s],["in t",s],["in",i],["l",i],["l'",i],["la",i],["las",i],["le",i],["les",n],["lo",n],["los",i],["lou",i],["of",i],["onder 't",s],["onder de",s],["onder den",s],["onder het",s],["onder t",s],["onder",i],["op 't",s],["op de",a],["op den",s],["op der",s],["op gen",s],["op het",s],["op t",s],["op ten",s],["op",i],["over 't",s],["over de",s],["over den",s],["over het",s],["over t",s],["over",i],["s",i],["s'",i],["sen",e],["t",i],["te",i],["ten",i],["ter",i],["tho",i],["thoe",i],["thor",i],["to",i],["toe",i],["tot",i],["uijt 't",s],["uijt de",s],["uijt den",s],["uijt te de",r],["uijt ten",s],["uijt",i],["uit 't",s],["uit de",s],["uit den",s],["uit het",s],["uit t",s],["uit te de",r],["uit ten",s],["uit",i],["unter",i],["v",i],["v.",i],["v.d.",i],["van 't",s],["van de l",r],["van de l'",r],["van de",s],["van de",s],["van den",s],["van der",s],["van gen",s],["van het",s],["van la",s],["van t",s],["van ter",s],["van van de",r],["van",n],["vander",i],["vd",i],["ver",i],["vom und zum",[[[0,3],null]]],["vom",n],["von 't",s],["von dem",l],["von den",l],["von der",l],["von t",s],["von und zu",[[[0,3],null],[null,[0,3]]]],["von zu",l],["von",o],["voor 't",s],["voor de",s],["voor den",s],["voor in 't",r],["voor in t",r],["voor",i],["vor der",l],["vor",o],["z",e],["ze",e],["zu",o],["zum",n],["zur",n]],p.parseParticles=function(){function t(t,e,i){var s=t;t=i?t.toLowerCase():t;var r,n,a=[];e?(t=t.split("").reverse().join(""),r=p.PARTICLE_GIVEN_REGEXP):r=p.PARTICLE_FAMILY_REGEXP;for(var o=t.match(r);o;){var l,u=e?o[1].split("").reverse().join(""):o[1];if(!(n=!!(l=!!(l=!!o&&u)&&u.replace(/^[-\'\u02bb\u2019\s]*(.).*$/,"$1"))&&l.toUpperCase()!==l))break;e?(a.push(s.slice(-1*u.length)),s=s.slice(0,-1*u.length)):(a.push(s.slice(0,u.length)),s=s.slice(u.length)),o=(t=o[2]).match(r)}if(e){t=t.split("").reverse().join(""),a.reverse();for(var h=1,c=a.length;h<c;h++)" "==a[h].slice(0,1)&&(a[h-1]+=" ");for(h=0,c=a.length;h<c;h++)" "==a[h].slice(0,1)&&(a[h]=a[h].slice(1));t=s.slice(0,t.length)}else t=s.slice(-1*t.length);return[n,t,a]}return function(e){var i=(o=t(e.family))[1],s=o[2];e.family=i;var r,n,a=(r=s.join(""),n=r.slice(-1),r=r.trim()," "===n&&["'","’"].indexOf(r.slice(-1))>-1&&(r+=" "),r);a&&(e["non-dropping-particle"]=a),function(t){if(!t.suffix&&t.given){var e=t.given.match(/(\s*,!*\s*)/);if(e){var i=t.given.indexOf(e[1]),s=t.given.slice(i+e[1].length),r=t.given.slice(i,i+e[1].length).replace(/\s*/g,"");"et al"!==s.replace(/\./g,"")||t["dropping-particle"]?(2===r.length&&(t["comma-suffix"]=!0),t.suffix=s):(t["dropping-particle"]=s,t["comma-dropping-particle"]=","),t.given=t.given.slice(0,i)}}}(e);var o,l=(o=t(e.given,!0))[1],u=o[2];e.given=l;var p=u.join("").trim();p&&(e["dropping-particle"]=p)}}(),p}();
